<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrikTable extends fabrikDBTable {
	/** @var int Primary key */
	var $id=null;

	/** @var string The menu title for the Section (a short name)*/
	var $label = null;

	/** @var string The text that goes at the start of the table view page*/
	var $introduction = null;

	/** @var int The form id that the table references (Foregin Key)*/
	var $form_id = null;

	/** @var int foreign key to connections table */
	var $connection_id = null;

	/** @var string if database selected rather than form: this is the database's table name*/
	var $db_table_name = null;

	/** @var string name of table's primay key column */
	var $db_primary_key = null;

	/** @var bol is the primary key autoincrementing */
	var $auto_inc = 0;

	/** @var bol allow user to add records to table*/
	var $allow_add = null;

	/** @var bol allow user to delete records to table*/
	var $allow_delete = null;

	/** @var bol allow user to view in depth version of records*/
	var $allow_view_details = null;

	/** @var int allow users to view and edit the details of a record */
	var $allow_edit_details = null;

	/** @var int published*/
	var $state = 0;

	/** @var date date created */
	var $created = null;

	/** @var int */
	var $created_by = null;

	/** @var string */
	var $created_by_alias = null;

	/** @var date date modified */
	var $modified = null;

	/** @var int */
	var $modified_by = null;

	/** @var int */
	var $checked_out = null;

	/** @var date */
	var $checked_out_time = null;

	/** @var date */
	var $publish_up = null;

	/** @var date */
	var $publish_down = null;

	/** @var int the access level the user has to be to view the table*/
	var $access = null;

	/** @var int the number of times the table has been viewed*/
	var $hits = null;

	/** @var int the default number of rows to show per pages*/
	var $rows_per_page = 10;

	/** @var string table template */
	var $table_template = 'default';

	/** @var string column to order by */
	var $order_by = null;

	/** @var string order by direction */
	var $order_dir = null;

	/** @var string defines how filters work either onchange or submit button to trigger filter form*/
	var $filter_action = null;

	/** @var bol if the logged in user only gets to see their own table records */
	var $table_view_own_details = 0;

	/** @var string the name of the column that contains the user's id - used in conjunction with $table_view_own_details*/
	var $table_view_own_details_id_col = null;

	/** @var string column to do grouping */
	var $group_by = null;

	var $attribs = null;

	/** @var object current row data object */
	var $_oRow = null;

	/** @var object the tables connection object */
	var $_oConn = null;

	/** @var array filters applied to table */
	var $_aFilter = null;

	/** @var object table's database connection object (loaded from connection object) */
	var $_oConnDB = null;

	/** @var object table's form object */
	var $_oForm = null;

	/** @var array joins */
	var $_aJoins = null;

	/** @var array column calculations */
	var $_aRunCalculations = array();

	/** @var string table output format - set to rss to collect correct element data within function getElementData*/
	var $_outPutFormat = 'html';

	/** @var if in json format defines if records returned as form data (form) or view only data (record)*/
	var $_jsonView = null;

	/** @var bol is in a mambot */
	var $_isMambot = false;

	/** @var bol is in a module */
	var $_isModule = false;

	/** @var object to contain access rights **/
	var $_access = null;

	/** @var int the id of the last inserted record (or if updated the last record updated) **/
	var $_lastInsertId = null;

	/** @var bol determine if we apply prefilters (0 = yes, 1 = no )*/
	var $_togglePreFilters = 0;

	/** @var object menu params */
	var $_menuParams = null;

	/** @var string where sql to filter table data on */
	var $_whereSQL = null;

	/** @var array prefilters **/
	var $_aPrefilters = null;

	/** @var array data **/
	var $_aData = null;

	/** @var array store data to create joined records from */
	var $_joinsToProcess = array();

	/** @var array join obj **/
	var $_joinsToThisKey = null;

	var $_totalRecords = null;

	/**returns all elements (false) or just
	 those in the table (true)*/
	var $_tableViewOnly = null;

	/** @var object search form **/
	var $_oFromForm = null;

	var $_jsonHeadings = null;
	/**
	 * @var array if using a search form, which jumps to filter a table,
	 * this array contains all searched on fields that aren't set up as
	 *table filters. This array is then used by the table view to build a message
	 * informing the user of any of these filters that are applied.
	 * @var unknown_type
	 */
	var $_searchesNoFilterSetup = array();

	/**
	 * @param database A database connector object
	 */

	function fabrikTable( &$db ) {
		$this->mosDBTable( '#__fabrik_tables', 'id', $db );
		$this->_access = new stdClass();
	}

	/**
	 * save the table from admin
	 *
	 * @param array $aData (used for testing to mimic post data )
	 * @return bol true if saved ok
	 */

	function save( $aData = null ){
		global $_VERSION, $database;

		if( is_null( $aData ) ){
			$aData = $_POST;
		}
		$id 		= mosGetParam( $aData, 'id', 0 );
		$this->load( $id );
		$fabrikid 	= mosGetParam( $aData, 'fabrikid', '' );
		$tableName 	= mosGetParam( $aData, 'db_table_name', $this->db_table_name );
		//if this is passed then a form is trying to create a table
		$primaryKey = mosGetParam( $aData, 'db_primary_key', '' );
		$autoInc 	= mosGetParam( $aData, 'auto_inc', '' );

		// if its a new table no key or table id should be present but we still
		// have to look up the connection for the table selected
		if ( $primaryKey == '' and $id == 0 ){
			$connectionId = mosGetParam( $aData, 'connection_id', 0 );
			$this->setConnectionId( $connectionId );
			$this->getConnection( );
		}

		if( $primaryKey == '' ){
			if( $this->databaseTableExists( $tableName ) ){
				$this->db_table_name = $tableName;
				$aKeyInfo = $this->getPrimaryKeyAndExtra(  );
				$primaryKey = $aKeyInfo['colname'];
				$aData['auto_inc'] = ($aKeyInfo['extra'] == 'auto_increment') ?  '1' : '0' ;
				if ( $primaryKey != "" ) {
					$this->db_primary_key = $tableName.'.'.$primaryKey;
				} else {
					echo "<script> alert('" . _NO_PRIMARY_KEY . "');</script>\n";
				}
			}
		} else {
			$this->updatePrimaryKey( $primaryKey, $autoInc );
		}

		//array of param keys not be be encoded
		$aDontEncode = array('filter-value');

		//set table attributes / params
		$params = mosGetParam( $aData, 'params', array() );

		$this->updateAttribsFromParams( $params, $aDontEncode );

		if ( !$this->bind( $aData, 'elements,admin' ) ) {
			echo "<script> alert('BIND: ".$this->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}

		$this->rows_per_page 			= mosGetParam( $aData, 'rows_per_page', 10 );
		$this->state		 					= mosGetParam( $aData, 'state', 0 );
		$this->table_view_own_details  	= mosGetParam( $aData, 'table_view_own_details', 0 );
		$this->auto_inc		 				= mosGetParam( $aData, 'auto_inc', 0 );

		if ( !$this->store( ) ) {
			echo "<script> alert('STORE: ".$this->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}

		if ( $id == 0 ) {
			if($_VERSION->PRODUCT != 'Joomla!'){
				//mambo insertid() deosnt work!
				$sql = "select MAX(id) from #__fabrik_tables";
				$database->setQuery( $sql );
				$newId = $database->loadResult();
				$this->id = $newId;
				$aData['id'] = $newId;
			}else{
				$aData['id'] = $database->insertid( );
			}
			if ( $fabrikid == '' ){
				$oForm = $this->_createLinkedForm( $aData );
				$groupId = $this->createLinkedGroup( $aData, false );
				$oForm->createFormGroup( $groupId );
				$this->createLinkedElements( $groupId, $aData );
			} else {
				//update the existing form with the table id
				$oForm = new fabrikForm( $database );
				$formId = $fabrikid;
				$oForm->load( $formId );
				$oForm->updateFormWithNewTableId( $aData['id'] );
				if ( ! $oForm->setElementVars( 'show_in_table_summary', '1' ) ){
					return false;
				}
			}
			//set the tables form id
			$this->_updateFormId( $oForm->id );
		}
		// load in all the tables data - even if it wasnt in the post data
		$this->load( $this->id );
		$this->updateJoins( );
		// this was only run on a new table - but I've put it here so that if you upload a new table you can ensure that its columns are fixed
		$this->makeSafeTableColumns( );
		$this->checkin( );

		// lets see if we need to make a content element xml file for joomfish
		$params = $this->loadParams();
		$translate = $params->get('allow-data-translation');
		if ( $translate ) {
			if (is_dir( '../administrator/components/com_joomfish/contentelements' )) {
				if (!$this->_makeContentElementXML()) {
					echo "didnt make xml file :( ";exit;
				}
			}
		}
		return true;
	}

	/**
	 * write out the Joomfish contentelement xml file for the tables elements
	 * @return bol true if written out ok
	 */

	function _makeContentElementXML(){
		global $mosConfig_dbprefix, $mosConfig_absolute_path, $database;

		//get all database join elements and check if we need to create xml files for them
		$groups =  $this->_oForm->getFormGroupsHiarachy( true, false, false );
		foreach ($groups as $group) {
			foreach( $group->_aElements as $element ){
				if ($element->elementtype_id == 12) {
					$translateTable = str_replace($mosConfig_dbprefix, '', $element->join_db_name);
					$xmlFile = "fabrik-join-".$translateTable.".xml";
					$path = $mosConfig_absolute_path . '/administrator/components/com_joomfish/contentelements/'.$xmlFile;

					if(file_exists($path)){
						continue;
					}
					$database->setQuery("DESCRIBE $element->join_db_name")	;
					$fields = $database->loadObjectList();
					$translationFieldTypes = array('text', 'varchar');
					$str = '<?xml version="1.0" ?>
<joomfish type="contentelement">
  <name>Fabrik - Join - '. $translateTable . '</name>
  <author>rob@pollen-8.co.uk</author>
  <version>1.0 for Fabrik 1.0.5</version>
  <description>Definition for Fabrik Join Table data - '. $translateTable . '</description>
  <reference>
  	<table name="'. $translateTable . '">';
					$title = false;
					foreach( $fields as $field ){
						if($field->Key == 'PRI'){
							$str .= '<field type="referenceid" name="' . $field->Field . '" translate="0">id</field>' . "\n";
						}else{
							$t = strtolower(array_shift(explode("(", $field->Type)));
							if(!$title){
								$type = "titletext";
								$title = true;
							}else{
								$type = ( $t == 'text' ) ? 'textarea' : "text";
							}
							if( in_array( $t, $translationFieldTypes )){
								$str .= '<field type="' . $type . '" name="' . $field->Field . '" translate="1">' . $field->Field . '</field>' . "\n";
							}
						}
					}
					$str .= '</table>
  </reference>
</joomfish >';
					$fp = fopen($path, "wb");
					if ($fp) {
						$len = strlen($str);
						fwrite($fp, $str, $len);
						fclose($fp);
					}

				}
			}
		}
		$tableName = str_replace($mosConfig_dbprefix, '',$this->db_table_name);
		$str = '<?xml version="1.0" ?>
<joomfish type="contentelement">
  <name>Fabrik - ' . $this->label . '</name>
  <author>rob@pollen-8.co.uk</author>
  <version>1.0 for Fabrik 1.0.5</version>
  <description>Definition for Fabrik Table data - ' . $this->label . '</description>
  <reference>
  	<table name="' . $tableName . '">';

		$this->getFormGroupElementData( false, true, false );

		$shortkey = array_pop( explode(".",$this->db_primary_key ));
		$title = false;
		foreach($this->_oForm->_groups as $oGroup){
			foreach($oGroup->_aElements as $oElement){
				$translate = false;
				if ($oElement->element_name == 'time_date'){
					continue;
				}
				$t = 1;
				switch($oElement->elementtype_id){
					case '2':
						$translate = true;
						$type = 'text';
						break;
					case '5' : //text area
						$translate = true;
						$type = 'textarea';
						break;
				}
				if( $oElement->element_name == $shortkey){
					$translate = true;
					$type = 'referenceid';
					$t = 0;
				}else{
					if(!$title && $translate && $oElement->element_name != 'time_date'){
						$title = true;
						$type = 'titletext';
					}
				}
				if($translate){
					$str .= "\n\t\t" . '<field type="'.$type.'" name="'.$oElement->element_name.'" translate="'.$t.'">' . $oElement->element_label . '</field>';
				}
			}
		}
		$str .='
  	</table>
  </reference>
</joomfish >';

		$fp = @fopen('../administrator/components/com_joomfish/contentelements/fabrik-' . $this->db_table_name . '.xml', "wb");
		if ($fp) {
			$len = strlen($str);
			fwrite($fp, $str, $len);
			fclose($fp);
			return true;
		}
		return false;
	}

	/**
	 * when saving a table that links to a database for the first time we
	 * automatically create a form to allow the update/creation of that tables
	 * records
	 * @param array newly created table data
	 * @return object form
	 */

	function _createLinkedForm( $tableData ) {
		global $database, $my, $mosConfig_mailfrom, $mosConfig_offset, $mosConfig_absolute_path, $_VERSION;
		//require_once ( $mosConfig_absolute_path . "/administrator/components/com_fabrik/admin.fabrik.forms.php" );
		$aData['form_title'] 			= $tableData['label'];
		$aData['record_in_database'] 	= '1';
		$aData['created'] 				= mosformatDate( date('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S', - $mosConfig_offset );
		$aData['created_by'] 			= $my->id;
		$aData['created_by_alias'] 		= $my->username;
		// @TODO : fabrik : 0.5 : create a overall fabrik params admin page which sets the default settings for all forms, from which these settings below can be populated
		$aData['align'] 				= 'left';
		$aData['width'] 				= '100%';
		$aData['form_subject'] 			= $tableData['label'];
		$aData['form_submit_jumppage'] 	= 'index.php?option=com_fabrik&amp;task=viewTable&amp;tableid=' . $tableData['id'];
		$aData['email_to'] 				= '';
		$aData['email_from'] 			= $mosConfig_mailfrom;
		$aData['receipt_email'] 		= '';
		$aData['receipt_message'] 		= '';
		$aData['reset_button'] 			= 0;
		$aData['reset_button_label'] 	= _CMN_CANCEL;
		$aData['submit_button_label'] 	= _CMN_SAVE;
		$aData['table_id'] 				= $tableData['id'];
		$aData['state']					= $tableData['state'];
		$aData['form_template']			= 'default';
		$aData['view_only_template']	= 'default';

		$this->_oForm = new fabrikForm( $database );
		//saveForm
		$form_id = $this->_oForm->save( $aData );

		if($_VERSION->PRODUCT != 'Joomla!'){
			//mambo insertid() deosnt work!
			$sql = "select MAX(id) from #__fabrik_forms";
			$database->setQuery($sql);
			$form_id = $database->loadResult();
		}

		$this->_oForm->load( $form_id );
		return $this->_oForm;
	}


	/**
	 * updates the table record to point to the newly created form
	 * @params int form id
	 */

	function _updateFormId( $formId ){
		global $database;
		$this->form_id = $formId;
		if (!$this->store()) {
			echo "<script> alert('".$this->getError()."'); window.history.go(-1); </script>\n";
			exit ();
		}
	}

	/**
	 * check use can view the table
	 * @return bol can view or not
	 */

	function canView( ){
		global $my, $acl, $database;
		if ($this->access == '29') {
			$this->_access->view =  true;
		} else {
			if (!is_object($this->_access) || !array_key_exists('view', $this->_access)) {
				$sql = "SELECT name FROM #__core_acl_aro_groups WHERE group_id >= '$this->access' AND  group_id < 28";
				$database->setQuery($sql);

				$groupNames = $database->loadResultArray();
				foreach ($groupNames as $name) {
					$acl->_mos_add_acl( 'action', 'view', 'fabrik', $name, 'components', null );
				}
					
				if ($acl->acl_check( 'action', 'view', 'fabrik', $my->usertype, 'components', null )) {
					$this->_access->view =  true;
				} else {
					$this->_access->view = false;
				}
			}
		}
		return $this->_access->view;
	}

	/**
	 * check to see if prefilter should be applied
	 * Kind of an inverse access lookup
	 * @param int group id to check against
	 * @param string ref for filter
	 * @return bol must apply filter - true, ignore filter (user has enough access rights) false;
	 */

	function mustApplyFilter( $gid, $ref ){
		global $my, $acl, $database;
		if( $gid == '29' || $gid == '26'){ //26 is for apply to nobody
			return false;
		}else{
			if( $my->id == 0 ){
				return true;
			}
			$sql = "SELECT name FROM #__core_acl_aro_groups WHERE group_id < '$gid' ";
			$database->setQuery($sql);
			$groupNames = $database->loadResultArray();
			foreach($groupNames as $name){
				$acl->_mos_add_acl( 'action', 'prefilter-' . $ref, 'fabrik', $name, 'components', null );
			}
			if($acl->acl_check( 'action', 'prefilter-' . $ref, 'fabrik', $my->usertype, 'components', null )){
				return true;
			}else{
				return false;
			}
		}
	}

	/**
	 * check if the user can view the detailed records
	 *
	 * @return bol
	 */

	function canViewDetails(){
		global $my, $acl, $database;
		if( $this->allow_view_details == '29'|| $this->allow_view_details == '' ){
			$this->_access->viewdetails =  true;
		}else{
			if(!is_object($this->_access) || !array_key_exists('viewdetails', $this->_access)){
				$sql = "SELECT name FROM #__core_acl_aro_groups WHERE group_id >= '$this->allow_view_details' AND group_id < 28";
				$database->setQuery($sql);
				$groupNames = $database->loadResultArray();
				foreach($groupNames as $name){
					$acl->_mos_add_acl( 'action', 'viewdetails', 'fabrik', $name, 'components', null );
				}
				if($acl->acl_check( 'action', 'viewdetails', 'fabrik', $my->usertype, 'components', null )){
					$this->_access->viewdetails = true;
				}else{
					$this->_access->viewdetails = false;
				}
			}
		}
		return $this->_access->viewdetails;
	}

	function canEdit(){
		global $my, $acl, $database;
		if ($this->allow_edit_details == '29'|| $this->allow_edit_details == ''|| $this->allow_edit_details == 30) { //29 registered //30 everybody
			$this->_access->edit =  true;
		} else {
			if (!is_object( $this->_access ) || !array_key_exists( 'edit', $this->_access )) {
				$sql = "SELECT name FROM #__core_acl_aro_groups WHERE group_id >= '$this->allow_edit_details' AND group_id < 28";
				$database->setQuery($sql);
				$groupNames = $database->loadResultArray();
				foreach ($groupNames as $name) {
					$acl->_mos_add_acl( 'action', 'edit', 'fabrik', $name, 'components', null );
				}
				if ($acl->acl_check( 'action', 'edit', 'fabrik', $my->usertype, 'components', null )) {
					$this->_access->edit = true;
				} else {
					$this->_access->edit = false;
				}
			}
		}
		return $this->_access->edit;
	}

	function canAdd(){
		global $my, $acl, $database;
		if($this->allow_add == '29' || $this->allow_add == ''){
			$this->_access->add =  true;
		}else{
			if(!is_object($this->_access) || !array_key_exists('add', $this->_access)){
				$sql = "SELECT name FROM #__core_acl_aro_groups WHERE group_id >= '$this->allow_add' AND group_id < 28";
				$database->setQuery($sql);
				$groupNames = $database->loadResultArray();
				foreach($groupNames as $name){
					$acl->_mos_add_acl( 'action', 'add', 'fabrik', $name, 'components', null );
				}
				if($acl->acl_check( 'action', 'add', 'fabrik', $my->usertype, 'components', null )){
					$this->_access->add = true;
				}else{
					$this->_access->add = false;
				}
			}
		}
		return $this->_access->add;
	}

	function canDelete(){
		global $my, $acl, $database;
		if($this->allow_delete == '29'|| $this->allow_delete == ''){
			$this->_access->delete =  true;
		}else{
			if(!is_object($this->_access) || !array_key_exists('delete', $this->_access)){
				$sql = "SELECT name FROM #__core_acl_aro_groups WHERE group_id >= '$this->allow_delete' AND group_id < 28";
				$database->setQuery($sql);
				$groupNames = $database->loadResultArray();
				foreach($groupNames as $name){
					$acl->_mos_add_acl( 'action', 'delete', 'fabrik', $name, 'components', null );
				}
				if($acl->acl_check( 'action', 'delete', 'fabrik', $my->usertype, 'components', null )){
					$this->_access->delete = true;
				}else{
					$this->_access->delete = false;
				}
			}
		}
		return $this->_access->delete;
	}

	function canEmpty(){
		global $my, $acl, $database;
		$params =& $this->loadParams();
		$allowEmpty = $params->get( 'allow-empty' );
		if ($allowEmpty == '29'|| $allowEmpty == '') {
			$this->_access->empty =  true;
		}else{
			if (!is_object( $this->_access ) || !array_key_exists( 'empty', $this->_access )) {
				$sql = "SELECT name FROM #__core_acl_aro_groups WHERE group_id >= '$allowEmpty' AND group_id < 28";
				$database->setQuery( $sql );
				$groupNames = $database->loadResultArray();
				foreach ($groupNames as $name) {
					$acl->_mos_add_acl( 'action', 'empty', 'fabrik', $name, 'components', null );
				}
				if ($acl->acl_check( 'action', 'empty', 'fabrik', $my->usertype, 'components', null )) {
					$this->_access->empty = true;
				} else {
					$this->_access->empty = false;
				}
			}
		}
		return $this->_access->empty;
	}

	/**
	 * load  the database associated with the table
	 *@return object database
	 */
	function &getDb(){
		$this->getConnection();
		return $this->_oConnDB;
	}

	/**
	 * function get the tables connection object
	 * @return object connection
	 */

	function getConnection( ){
		if ( isset( $this->_oConn ) ) {
			if(!isset($this->_oConnDB)){
				$this->_oConnDB = $oConn->loadTableConnectionDB( );
			}
			return $this->_oConn;
		} else {
			global $database;
			$connId = $this->connection_id;
			$oConn = new fabrikConnection( $database );
			if(is_null( $this->connection_id ) || $this->connection_id == ''){
				$oConn->loadDefaultConnection( );
			}else{
				$oConn->load( $connId );
			}
			// if its the default connection then load from the
			// config file
			if( $oConn->default_cnn ){
				global $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db;
				$oConn->host = $mosConfig_host;
				$oConn->user = $mosConfig_user;
				$oConn->password = $mosConfig_password;
				$oConn->database = $mosConfig_db;
			}
			$this->_oConn = $oConn;
			$this->_oConnDB = $oConn->loadTableConnectionDB( );
			return $this->_oConn;
		}
	}

	/**
	 * set the connection id - used when creating a new table
	 * @param int connection id
	 */

	function setConnectionId( $id ){
		$this->connection_id = $id;
	}

	/**
	 * gets drop down list of all the fileds for the loaded table
	 */

	function makeTableColumnsDd( $name='tablefields', $javascript = '', $selected = '' ){
		global $database;
		if ( $this->id ) {
			$oCnn = $this->getConnection( );
			if ( $oCnn->testConnection( ) ) {
				$joinDb = new database( $oCnn->host, $oCnn->user, $oCnn->password, $oCnn->database, "" );
				$sql = "DESCRIBE $this->db_table_name";
				$joinDb->setQuery( $sql );
				$aRes = $joinDb->loadObjectList( );
				foreach( $aRes as $oRes ){
					$fieldOptions[] = mosHTML::makeOption( $oRes->Field, $oRes->Field );
				}
				return mosHTML::selectList( $fieldOptions, $name, 'class="inputbox" size="1" id="' . $name  . '" '.$javascript, 'value', 'text', $selected );
			}
		}
	}

	/**
	 * returns $this->_dbFields if not set _loadDBFields
	 * @param string table name
	 * @return array table fields
	 */

	function _getDBFields( $tbl = null ){
		if(!is_null($this->_dbFields)){
			return $this->_dbFields;
		}else{
			return $this->_dbFields = $this->_loadDBFields( $tbl );
		}
	}

	/**
	 * calls sql "describe table"
	 * @param string table name
	 * @return array table fields
	 */

	function _loadDBFields( $tbl = null){
		if(is_null($tbl)){
			$tbl = $this->db_table_name ;
		}
		$oCnn = $this->getConnection( );
		$db = $this->_oConnDB;
		$db->setQuery( "DESCRIBE `$tbl`" );
		return $db->loadObjectList( );
	}

	/*
	 *  overloaded check function
	 */
	function check() {
		return true;
	}

	/**
	 * get a merged request and session data array
	 *
	 * @return array
	 */
	function getData()
	{
		if (is_null( $this->_aData )) {
			$this->_aData = array();
		}
		return $this->_aData;
	}

	/**
	 * parses aData for filters to apply to the table view
	 * @param array posted data
	 * @return array filters
	 */

	function _loadFilterArray( )
	{
		global $my, $mainframe, $database, $option;
		$aData = $this->getData();
		$aFilter = array();
		$i = 0;
		$filterCondSQL = "";
		$cond ='';
		/* if posted data comes from a module we want to strip out its table name
		 and replace it with current table name
		 not sure how to deal with this for joins ? */
		$fromModule 		 = mosGetParam( $_REQUEST, 'fabrik_frommodule', 0 );

		$oFilters 	=  $this->getTableFilters2( );
		$oGroup 	= new fabrikGroup( $database );
		foreach ($oFilters as $oFilter) {
			if ($oFilter->canView()) {
				$params = $oFilter->loadParams( );
				$key = $oGroup->getElementFullName( $oFilter, $this->_oForm,  true, true, false );
				// $$$ hugh - moved these, see comment bloew
				$aData[$key]['type'] 	= $oFilter->filter_type;
				$aData[$key]['match'] 	= $oFilter->filter_exact_match;
			}
		}
		foreach ($aData as $key=>$val) {
			
			if ($this->_oForm->hasElement( $key )) {
				
				$thisElement = $this->_oForm->_currentElement;
				if ($thisElement->password == '1') {
					continue;
				}
				//default
				$ellabel = $thisElement->element_label;
				$params =& $thisElement->loadParams();

				if (!in_array( $key, $this->_aDataToIgnore )) {
					if (is_array( $val )) {

						// $$$ - hugh, changed these above, 'cos $oFilter isn't in scope here
						// and for reasons I have no clue about, these two aren't avaliable in $params
						// like full_words_only is!??
						$filterType 			= isset( $val['type']) ? $val['type'] : 'dropdown';
						$filterExactMatch = isset( $val['match'] )? $val['match'] : '';
						$filterVal 				= isset( $val['value'] )?  $val['value'] : '';

						$fullWordsOnly 		= isset( $val['full_words_only'] )? $val['full_words_only'] : $params->get('full_words_only', '1');
						$joinDbName 			= isset( $val['join_db_name']) ? $val['join_db_name'] : '';
						$joinKey 					= isset( $val['join_key_column']) ? $val['join_key_column'] : '';
						$joinVal 					= isset( $val['join_val_column']) ? $val['join_val_column'] : '';

						if (!is_array( $filterVal )) {
							$filterVal = urldecode( $filterVal );
						}
						if ($filterVal != "" || is_array( $filterVal )) {
							//test if the data is from a joined group
							if (strstr( $key, "join[" )) {
								$bits = explode("[", $key);
								$key = array_pop($bits);
								$key = trim($key, "]");
							}

							/*HACK!
							 php will strip out dots from the query string - to get around this you need to make your filter links like this:
							 jos_cbx_shot...bid_status_id[value]=1
							 the three dots will get converted to ___ and we then replace that with the requierd '.' in the code below */
							$dbkey = $key;
							if (strstr( $dbkey, '___')) {
								$dbkey = str_replace( '___', '.', $dbkey );
							}

							if (!strstr( $dbkey, '.' )) {
								$dbkey = $this->db_table_name . '.' . $dbkey;
							}
							if ($fromModule) {
								$aKeyParts = explode( '.', $dbkey);
								$dbkey = $this->db_table_name . '.' . $aKeyParts[1];
								$key = $this->db_table_name . '___' . $aKeyParts[1];
							}

							switch ($filterType) {
								case 'range':
									
									$cond = $this->_getFilterSQLPart( 'range', $filterVal, $filterExactMatch, $dbkey, $fullWordsOnly );
									if ($cond != '') {
										if (array_key_exists( $key, $aFilter )) {
											$aFilter[$key][] = $aFilter[$key];
											$aFilter[$key][] = array('type'=>'range', 'value'=>$filterVal , 'filterVal'=>$filterVal, 'sqlCond' =>$cond );
										} else {
											$aFilter[$key] = array('type'=>'range', 'value'=>$filterVal , 'filterVal'=>$filterVal, 'sqlCond' =>$cond );
										}
									}
									break;
								case 'dropdown';
								
									$cond = $this->_getFilterSQLPart( 'dropdown', $filterVal, $filterExactMatch, $dbkey, $fullWordsOnly );
	
									if (array_key_exists( $key, $aFilter )) {
										$aFilter[$key][] = $aFilter[$key];
										$aFilter[$key][] = array( 'type'=>'dropdown', 'value'=>$filterVal , 'filterVal'=>$filterVal, 'sqlCond' =>$cond );
									} else {
										$aFilter[$key] = array( 'type'=>'dropdown', 'value'=>$filterVal , 'filterVal'=>$filterVal, 'sqlCond' =>$cond );
									}
									break;
								case "":
								case "field":
									if ($joinDbName != '') {
										//$$rob $dbkey should always have a '.'
										//if (strstr( $key, '.' )) {
											$filterCondSQL .= " LEFT JOIN $joinDbName ON $joinDbName.$joinKey = " . $dbkey . " ";
										//} else {
										//	$filterCondSQL .= " LEFT JOIN $joinDbName ON $joinDbName.$joinKey = " . $this->db_table_name . "." . $dbkey . " ";
										//}
										$dbkey = $joinDbName . "." . $joinVal;
									}
									/* full_words_only
									 all search for multiple fragments of text*/

									$cond = $this->_getFilterSQLPart( 'field', $filterVal, $filterExactMatch, $dbkey, $fullWordsOnly );

									$aFilter[$key] = array( 'type'=>'field',
																   'value'=>$cond, 
																	'filterVal'=>$filterVal, 
																	'full_words_only'=>$fullWordsOnly,
																	'join_db_name' => $joinDbName,
																	'join_db_key' => $joinKey,
																	'join_val_column' => $joinVal,
																	'prewritten_join' => $filterCondSQL,
																	'sqlCond' =>$cond 
									);
									
									break;
								case "search":
									//no longer used  use 'advancedFilterContainer' instead
									break;
							}
							$aFilter[$key]['ellabel'] = $ellabel;
							$i ++;
						}
					}
				}
			}
		}

		$this->_searchesNoFilterSetup =array();
		$keys = array_keys($aFilter);
		foreach ($aFilter as $key=>$value) {
			$isSetAsFilter = false;
			foreach ($oFilters as $filter) {
				if ($this->db_table_name.'___'.$filter->element_name == $key) {
					$isSetAsFilter = true;
				}
			}
			if (!$isSetAsFilter) {
				$name = str_replace('.', '___', $key) . "[value]";
				$this->_searchesNoFilterSetup[$value['ellabel']] = "<input class='fabrik_filter' type='hidden' name='$name' value='" . $value['filterVal'] . "' />" . $value['filterVal'];
			}
		}

		//check for advanced search option (now set in table rather than individidual element
		if (array_key_exists( 'advancedFilterContainer', $aData )) {
			$filterVal = $aData['advancedFilterContainer']['value'];
			$filterVal = urldecode( $filterVal );
			$cond = str_replace( '\"', '"', $filterVal );
			$aFilter['advancedFilterContainer'] = array( 'type'=>'search',
										   'value'=>$cond, 
										   'filterVal'=>$filterVal,
											'full_words_only'=>'0',
											'join_db_name' => '',
											'join_db_key' => ''
											, 'sqlCond' =>$cond
											);

		}
		return $aFilter;
	}

	/**
	 * @access private
	 * fomat the part of the sql that filters table data based on posted/get filter vals
	 * @param string filter type
	 * @param string value of filter
	 * @param bol return exact matches
	 * @param string filter's pk
	 * @param bol return fullwords only
	 * @return string sql where filter part
	 */

	function _getFilterSQLPart( $type, $filterVal, $filterExactMatch, $key, $fullWordsOnly )
	{
		$cond = '';
		// $$$ rob
		//use this in query strings as passing and empty string doesnt trigger the filter
		if ($filterVal == '_empty_') {
			$filterVal = '';
		}
		switch($type){
			case "range":
				if (is_array( $filterVal )) {
					if (count( $filterVal ) == 2 && ( trim($filterVal[0] ) != '' && trim( $filterVal[1] != '' )))  {
						$cond = " $key BETWEEN '" . $filterVal[0] . "' AND  '" . $filterVal[1] . "' ";
					}
				}
				break;
			case "dropdown":
				if(!is_array($filterVal)){
					if ( $filterExactMatch == '0' ){
						$cond = " $key LIKE '%$filterVal%' ";
					} else {
						//$cond = " $key = '$filterVal' ";
						//$$$rob  use regex to check for repeat groups no joins as well
						$cond = " $key REGEXP \"[[:<:]]" . $filterVal . "[[:>:]]\"";
					}
				}else{
					$cond = "( ";
					foreach($filterVal as $fval){
						if(trim($fval) != ''){
							if ( $filterExactMatch == '0' ){
								$cond .= " $key LIKE '%$fval%' OR ";
							} else {
								if(trim( $fval ) == '_null_'){
									$cond .= " $key IS NULL OR ";
								} else {
									//$cond .= " $key = '$fval' OR ";
									//$$$rob  use regex to check for repeat groups no joins as well
									$cond = " $key REGEXP \"[[:<:]]" . $fval . "[[:>:]]\" OR ";
								}
							}
						}
					}
					$cond = substr( $cond, 0, strlen( $cond )-3 );
					$cond .= " ) ";
				}
				break;
			case "field":
				$aFilterVals = explode( "+", $filterVal );
				if ($fullWordsOnly == '1') {
					if( !is_array( $filterVal )) {
						$cond = " $key REGEXP \"[[:<:]]" . $filterVal . "[[:>:]]\"";
					}
				} else {
					$cond = " $key LIKE '%";
					foreach ($aFilterVals as $filt) {
						$cond .="$filt%";
					}
					$cond .="'";
				}
		}
		return $cond;
	}

	/**
	 * @return string join part of tables sql statement
	 */

	function addJoinTableSQL( )
	{
		$aJoinObjs = $this->loadJoins( );
		$sql = '';
		if (is_array( $aJoinObjs )) {
			foreach ($aJoinObjs as $oJoin) {
				$sql .= " " . strtoupper($oJoin->join_type) . " JOIN $oJoin->table_join " .
					"ON $oJoin->table_join.$oJoin->table_join_key = " .
					"$oJoin->join_from_table.$oJoin->table_key \n";
			}
		}
		return $sql;
	}

	/**
	 * update any link element types data so that it is changed from
	 * Label|http://www.link.com
	 * to
	 * <a href="http://www.link.com">Label</a>
	 * Also checks images and converts /images/stories/image.png to
	 * <img src="http://site.com/images/stories/image.png" />
	 * IF IN RSS MODE
	 * @param object origional element data
	 * @param object form
	 * @return object modified element data
	 */

	function convertURLsToLinks( $elementData, $oForm ){
		///
		global $mosConfig_absolute_path, $mosConfig_live_site;
		if( is_array( $elementData ) ){
			foreach( $oForm->_groups as $oGroup ){
				foreach( $oGroup->_aElements as $oElement ){
					/* url element type */
		  	if ( $oElement->elementtype_id == "14" ){
	  			$col = $oGroup->getElementFullName( $oElement, $oForm, true, false );
	  			$splitter = $oGroup->_splitter_1;
	  			$params = $oElement->loadParams();
	  			$linkTarget = $params->get('link_target', '_self');
	  			if( !empty( $elementData ) && array_key_exists( $col, $elementData[0] ) ){
	  				for( $i=0; $i<count( $elementData ); $i++ ){
	  					$data = $elementData[$i]->$col;
	  					$data = explode($splitter, $data );
	  					if ( is_array( $data ) ){
	  						if ( count( $data ) == 1 ){ $data[1] = $data[0];}
	  						if( $this->_outPutFormat != 'rss' ){
	  							//
	  							$link = "<a href='" . $data[1] . "' target='" . $linkTarget . "'>" . $data[0] . "</a>";
	  						} else {
	  							$link = $data[1];
	  						}
	  						$elementData[$i]->$col = $link;
	  					}
	  				}
	  			}
		  	}
		  	if( $oElement->elementtype_id == "9" || $oElement->elementtype_id == "8" ){
		  		$params = $oElement->loadParams();
		  		if( $this->_outPutFormat == 'rss' ){
		  			$col = $oGroup->getElementFullName( $oElement, $oForm, true, false, false );
		  			if( !empty( $elementData ) && array_key_exists( $col, $elementData[0] ) ){
		  				$selectImage_root_folder = $params->get('selectImage_root_folder', '');
		  				for( $i=0; $i<count( $elementData ); $i++ ){
		  					$data = $elementData[$i]->$col;
		  					$img = "<img src='" . $mosConfig_live_site . '/images/stories/' . $selectImage_root_folder . '/'. $data . "' />";
		  					$elementData[$i]->$col = $img;
		  				}
		  			}
		  		}else{
		  			//do this in replaceDataWithIcons() instead
		  			/*if( $params->get( 'make_link', 0 ) ){
		  			 $col = $oGroup->getElementFullName( $oElement, $oForm, true, false, false );
		  			 if( !empty( $elementData ) && array_key_exists( $col, $elementData[0] ) ){
		  			 $selectImage_root_folder = $params->get('selectImage_root_folder', '');
		  			 for( $i=0; $i<count( $elementData ); $i++ ){
		  			 $data = $elementData[$i]->$col;
		  			 $bits = explode( "/", $data );
		  			 $file = array_pop( $bits );
		  			 $elementData[$i]->$col = "<a href='$data'>$file</a>";
		  			 }
		  			 }
		  				}*/
	  			}
	  		}
	  		//$$$ rob test if fields should get set to links
	  		if( $oElement->elementtype_id == "2" ){
	  			$params = $oElement->loadParams();
	  			if( $params->get('guess_linktype') == '1'){
	  				$col = $oGroup->getElementFullName( $oElement, $oForm, true, false, false );
	  				for( $i=0; $i<count( $elementData ); $i++ ){
	  					$data = $elementData[$i]->$col;
	  						
	  					if( $oForm->check_email_address( $data )){
	  						$data = "<a href='mailto:$data'>$data</a>";
	  					}
	  					if(stristr($data, 'http')){
	  						$data = "<a href='$data'>$data</a>";
	  					}else{
	  						if( stristr($data, 'www.')){
	  							$data = "<a href='http://$data'>$data</a>";
	  						}
	  					}
	  					$elementData[$i]->$col = $data;
	  				}
	  			}
	  		}
				}
			}
		}
		return $elementData;
	}

	/**
	 * replaces values with the labels for radio and drop down elements
	 * @param array element data
	 * @return array element data
	 */

	function replaceRadioDataWithLabels( $elementData ){
		if ($this->_jsonView == 'form') {
			return $elementData;
		}
		if (is_array( $elementData )) {

			foreach( $this->_oForm->_groups as $oGroup) {
				foreach ($oGroup->_aElements as $oElement) {
					/* radio buttons & drop downs & checkboxes*/
	  		if ($oElement->elementtype_id == "4" || $oElement->elementtype_id == "6" || $oElement->elementtype_id == "3") {
	  			$attribs =& new mosParameters( $oElement->attribs );
	  			if ($this->_outPutFormat == 'json') {
	  				$col = $oGroup->getElementFullName( $oElement, $this->_oForm, true, true );
	  			} else {
	  				$col = $oGroup->getElementFullName( $oElement, $this->_oForm, true, false );
	  			}
	  			$labels = explode( '|', $oElement->dd_text );
	  			$values = explode( '|', $oElement->dd_values );
	  			if (!empty( $elementData ) && array_key_exists( $col, $elementData[0] )) {
	  				$iconFolder = $attribs->get( 'icon_folder', '' );
	  				for ($i=0; $i<count( $elementData ); $i++) {
	  					$data = $elementData[$i]->$col;
	  					//check if the data is in csv format, if so then the element is a multi drop down
	  					if (strstr( $data, $oGroup->_splitter_1 ) && ( $oElement->multiple == 1 || $oElement->elementtype_id == "3" )) {
	  						$aData = explode( $oGroup->_splitter_1, $data );
	  						$sLabels = '';
	  						foreach ($aData as $tmpVal) {
	  							$key = array_search($tmpVal, $values);
	  							$sLabels.= $labels[$key]. "<br />";
	  						}
	  						$elementData[$i]->$col = rtrim( $sLabels, "<br />" );
	  					} else {
	  						$key = array_search($data, $values);
	  						$col_img = $col . '_img';
	  						if ($iconFolder != '' && array_key_exists( $col_img, $elementData[$i] )) {
	  							$elementData[$i]->$col = $elementData[$i]->$col_img;
	  						} else {
	  							$elementData[$i]->$col = $labels[$key];
	  						}
	  					}
	  				}
	  			}
	  		}
	  	}
			}
		}
		return $elementData;
	}

	/**
	 * ONLY ADVANCED JOINS HERE - SIMPLE JOINS SHOULD BE DONE IN GETELEMENT DATA INSTEAD
	 * JUST TESTING REMOVING FUNC FOR SIMPLE JOINS FIRST - SO COMPLEX JOINS ARE (FOR THE MOMENT)
	 * STILL CALCULATED HERE
	 * this parses all the element data to be shown in the table and replaces any
	 * data marked as a foreign key with the foriegn key value
	 * @param object origional element data
	 * @param object form
	 * @return object modified element data
	 */

	function getForiegnKeys( $elementData ){
		global $database, $mosConfig_absolute_path;
		foreach ($this->_oForm->_groups as $oGroup) {
			if (is_object( $oGroup )) {
				if (is_array( $oGroup->_aElements )) {
					foreach ($oGroup->_aElements as $oElement) {
						/* a join connection has been set up */
						if ($oElement->elementtype_id == "12") {
							$params = new fabrikParams( $oElement->attribs, $mosConfig_absolute_path.'/administrator/components/com_fabrik/xml/element.xml', 'component');
							$cn = new fabrikConnection( $database );
							if ($oElement->join_conn_id == '' || $oElement->join_conn_id == '-1') {
								$cn->loadDefaultConnection();
							} else {
								$cn->load( $oElement->join_conn_id );
							}
							if ($cn->testConnection()) {
								$joinDb = new database( $cn->host, $cn->user, $cn->password, $cn->database, "" );
								$col	= $oElement->element_name;
								$aVals = array();
								switch ($params->get( 'joinType' )) {
									case 'advanced':
										$aAvJoins 	= $oElement->getAdvancedJoinsObjs( );
										$val 		= stripslashes( htmlspecialchars_decode( $params->get( 'advJoin_concat' ), ENT_QUOTES ) );
										$table 		= $aAvJoins[0]->join_from_table;
										$key 		= $aAvJoins[0]->table_join_key;
										$key 		= $params->get('advJoin_key', $table.'.'.$oElement->element_name );
										$table 		= $params->get('advJoin_startTable', $table);
										$sql 		= "SELECT $key AS value, CONCAT($val) AS text FROM $table ";
										$aUsedJoins = array();
										foreach  ($aAvJoins as $oJoin) {
											$tmpSql = "\n " . strtoupper($oJoin->join_type) . " JOIN $oJoin->table_join  ON $oJoin->join_from_table.$oJoin->table_key = $oJoin->table_join.$oJoin->table_join_key";
											if  (!in_array( $tmpSql, $aUsedJoins )) {
												$sql .= $tmpSql;
												$aUsedJoins[] = $tmpSql;
											}
										}

										if (!strstr( $col, '.' )) {
											$col = $table . '.' . $col;
										}
											
										$col = $oGroup->getElementsJoinKeyFullName( $oElement, $oForm, false, false, false );
										$newCol = $col;

										for ($i=0; $i<count( $elementData ); $i++ ) {
											if (!array_key_exists( $col, $elementData[$i] )) {
												// $$$ rob - can occur when you have a join element that is in a repeat group but
												// not one that was created by a db join
												$col = $this->db_table_name . '.' . $oElement->element_name;
											}
											if (array_key_exists( $col, $elementData[$i] )) {
												if (!in_array($elementData[$i]->$col, $aVals )) {
													if (isset( $elementData[$i]->$col )) {
														$splitdata = explode( $oGroup->_splitter_1, $elementData[$i]->$col );
														$aVals = array_merge($aVals, $splitdata);
													}
												}
											}
										}
										$aVals = array_unique( $aVals );
										$sVals	= implode( '\', \'', $aVals );
										$sql .= " WHERE $key IN ( '$sVals' )";
										if (count($aVals) > 0) {
											$joinDb->setQuery( $sql );
											$oNewJoinStuff = $joinDb->loadObjectList( 'value' );
											if (is_array( $oNewJoinStuff )) {
												for ($i=0; $i<count( $elementData ); $i++) {
													if (array_key_exists( $col, $elementData[$i] )) {
														$this->_updateFromKeyToVal( &$oGroup, $col, $elementData[$i], $oNewJoinStuff );
													} else {
														$this->_updateFromKeyToVal( &$oGroup, $newCol, $elementData[$i], $oNewJoinStuff );
													}
												}
											}
										}
										if ($joinDb->getErrorMsg() != '') {
											echo "<br>1.db error for $sql <br /><br />";
										}
										break;
									case 'diy':

										$aVals = array();
										$col = $oGroup->getElementsJoinKeyFullName( $oElement, $oForm, false, false, false );
										//$newCol = $this->db_table_name . '.' . $oElement->element_name;
										for ($i=0; $i<count( $elementData ); $i++ ) {
											if (!array_key_exists( $col, $elementData[$i] )) {
												// $$$ rob - can occur when you have a join element that is in a repeat group but
												// not one that was created by a db join
												$col = $this->db_table_name . '.' . $oElement->element_name;
											}
											if (array_key_exists( $col, $elementData[$i] )) {
												if (!in_array( $elementData[$i]->$col, $aVals )) {
													if (isset( $elementData[$i]->$col )) {
														$splitdata = explode( $oGroup->_splitter_1, $elementData[$i]->$col );
														$aVals = array_merge( $aVals, $splitdata );
													}
												}
											}
										}
										global $mosConfig_dbprefix;
										$sql = str_replace('#__', $mosConfig_dbprefix, $params->get( 'advanced-join-sql' ));
										//	try to find the key
										//$pattern = '@^(?:"select")?([^as]+)@'; //doesnt work for "select user_id as "
										$pattern = '/select(.*?)as/i';
										$match = preg_match($pattern, strtolower($sql), $matches);
										if ($match && count( $matches ) > 1) {
											$key = $matches[1];
										}
										$aVals = array_unique( $aVals );
										$sVals	= implode( '\', \'', $aVals );
										$sql .= " WHERE $key IN ( '$sVals' )";
										$joinDb->setQuery( $sql );
										$oNewJoinStuff = $joinDb->loadObjectList( 'value' );
										$valCol = $col  . "___value";
										if (is_array( $oNewJoinStuff )) {
											for ($i=0; $i<count( $elementData ); $i++) {
												//object keys are in table.element syntax cant acces with $o->key so convert to array
												$row = mosObjectToArray( $elementData[$i] );
												if (!array_key_exists( $col, $row )) {
													$col = $oElement->element_name;
													if (!isset( $row[$col] )) {
														$col = $oElement->element_label;
													}
												}
												$elementData[$i]->$valCol  = @$row[$col];
												$v = array();
												$this->_updateFromKeyToVal( &$oGroup, $col, $elementData[$i], $oNewJoinStuff );
											}
										}
										break;
								}
							} else {
								echo "get foregin keys: could not connect to database<br />";
							}
						}
					}
				}
			}
		}
		return $elementData;
	}

	/**
	 * helper function to be used inside getForiegnKeys()
	 *
	 * @param object $oGroup
	 * @param string $key
	 * @param object $row
	 * @param array $oNewJoinStuff
	 */

	function _updateFromKeyToVal( &$oGroup, $key, &$row, $oNewJoinStuff )
	{
		$v = array();
		if (array_key_exists( $key, $row )) {
			$testKey = explode( $oGroup->_splitter_1, $row->$key );
			$row->$key = '';
			foreach ($testKey as $k) {
				if (array_key_exists( $k, $oNewJoinStuff )) {
					$v[] = $oNewJoinStuff[$k]->text;
				}
			}
			$row->$key .= implode("<br />", $v);
		}
	}

	/**
	 * ensures that the joins are only loaded once, and that if two element joins
	 * use the same table, that the join table name is turned into an alias
	 * @param object join to test
	 * @return string new join table name ($oTestJoin->table_join if not updated)
	 */

	function _loadJoinOnce( $oTestJoin ){
		$oTestJoin->table_join_alias = '';
		foreach( $this->_aJoins as $oJoin ){

			if( $oJoin->table_join == $oTestJoin->table_join ){
				if( isset( $oJoin->element_name ) ){
					if( $oJoin->element_name != $oTestJoin->element_name ){
							
						/* a join exists to the same table but for a different element
						 we need to alter the joins 'table_join' value to table_join.element_name to create
						 a unique reference, also this reference needs to then be used by getElementData to look up
						 the correct field

						 example of where this occurs is in a table which has fields 'manager', 'name'
						 which both links to two different users

						 note this joins then get double checked before being appended to the sql query to create the table data
						 */
						$oTestJoin->table_join_alias = $oTestJoin->table_join . '___' . $oTestJoin->element_name;
							
						$this->_aJoins[] = $oTestJoin;
						return $oTestJoin->table_join_alias;
					} else {
						return $oTestJoin->table_join;
					}
				}else{
					return $oTestJoin->table_join;
				}
			}
		}

		// $$$rob check if the join table_join is the same as this table's key
		// this occurs if you have a database join element type that points to its own table
		$return = $oTestJoin->table_join;
		if ($oTestJoin->table_join == $this->db_table_name) {

			$oTestJoin->table_join_alias =  $oTestJoin->table_join . '_' . count($this->_aJoins) ;

			//also at this point the database join element name needs to be updated from "tablename___elementname" to "tablename_1___elementname"
			$return = $oTestJoin->table_join_alias ;

		}
		$this->_aJoins[] = $oTestJoin;
		return $return;
	}

	/**
	 * gets the data associated with the table
	 * @param object pagenav
	 * @return object element data
	 *
	 */

	function getElementData( &$pageNav )
	{
		global $database, $my, $mosConfig_absolute_path;
		$aJoinObjs 		= $this->loadJoins( );
		$params =& $this->loadParams();
		$aJoinObjs 		= $this->_aJoins;

		$aFilters		= $this->getFilterArray( );
		$this->getConnection( );
		$fromModule 	= mosGetParam( $_REQUEST, 'fabrik_frommodule', 0 );
		$sql 			= '';
		$cond 		= '';
		/*used to store list of fields to select (inc order by at end !)*/
		$aFields = array( );

		//store queries used when replacing database join elements in non joined repeating groups
		$innerSQL = array();

		/* contains purely the AS part of the selected elements -
		 need to check this as well as $aFields as order field (if join element ) can cause sql errror
		 */

		$aAsFields 	= array();
		foreach ($this->_oForm->_groups as $oGroup) {
			if ($oGroup->is_join) {
				foreach ($aJoinObjs as $oJoin) {
					if(array_key_exists( 'group_id', $oJoin ) && $oJoin->group_id == $oGroup->id) {
						$table = $oJoin->table_join;
					}
				}
			} else {
				$table = $this->db_table_name;
			}
			foreach ($oGroup->_aElements as $oElement) {
				$elParams = new fabrikParams( $oElement->attribs, $mosConfig_absolute_path.'/administrator/components/com_fabrik/xml/element.xml', 'component');
				if ($this->_outPutFormat == 'rss') {
					$bAddElement = ( $elParams->get( 'show_in_rss_feed' ) == '1' );
					/* if its the date ordering col we should add it to the list of allowed elements */
					$elFullName = $oGroup->getElementFullName( $oElement, $this->_oForm,  true, false );

					if ($elFullName == $params->get( 'feed_date', '' )) {
						$bAddElement = '1';
					}
				} else {
					//$$$ rob - for scroller js code - otherwise it doesnt return all element data
					$bAddElement = !is_null( $this->_tableViewOnly ) ? !$this->_tableViewOnly : $oElement->show_in_table_summary;
				}
				if ($bAddElement) {
					$tmpLabel = "$table.$oElement->element_name";
					$tmpName = "$table.$oElement->element_name";
					// make a simple name
					$csvfullname= $params->get( 'csvfullname', 0 );
					if ($this->_outPutFormat == 'csv') {
						switch ( $csvfullname ){
							case 0:
								$tmpLabel = $oElement->element_name;
								break;
							case 2:
								$tmpLabel = $oElement->element_label;
								break;
						}
					}
					if ($this->_outPutFormat == 'json') {
						$tmpLabel = $table."___".$oElement->element_name;
					}
					/** if we're (simple) joining elements to the same database then do it here*/
					if ($oElement->elementtype_id == "12") {
						$cn =& new fabrikConnection( $database );

						//make sure same connection as this table and that its not an advanced join
						// $$$ hugh - what if it's not a simple join?

						// $$$ rob @since 1.0.6  if its in a repeat group we cant do a simple join
						if ($oElement->join_conn_id == $this->_oConn->id && $elParams->get( 'joinType' ) == 'simple' && !$oGroup->getCanRepeatGroup()) {
							$oJoin 					= new stdClass();
							$oJoin->join_type 		= 'LEFT';
							$oJoin->element_name 	= $oElement->element_name;
							$oJoin->table_join 		= $oElement->join_db_name;
							$oJoin->table_join_key 	= $oElement->join_key_column;

							//if the element is in a joined table then we use that table name
							if ($oGroup->is_join) {
								foreach ($this->_aJoins as $j) {
									if (@$j->group_id == $oGroup->id) {
										$oJoin->join_from_table = $j->table_join;
									}
								}
							} else {
								//otherwise use the default table
								$oJoin->join_from_table = $table;
							}
							$oJoin->table_key 		= $oElement->element_name;
							$joinTableName  =  $this->_loadJoinOnce( $oJoin );
							switch( $this->_outPutFormat ){
								case 'csv':
									$tmpStr = "$joinTableName.$oElement->join_val_column AS `$tmpLabel`" ;
									$tmpAsStr = $tmpName;
									break;
								case 'json':
									$tmpStr = "$joinTableName.$oElement->join_val_column AS `$tmpLabel`" ;
									//use so we can access the pkey value for the dd.
									$tmpStr .= ", $tmpName AS `$tmpLabel" . "___value`" ;
									$tmpAsStr = $tmpName;
									break;
								default:
									$tmpStr = "$joinTableName.$oElement->join_val_column AS `$tmpName`" ;
									//use so we can access the pkey value for the dd.
									$tmpStr .= ", $tmpName AS `$tmpLabel" . "___value`" ;
									$tmpAsStr = $tmpName;
									break;
							}
							$aFields[] 		= $tmpStr;
							$aAsFields[]	= $tmpAsStr;
						} else {
							$aFields[] 		= "$tmpName AS `$tmpLabel`" ;
							$aAsFields[] 	= "$tmpName";
						}

						if ($oElement->join_conn_id == $this->_oConn->id && $elParams->get( 'joinType' ) == 'simple' && $oGroup->getCanRepeatGroup()) {
							$innerSQL[$tmpName] = "SELECT $oElement->join_key_column AS `value`, $oElement->join_val_column AS `label` FROM $oElement->join_db_name WHERE $oElement->join_key_column IN";
						}
					} else{
						$aFields[] 		= "$tmpName AS `$tmpLabel`" ;
						$aAsFields[] 	= "$tmpName";
					}

				}
			}
		}
		if (is_array( $this->_aJoins )) {
			foreach ($this->_aJoins as $oJoin) {
				$testSQL = " " . strtoupper($oJoin->join_type) ." JOIN $oJoin->table_join " ;
				if( array_key_exists('table_join_alias', $oJoin) && $oJoin->table_join_alias != '' ){
					$testSQL .= " AS `" . $oJoin->table_join_alias .
					"` ON " . $oJoin->table_join_alias . ".$oJoin->table_join_key = " .
						"$oJoin->join_from_table.$oJoin->table_key \n ";
				}else{
					$testSQL .=
						" ON $oJoin->table_join.$oJoin->table_join_key = " .
						"$oJoin->join_from_table.$oJoin->table_key \n ";
				}
				if(!strstr($sql, $testSQL)){
					$sql .= $testSQL;
				}
			}
		}
		if (is_array( $aFilters )) {
			foreach ($aFilters as $filter) {
				if (isset( $filter['join_db_name'] ) && $filter['join_db_name'] != '') {

					if (isset( $filter['prewritten_join'] ) && $filter['prewritten_join'] != '') {

						/* used for join elements whose filter is rendered as a field
						 * test the join code hasnt already been added

							NOTE - THIS WAS CAUSING ISSUES WITH POLLEN8 HOSTING ACC PAGE, NOT SURE IF REMOVING IT IS A GOOD IDEA THO!
							$sql .= $filter['prewritten_join'];*/
					} else {
						$sql .= "\n LEFT JOIN " . $filter['join_db_name']  .
						" ON " . $filter['join_db_name']. "." . $filter['join_db_key']. " = " .
						"$this->db_table_name.$this->db_primary_key \n ";
					}

				}
			}
		}

		/* filter the rows based on posted form data
		 * this seems to be duplicating code in getFilterCondition SQL - perhaps its should be refractored
		 */
		$sql .= $this->getSQLWhere();

		/*apply ordering */
		if ($this->_outPutFormat != 'csv') {
			$sql .= $this->orderSQL( $aAsFields );
		}

		/* set the limit data */
		$sql .= " LIMIT " . $pageNav->limitstart . ", " . $pageNav->limit;
		if (empty( $aFields )) {
			$fields = '';
		} else {
			$fields = implode( ", \n ", $aFields ) . ",\n ";
		}

		if (trim( $this->db_primary_key ) != '') {
			/*pkey is now defined as table.col in admin form */
			$pKey =  $this->db_primary_key;
			$strPKey = '';
			if ($this->_outPutFormat != 'csv') {
				$strPKey = $pKey . " AS `" . $this->db_primary_key . "`,\n $pKey AS __pk_val\n";
			} else {
				$fields = rtrim( $fields, ", \n " );
			}
			$query = 'SELECT ' . $fields . $strPKey . " FROM $this->db_table_name \n". $sql;
		} else {
			/* check if its an internal fabrik table */
			if (strstr( $this->db_table_name, 'fabrik_formdata' )) {
				$pKey = 'fabrik_internal_id';
				$this->db_primary_key = $pKey;
				if ($this->_outPutFormat != 'csv') {
					$query = 'SELECT ' . $fields . ' ' . $pKey . " AS `" . $pKey . "`,\n $pKey AS __pk_val\n FROM $this->db_table_name \n". $sql;
				} else {
					$query = 'SELECT ' .  trim($fields, ", \n")  . " FROM $this->db_table_name \n". $sql;
				}
			} else {
				$query = "SELECT " . trim($fields, ", \n")  . "\n FROM $this->db_table_name \n" . $sql;
			}
		}

		$this->_oConnDB->setQuery( $query );
		if (mosGetParam( $_REQUEST, 'fabrikdebug', '0' )) {
			echo $this->_oConnDB->getQuery() . "<br />";
		}

		$res =  $this->_oConnDB->loadObjectList( );
		//append the cursor & total to the data - perhaps move into the sql query - might be faster?
		for ($i=0; $i<count($res); $i++) {
			$res[$i]->fabrik__cursor = $i + $pageNav->limitstart;
			$res[$i]->fabrik__total = $pageNav->total;
		}
		echo  str_replace( '\n', "<br />", $this->_oConnDB->getErrorMsg( ) );

		// $$$ rob since 1.0.6 if database join element in repeat group
		// we have to manually run queries and merge the resulting data with the repeat group values
		foreach ($innerSQL as $key=>$query) {
			$fkeys = array();
			foreach ($res as $row) {
				$fkeys = array_merge( $fkeys, explode( "//..*..//", $row->$key ) );
			}
			array_unique($fkeys);
			//remove empty values
			for ($i=count( $fkeys )-1; $i>0; $i--) {
				if(($fkeys[$i] == '')){
					unset($fkeys[$i]);
				}
			}
			$query .= "  (" .  implode(",", $fkeys) . ")";
			$database->setQuery( $query );
			$innerData = $database->loadObjectList( 'value' );
			for ($i=0; $i<count( $res ); $i++) {
				if ($res[$i]->$key == '') {
					continue;
				}
				$bits = explode("//..*..//", $res[$i]->$key);
				$s = array();
				foreach ($bits as $b) {
					$s[] = @$innerData[$b]->label;
				}
				$res[$i]->$key = implode( "//..*..//",$s );
			}
		}
		return $res;
	}

	/**
	 * build where statement for table sql, using prefilters and filters
	 * @param bol include prefilters (default true) - false for creating filter drop downs
	 * @return string where sql statement
	 */

	function getSQLWhere( $incFilters = true )
	{
		if (!isset( $this->_whereSQL )) {
			$this->_whereSQL = $this->_loadSQLWhere( );
		}
		return $this->_whereSQL[$incFilters];
	}

	/**
	 * @access: private
	 * @param bol include filters
	 * @return array 'where' part of sql statement key 0 is where statement without the filters,
	 * key '1' is the where statement including filters
	 */

	function _loadSQLWhere( $incFilters = true )
	{
		$params =& $this->loadParams();
			
		// $$$ rob new option in the table to block any url or filter options working on the table
		$aFilters	= ($params->get( 'allow-filters', true )) ?  $this->getFilterArray(  ) : array();
			
		if ($this->_togglePreFilters == 0) {
			$aPrefilters = $this->getPrefilterArray( );
		} else {
			$aPrefilters = array();
		}

		$aOrSQL = array( );
		$aFoundOrGroupings = array( );
		$i = 0;

		$aSQLBits = array();
		if (is_array( $aFilters )) {
			/* stores sql for or statements */
			$c = 0;
			foreach ($aFilters as $key=>$val) {
				/*work through or columns first to build sql ( col = val or col = val...)
				 * then remove them from the rest of the array
				 */
				if (isset( $val['aOrCols'] )) {
					$aOrColumns = $val['aOrCols'] ;
					$filterVal =  isset( $val['value'] ) ? $val['value'] : '';
					/* check if we've already performed it elsewhere */
					$done 		= false;
					foreach ($aFoundOrGroupings as $aFoundOrGroupSet) {
						$a = filter_unused( $aFoundOrGroupSet, $aOrColumns );
						if (empty( $a )) {
							$done = true;
						}
					}
					if (!$done) {
						/*
						 * ok we havent processed this group -
						 * lets add it to the groups the we have processed
						 */
						$aFoundOrGroupings[] = $aOrColumns;
						/*
						 *now lets build that query string!
						 */
						$orSql ='(';
						foreach ($aOrColumns as $col) {
							if (strstr( $col, "." )) {
								/* table.column cant be encased in `` */
								$orSql .= "$col = '$filterVal' OR " ;
							} else {
								/* encase in `` to attempt to catch names with spaces in */
								$orSql .= "`$col` = '$filterVal' OR " ;
							}
						}
						$orSql = substr( $orSql, 0, strlen($orSql)-3 ) . ')';
						$aOrSQL[] = $orSql;
					}
					/* ok, even if its been done before we still need to remove it from the filter array */
					unset( $aFilters[$key] );
					$c++;
				}
			}

			foreach ($aFilters as $key=>$val) {
					
				$filterType 			= isset( $val['type'] )  ? $val['type']			: 'dropdown';
				$filterVal 				= isset( $val['value'] ) ? $val['value'] 		: '';
				$filterExactMatch = isset( $val['match'] ) ? $val['match'] 		: '';
				$fullWordsOnly 		= isset( $val['full_words_only'] )? $val['full_words_only'] : '0';

				if (array_key_exists( $key, $aPrefilters )) {
					if (array_key_exists( 'sqlCond' , $aPrefilters[$key] )) {
						$sqlCond = "( " .$val['sqlCond'] . " AND " . $aPrefilters[$key]['sqlCond'] . " )";
					} else {
						//$$$rob used for prefilter and table - "Tables with database join elements linking to this table " pointing to same prefilter opt
						//$sqlCond = "( " .$val['sqlCond'];

						//$$$rob try to override url filter - basically if "no" selected for table's prefilter "Overridden by url filter" option
						// then we need to ignore the url filter when creating this part of the where statement.
						$overridden = true;
						foreach ($aPrefilters[$key] as $tmpC) {
							if($tmpC['override'] == '0'){
								$overridden = false;
							}
						}
						if($overridden){
							$sqlCond = "( " .$val['sqlCond'];
						}else{
							$sqlCond = "( 1=1 ";
						}
						foreach ($aPrefilters[$key] as $tmpC) {

							if( $tmpC['override'] != '1') {
								$sqlCond .= " AND " . $tmpC['sqlCond'];
							}
						}
						$sqlCond .= " )";
					}
					unset( $aPrefilters[$key] );
				} else {
					$sqlCond = @$val['sqlCond'];
				}

				if ($filterVal != "") {
					$aSQLBits[] = " AND ";
					$aSQLBits[] = $sqlCond;
					$i ++;
				}
			}
		}

		//add in any prefiltres not duplicated by filters
		//put them at the beginning of query as well

		$aSQLBits2 = array();
		foreach ($aPrefilters as $key=>$ar) {
			if ($key != '') {
				foreach ($ar as $val) {
					$aSQLBits2[] =  $val['concat'];
					$aSQLBits2[] = $val['sqlCond'];
				}
			}
		}

		// $$$rob work out the where statment minus any filters (so only include prefilters)
		// this is needed to ensure that the filter drop downs contain the correct info.

		$sqlNoFilter = '';
		if (!empty( $aSQLBits2 )) {
			$aSQLBits2[0] = "WHERE";
			$sqlNoFilter .= implode( ' ', $aSQLBits2 );
			if (count( $aOrSQL ) > 0) {
				if (empty( $aSQLBits2 )) {
					$sqlNoFilter .= " WHERE " . implode( ' AND ', $aOrSQL );
				} else {
					$sqlNoFilter .=  ' AND ' . implode( ' AND ', $aOrSQL );
				}
			}
		}

		$sql = '';
		$aSQLBits = array_merge( $aSQLBits2, $aSQLBits );
		if (!empty( $aSQLBits )) {
			$aSQLBits[0] = "WHERE";
			$sql .= implode( ' ', $aSQLBits );
			if (count( $aOrSQL ) > 0) {
				if (empty( $aSQLBits )) {
					$sql .= " WHERE " . implode( ' AND ', $aOrSQL );
				} else {
					$sql .=  ' AND ' . implode( ' AND ', $aOrSQL );
				}
			}
		}
		$r = array( '0'=>$sqlNoFilter, '1'=>$sql );
		return $r;
	}

	/**
	 * get the part of the sql statement that orders the table data
	 * @param array of fields selected in the form - check against this to avoid ordering on recently upublished elements
	 * @return string ordering part of sql statement
	 */

	function orderSQL( $aAsFields )
	{
		global $option, $_SESSION;
		$params =& $this->loadParams();

		$postOrderBy 	= mosGetParam( $_POST, 'orderby', '' );
		$postOrderDir 	= mosGetParam( $_POST, 'orderdir', '' );
		//set any posted changes to odering
		foreach ($aAsFields as $field) {
			if ($postOrderBy == $field) {
				$orderByKey = 'tableOrder{' . $option. '}{' . $this->id . '}{' . $field . '}';
				mosSession::set( $orderByKey, $postOrderDir );
			}
		}
		
		//find out if the default order by's element has a filter as well
		//& build the order by statement from the session
		$useDefault = true;
		$strOrder = '';
		foreach ($this->_oForm->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				$name = $oGroup->getElementFullName( $oElement, $this->_oForm, false, false, false );
				if ($name == $this->order_by) {
					$useDefault = false;
				}
				$orderByKey = 'tableOrder{' . $option. '}{' . $this->id . '}{' . $name . '}';
				$dir = mosSession::get($orderByKey, '');
				if ($dir != '' && $dir != '-') {
					$strOrder == '' ? $strOrder = "\n ORDER BY " : $strOrder .= ',';
					$strOrder .= " `$name` " . $dir;
				}
			}
		}
			
		//if nothing found in session use default ordering
		if ($strOrder == '' && $useDefault) {
			if ($this->order_by != '') {
				$this->order_dir != ''? $dir = $this->order_dir : $dir = 'desc';
				$strOrder = "\n ORDER BY $this->order_by $dir";
			}
		}
		// apply group ordering
		$groupOrderBy = $params->get( 'group_by_order' );
		if ($groupOrderBy != '' && in_array( $groupOrderBy, $aAsFields )) {
			$groupOrderDir = $params->get( 'group_by_order_dir' );
			$strOrder == '' ? $strOrder = "\n ORDER BY " : $strOrder .= ',';
			$strOrder .= " `$groupOrderBy`  $groupOrderDir ";
		}
		return $strOrder;
	}

	/**
	 * creates array of prefilters
	 * @return array prefilter
	 */

	function getPrefilterArray( )
	{
		if (isset( $this->_aPrefilters )) {
			return $this->_aPrefilters;
		}
		$this->_aPrefilters = $this->_loadPrefilters();
		return $this->_aPrefilters;
	}

	/**
	 * force load prefiltres
	 *
	 * @return array prefilter data
	 */

	function _loadPrefilters()
	{
		$params =& $this->loadParams();
		$afilterJoins 		= $params->get( 'filter-join', '', 'array' );
		$afilterFields 		= $params->get( 'filter-fields', '', 'array' );
		$afilterConditions 	= $params->get( 'filter-conditions', '', 'array' );
		$afilterValues 		= $params->get( 'filter-value', '', 'array' );
		$afilterAccess 		= $params->get( 'filter-access', '', 'array' );
		$afilterEval	 	= $params->get( 'filter-eval', '', 'array' );
		$aOverridden			= $params->get( 'filter-override', '', 'array' );
		$appliedPrefilters = 0;
		$selJoin = 'WHERE';
		$aReturn = array();
		for ($i=0;$i<count( $afilterJoins );$i++) {
			if ($afilterJoins[0] <> '') {
				$selJoin 	  = $afilterJoins[$i];
				$selFilter 	  = $afilterFields[$i];
				$selCondition = $afilterConditions[$i];
				$selValue 	  = $afilterValues[$i];
				//$filerEval	  = array_key_exists($i, $afilterEval ) ? $afilterEval[$i] : '';
				$filerEval	  = @$afilterEval[$i] ; // changed from checkbox to radio button
				$override			= @$aOverridden[$i];
				$selValue 	  = $this->parseMessageForPlaceHolder( $selValue );
				if ($filerEval == 'on') {
					$selValue 	= stripslashes( htmlspecialchars_decode( $selValue, ENT_QUOTES ) );
					$selValue 	  = eval($selValue);
				}
				// $$$ hugh - added subquery option for prefilters
				else if ($filerEval == 'subquery') {
					$selValue 	= stripslashes( htmlspecialchars_decode( $selValue, ENT_QUOTES ) );
					$selValue = $this->_replaceWithUserData( $selValue );
					$selValue = $this->_replaceWithGlobals( $selValue );
					if (!preg_match('#^\s*\(.*\)\s*$#',$selValue)) {
						$selValue = '(' . $selValue . ')';
					}
				}
				$selAccess 	  = $afilterAccess[$i];
				if (!$this->mustApplyFilter( $selAccess, $i )) {
					continue;
				}
				switch ($selCondition) {
					// $$$ hugh - added IN conditions
					case 'notin':
						$selCondition = " NOT IN ";
						if (!preg_match('#^\s*\(.*\)\s*$#',$selValue)) {
							$selValue = '(' . $selValue . ')';
						}
						break;
					case 'in':
						$selCondition = " IN ";
						if (!preg_match('#^\s*\(.*\)\s*$#',$selValue)) {
							$selValue = '(' . $selValue . ')';
						}
						break;
					case 'notequals':
						$selCondition = " <> ";
						$selValue = "'$selValue'";
						break;
					case 'equals':
						$selCondition = " = ";
						$selValue = "'$selValue'";
						break;
					case 'begins':
						$selCondition = " LIKE ";
						//if its a quoted string put the % inside the quote
						if ($selValue{0} == '"' || $selValue{0} == '"') {
							$selValue = substr($selValue, 0, -1) . "%" . $selValue{0};
						} else {
							$selValue = "'$selValue%'";
						}
						break;
					case 'ends':
						$selCondition = " LIKE ";
						if ($selValue{0} == '"' || $selValue{0} == '"' ){
							$selValue = $selValue{0} . "%" .  substr($selValue, 0, 1) ;
						} else {
							$selValue = "'%$selValue'";
						}
						break;
					case 'contains':
						$selCondition = " LIKE ";
						if ($selValue{0} == '"' || $selValue{0} == '"' ){
							$selValue = $selValue{0} . "%" .  substr($selValue, 0, 1) ;
						} else {
							$selValue = "'%$selValue%'";
						}
						break;
					case '>':
					case '&gt;':
						$selCondition = ' > ';
						break;
					case '<':
					case '&lt;':
						$selCondition = ' < ';
						break;
				}
					
				if ($selCondition == ' = ' && $selValue == "'_null_'") {
					$strCond = " $selFilter IS NULL ";
				} else {
					$strCond = " $selFilter $selCondition $selValue ";
				}
				//	$override = $override == 1 ? 0 : 1;
				$aReturn[$selFilter][] = array( 'type' => '', 'value' =>$selValue, 'filterVal' => $selValue,  'sqlCond' => $strCond, 'concat' => $selJoin, 'override'=>$override );
				$appliedPrefilters ++;
			}
		}
		return $aReturn;
	}

	/**
	 * DEPRECIATED - USE getPrefilterArray() instead
	 * updates sql statement to include prefilter code
	 * @param string sql to get table data
	 * @param string other conditions that will be applied to the sql after (effects how you build the sql for and/or)
	 * @return string sql to get table data (inc prefilters)
	 */

	function getPrefilterSql( $sql, $cond ){
		$params =& $this->loadParams();
		$afilterJoins 		= $params->get( 'filter-join', '', 'array' );
		$afilterFields 		= $params->get( 'filter-fields', '', 'array' );
		$afilterConditions 	= $params->get( 'filter-conditions', '', 'array' );
		$afilterValues 		= $params->get( 'filter-value', '', 'array' );
		$afilterAccess 		= $params->get( 'filter-access', '', 'array' );

		$appliedPrefilters = 0;
		$prefiltersSQL = '';
		$selJoin = 'WHERE';

		for( $i=0;$i<count( $afilterJoins );$i++ ){
			if($afilterJoins[0] <> ''){
				$selJoin 	  = $afilterJoins[$i];
				$selFilter 	  = $afilterFields[$i];
				$selCondition = $afilterConditions[$i];
				$selValue 	  = $afilterValues[$i];
				$selValue 	  = $this->parseMessageForPlaceHolder($selValue);
				$selAccess 	  = $afilterAccess[$i];
				if( !$this->mustApplyFilter( $selAccess, $i )){
					continue;
				}
				switch( $selCondition ){
					case 'notequals':
						$selCondition = " <> ";
						$selValue = "'$selValue'";
						break;
					case 'equals':
						$selCondition = " = ";
						$selValue = "'$selValue'";
						break;
					case 'begins':
						$selCondition = " LIKE ";
						//if its a quoted string put the % inside the quote
						if($string{0} == '"' || $string{0} == '"'){
							$selValue = substr(0, -1) . "%" . $string{0};
						}else{
							$selValue = "'$selValue%'";
						}
						break;
					case 'ends':
						$selCondition = " LIKE ";
						if($string{0} == '"' || $string{0} == '"'){
							$selValue = $string{0} . "%" .  substr(0, 1) ;
						}else{
							$selValue = "'%$selValue'";
						}
						break;
					case 'contains':
						$selCondition = " LIKE ";
						if($string{0} == '"' || $string{0} == '"'){
							$selValue = $string{0} . "%" .  substr(0, 1) ;
						}else{
							$selValue = "'%$selValue%'";
						}
						break;
					case '>':
					case '&gt;':
						$selCondition = ' > ';
						break;
					case '<':
					case '&lt;':
						$selCondition = ' < ';
						break;
				}
				if( $selJoin == 'WHERE' && ( $i > 0 or $cond != '') ){
					$selJoin = 'AND';
				}
				if( $appliedPrefilters == 0 and $cond == ''  ){
					$selJoin = 'WHERE';
				}
				//make sure we dont duplicate the where statement
				if(stristr($sql, 'WHERE') && $selJoin == 'WHERE'){
					$selJoin = 'AND';
				}
				if( $selCondition == ' = ' && $selValue == "'_null_'"){
					$strCond = " $selFilter IS NULL ";
				} else {
					$strCond = " $selFilter $selCondition $selValue ";
				}
				if( $appliedPrefilters == 0 ){
					$prefiltersSQL .= " \n $selJoin ( $strCond";
				} else {
					$prefiltersSQL .= " \n $selJoin $strCond";
				}
				$appliedPrefilters ++;
			}
		}
		if( $prefiltersSQL != '' ){
			$sql .= " $prefiltersSQL )";
		}
		return $sql;
	}

	/**
	 * gets all filters based on the tableid
	 * @param object form
	 * @return array of element objects that are filters
	 */

	function getTableFilters2( )
	{
		$aFilters = array();
		$form =& $this->getForm();
		$form->getFormGroupsHiarachy();
		foreach ($this->_oForm->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if ($oElement->filter_type <> '' && $oElement->can_filter == '1') {
					$aFilters[] = $oElement;
				}
			}
		}
		return $aFilters;
	}

	/**
	 * creates an array of html code for each filter
	 * @return array of html code for each filter
	 */

	function makeFilters( )
	{
		global $database, $mosConfig_absolute_path, $my, $mainframe, $option, $mosConfig_dbprefix, $mosConfig_lang;
		$table = $this->db_table_name;
		$fabrikDb =& $this->_oConnDB;
		$aFilter = $this->getFilterArray();
		$origTable = $table;
		$aData = $this->getData();
		$aFilters = array();
		$joinStr = '';
		$oGroup = new fabrikGroup( $database );
		$aJoins = $this->loadJoins( );
		foreach ($this->_oForm->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oFilter) {
				if ($oFilter->filter_type <> '' and $oFilter->can_filter == '1') {
					$aUsedJoins = array();
					if ($oFilter->canView()) {
						$params = $oFilter->loadParams();
						/***
						 * ATTENTION!
						 * The filter values WERE using the elements name
						 * We're now using the FULL name (including table name) as of 1.0.3
						 * E.g.
						 *
						 * tablename___elementname
						 *
						 * This is to ensure that filters work on the correct element.

						 */

						$js 				= "";
						$elName 		= rtrim( $oGroup->getElementFullName( $oFilter, $this->_oForm, false, true), "[]");
						$dbElName		= rtrim( $oGroup->getElementFullName( $oFilter, $this->_oForm, false, false), "[]");
						$elLabel 		= $oFilter->element_label;
						$elExactMatch 	= $oFilter->filter_exact_match;
						$v 				= $elName . "[value]";
						$t 				= $elName . "[type]";
						$e 				= $elName . "[match]";
						$jt 			= $elName . "[join_db_name]";
						$jk 			= $elName . "[join_key_column]";
						$jv 			= $elName . "[join_val_column]";
						$origDate 	= $elName . "[filterVal]";
						$fullword 	= $elName . "[full_words_only]";
						$default 		= "";
						if (isset( $aFilter[$elName] )) {
							if (array_key_exists( 'filterVal', $aFilter[$elName] )) {
								$default = $aFilter[$elName]['filterVal'];
							} else {
								$default = $aFilter[$elName]['value'];
							}
						} else {
							if (isset( $aFilter[$oFilter->join_db_name. "." . $oFilter->join_val_column] )) {
								$default = $aFilter[$oFilter->join_db_name. "." . $oFilter->join_val_column]['filterVal'];;
							} else {
								$testKey = '';
								if ($params->get( 'joinType' ) == 'advanced' || $params->get( 'joinType' ) == 'diy') {
									$default = $oFilter->getDefaultAdvancedFilterVal( $aFilter );
								}
							}
						}
						$aThisFilter = array();
							
						//filter the drop downs lists if the table_view_own_details option is on
						//other wise the lists contain data the user should not be able to see
						//ONLY if the label or value of the view_own_details column is the same as the label or key for the drop down
							
						$tmpVal = $oFilter->join_db_name . '.' . $oFilter->join_key_column;
							
						$where = $this->getSQLWhere( false );
						$where .= (stristr( $where, "where" )) ? " AND " : " WHERE ";
						$where .= " TRIM($dbElName) <> '' GROUP BY elText ASC";

						if ($oFilter->elementtype_id == '12' ) {

							/* database join */
							$aUsedJoins 	= array();
							$aJoinedTables 	= array();
							/*
							 * list of all tables that have been joined to -
							 * if duplicated then we need to join using a table alias
							 */
							switch( $params->get( 'joinType' ) ){
								case 'advanced':
									$aAvJoins = $oFilter->getAdvancedJoinsObjs( );
									$val = stripslashes( htmlspecialchars_decode( $params->get( 'advJoin_concat' ), ENT_QUOTES ) );
									$table = $aAvJoins[0]->join_from_table;

									$key = $aAvJoins[0]->table_join_key;

									/*********** test ***/

									$val 		= stripslashes( htmlspecialchars_decode( $params->get( 'advJoin_concat' ), ENT_QUOTES ) );
									$key 		= $params->get('advJoin_key', $table.'.'.$oFilter->element_name );
									$table 		= $params->get('advJoin_startTable', $table);

									/******end *******/

									/**
									 * WARNING - ALL STRINGS THAT GO IN AUSEDJOINS NEED TO BE FORMATTED THE SAME
									 * EEK!
									 */

									$sql = "SELECT DISTINCT($key) AS elVal, CONCAT($val) AS elText \n FROM ";
									$sql .=  $table . "\n";

									foreach( $aAvJoins as $oJoin ){
										$tmpSql = " " . strtoupper($oJoin->join_type) . " JOIN $oJoin->table_join ON $oJoin->join_from_table.$oJoin->table_key = $oJoin->table_join.$oJoin->table_join_key \n";
										if( !in_array($tmpSql, $aUsedJoins ) ){
											$sql .= $tmpSql;
											$aUsedJoins[] = $tmpSql;
											$aJoinedTables[] = $oJoin->table_join;
										}
									}

									$where = $this->getSQLWhere( false );
									$where .= (stristr($where, "where")) ? " AND " : " WHERE ";
									$where .= " TRIM($key) <> '' GROUP BY elText ASC";
									break;
								case 'diy':
									$sql = str_replace('#__', $mosConfig_dbprefix, $params->get( 'advanced-join-sql' ));
									//	try to find the key
									//$pattern = '@^(?:select)?([^as]+)@';
									$pattern = '/select(.*?)as/i';
									$match = preg_match($pattern, strtolower($sql), $matches);
									if($match && count($matches) > 1) {
										$key = $matches[1];
									}
									$where = $this->getSQLWhere( false );
									break;
								default:
									$joinTable 	= $oFilter->join_db_name;
									$joinKey	= $oFilter->join_key_column;
									$joinVal	= $oFilter->join_val_column;

									//Cant use origTable if the filter is in a joined group
									$newTable = $origTable;
									if (strstr( $dbElName, '.' )) {
										$bits = explode('.', $dbElName);
										$newTable = array_shift($bits);
									}

									if ($oGroup->getCanRepeatGroup() && !$oGroup->is_join) {
										//$$$rob have to do a simple query here as there could be data stored as 1//..*..//4
										// @since 1.0.5.3
										$sql = "SELECT DISTINCT( $joinTable.$joinVal ) AS elText, $joinTable.$joinKey AS elVal " .
											"\n FROM $joinTable ";				
									}else{


										if ($table != $joinTable) {
											$sql = "SELECT DISTINCT( $joinTable.$joinVal ) AS elText, $joinTable.$joinKey AS elVal " .
												"\n FROM $newTable " .
										 		"\n LEFT JOIN $joinTable ON $joinTable.$joinKey = $dbElName" ;
											$aUsedJoins[] = $sql;
											$aJoinedTables[] = $joinTable;

										} else {
											/* this is for tables that foreign join to themselves :S hehe */
											$sql = "SELECT DISTINCT( $joinTable.$joinVal ) AS elText, $dbElName AS elVal " .
											"\n FROM $table ";							
										}
									}
									$where = $this->getSQLWhere( false );
									$where .= (stristr($where, "where")) ? " AND " : " WHERE ";
									$where .= " TRIM($joinTable.$joinVal) <> '' GROUP BY elText ASC";
									break;
							}
						} else {

							/* check if the elements group id is on of the table join groups if it is then we swap over the table name*/
							$joinStr = '';
							$fromTable = $origTable;
							foreach ($this->_aJoins as $aJoin) {
								/** not sure why the group id key wasnt found - but put here to remove error **/
								if (array_key_exists( 'group_id', $aJoin )) {
									if ($aJoin->group_id == $oFilter->group_id) {
										$fromTable = $aJoin->table_join;
										$joinStr = " LEFT JOIN $fromTable ON " . $aJoin->table_join . "." . $aJoin->table_join_key . " = " . $aJoin->join_from_table . "." . $aJoin->table_key;
										$joinElName = str_replace( $origTable . '.', $fromTable . '.', $dbElName);
										$where = $this->getSQLWhere( false );
										$where .= (stristr($where, "where")) ? " AND " : " WHERE ";
										$where .= " TRIM($joinElName) <> '' GROUP BY elText ASC";
											
										$v = $fromTable . '___' . $oFilter->element_name . "[value]";
										$t = $fromTable . '___' . $oFilter->element_name . "[type]";
										$e = $fromTable . '___' . $oFilter->element_name . "[match]";
										$fullword = $fromTable . '___' . $oFilter->element_name . "[full_words_only]";
									}
								}
							}
							/* elname should be in format table.key */
							$sql = "SELECT DISTINCT( $dbElName ) AS elText, $dbElName AS elVal FROM $origTable $joinStr\n";
						}
						$sql .= " " . $where;

						$requestName 		= $elName . "___filter";
						$default = '';
						$userStateName 		= trim($elName) . "{" . $option . "}{table}{" . $this->id . "}";
						if (array_key_exists( $elName, $aData )) {
							if (is_array( $aData[$elName] )) {
								$_REQUEST[$requestName] = $aData[$elName]['value'];
								$default = $aData[$elName]['value'];
							}
						}
						$default 			= mosSession::setFromRequest( $userStateName, $requestName, $default );

						switch ($oFilter->filter_type) {
							// $$$ hugh - rmeoved the $js 'onchange' stuff, and added 'filter_element' as a class name.

							// So the onchange stuff is now handled via addEvent code in the table.js.
							// Related note ... also removed the 'onclick' from the template.php's, as that is also
							// handled in table.js with an addEvent.

							// $$$ rob - merged with the same thing i was doing - except using 'fabrikFilter' as the class name (for better consistency with fabrik class
							// naming conventions
							case "dropdown":
								$fabrikDb->setQuery( $sql );
								if (mosGetParam( $_REQUEST, 'fabrikdebug') == 1) {
									echo $fabrikDb->getQuery();
								}
								$oDistinctData = $fabrikDb->loadObjectList( );

								if ($oGroup->getCanRepeatGroup() && !$oGroup->is_join) {
									//$$$rob have to do a simple query here as there could be data stored as 1//..*..//4
									foreach ($oDistinctData as $k => $vv) {
										if (strstr($vv->elVal, '//..*..//')) {
											$vbits = explode( '//..*..//', $vv->elVal );
											$lbits = explode( '//..*..//', $vv->elText );
											for ($jj=0;$jj<count($vbits);$jj++) {
												$o = new stdClass();
												$o->elVal = $vbits[$jj];
												$o->elText = $lbits[$jj];
												$oDistinctData[] = $o;
											}
											unset($oDistinctData[$k]);
										}
									}
									sort($oDistinctData);
								}
								//$$$ rob beta translation of filter dropdowns

								if ( class_exists( 'JoomFish' )) {
									$translateTable = str_replace($mosConfig_dbprefix, '', $oFilter->join_db_name);
									$tableArray["fieldTableAliasData"] =array();
									$tableArray["fieldTableAliasData"][0]["tableName"] = $translateTable;
									$tableArray["fieldTableAliasData"][0]["fieldName"] = $oFilter->join_val_column;
									$tableArray["fieldTableAliasData"][0]["tableNameAlias"] = $translateTable;
									$tableArray["fieldTableAliasData"][0]["fieldNameAlias"] = $this->db_table_name.'.'.$oFilter->element_name;
									$tableArray["fieldCount"] = 1 ;
									$ids = array();
									$vKey = ( $params->get( 'joinType' ) == 'diy' && $oFilter->elementtype_id == '12' ) ? "value"  : "elVal";
									foreach ($oDistinctData as $row) {
										$ids[] = $row->$vKey;
									}
									$ids = array_unique( $ids );
									$translationkey =  $this->db_table_name . '.' . $oFilter->element_name.'___value';
									$translationkey = 'elVal';
									JoomFish::translateListWithIDs( $oDistinctData, trim(implode($ids, ","), ","), $translateTable, $mosConfig_lang, $translationkey, $tableArray);
									$transkey = $this->db_table_name.'.'.$oFilter->element_name;
									foreach( $oDistinctData as $ix=>$vx ){
										$arow =& $oDistinctData[$ix]; //php 4 pass by reference stupidity
										if (array_key_exists( $transkey, $arow )) {
											$arow->elText = $arow->$transkey;
											unset($arow->$transkey);
										}
									}
								}
									
								///end beta translate

								//diy data keys are different - update them
								if ($params->get( 'joinType' ) == 'diy' && $oFilter->elementtype_id == '12') {
									for ($i = 0; $i < count($oDistinctData); $i++) {
										$oDistinctData[$i]->elVal = $oDistinctData[$i]->value;
										$oDistinctData[$i]->elText = $oDistinctData[$i]->text;
									}
								}
								$this->_amendFilterData( &$oFilter, &$oDistinctData );

								$aThisFilter[] = mosHTML::makeOption( '', _PLEASE_SELECT, 'elVal', 'elText' );
								if (is_array( $oDistinctData )) {
									$aThisFilter = array_merge( $aThisFilter, $oDistinctData );
								}
								$aThisFilter = $this->_replaceDdValsWithText( $oFilter, $aThisFilter );
								$aFilters[$elLabel] = mosHTML::selectList($aThisFilter , $v, 'class="inputbox fabrikFilter" size="1" ', "elVal", 'elText', $default);
								break;
									
							case "field":
								if (get_magic_quotes_gpc()) {
									$default			= stripslashes( $default );
								}
								$default = htmlspecialchars( $default );
									
								$aFilters[$elLabel] = "<input type=\"text\" name=\"$v\" value=\"$default\" class=\"inputbox fabrikFilter\"  />";
								if ($oFilter->elementtype_id == '12') {
									$aFilters[$elLabel] .= "\n<input type='hidden' name='$jt' value='" . $oFilter->join_db_name . "'/>";
									$aFilters[$elLabel] .= "\n<input type='hidden' name='$jk' value='" . $oFilter->join_key_column . "'/>";
									$aFilters[$elLabel] .= "\n<input type='hidden' name='$jv' value='" . $oFilter->join_val_column . "'/>";
								}
								break;
									
							case "search":
								break;
								//ROB: DEPRECAITED -use the advance filter code below which is no longer
								// assigned to the element but to the table
							case 'range':
								$fabrikDb->setQuery( $sql );
								$oDistinctData = $fabrikDb->loadObjectList( );
								echo $fabrikDb->getErrorMsg( );
								$aThisFilter[] = mosHTML::makeOption( '', _PLEASE_SELECT, 'elVal', 'elText' );

								if (!is_array( $default )) {
									$default = array( '', '' );
								}

								if (is_array( $oDistinctData )) {
									$aThisFilter = array_merge( $aThisFilter, $oDistinctData );
								}

								$this->_amendFilterData( $oFilter, $aThisFilter );

								//add in searched data to the drop down if it doesnt exist in the table data
								$fromFound = false;
								$toFound = false;
								foreach ($oDistinctData as $pair) {
									if ($default[0] == $pair->elVal) {
										$fromFound = true;
									}
									if ($default[1] == $pair->elVal) {
										$toFound = true;
									}
								}
								if (!$fromFound) {
									$aThisFilter[] = mosHTML::makeOption( $default[0], $default[0], 'elVal', 'elText' );
								}
								if (!$toFound) {
									$aThisFilter[] = mosHTML::makeOption( $default[1], $default[1], 'elVal', 'elText' );
								}

								$aFilters[$elLabel] = _BETWEEN;
								$aFilters[$elLabel] .= mosHTML::selectList( $aThisFilter , $v.'[]', 'class="inputbox fabrikFilter" size="1" '  , "elVal", 'elText', $default[0] );
								$aFilters[$elLabel] .= _AND;
								$aFilters[$elLabel] .= mosHTML::selectList( $aThisFilter , $v.'[]', 'class="inputbox fabrikFilter" size="1" '  , "elVal", 'elText', $default[1] );
								break;
						}
					}
				}
			}
		}

		//new moved advanced filters to table settings

		$params = $this->loadParams();
		if ($params->get( 'advanced-filter', '0' )) {
			$aAllQueries = array( );
			$words = array_key_exists( 'advancedFilterContainer', $aFilter) ? trim($aFilter['advancedFilterContainer']['value']) : "";
			//build aWords keeping quoted strings together
			$aWords  = array();
			$inQuote = false;
			$curWord = '';
			for ($c=0; $c<strlen($words); $c++) {
				$char = $words[$c];
				$curWord .= $char;
				if ($char == '"' || $char == "'") {
					$inQuote = ($inQuote)? false : true;
				} else
				if ($char == " " && !$inQuote) {
					$aWords[] = trim($curWord);
					$curWord = '';
				}
			}
			$aWords[] = $curWord;
			$aQuery = array();
			if (count($aWords) > 1) {
				if (!($aWords[0] == "AND" || $aWords[0] == "OR") ){
					array_unshift($aWords, "AND");
				}
				for ($i=0; $i<count($aWords); $i++) {
					$word = $aWords[$i];
					if ($aWords[$i] == 'like') {
						$firstChar = substr( $aWords[$i + 1], 1, 1 );
						$lastChar =  substr( $aWords[$i + 1], strlen($aWords[$i + 1])-2, 1 );
						if ($firstChar == "%" && $lastChar == "%") {
							$aQuery[] = "CONTAINS";
						}
						if ($firstChar == "%" && $lastChar != "%") {
							$aQuery[] = "ENDS WITH";
						}
						if ($firstChar != "%" && $lastChar == "%") {
							$aQuery[] = "BEGINS WITH";
						}
						$aWords[$i + 1] = str_replace( "%", "", $aWords[$i + 1] );
					}else
					if ($aWords[$i] == ">") {
						$aQuery[$i] = "GREATER THAN";
					} else
					if ($aWords[$i] == "<"){
						$aQuery[] = "LESS THAN";
					} else {
						$aQuery[] = $word;
					}
					if ($i+1 >= count( $aWords ) || ($aWords[$i+1] == "AND" || $aWords[$i+1] == "OR")) {
						$aAllQueries[] = $aQuery;
						$aQuery = array();
					}
				}
			}
			$fieldNames[] = mosHTML::makeOption( '', _PLEASE_SELECT );
			foreach ($this->_oForm->_groups as $oGroup) {
				foreach ($oGroup->_aElements as $oElement) {
					$elName = $oGroup->getElementFullName( $oElement, $this->_oForm, false, false, false );
					$fieldNames[] = mosHTML::makeOption( $elName, $oElement->element_label );
				}
			}
			$fields = mosHTML::selectList( $fieldNames, 'search_key', "class=\"inputbox\"  size=\"1\" ", 'value', 'text', '' );
			$fields = str_replace("\n", "", $fields);
			//todo: make database join elements filtereable on all their join table's fields

			$filterJoinDd = str_replace(array("<br />", "<br>", "\n", "\r"), '', $this->getFilterJoinDd() );
			$filterCondDd = str_replace(array("<br />", "<br>", "\n", "\r"), '', $this->getFilterConditionDd() );
			$aFilters[_ADVANCED_SEARCH] = "<a href='#' id='advancedFiltershow'>" . _ADVANCED_SEARCH . "</a>" .
				"<div class='advancedFilter' style='display:none;background-color:white;border:1px solid black;padding:5px;' id='advancedFilter'>" .
				"<a href='#' onclick='return oSearchManager.addFilterOption(\"advancedFilterTable\");'>" . _ADD . "</a>".
					"<table class='advancedFilterHandle adminlist' id=\"advancedFilterTable\" style=\"width:300px;\">".
				"<tbody></tbody>".
		 		"</table>".
		 	"</div>".
		 	"<script language='JavaScript' type='text/javascript'>" .
					"<!-- \n window.addEvent('load', function(e){
					$('advancedFiltershow').addEvent('click', function(e){
						e = new Event(e);
						$('advancedFilter').toggle();
						oSearchBox.toggle();
						e.stop();
					});
					".
		 			"oSearchBox = new searchBox( \"advancedFilterTable\", \"" . addslashes( $fields ) . "\"";
			//$$$ Rob
			$aFilters[_ADVANCED_SEARCH] .= ", false ";
			$aFilters[_ADVANCED_SEARCH] .= ($this->filter_action != 'submitform') ? ', true' : ', false';
			$aFilters[_ADVANCED_SEARCH] .= ", \"" . ADVANCED_SEARCH . "\"";
			//test not sure if used now
			//$aFilters[$elLabel] .=", \"`$dbElName`\");
			$aFilters[_ADVANCED_SEARCH] .=",{
			filterJoinDd: '$filterJoinDd',
			filterCondDd: '$filterCondDd'
		});
		oSearchManager.addBox( oSearchBox );\n" ;
			
		foreach ($aAllQueries as $aQuery) {
			if ($aQuery[1] != '') {
				$aFilters[_ADVANCED_SEARCH] .= "oSearchBox.addFilterOption('$aQuery[0]', '$aQuery[1]', '$aQuery[2]', $aQuery[3]);\n";
			}
		}
		$aFilters[_ADVANCED_SEARCH] .=
			"});\n".
			"-->".
		 	"</script><input type='hidden' name=\"advancedFilterContainer[value]\" value='' id=\"advancedFilterContainer\" />";
		}
		return $aFilters;
	}

	/**
	 * called from within makeFilter() used to format the dropdown and range labels
	 *
	 */
	function _amendFilterData( &$oFilter, &$aThisFilter )
	{
		$params = $oFilter->loadParams();
		switch( $oFilter->elementtype_id )
		{
			case 3:
			case 6 && $oFilter->multiple == 1:
				$aCheckBoxExplodedData = array( );
				foreach ($aThisFilter as $oPair) {
					$aExpText = explode( ',', $oPair->elText );
					$aExpVal = explode( ',', $oPair->elVal );
					$i = 0;
					foreach ($aExpText as $sepText) {
						$obj = mosHTML::makeOption( $aExpVal[$i], $sepText, 'elVal', 'elText' );
						$i++;
						$add = true;
						foreach ($aCheckBoxExplodedData as $oTest) {
							if ($oTest->elVal == $obj->elVal) {
								$add = false;
								break ;
							}
						}
						if ($add){
							$aCheckBoxExplodedData[] = $obj;
						}
					}
				}
				/* if you want to keep the grouped data then uncomment this line */
				$aThisFilter = array_merge( $aThisFilter, $aCheckBoxExplodedData );
				/* if you simply want the individaul records then uncomment this line */
				$aThisFilter = $aCheckBoxExplodedData;
				break;
			case 11: //date
				$format = $params->get('date_table_format');
				foreach ($aThisFilter as $o) {
					if ($o->elText != '0000-00-00' && $o->elText != '0000-00-00 00:00:00') {
						$o->elText =  date( $format, strtotime( $o->elText ) );
						$o->elVal =  date( $format, strtotime( $o->elVal ) );
					} else {
						$o->elText =  '';
						$o->elVal =  '';
					}
				}
				break;
			case 14: //url
				for ($i=0; $i<count($aThisFilter); $i++) {
					list( $link_text,$link_url ) = explode( '//..*..//',$aThisFilter[$i]->elText );
					$aThisFilter[$i]->elText = $link_url;
				}
				break;
		}
	}

	/**
	 * when making drop down filters, if the element is a drop down then we need to replace element text with the dd text
	 * @param object element which has been set to be a filter
	 * @param array of objects containing filter val/text pairs
	 */

	function _replaceDdValsWithText( &$oFilter, $aThisFilter )
	{
		if ($oFilter->elementtype_id == '6') {
			$aDdText = explode('|',$oFilter->dd_text );
			$aDdValues = explode('|',$oFilter->dd_values );
			$c = count( $aThisFilter );
			for ($y=0; $y<$c; $y++) {
				$oBit  = $aThisFilter[$y];
				$key = array_search( trim($aThisFilter[$y]->elText), $aDdValues );
				if ($key !== false) {
					$aThisFilter[$y]->elText = $aDdText[$key];
				}
			}
		}
		return $aThisFilter;
	}

	/**
	 * replaces the table column names with a safer name - ie removes white
	 * space and none alpha numeric characters
	 */

	function makeSafeTableColumns()
	{
		global $database;
		$oConn = $this->getConnection( );
		$fabrikDatabase = $oConn->loadTableConnectionDB( );
		$sql = "DESCRIBE `$this->db_table_name`";
		$fabrikDatabase->setQuery( $sql );
		$origColNames = $fabrikDatabase->loadObjectList( );
		foreach ($origColNames as $origColName) {
			$colName = $origColName->Field;
			$type = $origColName->Type;
			$newColName = preg_replace("/[^A-Za-z0-9]/", "_", $colName);
			if ($colName != $newColName) {
				$sql = "ALTER TABLE $this->db_table_name CHANGE `$colName` `$newColName` $type";
				$fabrikDatabase->setQuery( $sql );
				if (!$fabrikDatabase->query( )) {
					echo "error for $sql <br>";
				}
			}
		}
	}

	/**
	 * get the tables primary key and if the primary key is auto increment
	 * @return mixed if ok returns array (key, extra, type, name) otherwise
	 * returns false
	 */

	function getPrimaryKeyAndExtra( )
	{
		$db 	=& $this->getDb();
		$sql 	= "DESCRIBE $this->db_table_name";
		$db->setQuery( $sql );
		$origColNames = $db->loadObjectList( );
		foreach ($origColNames as $origColName) {
			$colName = $origColName->Field;
			$key = $origColName->Key;
			$extra = $origColName->Extra;
			$type = $origColName->Type;
			if ($key == "PRI") {
				return array( "key"=>$key, "extra"=>$extra, "type"=>$type, "colname"=>$colName );
			}
		}
		return false;
	}

	/**
	 * adds a primary key to the database table
	 * @param string the column name to make into the primary key
	 * @param bol is the column an auto incrementing number
	 * @param string column type definition (eg varchar(255))
	 */

	function updatePrimaryKey( $fieldName, $autoIncrement, $type = 'int(11)' )
	{
		$db 				=& $this->getDb();
		$aPriKey 		= $this->getPrimaryKeyAndExtra( );
		$shortKey 		= $this->_shortKey( $fieldName );
		if (!$aPriKey) { // no primary key set so we should set it
			$this->_addKey( $fieldName, $autoIncrement, $db, $type );
		} else {
			if ($fieldName !=  $aPriKey['colname'] &&  $fieldName != $shortKey) {
				// primary key already exists so we should drop it
				$this->_dropKey( $aPriKey, $db );
				$this->_addKey( $fieldName, $autoIncrement, $db, $type );
			} else {
				//update the key
				$this->_updateKey( $fieldName, $autoIncrement, $db, $type );
			}
		}
	}

	/**
	 * internal function: update an exisitng key in the table
	 * @param string primary key column name
	 * @param bol is the column auto incrementing
	 * @param object fabrik database object
	 * @param string the primary keys column type
	 */

	function _updateKey( $fieldName, $autoIncrement, &$fabrikDatabase, $type = "INT(11)" ){
		if (strstr( $fieldName, '.' )) {
			$fieldName = array_pop(explode(".", $fieldName));
		}
		$sql = "ALTER TABLE `$this->db_table_name` CHANGE `$fieldName` `$fieldName` $type NOT NULL ";
		/* update primary key */
		if ($autoIncrement) {
			$sql .= " AUTO_INCREMENT";
		}
		$fabrikDatabase->setQuery( $sql );
		if(!$fabrikDatabase->query( )){
			echo $fabrikDatabase->getErrorMsg( );
			exit;
		}
	}

	/**
	 * internal function: add a key to the table
	 * @param string primary key column name
	 * @param bol is the column auto incrementing
	 * @param object fabrik database object
	 * @param string the primary keys column type
	 */

	function _addKey( $fieldName, $autoIncrement, &$fabrikDatabase, $type = "INT(11)" )
	{
		if (strstr( $fieldName, '.' )) {
			$fieldName = array_pop( explode( ".", $fieldName ) );
		}
		$sql = "ALTER TABLE $this->db_table_name ADD PRIMARY KEY ($fieldName)";
		/* add a primary key */
		$fabrikDatabase->setQuery( $sql );
		if (!$fabrikDatabase->query( )) {
			echo $fabrikDatabase->getErrorMsg( );
		} else {
			if ($autoIncrement) {
				$sql = "ALTER TABLE $this->db_table_name CHANGE $fieldName $fieldName $type NOT NULL AUTO_INCREMENT"; //add the autoinc
				$fabrikDatabase->setQuery( $sql );
				if (!$fabrikDatabase->query( )) {
					echo $fabrikDatabase->getErrorMsg( );
					exit;
				}
			}
		}
	}

	/**
	 * internal function: drop the table's key
	 * @param array existing key data
	 * @param object fabrik database object
	 * @return bol true if ke droped
	 */

	function _dropKey( $aPriKey, &$fabrikDatabase )
	{
		$sql = "ALTER TABLE $this->db_table_name CHANGE `" . $aPriKey['colname'] . '` `'. $aPriKey['colname'] . '` '  . $aPriKey['type'] . " NOT NULL";
		/* removes the autoinc */
		$fabrikDatabase->setQuery( $sql );
		if (!$fabrikDatabase->query( )) {
			echo "<br />" . $fabrikDatabase->getErrorMsg();
			return false;
		}
		$sql = "ALTER TABLE $this->db_table_name DROP PRIMARY KEY";
		/* drops the primary key */
		$fabrikDatabase->setQuery( $sql );
		if (!$fabrikDatabase->query( )) {
			echo "<br />" . $fabrikDatabase->getErrorMsg();
			return false;
		}
			
		//$$$ rob ensure that ALL other rows are NOT auto incrementing
		$fabrikDatabase->setQuery( "describe $this->db_table_name" );
		$rows = $fabrikDatabase->loadObjectList();
		foreach ($rows as $row) {
			if ($row->Extra == 'auto_increment') {
				$sql = "ALTER TABLE $this->db_table_name CHANGE `" . $row->Field . '` `'. $row->Field . '` '  . $row->Type . " NOT NULL";
				$fabrikDatabase->setQuery($sql);
				$fabrikDatabase->query();
				if (!$fabrikDatabase->query( )) {
					echo "<br />" . $fabrikDatabase->getErrorMsg();
					return false;
				}
			}
		}
		return true;
	}

	/**
	 * deletes the currently loaded table
	 * @param bol if true then delete form group and elements associated with the table
	 * @return string error message
	 */

	function deleteTable( $delRelated = false )
	{
		global $database;
		$msg = '';
		$db =& $this->getDb();
		if ($delRelated) {
			$oForm = $this->getForm();
			$oForm->getFormGroupsHiarachy( false, false );
			foreach ($oForm->_groups as $oGroup) {
				foreach ($oGroup->_aElements as $oElement){
					$oElement->delete();
				}
				$oGroup->delete();
			}
			$oForm->delete();
		} else {
			//remove references to the table in forms and set them to not record in database
			$database->setQuery( "UPDATE #__fabrik_forms set `record_in_database` = 0, table_id = null WHERE table_id = '$this->id'" );
			$database->query();
		}
		if ($this->id) {
			$database->setQuery( "DELETE FROM #__fabrik_tables WHERE id = '" . $this->id . "'" );
			if (!$database->query( )) {
				$msg = $database->getErrorMsg( ) . "\n";
			}
		}
		return $msg;
	}

	/**
	 * deletes the currently loaded table -- this is wrong !!
	 * @param string key value to delete
	 * @param string key to use (leave empty to default to the table's key)
	 * @return string error message
	 */

	function deleteTableRow( $val, $key = '' ){
		josSpoofCheck();
		if ( $key=='' ) {
			$key = $this->db_primary_key;
			if($key == ''){
				if(strstr( $this->db_table_name, 'fabrik_formdata')){
					$key = 'fabrik_internal_id';
					$this->db_primary_key = $key;
				}
			}
		}
		$msg = "";
		$sql = 	"DELETE FROM " .  $this->db_table_name  . " WHERE " . $key . " = '" . $val . "'";
		$this->_oConnDB->setQuery( $sql );
		if ( !$this->_oConnDB->query( ) ) {
			$msg = $this->_oConnDB->getErrorMsg( ) . "\n";
		}
		return $msg;
	}

	/**
	 * remove all records from the table
	 * @return sting error message
	 */

	function dropData()
	{
		$db =& $this->getDb();
		$msg = '';
		$sql = "DELETE FROM " .  $this->db_table_name;
		$db->setQuery( $sql );
		if (!$db->query( )) {
			$msg = $db->getErrorMsg( ) . "\n";
		}
		return $msg;
	}

	/**
	 * drop the table containing the fabriktables data
		* @return sting error message
		*/

	function drop()
	{
		$db =& $this->getDb();
		$sql = "DROP TABLE IF EXISTS `$this->db_table_name`;";
		$db->setQuery( $sql );
		if (!$db->query( )) {
			$msg = $db->getErrorMsg( ) . "\n";
		}
		return $msg;
	}

	/**
	 *
	 *@return array filters
	 */

	function getFilterArray( )
	{
		if (!isset( $this->_aFilter )) {
			$this->_aFilter = $this->_loadFilterArray( );
		}
		return $this->_aFilter;
	}

	/**
	 * deals with ensuring joins are managed correctly when table is saved
	 * @param array data to update joins with
	 */

	function updateJoins( $aData = null )
	{
		global $database;
		if (is_null( $aData )) {
			$aData = $_POST;
		}
		$oForm 			= $this->getForm();
		$aOldJoins 		= $this->loadJoins( );
		$aOldJoinsToKeep = array( );
		$oJoin 			= new fabrikJoin( $database );
		$joinIds 		= mosGetParam( $aData, 'join_id', array() );
		$joinTypes 		= mosGetParam( $aData, 'join_type', array() );
		$joinTableFrom  = mosGetParam( $aData, 'join_from_table', array() );
		$joinTable 		= mosGetParam( $aData, 'table_join', array() );
		$tableKey		= mosGetParam( $aData, 'table_key', array() );
		$joinTableKey	= mosGetParam( $aData, 'table_join_key', array() );
		$groupIds		= mosGetParam( $aData, 'group_id', array() );
		for ($i = 0;$i < count( $joinTypes );$i++) {
			$existingJoin = false;
			foreach ($aOldJoins as $oOldJoin) {
				if ($joinIds[$i] == $oOldJoin->id) {
					$existingJoin = true;
				}
			}
			if (!$existingJoin) {
				/* new join make the group, group elements and formgroup entries for the join data */
				$aData = array( "label"=>"$joinTable[$i] - [joined to $this->label]" );
				$groupId = $this->createLinkedGroup( $aData, true );
				$oForm->createFormGroup( $groupId );
				$aJoinTable = array( 'db_table_name'=>$joinTable[$i] );
				$this->createLinkedElements( $groupId, $aJoinTable );
				$aJoinData = array(
							'table_id' => $this->id,
							'join_from_table' => "$joinTableFrom[$i]", 
							'table_join' => "$joinTable[$i]",
							'table_join_key' => "$joinTableKey[$i]",
							'table_key' => "$tableKey[$i]",
							'join_type' => "$joinTypes[$i]",
							'group_id' => "$groupId"
				);
				$oJoin = new fabrikJoin( $database );
				$oJoin->bind( $aJoinData );

				$ok = $oJoin->store( );
				echo $database->getErrorMsg( );
			} else {
				/* mark old join as still valid
				 with exisitng joins you can only edit the join type  so data will be the same) */
				$oJoin->load( $joinIds[$i] );
				$oJoin->table_key 		= $tableKey[$i];
				$oJoin->table_join_key 	= $joinTableKey[$i];
				$oJoin->join_type 		= $joinTypes[$i];
				$oJoin->store();
				$aOldJoinsToKeep[] 		= $joinIds[$i];
			}
		}

		/* remove non exisiting joins */
		if (is_array( $aOldJoins )) {
			foreach ($aOldJoins as $oOldJoin) {
				if (!in_array( $oOldJoin->id, $aOldJoinsToKeep )) {
					/* delete join */
					$oJoin->load( $oOldJoin->id );
					$oJoin->deleteAll( $oOldJoin->group_id );
				}
			}
		}
	}

	/**
	 * check to see if a table exists
	 * @param string name of table (ovewrites form_id val to test)
	 * @param object database that contains the table if null then default $database object used
	 * @return boolean false if no table found, true if table found
	 */

	function databaseTableExists( $tableName = null, $fabrikDatabase = null )
	{
		global $database, $mosConfig_dbprefix;
		if ($tableName === '') {
			return false;
		}
		if (is_null($tableName)) {
			$tableName = $this->db_table_name;
		}
		$sql = "SHOW TABLES LIKE '$tableName'";
		/* use the default Joomla database if no table database specified */
		if (is_null( $fabrikDatabase ) || !is_object( $fabrikDatabase )) {
			$fabrikDatabase = $this->getDb();
			// not sure why but this thread in the forum http://fabrikar.com/index.php?option=com_smf&Itemid=9&topic=1028.0
			// people were getting an empty database object - so if this is the case revert to the joomla standard database
			if (is_null( $fabrikDatabase ) || !is_object( $fabrikDatabase )) {
				$fabrikDatabase = $database;
			}
		}
		$fabrikDatabase->setQuery( $sql );
		$total = $fabrikDatabase->loadResult( );
		if ($total == "" || $total != $tableName) {
			return false;
		} else {
			return true;
		}
	}

	/**
	 * Create a table to store the forms' data depending upon what groups are assigned to the form
	 * @param object form
	 * @param string table name - taken from the table oject linked to the form
	 * @param obj tables database object
	 */

	function createFormTable( &$oForm, $dbTableName = null, $tableDatabase = null )
	{
		global $database, $my, $mosConfig_offset;
		if (is_null( $dbTableName )) {
			$dbTableName = $this->db_table_name;
		}
		$sql = "CREATE TABLE $dbTableName ( " ;
		$groupIds = $oForm->getGroups();

		$newElements = array();
		/* create elements for the internal id and time_date fields */
		$oElement = new fabrikElement( $database );
		$oElement->element_name		= "fabrik_internal_id";
		$oElement->element_label	= "id";
		$oElement->elementtype_id 	= '2';
		$oElement->hidden 			= 1;
		$oElement->group_id 		= $groupIds[0];
		$oElement->primary_key		= 1;
		$oElement->auto_increment	= 1;
		$oElement->created 			= mosformatDate(date('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S', - $mosConfig_offset);
		$oElement->created_by 		= $my->id;
		$oElement->created_by_alias = $my->username;
		$oElement->state 			= '1';
		$oElement->show_in_table_summary = '1';
		$oElement->element_width 	= '30';
		$oElement->ordering 		= 0;
		if (!$oElement->store()) {
			echo $oElement->getError();exit;
		}
		$newElements[] = $oElement;
		// $$$ hugh - set db_primary_key and auto_inc
		// $$$ STATUS - provisional
		//$this->db_primary_key = 'fabrik_internal_id';

		//$$$ rob - if possible key needs to contain the table name as well
		if ($dbTableName != '') {
			$this->db_primary_key = $dbTableName . '.' . 'fabrik_internal_id';
		} else {
			$this->db_primary_key =  'fabrik_internal_id';
		}
		//$$$ end rob
		$this->auto_inc = 1;
		// $$$ end hugh

		$oElement = new fabrikElement( $database );
		$oElement->element_name		= "time_date";
		$oElement->element_label	= "time_date";
		$oElement->elementtype_id 	= '2';
		$oElement->hidden 			= 1;
		$oElement->eval				= 1;
		$oElement->default			= "return date('Y-m-d');";
		$oElement->group_id 		= $groupIds[0];
		$oElement->primary_key		= 0;
		$oElement->auto_increment	= 0;
		$oElement->created 			= mosformatDate(date('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S', - $mosConfig_offset);
		$oElement->created_by 		= $my->id;
		$oElement->created_by_alias = $my->username;
		$oElement->state 			= '1';
		$oElement->show_in_table_summary = '1';
		$oElement->element_width 	= '30';
		$oElement->ordering 		= 1;
		if(!$oElement->store()){
			echo $oElement->getError();exit;
		}

		$newElements[] = $oElement;

		$aGroups = $oForm->getFormGroupsHiarachy( false, false );
		if (empty( $aGroups )) {
			//$$$ rob a new form created with no groups selected - ensure that we have the id and date elements created in
			// the database table.
			foreach ($newElements as $oElement) {
				$objname = preg_replace("/[^A-Za-z0-9]/", "_", $oElement->element_name);
				$objtype = $oElement->getFieldDescription();
				if ($objname != "" && !is_null( $objtype )) {
					$sql .= " `$objname` $objtype";
					//$$$rob pk can not be defined as "NULL", must be "NOT NULL"
					if( $objname == 'fabrik_internal_id' ){
						$sql .= " NOT NULL, ";
					} else {
						$sql .= " NULL, ";
					}
				}
			}
		} else {
			$arAddedObj = array();
			//these two should be real elements not hacked in here
			foreach ($aGroups as $oGroup) {
				foreach ($oGroup->_aElements as $obj) {
					/* replace all non alphanumeric characters with _ */
					$objname = preg_replace("/[^A-Za-z0-9]/", "_", $obj->element_name);
					/* any elements that are names the same (eg radio buttons) can not be entered twice into the database */
					if (!in_array( $objname, $arAddedObj )) {
						$arAddedObj[] = $objname;
						$objtype = $obj->getFieldDescription();
						if ($objname != "" && !is_null( $objtype )) {
							$sql .= " `$objname` $objtype";
							//$$$rob pk can not be defined as "NULL", must be "NOT NULL"
							if ($objname == 'fabrik_internal_id') {
								$sql .= " NOT NULL, ";
							} else {
								$sql .= " NULL, ";
							}
						}
					}
				}
			}
		}
		$sql .= "  primary key (fabrik_internal_id))";
		$database->setQuery( $sql );

		if (!$database->query()) {
			echo $database->getErrorMsg();
			exit;
		}
		//ensure the key is autoincrementing
		$this->_updateKey( 'fabrik_internal_id', true, $database );
	}

	/**
	 * Alter the forms' data collection table when the forms' groups and/or
	 * elements are altered
	 * @param object form
	 * @param string table name
	 * @param object database connection object
	 */

	function ammendTable( &$oForm, $tableName = null, $tableDatabase = null )
	{
		global $database, $my, $mosConfig_dbprefix;
		$ammend 		= false;
		if (is_null( $tableName )) {
			$tableName = $this->db_table_name;
		}
		if (is_null( $tableDatabase ) || !is_object( $tableDatabase )) {
			$tableDatabase 	=& $this->getDb();
		}
		$dbdescriptions = $this->_loadDBFields( $tableName );
		//@TODO: test (was strtolower($dbdescription->Field))  if this is going to cause issues, think fields should be case insenitvely compared as some joomla core fields are mixed case
		// $$$ hugh - reinstated the strtolower() as non-Fabrik created tables with mixed case are
		// blowing up when it tries to re-add column 'foo' to a table with 'Foo' in it.
		foreach ($dbdescriptions as $dbdescription) {
			$exitingfields[] = strtolower($dbdescription->Field);
		}
		$lastfield = $exitingfields[count($exitingfields)-1];
		$sql = "ALTER TABLE $tableName " ;
		if (!isset( $_POST['current_groups_str'] )) {
			/* get a list of groups used by the form */
			$groupsql = "SELECT group_id FROM #__fabrik_formgroup WHERE form_id = '" . $oForm->id . "'";
			$database->setQuery( $groupsql );
			$groups = $database->loadObjectList( );
			echo $database->getErrorMsg( );
			$arGroups = array( );
			foreach ($groups as $g) {
				$arGroups[] = $g->group_id;
			}
		} else {
			$current_groups_str = $_POST['current_groups_str'];
			$arGroups = explode( ",", $current_groups_str );
		}
		$arAddedObj = array();
		foreach ($arGroups as $group_id) {
			$oGroup = new fabrikGroup( $database );
			$oGroup->load( $group_id );
			if ($oGroup->is_join == '0') {
				$elements = $oGroup->getMyElements();
				foreach ($elements as $obj) {
					$objname = preg_replace( "/[^A-Za-z0-9]/", "_", $obj->element_name );
					/* replace all non alphanumeric characters with _*/
					// $$$ hugh - remember we converted $exitingfields to lower case
					if (!in_array( strtolower($objname), $exitingfields )) {
						/* make sure that the object is not already in the table*/
						// $$$ hugh - note to self!  don't strtolower this test!!
						if (!in_array( $objname, $arAddedObj )) {
							/* any elements that are names the same (eg radio buttons) can not be entered twice into the database*/
							$arAddedObj[] 	= $objname;
							$objtypeid 		= $obj->elementtype_id;
							$objtype 		= $obj->getFieldDescription();
							if ($objname != "" && !is_null( $objtype )) {
								$ammend = true;
								$sql .= ", ADD COLUMN `$objname` $objtype null AFTER `$lastfield`";
							}
						}
					}
				}
			}
		}
		if ($ammend) {
			$tableDatabase->setQuery( $sql );
			if (!$tableDatabase->query( )) {
				echo $tableDatabase->getErrorMsg();
				exit;
			}
		}
	}

	/**
	 * load the tables joins
	 * @return array join objects
	 */

	function loadJoins( )
	{
		global $database;
		if (!isset( $this->_aJoins )) {
			$sql = "SELECT * FROM #__fabrik_joins WHERE table_id = '$this->id' ORDER BY id";
			$database->setQuery( $sql );
			$this->_aJoins = $database->loadObjectList( );
			echo $database->getErrorMsg( );
		}
		return $this->_aJoins;
	}

	/**
	 * when form saved (and set to record in database)
	 * this is run to see if there is any table join data, if there is it stores it in $this->_joinsToProcess
	 * @return array [joinid] = array(join, group array);
	 */

	function preProcessJoin( )
	{
		global $database;
		$this->_joinsToProcess = array( );
		$oForm = $this->getForm( );
		if (!is_array( $oForm->_groups )) {
			$oForm->getFormGroupsHiarachy( );
		}
		$aJoinGroups = array( );
		foreach ($oForm->_groups as $oGroup) {
			if ($oGroup->is_join) {
				$oJoin = new fabrikJoin( $database );
				$oJoin->loadFromGroupId( $oGroup->id, $this->id );
				if (!array_key_exists( $oJoin->id, $aJoinGroups )) {
					$aJoinGroups[$oJoin->id] =array( "join"=>$oJoin, "groups"=>array($oGroup) );
				} else {
					$aJoinGroups[$oJoin->id]["groups"][] = $oGroup;
				}
			}
		}
		return $aJoinGroups;
	}

	/**
	 * strip the table names from the front of the key
	 * @param array data to strip
	 * @return array stripped data
	 */

	function removeTableNameFromSaveData( $data, $split='___' )
	{
		foreach ($data as $key=>$val) {
			$akey = explode( $split, $key );
			if (count( $akey ) > 1) {
				$newKey = $akey[1];
				unset( $data[$key] );
			} else {
				$newKey = $akey[0];
			}
			$data[$newKey] = $val;
		}
		return $data;
	}

	/**
	 * saves posted form data into a table, you can supply table name etc to override the objects
	 * variables, this is needed to allow form class to use this object to save to a database table
	 * that doesnt have a table view associated with it
	 * @param array data to save
	 * @param int row id to edit/updated
	 * @param bol is the data being saved into a join table
	 * @param string table name (optional - if not supplied uses the objects db_table_name
	 * @return bol true if saved ok
	 */

	function storeRow( $data, $rowId, $isJoin = false, $table = null )
	{
		global $mosConfig_live_site, $database;
		//dont save a record if no data collected
		//$data['dontUpdateFields'] = (isset($data['dontUpdateFields'])) ? $data['dontUpdateFields'] : '';
		if ($isJoin && empty( $data )) {
			return;
		}
		$fabrikDb 	=& $this->getDb();
		if (is_null( $table )) {
			$table 	= $this->db_table_name;
		}

		$this->getForm();
		if ($isJoin) {
			$this->getFormGroupElementData( null, true, false );
		}

		if (strstr( $this->db_table_name, 'fabrik_formdata')) {
			$pKey = 'fabrik_internal_id';
			$this->db_primary_key = $pKey;
		}
		//try to create an object with keys created bu empty data and an array with data
		//bound afterwards using mosBindArrayToObject();
		$oRecord = new stdClass();
		$aBindData = array();
		foreach ($data as $key => $val) {
			if ($this->_oForm->hasElement( $key )) {
				$oElement = $this->_oForm->_currentElement;
				if (!in_array( $key, $this->_reservedWords ) and substr( $key, 0, 4 ) != "mce_") {
					$fullKey = $this->_oForm->getTableName() . $this->_oForm->_joinTableElementStep . $key;
					if (is_array( $val )) {
						if (isset( $_FILES[$fullKey] )) {
							$ul_dir = $oElement->ul_directory;
							// if the array is from a file upload we need to add the file path and name to the database
							if (is_array( $_FILES[$fullKey]['name'] )) {
								$val = '';
								foreach ($_FILES[$fullKey]['name'] as $f) {
									if ($f != '') {
										$val .= $mosConfig_live_site  . str_replace("//", "/", '/' . $ul_dir . '/' . $f ) ;
									}
								}
							} else {
								if ($_FILES[$fullKey]['name'] != '') {
									$val = $mosConfig_live_site  . str_replace("//", "/", '/' . $ul_dir . '/' . $_FILES[$fullKey]['name'] ) ;
								} else {
									// $$$ hugh - if no new uploaded file, lets just skip this
									// $$$ element, leave any existing data untouched.
									// $val = null;
									continue;
								}
							}
						} else {
							if (isset( $val['delimiter'] )) {
								$delimiter = $val['delimiter'] ;
								// if a delimiter passed in the array use that rather than the comma (used for URLS elements)
								unset( $val['delimiter'] );
							} else {
								$delimiter = ",";
							}
							// check if its in a repeat group
							if (array_key_exists( "fabrik_repeat_group_{$oElement->group_id}_counter", $data )){
								reset($this->_oForm->_groups);
								$oGroup = current($this->_oForm->_groups);
								$delimiter = $oGroup->_splitter_1;
							}
							if (is_array( $val[0] )) {
								//radios / checkboxes in repeated groups
								$tmpval  = '';
								foreach ($val as $v) {
									$tmpval  .= implode($delimiter, $v). $delimiter;
								}
								$val = rtrim( $tmpval, $delimiter );
							} else {
								$val  = implode($delimiter, $val);
							}
						}
					}

					$oRecord->$key = '';
					if ($oElement->password == 1 && $rowId == '') {
						$val = md5($val);
					}
					$aBindData[$key] = $val;
				}
			}
		}
		$this->_addDefaultDataFromRO( $aBindData, $oRecord );

		$key 			= $this->_shortKey();
		mosBindArrayToObject( $aBindData, $oRecord );

		$oRecord->$key 	= $rowId;
		if ( $rowId == '') {
			$ok = $fabrikDb->insertObject( $this->db_table_name, $oRecord, $key, false );
		} else {
			$ok = $fabrikDb->updateObject( $this->db_table_name, $oRecord, $key, true );
		}

		$this->_tmpSQL = $fabrikDb->getQuery();
		if (!$ok) {
			echo $fabrikDb->getErrorMsg();
			return false;
		} else {
			if ($rowId == '') {
				$this->_lastInsertId = $fabrikDb->insertid() ;
			} else {
				$this->_lastInsertId = $rowId ;
			}
			return true;
		}
	}

	/**
	 * If an element is set to readonly, and has a default value selected then insert this
	 * data into the array that is to be bound to the table record
	 * @since 1.0.6
	 * @param array data
	 * @param object to bind to table row
	 */

	function _addDefaultDataFromRO( &$data, &$oRecord )
	{

		// $$$ rob since 1.0.6 : 10 June 08
		// get the current record - not that which was posted
		$pkv = $data[$this->_shortKey($this->db_primary_key)];
		$sql = $this->_oForm->_buildQuery( $this->id, $pkv );
		$db =& $this->getDb();
		$db->setQuery($sql);
		$db->loadObject($origdata);
		$origdata= mosObjectToArray($origdata);

		//
		$form =& $this->getForm();
		foreach  ($form->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if (!$oElement->canUse() && $oElement->canView()) {
					$key = $oElement->element_name;
					if(!array_key_exists($key, $data)){
						$default 		= $oGroup->getElementDefaultValue( $oElement, $origdata, $form, false, 0 );
						$data[$key] = $default;
						$oRecord->$key = '';
					}
				}
			}
		}

		//check crypted querystring vars (encrypted in form/view.html.php ) _cryptQueryString
		if (array_key_exists( 'fabrik_vars', $_REQUEST ) && array_key_exists( 'querystring', $_REQUEST['fabrik_vars'] )) {
			global $mosConfig_absolute_path, $mosConfig_secret;
			require_once $mosConfig_absolute_path . '/components/com_fabrik/libs/blowfish.php';

			// crypt - one-way encryption
			$cipher_key = crypt( $form->id . $form->_table->id , $mosConfig_secret );

			//$bf = new Crypt_Blowfish('ecb');
			//$bf->setKey( $cipher_key );
			$bf = Crypt_Blowfish::factory( 'ecb', $cipher_key );

			foreach ($_REQUEST['fabrik_vars']['querystring'] as $key => $encrypted) {
				$key = str_replace( $form->_table->db_table_name . "___", "", $key );
				foreach  ($form->_groups as $oGroup) {
					foreach ($oGroup->_aElements as $oElement) {
						if ($oElement->element_name == $key) {
							//dont overwrite if something has been entered
							if (!$oElement->canUse() && $oElement->canView()) {
								//only decrypt if we actually managed to create a blowfish object
								if (!PEAR::isError($bf)) {
									$data[$key] = $bf->decrypt( $encrypted );
								}else{
									$data[$key] = $encrypted;
								}
							}
						}
					}
				}
			}
		}
	}

	/**
	 * get the short version of the primary key, e.g if key = table.key return "key"
	 *
	 * @param string key if not set uses objects primarykey
	 * @return string short version of the primary key
	 */

	function _shortKey( $key = null ){
		if(is_null($key)){
			$key = $this->db_primary_key;
		}
		if(strstr( $key, "." ) ){
			$bits = explode(".", $key);
			return array_pop($bits);
		}else{
			return $key;
		}
	}

	/**
	 * create a group
	 * used when creating a fabrik table from an existing db table
	 * @param array table data
	 * @param bol is a join (true) default (false)
	 * @return int group id
	 */

	function createLinkedGroup( $tableData, $isJoin = false ) {
		global $database, $my, $mosConfig_offset, $mosConfig_absolute_path, $_VERSION;
		require_once( $mosConfig_absolute_path . "/administrator/components/com_fabrik/admin.fabrik.groups.php");
		$oGroup = new fabrikGroup( $database );
		$oGroup->group_name 		=  $tableData['label'];
		$oGroup->group_title 		=  $tableData['label'];
		$oGroup->created 			= mosformatDate(date('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S', - $mosConfig_offset);
		$oGroup->created_by 		= $my->id;
		$oGroup->state 				= 1;
		$oGroup->created_by_alias 	= $my->username;
		$oGroup->is_join = ( $isJoin ) ? 1 : 0;
		$oGroup->store( );
		$groupId = $database->insertid( );
		if($_VERSION->PRODUCT != 'Joomla!'){
			//mambo insertid() deosnt work!
			$sql = "select MAX(id) from #__fabrik_groups";
			$database->setQuery($sql);
			$groupId = $database->loadResult();
		}
		return $groupId;
	}

	/**
	 * when saving a table that links to a database for the first time we
	 * need to create all the elements based on the database table fields and their
	 * column type
	 * @param int group id
	 * @param array newly created table data
	 * @param array of element objects - if this is not empty then we've come from the csv import and the elements
	 * have already been defined, use this instead of the field analysis to create correctly typed elements
	 *
	 */


	function createLinkedElements( $groupId, $aTableData, $aSpecificElements = array() ) {
		global $database, $my, $mosConfig_offset, $mosConfig_absolute_path;
		require_once ( $mosConfig_absolute_path . "/administrator/components/com_fabrik/admin.fabrik.elements.php" );
		$this->getConnection( );
		$fabrikDb = $this->_oConnDB;
		$fields = $fabrikDb->getTableFields( array ($aTableData['db_table_name']) );
		$fields = $fields[$aTableData['db_table_name']];
		if(!empty($aSpecificElements)){
			foreach($aSpecificElements as $oElement){
				if( $oElement->element_label == 'id' ){
					$oElement->hidden = '1';
					$oElement->primary_key = '1';
					$oElement->auto_increment = '1';
				}else{
					$oElement->hidden = '0';
				}
				$oElement->element_name = str_replace(' ', '_', $oElement->element_label );
				$oElement->group_id = $groupId;
				$oElement->created = mosformatDate(date('%Y-%m-%d %H:%M:%S'));
				$oElement->created_by = $my->id;
				$oElement->created_by_alias = $my->username;
				$oElement->state = '1';
				$oElement->show_in_table_summary = '1';
				$oElement->element_width = '30';
				$oElement->element_height = '10';
				$oElement->ordering = 99999;
				$oElement->store( );
				$where = " group_id = '" . $oElement->group_id . "'";
				$oElement->updateOrder( $where );
			}
		}else{
			$ordering = 0;
			foreach ( $fields as $label => $type ) {
				$oElement = new fabrikElement( $database );
				$aData['element_label'] = str_replace( "_", " ", $label );
				switch ( $type ) {
					case "int" :
					case "tinyint" :
					case "varchar" :
						$element_type_id = '2';
						break;
					case "text" :
					case "tinytext" :
					case "mediumtext" :
					case "longtext" :
						$element_type_id = '5';
						break;
					case "datetime" :
					case "date" :
					case "time" :
					case "timestamp" :
						$element_type_id = '11';
						break;
					default :
						$element_type_id = '2';
						break;

				}
				$aData['elementtype_id'] = $element_type_id;
				if( $aData['element_label'] == 'id' ){
					$aData['hidden'] = '1';
				}else{
					$aData['hidden'] = '0';
				}
				$aData['group_id'] = $groupId;
				$aData['element_name'] = $label;
				$aData['created'] = mosformatDate(date('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S', - $mosConfig_offset);
				$aData['created_by'] = $my->id;
				$aData['created_by_alias'] = $my->username;
				$aData['state'] = '1';
				$aData['show_in_table_summary'] = '1';
				$aData['element_width'] = '30';
				$aData['element_height'] = '10';
				$aData['maxlength'] = '255';
				$aData['ordering'] = $ordering;
				$oElement = new fabrikElement( $database );
				$oElement->bind( $aData );
				$oElement->store( );
				$ordering ++;
			}
		}
	}

	/**
	 * get all table objects
	 * @return array of table objects
	 */

	function getAllTables( ){
		global $database;
		$sql = "SELECT * FROM #__fabrik_tables ";
		$database->setQuery( $sql );
		return $database->loadObjectList( );
	}

	/**
	 * if not loaded this loads in the table's form object
	 * @return object form
	 */

	function getForm(){
		if ( is_null( $this->_oForm ) ){
			$this->_oForm = new fabrikForm( $this->_db );
			$this->_oForm->load( $this->form_id );
		}
		return $this->_oForm;
	}


	/**
	 * load in the elements for the table's form
	 * If no form loaded for the table object then one is loaded
	 * @param bol if true only those elements marked as 'show_in_table_view' are returned (leave null for default admin behaviour)
	 * @param bol if true only those elements that are published are returned
	 * @param bol if true load element validations (default true)
	 * @return array element objects
	 */

	function getFormGroupElementData( $tableViewOnly = null, $excludeUnpublished = true, $loadValidations = true ){
		$this->getForm( );
		if (is_null( $tableViewOnly )) {

			if (!is_null( $this->_tableViewOnly )){
				$tableViewOnly = $this->_tableViewOnly;
			} else {
				if ($this->_admin) {
					$tableViewOnly = true;
				} else {
					$tableViewOnly = false;
				}
			}
		}
		return $this->_oForm->getFormGroupsHiarachy( $tableViewOnly, $excludeUnpublished, $loadValidations );
	}

	/**
	 * @return array of element objects that are database joins and that
	 * use this table's key as their foregin key
	 *
	 */

	function &getJoinsToThisKey(  )
	{
		global $database;
		if (is_null( $this->_joinsToThisKey )) {
			$sql = "SELECT *, t.label AS tablelabel FROM #__fabrik_elements AS el " .
		  			"LEFT JOIN #__fabrik_formgroup AS fg 
					ON fg.group_id = el.group_id 
					LEFT JOIN #__fabrik_forms AS f 
					ON f.id = fg.form_id 
					LEFT JOIN #__fabrik_tables AS t 
					ON t.form_id = f.id " .
		  			"WHERE " . 
		  			" elementtype_id = '12' AND" .
		  			" join_db_name = '" . $this->db_table_name . "' " .
		  			"AND join_conn_id = '" . $this->connection_id . "' ";

			$database->setQuery( $sql );
			$this->_joinsToThisKey = $database->loadObjectList( );

		}
		return $this->_joinsToThisKey;
	}

	/**
	 * NOTE: this should be refractured into the element class, so each element type deals with its
	 * rendering
	 *
	 * go through each element and see if it has a folder icon assigned to it
	 * then swap any matching text in the row's field with this icon
	 * Also check any image elements and if there "show_image_in_table" param = yes then replace the file
	 * path with the uploaded image
	 * NOT run in JSON mode
	 * @param array row data
	 * @param object form
	 * @return array element data objects
	 */

	function replaceDataWithIcons( $elementData, &$oForm ){
		global $my, $database, $mosConfig_absolute_path, $mosConfig_live_site, $fabrikConfig;
		if ( is_array( $oForm->_groups ) && $this->_outPutFormat != 'json' ){
			$params =& $this->loadParams();
			foreach( $oForm->_groups as $oGroup ){
				foreach( $oGroup->_aElements as $oElement ){
					$attribs =& new mosParameters( $oElement->attribs );
					if( ($oElement->show_in_table_summary || $attribs->get('show_in_rss_feed', 0) == 1) ){
						$iconFolder = $attribs->get('icon_folder', '');
						if ( $iconFolder != ''  and $this->_outPutFormat != 'csv'){
							for( $i=0; $i < count( $elementData ); $i++ ){
								$data = $elementData[$i];
								$elName = $oGroup->getElementFullName($oElement, $oForm, false, false);
								if( isset( $data->$elName )){
									$elData = $data->$elName;
									$file = $mosConfig_absolute_path . '/images/stories/' . $iconFolder . '/' .$elData . '.png';
									if ( file_exists( $file ) ){
										$imageTemplateName = $elName . "_img" ;
										$elementData[$i]->$imageTemplateName = "<img src=\"images/stories/$iconFolder/$elData.png\" alt=\"$elData\" />";
										// $$$ hugh - need to set just the $elName as well, otherwise icon doesn't
										// get displayed in non-Image elements (which are the only ones that us the _img postfix)
										// hmmm ... can't do it here
										//$elementData[$i]->$elName = "<img src=\"images/stories/$iconFolder/$elData.png\" alt=\"$elData\" />";
									}
								}
							}
						}
						/** format dates **/
						if ($oElement->elementtype_id == '11') {
							$format = $attribs->get('date_table_format', 'Y-m-d');
							if ($this->_outPutFormat == 'csv') {
								$csvfullname = $params->get( 'csvfullname', 0 );
								switch ($csvfullname) {
									case 0:
										$elName = $oElement->element_name;
										break;
									case 1:
										$elName = str_replace('[]', '', $oGroup->getElementFullName($oElement, $oForm, false, false));
										break;
									case 2:
										$elName = $oElement->element_label;
										break;
								}
							}
							else
							{
								$elName = $oGroup->getElementFullName( $oElement, $oForm, false, false, false );
							}
							for ($i=0; $i < count( $elementData ); $i++) {
								$data = $elementData[$i];
								if (isset( $data->$elName ) && $data->$elName != '0000-00-00' && $data->$elName != '0000-00-00 00:00:00') {
									$elementData[$i]->$elName =  date( $format, strtotime($data->$elName ));
								} else {
									$elementData[$i]->$elName =  '';
								}
							}
						}
						/**
						 * replace image element with image if set
						 */
						if ($oElement->elementtype_id == '9' and $this->_outPutFormat != 'csv') {

							if ($attribs->get( 'show_image_in_table', 0 )) {
								$elName = $oGroup->getElementFullName( $oElement, $oForm, false, false, false );
								for ($i=0; $i < count( $elementData ); $i++) {
									$data = $elementData[$i];
									if (!empty( $data->$elName )) {
										$absFile = $data->$elName;
										$absFile = str_replace('\\', '/' , $absFile);
										$file = $mosConfig_live_site . '/images/stories/' . $attribs->get('selectImage_root_folder') . '/' . $absFile;
										// $$$ hugh - slimbox stuff
										// don't create lightbox link if they want the image to link to the form
										if ($oElement->link_to_detail != 1) {
											// This wierd bit of code basically looks to see if there is a file of the same name,
											// one directory level up.  If so, it will assume that the selected image was a thumbnail,
											// that the file one level up is the full size image, and create a lightbox link.
											// TODO check for some obvious thumb_ type prefix.
											// TODO constrain to within root dir
											$src_dir = $mosConfig_absolute_path . '/images/stories/' . $attribs->get('selectImage_root_folder') . '/' . $absFile;
											$src_dir = preg_replace('#//#','/',$src_dir);
											$src_dir_array = explode('/',$src_dir);
											$src_fname = array_pop($src_dir_array);
											array_pop($src_dir_array);
											array_push($src_dir_array,$src_fname);
											$maybe_src = implode('/',$src_dir_array);
											if (file_exists( $maybe_src )) {
												$maybe_link = str_replace( $mosConfig_absolute_path, $mosConfig_live_site, $maybe_src );
												if ($fabrikConfig->fbConf_use_highslide) {
													$str = '<a href="' . $maybe_link . '" class="highslide" onclick="return hs.expand(this)">';
												}
												else {
													$str = '<a href="' . $maybe_link . '" rel="lightbox[]">';
												}
												$str .= "<img src=\"$file\" alt=\"$oElement->element_label\" />";
												$str .= '</a>' . "\n";
											}
											else {
												$str = "<img src=\"$file\" alt=\"$oElement->element_label\" />";
											}
										}
										else {
											$str = "<img src=\"$file\" alt=\"$oElement->element_label\" />";
										}
										$elementData[$i]->$elName = $str;
										// $$$ end hugh
									}
								}
							}
						}
						/**
						 * check for sprintf option on fields
						 */
						if  ($oElement->elementtype_id == '2' ) {
							$format = $attribs->get( 'text_format_string' );
							$elName = $oGroup->getElementFullName( $oElement, $oForm, false, false, false );
							if ( $format  != '') {
								for( $i=0; $i < count( $elementData ); $i++ ){
									$data = $elementData[$i];
									if( isset( $data->$elName ) ){
										$elementData[$i]->$elName =sprintf( $format, $elementData[$i]->$elName );
										//$elementData[$i]->$elName =number_format( $elementData[$i]->$elName, 2, ',', ' ' );
									}
								}
							}
						}
						/**
						 * replace upload files with image if set
						 */
						if( $oElement->elementtype_id == '8'  and $this->_outPutFormat != 'csv'){
							if( $attribs->get( 'show_image', 0 ) ){
								$elName =& $oGroup->getElementFullName( $oElement, $oForm, false, false, false );
								for( $i=0; $i < count( $elementData ); $i++ ){
									$data = $elementData[$i];
									// $$$ hugh - slimbox stuff
									$str = '';
									if( !empty( $data->$elName ) ){
										$absFile = $data->$elName;
										if( !strstr( $absFile, 'http://' ) ){
											$absFile = str_replace('\\', '/' , $absFile);
											if( !strstr( $absFile, $mosConfig_absolute_path ) ){
												$absFile = $mosConfig_absolute_path . '/' . $oElement->ul_directory . '/' . $data->$elName;
											}
											$file = str_replace( $mosConfig_absolute_path, $mosConfig_live_site, $absFile );
											$str = "<img src=\"$file\" alt=\"$oElement->element_label\" />";
										}else{
											//hmm absfile is actually a url - lets find the absolute path as well then
											$file = $absFile;
											$absFile = str_replace( $mosConfig_live_site, $mosConfig_absolute_path, $absFile );
											$str = "<img src=\"$file\" alt=\"$oElement->element_label\" />";
										}

										if( $attribs->get( 'make_thumbnail' )  == '1' ){
											$ofile		= $file;
											$ulDir 		= trim( $oElement->ul_directory, "/" );
											$thumbDir 	= trim( $attribs->get('thumb_dir'), "/" );
											$file 		= str_replace( $ulDir, $thumbDir, $file );
											$file 		= dirname($file) . '/' . $attribs->get('thumb_prefix') . basename($file);
											$absThumb = str_replace( $mosConfig_live_site, $mosConfig_absolute_path, $file );
											$absThumbRel = str_replace( $mosConfig_absolute_path, '', dirname($absThumb) );
											$absThumbDir = dirname($absThumb);
											if (!file_exists($absThumbDir)) {
												if (empty($oUpload)) {
													$oUploader =& new uploader($oForm);
												}
												$oUploader->_makeRecursiveFolders( $absThumbRel );
											}
											// $$$ hugh
											// testing creating thumb on the fly if it doesn't exist, useful if they
											// added thumbs after already uploading images.
											if (file_exists($absThumbDir) and !file_exists($absThumb)) {
												if (empty($oImageController)) {
													$oImageController = new imageController();
													$imageLib =  $attribs->get( 'image_library', '' );
													if ($imageLib != '') {
														$oImage= $oImageController->loadLib( $imageLib );
													}
												}
												$maxWidth 		= $attribs->get( 'thumb_max_width' );
												$maxHeight 		= $attribs->get( 'thumb_max_height' );

												if ($imageLib != '') {
													$oImage->resize( $maxWidth, $maxHeight, $absFile, $absThumb );
												}

											}

											// don't create lightbox link if they want the image to link to the form
											if ($oElement->link_to_detail != 1) {
												if ($fabrikConfig->fbConf_use_highslide) {
													$str = '<a href="' . $ofile . '" class="highslide" onclick="return hs.expand(this)"><img src="' . $file . '" alt="' . $oElement->element_label . '" /></a>';
												}
												else {
													$str = "<a href=\"$ofile\" rel=\"lightbox[]\"><img src=\"$file\" alt=\"$oElement->element_label\" /></a>";
												}
											}
											else {
												$str 		= "<img src=\"$file\" alt=\"$oElement->element_label\" />";
											}
										}
										if( !file_exists( $absFile ) ){
											$file = $mosConfig_live_site . '/' .$attribs->get('default_image');
											$str = "<img src=\"$file\" alt=\"$oElement->element_label\" />";
										}
									}else{
										$default_image = $attribs->get('default_image');
										if (!empty($default_image)) {
											$file = $mosConfig_live_site . '/' .$default_image;
											$str = "<img src=\"$file\" alt=\"$oElement->element_label\" />";
										}
										else {
											$str = '';
										}
									}
									$elementData[$i]->$elName = $str;
									// $$$ end hugh
								}
							}else{
								if( $attribs->get( 'make_link', 0 ) ){
									for( $i=0; $i < count( $elementData ); $i++ ){
										$elName = $oGroup->getElementFullName( $oElement, $oForm, false, false, false );
										$data = $elementData[$i];
										if( isset( $data->$elName )){
											$bits = explode( "/", $data->$elName );
											$file = array_pop( $bits );
											$elementData[$i]->$elName = "<a href='" . $data->$elName. "'>" .$file . "</a>";

										}
									}
								}
							}
						}
					}
				}
			}
		}
		return $elementData;
	}

	/**
	 * get the part of the sql statement that joins all talbes together
	 *@access private
	 * @return string join sql statement
	 */

	function _getJoinSQL( ){
		$sql = '';
		if (is_array( $this->_aJoins )) {
			foreach ($this->_aJoins as $oJoin ) {
				$testSQL = " " . strtoupper($oJoin->join_type) ." JOIN $oJoin->table_join " ;
				if (array_key_exists('table_join_alias', $oJoin) && $oJoin->table_join_alias != '') {
					$testSQL .= " AS `" . $oJoin->table_join_alias .
					"` ON " . $oJoin->table_join_alias . ".$oJoin->table_join_key = " .
					"$oJoin->join_from_table.$oJoin->table_key \n ";
				} else {
					$testSQL .=	" ON $oJoin->table_join.$oJoin->table_join_key = " .
					"$oJoin->join_from_table.$oJoin->table_key \n ";
				}
				if (!strstr( $sql, $testSQL )) {
					$sql .= $testSQL;
				}
			}
		}
		return $sql;
	}


	/**
	 * @param element name (format: table.element_name)
	 * @return if el not join then return $col, else return table.element_join_label
	 */
	function _getJoinElName( $col ){
		global $database;
		$form 		=& $this->getForm();
		foreach($form->_groups as $oGroup){
			foreach( $oGroup->_aElements as $oElement ) {
				if( $col == $this->db_table_name . "." . $oElement->element_name ){
					if( $oElement->elementtype_id == 12 ){
						return $oElement->join_db_name . "." .$oElement->join_val_column;
					}
				}
			}
		}
		return $col;
	}
	/**
	 * called when the form is submitted to perform calculations
	 */

	function doCalculations(){
		global $database;
		$db = $this->getDb();
		$this->loadJoins( );
		$joinSQL 	= $this->_getJoinSQL();
		$form 		=& $this->getForm();
		if (!is_array( $form->_groups )) {
			$form->getFormGroupsHiarachy( );
		}
		$where = $this->getSQLWhere();
		foreach ($form->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				$params = $oElement->loadParams();
				$update = false;
				if ($params->get( 'sum_on', 0 )) {
					$splitSum		= $params->get( 'sum_split', '' );
					if ($splitSum != '') {
						$splitSumLabel = $this->_getJoinElName( $splitSum );
						$sql = "SELECT SUM($oElement->element_name) AS value, $splitSumLabel AS label FROM $this->db_table_name $joinSQL $where GROUP BY $splitSum ";
					} else {
						$sql = "SELECT SUM($oElement->element_name) AS value, 'All' AS label FROM $this->db_table_name $joinSQL $where";
					}
					$db->setQuery($sql);
					$res = '';
					$results =  $db->loadObjectList();
					echo $db->getErrorMsg();
					foreach ($results as $o) {
						$o->label = ($o->label == '') ? _EMPTY : $o->label;
						$res .= $o->label . ': ' . $o->value . "<br />";
					}
					$params->set( 'sum_value', $res );
					$update = true;
				}
				if ($params->get( 'avg_on', 0 )) {
					$splitAvg		= $params->get( 'avg_split', '' );

					if ($splitAvg != '') {
						$splitAvgLabel = $this->_getJoinElName( $splitAvg );
						$sql = "SELECT AVG($oElement->element_name) AS value, $splitAvgLabel AS label FROM $this->db_table_name $joinSQL $where GROUP BY $splitAvg " ;
					} else {
						$sql = "SELECT AVG($oElement->element_name) AS value, 'All' AS label FROM $this->db_table_name $joinSQL $where" ;
					}
					$db->setQuery( $sql );
					if (mosGetParam( $_REQUEST, 'fabrikdebug', '0' )) {
						echo $db->getQuery( );
					}
					$res = '';
					$results =  $db->loadObjectList();
					foreach ($results as $o) {
						$o->label = ($o->label == '') ? _EMPTY : $o->label;
						$res .= $o->label . ': ' . $o->value . "<br />";
					}
					$params->set( 'avg_value', $res );
					$update = true;
				}
				if ($params->get( 'median_on', 0 )) {
					$sql = "SELECT $oElement->element_name FROM $this->db_table_name $joinSQL $where";
					$db->setQuery($sql);
					$params->set('median_value', $this->median( $db->loadResultArray() ));
					$update = true;
				}
				if ($params->get( 'count_on', 0 )) {
					$splitCount = $params->get( 'count_split', '' );
					$countCond = $params->get('count_condition', '');
					if ($countCond == '') {
						$countCond = $where;
					} else {
						// $$$ ooopsie ... str_ireplace is PHP5 only
						//$countCond .= str_ireplace( 'WHERE', 'AND', $where );
						$countCond .= preg_replace('#WHERE#i', 'AND', $where);
					}
					if ($splitCount != '') {
						$splitCountLabel = $this->_getJoinElName( $splitCount );
						$sql = "SELECT COUNT($oElement->element_name) AS value, $splitCountLabel AS label FROM $this->db_table_name $joinSQL " . $countCond . " GROUP BY $splitCount";
					} else {
						$sql = "SELECT COUNT($oElement->element_name) AS value, 'All' AS label FROM $this->db_table_name $joinSQL " . $countCond;
					}
					$db->setQuery($sql);
					$res = '';
					$results =  $db->loadObjectList();
					foreach ($results as $o) {
						$o->label = ($o->label == '') ? _EMPTY : $o->label;
						$res .= $o->label . ': ' . $o->value . "<br />";
					}
					$params->set( 'count_value', $res );
					$update = true;
				}
				if ($update) {
					$oElement->updateAttribsFromParams( $params->toArray() );
					$oElement->store();
				}
			}
		}
	}

	/**
	 * return mathematical column calculations (run at doCalculations() on for submission)
	 */

	function runCalculations( ){
		global $my;
		$aCalculations = array();
		$aAvgs = array();
		$aSums = array();
		$aMedians = array();
		$aCounts = array();
		$this->getForm();
		if ( !is_array( $this->_oForm->_groups ) ){
			$this->_oForm->getFormGroupsHiarachy( );
		}

		if ( is_array( $this->_oForm->_groups ) ){

			foreach ( $this->_oForm->_groups as $oGroup ){

				if ( is_array( $oGroup->_aElements ) ){

					foreach( $oGroup->_aElements as $oElement ){
						$params = $oElement->loadParams();
						$elName = $oGroup->getElementFullName($oElement, $this->_oForm, false, false );
						$elName = rtrim($elName, "[]");
						$sum 			= $params->get( 'sum_on', '0' );
						$avg 			= $params->get( 'avg_on', '0' );
						$median 		= $params->get( 'median_on', '0' );
						$countOn 		= $params->get( 'count_on', '0' );

						$sumAccess 		= $params->get( 'sum_access', 0 );
						$avgAccess 		= $params->get( 'avg_access', 0 );
						$medianAccess 	= $params->get( 'median_access', 0 );
						$countAccess 	= $params->get( 'count_access', 0 );

						if( $sumAccess <= $my->gid && $params->get('sum_value', '') != ''){
							$aSums[ $elName ] = $params->get('sum_value', '');
						}
						if( $avgAccess <= $my->gid && $params->get('avg_value', '') != ''){
							$aAvgs[ $elName ] = $params->get('avg_value', '');
						}
						if( $medianAccess <= $my->gid && $params->get('median_value', '') != ''){
							$aMedians[ $elName ] = $params->get('median_value', '');
						}
						if( $countAccess <= $my->gid && $params->get('count_value', '') != ''){
							$aCounts[ $elName ] = $params->get('count_value', '');
						}
					}
				}
			}
		}
		$aCalculations['sums'] 			= $aSums;
		$aCalculations['avgs'] 			= $aAvgs;
		$aCalculations['medians'] 		= $aMedians;
		$aCalculations['count'] 		= $aCounts;
		$this->_aRunCalculations = $aCalculations;
		return $aSums;
	}

	/**
	 * calculate the median of an array of data values
	 * @param array data to use
	 * @return int median value
	 */

	function median( $aData ){
		sort( $aData );
		if ((count( $aData ) % 2)==1){
			/* odd */
			$midKey = floor( count( $aData ) / 2);
			return $aData[$midKey];
		} else {
			$midKey = floor( count( $aData ) / 2) - 1;
			$midKey2 = floor( count( $aData ) / 2) ;
			return ($aData[$midKey] + $aData[$midKey2]) / 2;
		}
	}

	/**
	 * @param int connection id to use
	 * @param string table to load fields for
	 * @param string show "please select" top option
	 * @param bol append field name values with table name
	 * @param string name of drop down
	 * @param string selected option
	 * @return string html to be added to DOM
	 */

	function getFieldsDropDown( $cnnId, $tbl, $incSelect, $incTableName = false, $selectListName = 'order_by', $selected = '', $className = "inputbox" ){
		$this->setConnectionId( $cnnId );
		$this->getConnection( );
		$sql = "DESCRIBE `$tbl`";
		$this->_oConnDB->setQuery( $sql );
		$aFields = $this->_oConnDB->loadObjectList( );
		$fieldNames = array( );
		if( $incSelect != '' ){
			$fieldNames[] = mosHTML::makeOption( '', $incSelect );
		}
		if( is_array( $aFields ) ) {
			foreach( $aFields as $oField ) {
				if( $incTableName ){
					$fieldNames[] = mosHTML::makeOption( $tbl . "." . $oField->Field, $oField->Field );
				} else {
					$fieldNames[] = mosHTML::makeOption( $oField->Field );
				}
			}
		}
		$fieldDropDown = mosHTML::selectList( $fieldNames, $selectListName, "class=\"$className\"  size=\"1\" ", 'value', 'text', $selected );
		return str_replace("\n", "", $fieldDropDown);
	}

	/**
	 * used in advanced search
	 * @param bol add slashes to reutrn data
	 */

	function getFilterJoinDd( $addSlashes = true, $name = 'join' ){
		$aConditions = array( );
		$aConditions[] = mosHTML::makeOption( 'AND' );
		$aConditions[] = mosHTML::makeOption( 'OR' );
		$dd = str_replace("\n", "", mosHTML::selectList( $aConditions, $name, "class=\"inputbox\"  size=\"1\" ", 'value', 'text', '' ));
		if( $addSlashes ){
			$dd = addslashes( $dd );
		}
		return $dd;
	}

	/**
	 *used in advanced search
	 *@param bol add slashes to reutrn data
	 *@param string name of the drop down
	 *@param int mode - states what values get put into drop down
	 */

	function getFilterConditionDd( $addSlashes = true, $name = 'conditions', $mode = 1 ){
		$aConditions = array( );
		switch ($mode){
			case 1:
				/* used for search filter */
				$aConditions[] = mosHTML::makeOPtion( '<>', 'NOT EQUALS');
				$aConditions[] = mosHTML::makeOption( '=', 'EQUALS' );
				$aConditions[] = mosHTML::makeOption( 'like', 'BEGINS WITH' );
				$aConditions[] = mosHTML::makeOption( 'like', 'CONTAINS' );
				$aConditions[] = mosHTML::makeOption( 'like', 'ENDS WITH' );
				$aConditions[] = mosHTML::makeOption( '>', 'GREATER THAN' );
				$aConditions[] = mosHTML::makeOption( '<', 'LESS THAN' );
				break;
			case 2:
				$aConditions[] = mosHTML::makeOption( 'equals', 'EQUALS' );
				$aConditions[] = mosHTML::makeOPtion( 'notequals', 'NOT EQUAL TO');
				$aConditions[] = mosHTML::makeOption( 'begins', 'BEGINS WITH' );
				$aConditions[] = mosHTML::makeOption( 'contains', 'CONTAINS' );
				$aConditions[] = mosHTML::makeOption( 'ends', 'ENDS WITH' );
				$aConditions[] = mosHTML::makeOption( '>', 'GREATER THAN' );
				$aConditions[] = mosHTML::makeOption( '<', 'LESS THAN' );
				$aConditions[] = mosHTML::makeOption( 'in', 'IN' );
				$aConditions[] = mosHTML::makeOption( 'notin', 'NOT IN' );
				break;
		}
		$dd = str_replace("\n", "", mosHTML::selectList( $aConditions, $name, "class=\"inputbox\"  size=\"1\" ", 'value', 'text', '' ));
		if( $addSlashes ){
			$dd = addslashes( $dd );
		}
		return $dd;
	}

	/**
	 * add or update a database column via sql
	 * @param object element
	 * @param bol is new
	 * @param string table name (if blank use this instance's table name)
	 * @param object database
	 * @param string origional field name
	 */

	function alterStructure( &$oElement, $new, $tableName, $fabrikDb='', $origColName=null ){
		global $database, $fabrikConfig;
		if ($fabrikDb == '') {
			$fabrikDb = $database;
		}
		$objtype = $oElement->getFieldDescription();
		$fabrikDb->setQuery( "DESCRIBE $tableName" );
		$dbdescriptions = $fabrikDb->loadObjectList( );
		foreach ( $dbdescriptions as $dbdescription ) {
			$fieldname = $dbdescription->Field;
			$exitingfields[] = $fieldname;
		}
		//$$$ rob double check that event if we are saying its not a new element
		// that the orig name still exists - if it doesnt treat the alter statement as if you were creating a new record
		$foundExisting = ( in_array( $origColName, $exitingfields ) ) ? true: false;
		$lastfield = $fieldname;
		if ( $new || !$foundExisting ) {
			$sql = "ALTER TABLE $tableName ADD COLUMN `" . $oElement->element_name . "` $objtype AFTER $lastfield";
		} else {
			if ( $origColName == null ) {
				$origColName = $oElement->element_name;
			}
			$sql = "ALTER TABLE $tableName CHANGE `$origColName` `" . $oElement->element_name . "`";
			if( $fabrikConfig->fbConf_alter_existing_db_cols ){
				$sql .= " $objtype";
			}
		}
		$fabrikDb->setQuery( $sql );
		if ( !$fabrikDb->query( ) ) {
			echo $fabrikDb->getErrorMsg( );
			return false;
		}
		return true;
	}

	/**
	 * checks if the params object has been created and if not creates and returns it
	 * @return object params
	 */

	function &loadParams()
	{
		global $mosConfig_absolute_path;
		if (!isset( $this->_params )) {
			$this->_params = &new fabrikParams( $this->attribs, $mosConfig_absolute_path . '/administrator/components/com_fabrik/xml/table.xml', 'component' );
		}
		return $this->_params;
	}

	/**
	 * this merges session data for the fromForm with any request data
	 * allowing us to filter data results from both search forms and filters
	 *
	 * @return array
	 */

	function setData()
	{
		global $_SESSION, $database;
		$aData 			= $_REQUEST;
		if (!array_key_exists( 'fabrik', $_SESSION )) {
			 $_SESSION['fabrik'] = array();
		}
		if (is_array( $_SESSION )) {
			if (array_key_exists( 'fromForm',  $_SESSION["fabrik"] )) {
				$fromForm = $_SESSION["fabrik"]['fromForm'];
				//only merge if the fromForm is not the same as the current table's form id
				if ($_SESSION["fabrik"]['fromForm'] != $this->_oForm->id) {
					$this->_oFromForm = new fabrikForm( $database );
					$this->_oFromForm->load( $fromForm );
					$fromFormParams = $this->_oFromForm->loadParams();
					if ($fromFormParams->get( 'remove_table_filtres', 0 )) {
						$this->_clearState( );
					}
					//fudge the sesson so that any search form data's keys are the same as the current
					//tables
					if (array_key_exists( $fromForm, $_SESSION['fabrik'] )) {
						foreach ($_SESSION['fabrik'][$fromForm] as $k1=>$v) {
							//only unset if not done previously
							if (strstr( $k1, "___" )) {
								$k2 = $this->db_table_name . "___" . array_pop(explode("___", $k1));
							} else {
								$k2 = $this->db_table_name . "___" . $k1;
							}
							if (array_key_exists( $k2, $_REQUEST )) {
								//override search form session info with any posted filters
								$v = $_REQUEST[$k2];
							}
							$_SESSION['fabrik'][$fromForm][$k2] = $v;
						}
					}
					if (array_key_exists( $fromForm,  $_SESSION["fabrik"])) {
						$aData = array_merge( $aData, $_SESSION["fabrik"][$fromForm] );
					}
				}
				//$$$rob since after 1.0.5.2 DONT unset as page nav no longer picks up the filter
				//unset( $_SESSION["fabrik"]['fromForm'] );
			}
		}
		//store filters
		foreach ($_REQUEST as $key=>$val) {
			if ($this->_oForm->hasElement( $key )) {
				$_SESSION['fabrik'][$this->_oForm->id][$key] = $val;
			}
		}
		if (array_key_exists($this->_oForm->id, $_SESSION["fabrik"])){
			$aData = array_merge( $aData, $_SESSION["fabrik"][$this->_oForm->id] );
		}
		return $aData;
	}

	/**
	 * main routine for rendering the table
	 *
	 * @return mixed, if in mambot mode then the html to create the table is returned
	 */

	function render( )
	{
		//$$$ rob leave $_MAMBOTS global decalation in as its needed for Arteo SEF
		global $database, $mosConfig_absolute_path, $mainframe, $my, $params, $_MAMBOTS, $_SESSION, $mosConfig_live_site, $option;
		if ($this->canPublish( )) {
			if ($this->canView( )) {
				$params 		=& $this->loadParams();
				$this->getConnection();
				$this->getForm( );
				writeFrontEndfabrikHead();
				$limitLength = mosSession::setFromRequest( 'tableLimitLength{' . $option. '}{' . $this->id . '}', 'pagelimit', $this->rows_per_page );
				$limitStart  = mosSession::setFromRequest( 'tableLimitStart{' . $option. '}{' . $this->id . '}', 'limitstart', 0 );
				$lists = array();
				if ($this->id == '0') {
					echo "No table found for this id";
					exit;
				}
				$this->_aData = $this->setData();

				//provide an override mechanism for session data.
				if (is_object( $this->_menuParams )) {
					if (mosGetParam( $_REQUEST, 'clearState', $this->_menuParams->get( 'clearState', 0 ) )) {
						$this->_clearState();
					}
				}

				$this->getFilterArray( );

				//$$$rob if the menu option to force recalculations is on the reload calculations, otherwise cached values are used
				//$$rob - testing to mocve inside getTableData, as the joins added in getTableData are needed for the calculations
				//if( is_object($this->_menuParams) && $this->_menuParams->get( 'calculations', 0 ) == 1){
				//	$this->doCalculations();
				//}
				$total 		= $this->getTotalRecords( );
				$pageNav 	= new fabrikPageNav( $total, $limitStart, $limitLength );
				$pageNav->_tableid = $this->id;

				$elementData = $this->getTableData( $pageNav );
				$this->_jsonHeadings();
				$this->hit( );
				$lists['filters'] = $this->makeFilters( );
				echo $this->_oConnDB->getErrorMsg( );

				if (!$this->_isMambot && !$this->_isModule) {
					$mainframe->setPageTitle( $this->label );
				}
				$lists['linksToTables'] =& $this->getAllJoinsToThisKey( );
				$lists['linksToForms'] 	=& $this->getLinksToThisKey( );
				$this->runCalculations( );
				$this->addCustomFiles( );
				$this->_rsssLink = $this->getRSSFeedLink( );
				if ($this->_rsssLink != '') {
					addHeadTag('<link rel="alternate" type="text/xml" title="RSS" href="' . $this->_rsssLink . '" />');
				}

				$tmpl = new fabrikViewTable( $this );
				$tmpl->_data 	= $elementData;
				$tmpl->_lists 	= $lists;
				$tmpl->_pageNav = $pageNav;

				$tmpl->_aJoinsToThisKey = $this->getAllJoinsToThisKey( );
				$tmpl->_params 	= $params;
				$tmpl->_admin 	= $this->_admin;
				$tmpl->_oForm 	= $this->_oForm ;
				if (!$this->_isModule) {
					$this->table_template = mosGetParam( $_REQUEST, 'layout', $this->table_template );
				}
				$html = $tmpl->display( $this->table_template );
				if ($this->_isMambot) {
					return $html;
				} else {
					echo $html;
				}
			} else {
				mosNotAuth( );
			}
		} else {
			fabrik_html_content::notPublished( 'table' );
		}
	}

	/**
	 * clears session info about the tables state
	 */

	function _clearState( $formForm = null )
	{
		global $option;
		//note doesnt remove filter sessions!
		if (is_array( $_SESSION )) {
			$serachKey = "{" . $option . "}{table}{" .  $this->id ."}";
			foreach ($_SESSION as $key=>$val) {
				if (strstr( $key, $serachKey )) {
					unset( $_SESSION[$key] );
				}
			}
		}
	}

	/**
	 * get the total number of records in the table
	 * @param object fabrik database object
	 * @param array posted data
	 */

	function getTotalRecords( )
	{
		if (!$this->_totalRecords) {
			$this->getFormGroupElementData( null, true, false );
			$count = "DISTINCT " . $this->db_primary_key;
			foreach ($this->_oForm->_groups as $oGroup) {
				foreach ($oGroup->_aElements as $oElement) {
					if ($oGroup->is_join || $oElement->show_in_table_summary && $oElement->elementtype_id == "12") {
						$count = "*";
					}
				}
			}
			$db = $this->getDb();
			$aPreFilters = $this->getPrefilterArray();
			$totalSql  	= "SELECT COUNT(" . $count . ") FROM " . $this->db_table_name . " " . $this->addJoinTableSQL( );
			$totalSql 	.= $this->getSQLWhere();
			$db->setQuery( $totalSql );
			if (mosGetParam( $_REQUEST, 'fabrikdebug', '0' )) {
				echo $db->getQuery( );
			}

			$this->_totalRecords  	= $db->loadResult( );
		}
		return $this->_totalRecords;
	}

	/**
	 * get array of elements that are joined to the table
	 * @return array elements that are joins
	 */

	function &getAllJoinsToThisKey()
	{
		$params =& $this->loadParams();
		$aExisitngLinked = $params->get( 'linkedtable', '', 'array' ) ;
		$aAllJoinsToThisKey =& $this->getJoinsToThisKey( );
		$aJoinsToThisKey= array();
		foreach ($aAllJoinsToThisKey as $join) {
			if (in_array( $join->tablelabel, $aExisitngLinked )) { //was $join->element_name ??
				$aJoinsToThisKey[] = $join;
			} else {
				$aJoinsToThisKey[] = '';
			}
		}
		return $aJoinsToThisKey;
	}

	/**
	 * get an array of elements that point to a form where their data will be filtered
	 *
	 * @return array
	 */

	function &getLinksToThisKey()
	{
		if (!isset( $this->_linksToThisKey )) {
			$params =& $this->loadParams();
			$aExisitngLinked = $params->get( 'linkedform', '', 'array' );
			$aAllJoinsToThisKey =& $this->getJoinsToThisKey( );
			$this->_linksToThisKey = array();
			foreach ($aAllJoinsToThisKey as $join) {
				if (in_array( $join->tablelabel, $aExisitngLinked )) {
					$this->_linksToThisKey[] = $join;
				} else {
					$this->_linksToThisKey[] = '';
				}
			}
		}
		return $this->_linksToThisKey;
	}

	/**
	 * wrapper function to get data from table including keys, urls, icons
	 * @param object pagnav
	 * @return array element data
	 */

	function getTableData( $pagNav ){
		$this->getForm( );
		$params =& $this->loadParams();
		$this->getFormGroupElementData( null, true, false );
		$elementData = $this->getElementData( $pagNav );

		//$$$rob moved here from start of render();
		if (is_object( $this->_menuParams ) && $this->_menuParams->get( 'calculations', 0 ) == 1) {
			$this->doCalculations();
		}

		$elementData = $this->getForiegnKeys( $elementData );
		$elementData = $this->convertURLsToLinks( $elementData, $this->_oForm );
		$elementData = $this->replaceDataWithIcons( $elementData, $this->_oForm );
		$elementData = $this->replaceRadioDataWithLabels( $elementData );
		if ($this->canViewDetails() && $params->get( 'detaillink' ) == '1') {
			$elementData = $this->addDetailsLink( $elementData );
		}
		/// new for php templates

		$this->_aGroupInfo = array();
		$groupTitle = array();

		$this->group_by = mosGetParam( $_GET, 'groupby', $this->group_by );

		//check if the data has a group by applied to it
		if ($this->group_by != '') {
			$groupedElData = array();
			$thisGroupedData = array();
			$groupBy = $this->group_by;
			$groupTitle = null;
			$aGroupTitles = array();
			$groupId = 0;
			for ($i=0; $i<count( $elementData ); $i++) {
				if (!in_array( $elementData[$i]->$groupBy , $aGroupTitles )) {
					$aGroupTitles[] = $elementData[$i]->$groupBy;
					$groupedElData[$elementData[$i]->$groupBy] = array();
				}
				$elementData[$i]->_groupId = $elementData[$i]->$groupBy;
				$groupedElData[$elementData[$i]->$groupBy][] = $elementData[$i];
			}
			$elementData = $groupedElData;
		} else {
			//make sure that the none grouped data is in the same format
			$elementData = array( $elementData );
		}
		return 	$elementData;
	}

	function addDetailsLink( $elementData ){
		for ($i=0;$i<count( $elementData );$i++) {
			$pKeyVal = '';
			$row = $elementData[$i];
			/** $$$ hugh
			 * needed to get at row data inside callback function for _replaceWithRowData
			 * but can't pass argmes in, so need it as a class variable.  Should probably
			 * set this up somewhere else, but here's where I need it right now, LOL!
			 */
			$this->_oRow =& $row;
			foreach( $row as $key=>$val ){
				if( $key == $this->db_primary_key ){
					$pKeyVal = $val;
					break;
				}
			}
			$elementData[$i]->fabrik__details_link = $this->viewDetailsLink( $pKeyVal, $row );
		}
		return $elementData;
	}

	/**
	 * create the RSS href link to go in the table template
	 * @return string RSS link
	 */

	function getRSSFeedLink(){
		global $Itemid;
		$link = '';
		$params =& $this->loadParams();
		if( $params->get('rss') == '1' ){
			$link = 'index2.php?option=com_fabrik&amp;no_html=1&amp;task=tableFeed&amp;tableid=' . $this->id . '&amp;Itemid=' . $Itemid;
			if(!$this->_admin){
				$link = sefRelToAbs($link);
			}
		}
		return $link;
	}

	/**
	 * iterates through string to replace every
	 * {placeholder} with row data
	 * (added by hugh, does the same thing as parseMessageForPlaceHolder in parent
	 * class, but for rows instead of forms)
	 * @param string text to parse
	 */

	function parseMessageForRowHolder( $msg, $row ){
		$msg = $this->_replaceWithUserData( $msg );
		$msg = $this->_replaceWithGlobals( $msg );
		$msg = preg_replace( "/{}/", "", $msg );
		/* replace {element name} with form data */
		$msg = preg_replace_callback( "/{[^}]+}/i", array($this,'_replaceWithRowData'), $msg );
		return $msg;
	}

	/**
	 * PRVIATE:
	 * called from parseMessageForRowHolder to iterate through string to replace
	 * {placeholder} with row data
	 * @param string placeholder e.g. {placeholder}
	 * @param array row
	 * @return string posted data that corresponds with placeholder
	 */

	function _replaceWithRowData( $matches ){
		$match = $matches[0];
		/* strip the {} */
		$match = substr( $match, 1, strlen($match) - 2 );

		$match = strtolower( $match );
		// $$$ hugh - allow use of {$rowpk} or {rowpk} to mean the rowid of the rwo within a table
		if ($match == 'rowpk' or $match == '$rowpk')
		{
			$match = $this->_table->db_primary_key;
			$match = preg_replace('#^(\w+\.)#','',$match);
		}
		$match = preg_replace( "/ /", "_", $match );
		return($this->_oRow->$match);
	}

	function viewDetailsLink( $id, $row ){
		global $Itemid;
		$params =& $this->loadParams();
		// $$$ hugh - added optional details link URL param
		if( $link = $params->get('detailurl') ){
			$link = htmlspecialchars($link);
			$link = $this->parseMessageForRowHolder($link,$row);
			if (strstr($link,'?')) {
				$link .= '&amp;rowid=' . $id;
			}
			else {
				$link .= '?rowid=' . $id;
			}
		}
		else {
			$link = 'index.php?option=com_fabrik&amp;task=viewTableRowDetails&amp;tableid=' . $this->id . '&amp;fabrik=' . $this->form_id . '&amp;rowid=' . $id . '&amp;Itemid=' . $Itemid;
		}
		$link .= "&amp;fabrik__cursor=" . $row->fabrik__cursor . "&amp;fabrik__total=" . $row->fabrik__total ;
		if( !$this->_admin ){
			$link = sefRelToAbs($link);
		}
		return $link;
	}

	/**
	 * creates the rss feed when the RSS link in clicked
	 * @return document rss xml
	 */

	function createRSSFeed()
	{
		global $mainframe, $mosConfig_absolute_path, $mosConfig_sitename, $mosConfig_cachepath, $mosConfig_live_site, $mosConfig_sitename;
		$params = $this->loadParams( );
		$this->_aData = array();

		if ($params->get('rss') == '1') {
			require_once( $mosConfig_absolute_path .'/includes/feedcreator.class.php' );
			$rss = new UniversalFeedCreator();
			$rss->descriptionHtmlSyndicated = true;
			$rss->cssStyleSheet = '';
			$limit = mosGetParam( $_GET, 'limit',   $params->get( 'rsslimit',150 ) );
			$maxLimit = $params->get( 'rsslimitmax', 2500 );
			if ($limit > $maxLimit) {
				$limit = $maxLimit;
			}

			$rss->useCached( 'RSS0.91', $mosConfig_cachepath .'/' . $this->db_table_name . '_' . $limit. '.xml' );
			$rss->title 			= $mosConfig_sitename . ": " . $this->label;
			$rss->link				= $mosConfig_live_site . "/" . $this->getRSSFeedLink();
			$rss->description 		= $this->introduction;
			$this->getConnection();
			$total 		= $this->getTotalRecords( );
			$aFilter 	= $this->getFilterArray( );
			$this->_outPutFormat = 'rss';
			$dateCol = $params->get( 'feed_date', '' );
			if ($dateCol == '') {
				$dateCol = $this->order_by;
			} else {
				$this->order_dir = 'DESC';
				$this->order_by 	= $dateCol;
			}
			$pageNav = new fabrikPageNav( $total, 0, $limit );
			$pageNav->_tableid = $this->id;
			$elementData = $this->getTableData( $pageNav );
			$aJoinsToThisKey = $this->getAllJoinsToThisKey();

			/* get headings */
			$aTableHeadings = array();
			foreach ($this->_oForm->_groups as $oGroup) {
				foreach ($oGroup->_aElements as $oElement) {
					$elParams =& new fabrikParams( $oElement->attribs, $mosConfig_absolute_path . '/administrator/components/com_fabrik/xml/element.xml', 'component' );
					if ($elParams->get( 'show_in_rss_feed' ) == '1') {
						$heading = $oElement->element_label;
						if ($elParams->get( 'show_label_in_rss_feed' ) == '1') {
							$aTableHeadings[$heading]['element_label']	 = $heading;
						} else {
							$aTableHeadings[$heading]['element_label']	 = '';
						}
						$aTableHeadings[$heading]['colName'] = $oGroup->getElementFullName( $oElement, $this->_oForm, false, false, false );
						$aTableHeadings[$heading]['dbField'] = $oElement->element_name;
						$aTableHeadings[$heading]['key'] = $elParams->get( 'use_as_fake_key' );
					}
				}
			}
			foreach ($aJoinsToThisKey as $oJoinElement) {
				if ($oJoinElement != '') {
					$elParams = new fabrikParams( $oJoinElement->attribs, $mosConfig_absolute_path . '/administrator/components/com_fabrik/xml/element.xml', 'component' );
					if ($elParams->get( 'show_in_rss_feed' ) == '1') {
						$heading = $oJoinElement->element_label;
						if ($elParams->get( 'show_label_in_rss_feed' ) == '1') {
							$aTableHeadings[$heading]['element_label']	 = $heading;
						} else {
							$aTableHeadings[$heading]['element_label']	 = '';
						}
						$aTableHeadings[$heading]['colName'] = $oGroup->getElementFullName( $oJoinElement, $this->_oForm, false, false, false );
						$aTableHeadings[$heading]['dbField'] = $oJoinElement->element_name;
						$aTableHeadings[$heading]['key'] = $elParams->get( 'use_as_fake_key' );
					}
				}
			}
			$titleElement = $params->get( 'feed_title' );
			if (is_array( $elementData )) {
				foreach ($elementData as $group) {
					foreach ($group as $row) { // for each row from the table
						$str = "<dl>";
						$str2 = '';
						//used for content not in dl
						//ok for feed gator you cant have the same item title so we'll take the first value from the table (asume its the pk and use that to append to the item title)'
						$title = '';
						foreach ($aTableHeadings as $heading=>$dbcolname) {
							// @since 1.0.5.2 split repeat group data from groups that arent joins
							if (strstr( $row->$dbcolname['colName'], $oGroup->_splitter_1)){
								$row->$dbcolname['colName'] = str_replace( $oGroup->_splitter_1, "<br />", $row->$dbcolname['colName'] );
							}
							if ($title == '') {
								//set a default title
								$title = $this->label . ' - ' . $row->$dbcolname['colName'];
							}
							if ($dbcolname['element_label'] == '') {
								$str2 .= $row->$dbcolname['colName'] . "<br />";
							} else {
								$str .= "<dt value='" . $dbcolname['dbField']  . "'";
								$str .= " key='" . $dbcolname['key'] . "' ";
								$str .= ">" . $dbcolname['element_label'] . "</dt>\n";
								$str .= "<dd>" . $row->$dbcolname['colName'] . "</dd>\n";
							}
						}
						if (isset( $row->$titleElement )) {
							$title = $row->$titleElement;
						}
						$pkKey = $this->db_primary_key;
						$pkVal = $row->$pkKey;
						$str .= "</dl>" . $str2;

						// load individual item creator class
						$item = new FeedItem();
						$item->descriptionHtmlSyndicated = true;
						// item info
						$item->title 		= $title;
						// $$$ hugh - I think trhe sefRelToAbs in viewDetailsLink already add live_site
						//$item->link 		= $mosConfig_live_site . "/" . $this->viewDetailsLink( $pkVal );
						$item->link 		= $this->viewDetailsLink( $pkVal, $row );
						// $$$ hugh - link ends up with &amp;amp; if we don't do this, 'cos the feed code does and htmlsepcialchars on it
						$item->link = 		htmlspecialchars_decode($item->link);
						// $$$ hugh - need a 'guid' (global unique id) so news readers can keep track of what they have seen
						// $$$ (usual value to use for the guid is the link URL, as this should be unique per item)
						$item->guid 		= $item->link;
						$item->description 	= $str;
						$item->source 		= 'source';
						$item->category     = 'category';
						if ($params->get( 'feed_date', '' ) != '') {
							$item->date = date( 'r', strtotime($row->$dateCol) );
						}
						// loads item info into rss array
						$rss->addItem( $item );
					}
				}
			}
			$rss->saveFeed( 'RSS0.91', $mosConfig_cachepath .'/' . $this->db_table_name . '.xml', true );
		}

	}
	/**
	 * add js and css files to the table locations
	 * js = /components/com_fabrik/js/table/{template_name}.js
	 * css = /components/com_fabrik/js/table/{template_name}.css
	 */

	function addCustomFiles(){
		//modules cant add to head :(
		global $mosConfig_absolute_path, $mainframe, $mosConfig_live_site;
		// check for a custom javascript file and include it if it exists
		$aJsPath =$mosConfig_absolute_path . "/components/com_fabrik/js/table/" . $this->id . ".js";
		if ( file_exists( $aJsPath ) ){
			$live_js_file = $mosConfig_live_site."/components/com_fabrik/js/table/" . $this->id . ".js";
			echo "<script type=\"text/javascript\" src=\"$live_js_file\"></script>";
		}

		// check for a custom js file and include it if it exists
		$aJsPath = $mosConfig_absolute_path."/components/com_fabrik/views/table/tmpl/".$this->table_template."/".$this->table_template.".js";
		if ( file_exists( $aJsPath ) ) {
			$live_js_file = $mosConfig_live_site."/components/com_fabrik/views/table/tmpl/".$this->table_template."/".$this->table_template.".js";
			if ( method_exists( $mainframe, 'addCustomHeadTag' ) && !$this->_isModule ) {
				addHeadTag("<script type=\"text/javascript\" src=\"$live_js_file\"></script>");
			} else {
				echo "<script type=\"text/javascript\" src=\"$live_js_file\"></script>";
			}
		}
	}

	/**
	 * make the drop slq statement for the table
	 * @return string drop table sql
	 */

	function getDropTableSQL(){
		$genTable 	= $this->getGenericTableName( );
		$sql = "DROP TABLE IF EXISTS `$genTable`;";
		return $sql;
	}

	function getGenericTableName(){
		global $mosConfig_dbprefix;
		return str_replace( $mosConfig_dbprefix, '#__', $this->db_table_name );
	}

	/**
	 * make the create sql statement for the table
	 * used in package export
	 * @return string sql to drop & or create table
	 */

	function getCreateTableSQL( ){
		$genTable 	= $this->getGenericTableName( );
		$cnn 		= $this->getConnection( );
		$db 		= $this->_oConnDB;
		$db->setQuery( "DESCRIBE `$this->db_table_name`");
		$fields = $db->loadObjectList( );
		$sql = $this->buildCreateTableSQL( $genTable, $fields );
		return $sql;
	}

	/**
	 * make the create sql statement for inserting the table data
	 * used in package export
	 * @param object exporter
	 * @return string sql to drop & or create table
	 */

	function getInsertRowsSQL( &$oExporter ){
		@set_time_limit(300);
		$memoryLimit = ini_get('memory_limit');

		$genTable 	= $this->getGenericTableName( );
		$cnn 		= $this->getConnection( );
		$db 		= $this->_oConnDB;
		//dont load in all the table data as on large tables this gives a memory error
		//in fact this wasnt the problem, but rather the $sql var becomes too large to hold in memory
		//going to try saving to a file on the server and then compressing that and sending it as a header for download
		$sql = "SELECT $this->db_primary_key FROM `$this->db_table_name`";
		$db->setQuery( $sql );
		$keys = $db->loadResultArray( );
		$sql = "";
		$dump_buffer_len = 0;
		if (is_array( $keys )) {
			foreach($keys as $id){
				$db->setQuery("SELECT * FROM `$this->db_table_name` WHERE $this->db_primary_key = $id");
				$db->loadObject($row);
				$fmtsql = "\t<query>INSERT INTO $this->db_table_name ( %s ) VALUES ( %s )</query>";
				$values = array();
				$fields = array();
				foreach( $row as $k => $v) {
					$fields[] = $db->NameQuote( $k );
					$values[] = $db->Quote( $v );
				}
				$sql .= sprintf( $fmtsql, implode( ",", $fields ) ,  implode( ",", $values ) )  ;
				$sql .= "\n";

				$dump_buffer_len += strlen($sql);
				if ($dump_buffer_len  > $memoryLimit) {
					$oExporter->writeExportBuffer( $sql );
					$sql = "";
					$dump_buffer_len = 0;
				}
				unset($values);
				unset($fmtsql);
			}
		}
		$oExporter->writeExportBuffer( $sql );
	}

	/**
	 *
	 */

	function buildCreateTableSQL( $table, $fields ){
		$primaryKey = "";
		$sql 		= "";
		$sql .= "CREATE table `" .  $table ."` (\n";
		foreach( $fields as $field ){
			if( $field->Key == 'PRI'){
				$primaryKey = "PRIMARY KEY (`$field->Field`)";
			}
			$sql .=	"`$field->Field` ";

			if( $field->Key == 'PRI'){
				$sql .= ' INT(6) ';
			}else{
				$sql .= ' ' . $field->Type . ' ';
			}
			if( $field->Null == '' ){
				$sql .= " NOT NULL ";
			}
			if( $field->Default != '' && $field->Key != 'PRI' ){
				if($field->Default == 'CURRENT_TIMESTAMP'){
					$sql .= "DEFAULT $field->Default";
				}else{
					$sql .= "DEFAULT '$field->Default'";
				}
			}
			if( $field->Key == 'PRI'){
				$sql .= " AUTO_INCREMENT ";
			}

			$sql .= $field->Extra . ",\n";
		}
		if($primaryKey == ''){
			$sql = rtrim($sql,",\n" );
		}
		$sql .= $primaryKey . ");";
		return $sql;
	}

	/**
	 * records data from a fabrik RSS feed into the table
	 * feeds need to be in <dl> format
	 * @param string html containing <dl> list
	 * @return string out come message can be'saved','error saving',return 'duplicate', 'error'
	 */

	function recordFromRSSFeed( $html ){
		global $mosConfig_absolute_path, $database;
		require_once($mosConfig_absolute_path . '/includes/domit/xml_domit_lite_include.php');
		//strip cdata text from html
		$html = str_replace( array(']]>', '<![CDATA['), '', $html );

		$xmlDoc = new DOMIT_Lite_Document();
		$ok = $xmlDoc->parseXML($html);
		if( $ok ){
			$key = '';
			$val = '';
			$debug = '';
			$aPseudoKeys = array();
			$isPseudoKey = false;
			$numDefinitionLists = count($xmlDoc->documentElement->childNodes);

			for( $i = 0; $i < $numDefinitionLists; $i++ ) {
				$currentChannel =& $xmlDoc->documentElement->childNodes[$i];

				if( ($i % 2) == 0){ // even so its the col heading
					$label = $currentChannel->firstChild->nodeValue;
					$key = $currentChannel->getAttribute("value");
					$isPseudoKey = $currentChannel->getAttribute("key");

				}else{
					$val = $currentChannel->firstChild->nodeValue;

					if( $key != $this->db_primary_key && $key != ''){
						$aData[$key] = $val;
					}
					if( $isPseudoKey == '1' ){
						$aPseudoKeys[] = "$key = '$val'";
					}
				}
			}
			//test if record already exists?
			$res = 0;
			if( count($aPseudoKeys > 0)){
				$sql = "SELECT count(*) FROM $this->db_table_name WHERE " . implode( ' AND ', $aPseudoKeys );
				$database->setQuery( $sql );
				$res = $database->loadResult( );
			}
			if( $res == 0 ){
				if( $this->storeRow( $aData, 0 ) ){
					return 'saved';
				} else {
					return 'error saving';
				}
			} else {
				return 'duplicate';
			}
		}
		return 'error';
	}


	/**
	 * switches the database depending on the table connection or fabrik id
	 * @param object table
	 * @param object connection
	 * @return array (database object, table name);
	 */

	function switchDatabase( $oConn ){
		global $database;
		if( $this->connection_id != '-1'){
			$fabrikDb = $oConn->loadTableConnectionDB( );
			$table = $this->db_table_name;
		}else{
			$fabrikDb = $database;
			$table = "#__fabrik_formdata_" . $this->form_id;
		}
		return array( $fabrikDb, $table );
	}

	/**
	 * get table headings to pass into table js oject
	 *
	 * @return string headings tablename___element_name
	 */

	function _jsonHeadings(){
		//$$$ rob clear the cache otherwise the old ordering is used to create the table headings.
		mosCache::cleanCache('com_content');
		if (!is_null($this->_jsonHeadings)) {
			return $this->_jsonHeadings;
		}
		global $option;
		$aHeadings = array();
		foreach ($this->_oForm->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if ($oElement->show_in_table_summary) {
					$key 				= $oGroup->getElementFullName( $oElement, $this->_oForm, false, false, false );
					$orderKey 	= $oElement->getOrderbyFullName( $oGroup, $this->_oForm, false, false );

					if ($oElement->can_order == '1') {
						$sessionOrderKey = 'tableOrder{' . $option. '}{' . $this->id . '}{' . $key . '}';
						$orderDir 	= mosSession::get( $sessionOrderKey,  '-' );
						$currentOrderDir = $orderDir;
						switch ($orderDir) {
							case "desc":
								$orderDir = "-";
								break;
							case "asc":
								$orderDir = "desc";
								break;
							case "-":
								$orderDir = "asc";
								break;
						}
					} else {
						$orderDir = '';
					}
					$tmp = array();
					$tmp['id'] =  $orderKey;
					$tmp['orderdir'] = $orderDir;
					$aHeadings[] = $tmp;
				}
			}
		}
		//echo "<pre>";print_r($aHeadings);
		$this->_jsonHeadings =  FastJSON::encode($aHeadings);
		//	echo $this->_jsonHeadings;
		return $this->_jsonHeadings;
	}

	/**
	 * ajax get record specified by row id
	 */

	function xRecord($id){
		$cursor = mosGetParam( $_REQUEST, 'cursor', 1 );
		$this->getConnection( );
		$this->_outPutFormat = 'json';
		$pageNav = new fabrikPageNav( 1, 0, 1 );
		$this->_tableViewOnly = false;
		$data = $this->getTableData( $pageNav );
		return FastJSON::encode($data);
	}

	/**
	 * ajax gets an ajax record defined by the cursor
	 * @return string json object representing record/row
	 */

	function nextRecord(){
		$cursor = mosGetParam( $_REQUEST, 'cursor', 1 );
		$view = mosGetParam( $_REQUEST, 'view', 'form');
		$this->_aData = array();
		$this->getConnection( );
		$this->_outPutFormat = 'json';
		$this->_jsonView = $view;
		$pageNav = new fabrikPageNav( 1, $cursor, 1 );
		$this->_tableViewOnly = false;
		$data = $this->getTableData( $pageNav );
		echo FastJSON::encode($data);
	}

	function truncate(){
		$db = $this->getDb();
		$db->setQuery( "TRUNCATE TABLE `$this->db_table_name`");
		$db->query();
	}

}
?>