<?php

/**
 * @package  fabrik
 * @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

 

/**
 * trys to connection to the database
 * @param array/int connection ids to test
 * @return string connection message
 */
 
function testConnection( $cid ){
	global $database;
	josSpoofCheck();
	$msg = _CONNECTION . " " . _SUCCESSFUL;
	if ( is_array( $cid ) ){
		foreach( $cid as $id ){
			$row = new fabrikConnection($database);
			$row->load($id); 
			if ( $row->testConnection() == false ){
				$msg = _CONNECTION . " " . _FAILED;
			}
		}
	} else {
		$row = new fabrikConnection( $database );
		$row->load( $cid ); 
		if ( $row->testConnection( ) == false ){
			$msg = _CONNECTION . " " . _FAILED;
		}
	}
	return $msg;
}

/**
 * lets you edit the connection 
 * @param int connection id - 0 if new connection
 */
 
function editConnection( $cid ){
	global $database, $my;
	$row = new fabrikConnection( $database );
	$row->load( $cid ); 
	// fail if checked out not by 'me'
	if ( $row->checked_out && $row->checked_out != $my->id ) {
		mosRedirect( 'index2.php?option=com_fabrik', 'The connection '. $row->description .' is currently being edited by another administrator' );
	}
	if ( $cid ) {
		$row->checkout( $my->id );
	}
	html_connection_content::editConnection( $row );
}

/**
 * 
 */
 
 function cancelConnection( ){
 	global $database;
 	josSpoofCheck();
	$row = new fabrikConnection( $database );
	$row->bind( $_POST );
	$row->checkin( );
	$redirect = mosGetParam( $_POST, 'redirect', 0 );
 }
 
/**
 * saves the connection to the database
 * @return id of saved connection
 */
 
function saveConnection( ){
	global $database;
	josSpoofCheck();
	$row = new fabrikConnection( $database );
	if( $_POST['passwordConf'] != $_POST['password'] ){
		echo "<script> alert('" . _PASSWORDS_DO_NOT_MATCH . "'); window.history.go(-1); </script>\n";
		exit();
	} 		
	if( $_POST['id'] != '0' ){ /* if we're editing an existing connection and no new password has been added we want to delete the post password data*/
		if( $_POST['password'] == '' ){
			unset( $_POST['password'] );
		}
	}	
	if ( !$row->bind( $_POST ) ) {
		echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
		exit();
	} 
	if ( !$row->store( ) ) {
		echo "<script> alert('" . $row->getError() . "'); window.history.go(-1); </script>\n";
		exit();
	} 
	$row->checkin( );
	return $row->id;
}

/**
 * copy a connection
 * @param int connection id
 */
 
function copyConnection( $cid ){
	global $database;
	josSpoofCheck();
	$maxOrder = 0;
	if( is_array( $cid ) ){	
		foreach( $cid as $id ){
			$maxOrder ++;
			$row = new fabrikConnection( $database );
			$row->load( $id );
			//remove the id to ensure that we create a new element rather than overwriting the origional element?
			$row->id = null;
			if ( !$row->check( ) ) {
				echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
				exit();
			}
			if ( !$row->store( ) ) {
				echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
				exit();
			}
		}
	}
	mosRedirect("index2.php?option=com_fabrik&amp;task=connections", _CONNECTION . _COPIED);
}

/**
 * delete connection
 * @param int connection id
 */
 
function deleteConnection( $cid ){
	global $database;
	josSpoofCheck();
	$msg = '';
	for ( $i = 0, $n = count($cid); $i < $n; $i++ ) {
		if ( $cid[$i] == '1' ){
			$msg .= _CAN_NOT_DELETE_FIRST_CONNECTION;
		} else {
			$sql = "DELETE FROM #__fabrik_connections WHERE id = '" . $cid[$i] . "'";
			$database->setQuery($sql);
			if ( !$database->query( ) ) {
				$msg .= $database->getErrorMsg( ) . "\n";
			} 
		}
	} 
	if ( $msg == '' ) {
		$msg = _DELETE_CONNECTION_OK;
	}
	mosRedirect("index2.php?option=com_fabrik&amp;task=connections", $msg);
}

/**
 * show list of database connection
 * @param string message
 */
 
function displayConnections( $msg = '' ){
	global $database, $mainframe, $mosConfig_offset, $mosConfig_absolute_path; 
	// get the total number of records
	$database->setQuery("SELECT count(*) FROM #__fabrik_connections");
	$total = $database->loadResult();
	echo $database->getErrorMsg();
	$limit = intval(mosGetParam($_POST, 'limit', 10));
	$limitstart = intval(mosGetParam($_POST, 'limitstart', 0));
	$sql = "SELECT *, u.name AS editor, #__fabrik_connections.id AS id FROM #__fabrik_connections " .
			"LEFT JOIN #__users AS u ON #__fabrik_connections.checked_out = u.id " .
			"LIMIT $limitstart,$limit";
	$database->setQuery( $sql );
	require_once( $mosConfig_absolute_path . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );
	$rows = $database->loadObjectList( );
	if ( $database->getErrorNum( ) ) {
		echo $database->stderr( );
		return false;
	} 
			
	html_connection_content::displayConnections( $rows, $pageNav, $msg );
}

/**
 * publish a connection
 * @param int connection id
 * @param bol true/false to publish/unpublish
 */

 function do_publish( $cid, $state ){
 	global $database;
 	josSpoofCheck();
	$row = new fabrikConnection( $database );
 	$row->publish( $cid, $state );
 }
 ?>