<?php

/**
 * @package  fabrik
 * @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
* copies a group
* @param int ground id
*/

function copyGroup( $cid ) {
	global $database;
	josSpoofCheck();
	if ( !is_array( $cid ) || count( $cid ) < 1 ) {
		echo "<script> alert('Select an item to move'); window.history.go(-1);</script>\n";
		exit;
	}
	foreach ( $cid as $id ) {
		$oGroup = new fabrikGroup( $database );
		$oGroup->load( $id );
		$oNewGroup = new fabrikGroup( $database );
		$oNewGroup->copyRow( $id );
	}
}

/**
 * cancels an edit operation
 */

function cancelGroup( ){
	global $database;
	josSpoofCheck();
	$row = new fabrikGroup( $database );
	$row->bind( $_POST );
	$row->checkin( );
	$redirect = mosGetParam( $_POST, 'redirect', 0 );
}

/**
 * publish/unpublish a table
 * @param array/int table to set publish state
 * @param bol publish on/off
 */

function publishGroup( $id, $state ) {
	global $database;
	josSpoofCheck();
	$oGroup = new fabrikGroup( $database );
	$oGroup->publish( $id, $state );
}


/**
* Show all groups
* @return boolean false if database error
*/

function showGroups( ) {
	global $database, $mainframe, $mosConfig_offset, $mosConfig_absolute_path;
	$limit = intval( mosGetParam( $_POST, 'limit', 10 ) );
	$limitstart = intval( mosGetParam( $_POST, 'limitstart', 0 ) );
	$filter_groupId = $mainframe->getUserStateFromRequest( "filter_groupId", 'filter_groupId', 0 );
	$filter_formId = $mainframe->getUserStateFromRequest( "filter_formId", 'filter_formId', 0 );

	$where = array ( );
	$lists = array ( );
	$sWhere = '';
	if ( $filter_groupId >= 1 ) {
		$where[] = " g.id = '$filter_groupId' ";
	}
	if ( $filter_formId >= 1 ) {
		$where[] = " fg.form_id = '$filter_formId' ";
	}
	if ( !empty ( $where ) ) {
		$sWhere .= " WHERE ".implode(' AND ', $where);
	}

	// get the total number of records
	$totalSql = "SELECT COUNT(g.id) FROM #__fabrik_groups AS g "."RIGHT JOIN #__fabrik_formgroup AS fg "."ON g.id = fg.group_id ".$sWhere;
	$database->setQuery( $totalSql );
	$total = $database->loadResult( );
	echo $database->getErrorMsg( );

	$sql = "SELECT *, u.name AS editor, g.id AS id, g.state as state FROM #__fabrik_groups AS g 
			LEFT JOIN #__fabrik_formgroup AS fg ON g.id = fg.group_id " .
			"LEFT JOIN #__users AS u ON u.id = g.checked_out" .
			"\n LEFT JOIN #__fabrik_forms AS f ON f.id = fg.form_id " .
			"\n $sWhere LIMIT $limitstart,$limit";
	$database->setQuery( $sql );
	echo $database->getErrorMsg( );
	$rows = $database->loadObjectList( );
	require_once( $mosConfig_absolute_path . '/administrator/includes/pageNavigation.php' );

	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	$arElcount = array ();

	foreach ( $rows as $row ) {
		$oGroup = new fabrikGroup( $database );
		$oGroup->load( $row->id );
		$aEls = $oGroup->getMyElements( false, false );
		$arElcount[$row->id] = count( $aEls );
	}

	$oGroup = new fabrikGroup( $database );
	$lists['groupId'] = $oGroup->makeDropDown( $filter_groupId );
	$oForm = new fabrikForm( $database );
	$lists['formId'] = $oForm->makeDropDown( $filter_formId );
	html_group_content::showGroups( $rows, $pageNav, $arElcount, $lists );
}

/**
* Delete a group
* @param aray of integers for groupids to delete
* @param string action
*/

function deleteGroup( $cid ) {
	global $database;
	josSpoofCheck();
	$msg = '';
	for ( $i = 0, $n = count( $cid ); $i < $n; $i ++ ) {
		$sql = "DELETE FROM #__fabrik_groups WHERE id = '".$cid[$i]."'";
		$database->setQuery( $sql );
		if ( !$database->query( ) ) {
			$msg .= $database->getErrorMsg() . "\n";
		}
		$sql = "DELETE FROM #__fabrik_formgroup WHERE group_id = '".$cid[$i]."'";
		$database->setQuery( $sql );
		if ( !$database->query( ) ) {
			$msg .= $database->getErrorMsg( ) . "\n";
		}
	}
}

/**
 * delete all groups elements - not plugged into admin yet 
 * @param int group id
 * @return string error message
 */

function deletefabrikGroupElements( $groupId ) {
	global $database;
	$datasbase->setQuery( "DELETE FROM #__fabrik_elements WHERE group_id = '$groupId'" );
	if ( !$database->query( ) ) {
		return $database->getErrorMsg( ) . "\n";
	}
	return "";
}

/**
* Save the group
* @param array data to save to group
* @return int group id
*/

function saveGroup( $aData ) {
	global $database, $my;
	josSpoofCheck();
	$row = new fabrikGroup( $database );
	$params = mosGetParam( $_POST, 'params', '' );
	if ( is_array( $params ) ) {
		$txt = array( );
		foreach ( $params as $k => $v ) {
			$txt[] = "$k=$v";
		}
		$row->attribs = implode( "\n", $txt );
	}
	if(!isset($aData['state'])){ $aData['state'] = 0;}
	if ( !$row->bind( $aData ) ) { 
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit( );
	}
	if ( !$row->check( ) ) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit( );
	}
	if ( !$row->store( ) ) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit( );
	}
	$row->checkin( );
	$isNew = ( $row->id == 0 );
	if ( $isNew ) {
		$groupId = $database->insertid( );
	} else {
		$groupId = $row->id;
	}
	return $groupId;
}

/**
* Edit a group
* @param integer groupid
* @param string scope??
* @param string message
*/

function editGroup( $uid = 0, $msg = '' ) {
	global $database, $my, $mosConfig_absolute_path;
	$row = new fabrikGroup( $database );
	$row->load( $uid );
	// fail if checked out not by 'me'
	if ( $row->checked_out && $row->checked_out <> $my->id ) {
		mosRedirect("index2.php?option=com_fabrik&scope=$row->scope&mosmsg=The form $row->title is currently being edited by another administrator");
	}
	if ( $uid ) {
		$row->checkout( $my->id );
	}
	// get the available element types
	$database->setQuery( "SELECT id AS value, element_name AS text FROM #__fabrik_elements" );
	$elements = $database->loadObjectList( );
	$elementslist = mosHTML :: selectList( $elements, 'element_id', 'class="inputbox" size="1"', 'value', 'text', intval( $row->id ) );
	//get params for element
	$params = new fabrikParams( $row->attribs, $mosConfig_absolute_path.'/administrator/components/com_fabrik/xml/group.xml', 'component' );
	html_group_content :: editGroup( $row, $elementslist, $msg, $params );
}

/**
* Order the group within a specific form
* @param integer groupid
* @param string inc??
* @return boolean false if not saved
*/

function orderfabrikFormGroup( $uid, $inc ) {
	global $database;
	josSpoofCheck();
	$row = new fabrikFormGroup( $database );
	$row->load( $uid );
	$row->move( $inc, "" );
}