<?php

/**
 * @package  fabrik
 * @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function askDeleteTableMethod( $id ){
	html_table_content::confirmDelete( $id );
}
/**
* Cancels an edit operation
*/

function cancelTable( )
{
	global $database;
	josSpoofCheck();
	$row = new fabrikTable( $database );
	$row->bind( $_POST );
	$row->checkin( );
	$redirect = mosGetParam( $_POST, 'redirect', 0 );
	mosRedirect( 'index2.php?option=com_fabrik&task=tables' );
}

/**
 * deletes rows from the table spec'd in table 
 * @param array ids to delete
 * @param int table id
 */
 
function deleteTableRows( $ids, $tableId )
{
	global $database;
	josSpoofCheck();
	$oTable = new fabrikTable( $database );
	$oTable->load( $tableId );
	$oTable->getConnection( );
	$db = $oTable->_oConnDB;
	$table = $oTable->db_table_name;
	$key = $oTable->db_primary_key;
	foreach ($ids as $id) {
		$id = urldecode($id);
		$sql = "DELETE FROM $table WHERE $key = '$id'";
		$db->setQuery( $sql );
		if (!$db->query( )) {
			echo $db->getErrorMsg( );
		}		
	}
}

/**
 * copys a table
 * @param array of table ids to delete
 */
 
function copyTable( $cid )
{
 	global $database;
 	josSpoofCheck();
	if (is_array( $cid )) {
		foreach ($cid as $id) {
			$row = new fabrikTable( $database );	
			$ar = array( "id"=>'$row->id' );
			$row->copyRow( $id, $ar	);
		}
	} else {
		$row = new fabrikTable( $database );	
		$ar = array( "id"=>'$row->id' );
		$row->copyRow( $cid, $ar );
	}
}
 
/**
 * shows a view of the database data
 * @param int table id
 */
 
function viewTable( $tableId )
{
 	global $database, $mosConfig_absolute_path, $mosConfig_list_limit, $mainframe;
	$oTable = new fabrikTable( $database );
	$oTable->load( $tableId );
	$doCalc = mosGetParam($_GET, 'calculations', false );
	if ($doCalc) {
		$oTable->_reloadCalculations = true;
	}
	$oTable->setAdmin( true );
	$oTable->render( );
}
 
/**
 * deletes an array of tables 
 * @param mixed array of table ids/single table id to delete
 * @param bol delete only table (0) or table, form groups and elements (1) 
 */

function deleteTable( $cid, $delRelated )
{
	global $database;
	josSpoofCheck();
	$oTable = new fabrikTable( $database );
	if (is_array( $cid )) {
		foreach ($cid as $id) {
			$oTable->load( $id );
			$oTable->deleteTable( $delRelated );
		}
	} else {
		$oTable->load( $cid );
		$oTable->deleteTable( $delRelated );
	}
}

/**
  * Create a psudo component in the admin menu
  * @param int table id to create admin link for
  */
  
function adminMenuLink( $id )
{
	global $database;
	$name = mosGetParam( $_POST, 'admin_link_name', '' );
	$sql = "INSERT INTO #__components "."(name, admin_menu_link, admin_menu_alt, `option`, admin_menu_img)"." values "."('$name', 'option=com_fabrik_app&id=$id', '$name', 'com_fabrik_app', 'js/ThemeOffice/component.png')";
	$database->setQuery( $sql );
	$database->query( );
	$msg .= $database->getErrorMsg( );
	$msg = " Admin component, $name,  successfully created";
	mosRedirect( "index2.php?option=com_fabrik&task=editTable&id=".$id, $msg );
}

/**
 * Save the table information to the database
 * @param string component current task
 */

function saveTable( $task )
{
	global $database;
	josSpoofCheck();
	$menu 		= mosGetParam( $_POST, 'menu', 'mainmenu' );
	$menuid 	= mosGetParam( $_POST, 'menuid', 0 );
	$oTable 	= new fabrikTable( $database );
	$oTable->save();
	switch ($task) {
		case 'go2menuTable' :
			mosRedirect( "index2.php?option=com_menus&menutype=".$menu );
			break;
		case 'go2menuitemTable' :
			mosRedirect( "index2.php?option=com_menus&menutype=".$menu."&task=edit&hidemainmenu=1&id=".$menuid );
			break;
		case 'menuLinkTable' :
			$oTable->menuLink( 'viewTable', 'tableid='.$oTable->id );
			$msg =_MENU_LINK . ' ' . _CREATED;
			$url = "index2.php?option=com_fabrik&task=editTable&cid=".$oTable->id;
			mosRedirect( $url, $msg );
			break;
		case 'makeadmincomponentTable' :
			adminMenuLink( $row->id );
			break;
		case 'applyTable':
			$msg = _TABLE . ' ' . _UPDATED;
			mosRedirect( 'index2.php?option=com_fabrik&task=editTable&hidemainmenu=1&cid=' . $oTable->id , $msg );
			break;
		default :
			$msg = _TABLE . ' ' . _SAVED;
			mosRedirect( 'index2.php?option=com_fabrik&task=tables' , $msg );
			break;
	}
}

/** 
 * this summarises what has automatically been created and allows the user to
 * navigate to any of the automatically created forms/groups/elements 
 * @param  int table id
 */

function showLinkedElements( $tableId )
{ 
	if( is_array( $tableId ) ){ $tableId = $tableId[0];}
	global $database;
	$oTable = new fabrikTable( $database );
	$oTable->load( $tableId );
	$formId = $oTable->form_id;
	$oForm = new fabrikForm( $database );
	$oForm->load( $formId );
	$formGroupEls = $oForm->getFormGroups( false, false );
	html_table_content::showTableDetail( $oForm, $formGroupEls );
}

/**
 * ajax function to update any drop down that contains records relating to the selected table
 * called each time the selected table is changed
 */

function ajax_updateColumDropDowns()
{
	global $database, $mosConfig_absolute_path;
	$cnnId = mosGetParam($_REQUEST, 'cid', 1);
	$tbl	= mosGetParam($_REQUEST, 'table', '');
	$oTable = new fabrikTable( $database );
	$fieldDropDown 	= $oTable->getFieldsDropDown( $cnnId, $tbl, '-', false, 'order_by' );
	$fieldDropDown2 = $oTable->getFieldsDropDown( $cnnId, $tbl, '-', false, 'group_by' );
	$fieldDropDown3 = $oTable->getFieldsDropDown( $cnnId, $tbl, '-', false, 'params[group_by_order]' );
	echo "$('orderByTd').innerHTML = '$fieldDropDown';";
	echo "$('groupByTd').innerHTML = '$fieldDropDown2';";
	echo "$('groupByOrderTd').innerHTML = '$fieldDropDown3';";
}

/**
 * edit or add a table
 * @param int id of the table to edit
 */

function editTable( $id )
{
	global $mosConfig_list_limit, $mosConfig_absolute_path, $database, $my, $acl, $mosConfig_dbprefix, $mosConfig_offset, $mosConfig_live_site;
	if (is_array( $id )) {
		$id = $id[0];
	}
	$connectionTables = array( );
	//  this only appears if you are automatically creating the table from an existing for - which has no table associated with it
	$fabrikid = mosGetParam( $_GET, 'fabrikid', '' ); 
	$row = new fabrikTable( $database );
	$row->load( $id );
	$params = new fabrikParams( $row->attribs, $mosConfig_absolute_path . '/administrator/components/com_fabrik/xml/table.xml', 'component' );	
	$tabs = new mosTabs( 1 );
	$lists['jointypes'] = "";
	$lists['tablejoin'] = "";
	$lists['defaultJoinTalbes'] = '';
	$lists['defaultJoinTableFrom'] = '';
		
	$oConn = new fabrikConnection( $database );
	if ($id == 0) {
		$row->table_template = 'default';
		$row->rows_per_page = $mosConfig_list_limit;
		if ($fabrikid == '') { 
			$row->publish_up = date( 'Y-m-d', time() + $mosConfig_offset * 60 * 60 );
			//create form drop down menu
			$database->setQuery( "SELECT id AS value, form_title AS text FROM #__fabrik_forms" );
			$forms[] = mosHTML::makeOption( '-1', _CHOOSE_NO_FORM );
			$forms = array_merge( $forms, $database->loadObjectList() );
			// ok for when form or table
			$javascript		= "onchange=\"document.adminForm.connection_id.selectedIndex = 0;"."changeDynaList( 'db_table_name', connectiontables, 0, 0, 0);\"";  
			$lists['current_forms'] = mosHTML::selectList( $forms, 'form_id', 'class="inputbox" size="1" '.$javascript, 'value', 'text', 0 );
			//create database connection drop down
			$realCnns 	= $oConn->getConnections( );
			$javascript = "onchange=\"changeDynaList( 'db_table_name', connectiontables, document.adminForm.connection_id.options[document.adminForm.connection_id.selectedIndex].value, 0, 0);\"";
			$lists['connections'] = $oConn->getConnectionsDd( $realCnns, $javascript , 'connection_id', '');
			// get a list of tables from each connection
			$connectionTables = $oConn->getConnectionTables( $realCnns );
			$javascript ='';
			$lists['tablename'] = 	'<select name="db_table_name" id="tablename" class="inputbox" size="1" >
						<option value="" selected="selected">' . _CHOOSE_NO_TABLE .'</option>
						</select>';
			
			// get list of links to this item
		} else {
			// set the connection to conn (id = 1)
			$oConn->load( 1 );
			$realCnns = $oConn->getConnections( );
			$connectionTables = $oConn->getConnectionTables( $realCnns );
			$lists['connections'] = $oConn->description . "<input type=\"hidden\" value=\"1\" id=\"connection_id\" name=\"connection_id\" />";
			//set the table to the fabrik table
			$thisTable = $mosConfig_dbprefix. "fabrik_formdata_" . $fabrikid;
			$lists['tablename'] = $thisTable .  "<input type=\"hidden\" value=\"$thisTable\" id=\"tablename\" name=\"db_table_name\" />";
		}
		$lists['order_by'] 			= _TABLE_ORDERING_AFTER_SAVE ;
		$lists['group_by'] 			= _TABLE_ORDERING_AFTER_SAVE ;
		$lists['group_by_order']	= _TABLE_ORDERING_AFTER_SAVE ;
		$lists['filter-fields'] 	= _TABLE_ORDERING_AFTER_SAVE ;
		$lists['feed_title']		= _TABLE_ORDERING_AFTER_SAVE ;
		$lists['db_primary_key'] 	= _TABLE_ORDERING_AFTER_SAVE ;
		$lists['feed_date']			= _TABLE_ORDERING_AFTER_SAVE ;
		 
	} else {  
		//if record already exists then you can't change the form or table it points to	
		// fail if checked out not by 'me'
		if ($row->checked_out && $row->checked_out != $my->id) {
			mosRedirect( 'index2.php?option=com_fabrik', 'The connection '. $row->description .' is currently being edited by another administrator' );
		}
		$row->checkout( $my->id );

		if ($row->connection_id != "-1") {
			$sql = "SELECT description FROM #__fabrik_connections WHERE id = '$row->connection_id'";
			$database->setQuery( $sql );
			$lists['connections'] = $database->loadResult();
			$lists['tablename'] = $row->db_table_name;
		} else {
			$lists['connections'] = "no database";
			$lists['tablename'] = "no table";
		}
		$oForm = new fabrikForm( $database );
		$oForm->load( $row->form_id );
		//table join info 
		$sql = "SELECT * FROM #__fabrik_joins WHERE table_id = '$row->id'";
		$database->setQuery( $sql );
		$aJoinObjs = $database->loadObjectList( );
		$lists['joins'] = &$aJoinObjs;
				
		$lists['order_by'] 		 = $oForm->getElementList( 'order_by', $row->order_by, false, false, true, $aJoinObjs, $row->db_table_name );
		$lists['group_by'] 		 = $oForm->getElementList( 'group_by', $row->group_by, false, false, true, $aJoinObjs, $row->db_table_name );
		$lists['group_by_order'] = $oForm->getElementList( 'params[group_by_order]', $params->get('group_by_order'), false, false, true, $aJoinObjs, $row->db_table_name );
		$lists['filter-fields']  = $oForm->getElementList( 'params[filter-fields][]', '', false, false, true, $aJoinObjs, $row->db_table_name );
		$lists['db_primary_key'] = $oForm->getElementList( 'db_primary_key', $row->db_primary_key, false, false, true, $aJoinObjs, $row->db_table_name );
		$lists['feed_title']	 = $oForm->getElementList( 'params[feed_title][]', $params->get('feed_title'), false, false, true, $aJoinObjs, $row->db_table_name );
		$lists['feed_date']		 = $oForm->getElementList( 'params[feed_date][]', $params->get('feed_date'), false, false, true, $aJoinObjs, $row->db_table_name );
		$sql = "SELECT form_title FROM #__fabrik_forms WHERE id = '$row->form_id'";
		$database->setQuery( $sql );
		$lists['current_forms'] = $database->loadResult( );
		//but you can now add table joins
		$oConn->load( $row->connection_id ); 
		///load in current connection
		$joinFromTables[] 		= mosHTML::makeOption( $row->db_table_name, $row->db_table_name );
		$lists['jointypes'] 	= html_content::makeTableJoinTypeDd();
		$javascript 			= "";
		$lists['defaultjoin'] 	= $oConn->getTableDdForThisConnection( $javascript, 'table_join[]', '');
		$lists['tablejoin'] 	= $oConn->getTableDdForThisConnection( $javascript, 'table_join[]', '');

		//make a drop down validation type for each validation
		$aActiveJoinTypes = array( );
		if (is_array( $aJoinObjs )) {
			for ($ff = 0;$ff<count($aJoinObjs);$ff++) {
				$oJoin = $aJoinObjs[$ff];
				$joinFromTables[] = mosHTML::makeOption( $oJoin->table_join, $oJoin->table_join );
				//join_from_table
		
				$aJoinObjs[$ff]->join_type = html_content::makeTableJoinTypeDd( $oJoin->join_type );
				$tableDd = $oConn->getTableDdForThisConnection( $javascript, 'table_join[]', $oJoin->table_join );
				$aJoinObjs[$ff]->table_join = $tableDd;
			}
			for ($ff = 0; $ff < count( $aJoinObjs ); $ff++) {
				$aJoinObjs[$ff]->join_from_table = mosHTML::selectList( $joinFromTables, 'join_from_table[]', 'class="inputbox" size="1" ', 'value', 'text',$aJoinObjs[$ff]->join_from_table ); 
			}
			$lists['defaultJoinTalbes'] = $oConn->getTableDdForThisConnection( $javascript, 'table_join[]', '');
			// need to put in this:
			//for dd below - but have to first figure out way to assign it to the correct dd (as multiple joins created)
			$lists['defaultJoinTableFrom'] = mosHTML::selectList( $joinFromTables, 'join_from_table[]', ' class="inputbox" size="1" ', 'value', 'text','' );
		}
	}
	if (trim( $row->publish_down ) == '0000-00-00 00:00:00') {
		$row->publish_down = 'Never';
	}
	if ($row->id != '') { 
		//only existing tables can have a menu linked to them
		$and = "\n AND link LIKE 'index.php?option=com_fabrik' AND params LIKE '%task=viewTable%'";
		$and .= " AND params LIKE '%tableid=".$row->id."'";
		$menus = mosAdminMenus::Links2Menu('components', $and );
	} else {
		$menus = null;
	}
	// build list of users
	$active = (intval( $row->created_by ) ? intval( $row->created_by ) : $my->id);
	$lists['created_by'] = mosAdminMenus::UserSelect( 'created_by', $active );
	//$query = 'SELECT id AS value, name AS text FROM #__groups ORDER BY id';
	
	$query =  'SELECT group_id AS value, name AS text FROM #__core_acl_aro_groups ORDER BY group_id';
	
	$gtree = $acl->get_group_children_tree( null, 'USERS', false );
	$optAll = array(mosHTML::makeOption( '30', ' - Everyone'), mosHTML::makeOption( "26", 'Nobody' ));
	$gtree = array_merge( $gtree, $optAll );
	
	$database->setQuery( $query );
	$groups = $database->loadObjectList( );

	$lists['access'] 			 = mosHTML::selectList( $gtree, 'access', 'class="inputbox" size="1"', 'value', 'text', (intval( $row->access ) == 0)? 29: intval( $row->access )   );
	$lists['filter-access'] 	 = mosHTML::selectList( $gtree, 'params[filter-access][]', 'class="inputbox"', 'value', 'text', (intval( $row->access ) == 0)? 29: intval( $row->access ) );
	$lists['allow_view_details'] = mosHTML::selectList( $gtree, 'allow_view_details', 'class="inputbox" size="1"', 'value', 'text', (intval( $row->allow_view_details ) == 0)? 29: intval( $row->allow_view_details ) );
	$lists['allow_edit_details'] = mosHTML::selectList( $gtree, 'allow_edit_details', 'class="inputbox" size="1"', 'value', 'text', (intval( $row->allow_edit_details ) == 0)? 29: intval( $row->allow_edit_details ) );
	$lists['allow_add'] 		 = mosHTML::selectList( $gtree, 'allow_add', 'class="inputbox" size="1"', 'value', 'text', (intval( $row->allow_add ) == 0)? 29: intval( $row->allow_add ) );
	$lists['allow_delete'] 		 = mosHTML::selectList( $gtree, 'allow_delete', 'class="inputbox" size="1"', 'value', 'text', (intval( $row->allow_delete ) == 0)? 29: intval( $row->allow_delete ));
	$lists['allow_empty'] 		 = mosHTML::selectList( $gtree, 'params[allow-empty]', 'class="inputbox"', 'value', 'text', (intval( $params->get('allow-empty')) == 0)? 25:  $params->get('allow-empty'));
	$lists['menuselect'] 		 = mosAdminMenus::MenuSelect( );

	$aUniqueUserVars = array( );
	$aUniqueUserVars[] = mosHTML::makeOption('0', 'n/a');
	$aUniqueUserVars[] = mosHTML::makeOption('1', 'id');
	$aUniqueUserVars[] = mosHTML::makeOption('2', 'email');
	$aUniqueUserVars[] = mosHTML::makeOption('3', 'username');
	$lists['uniqueUserVars'] = mosHTML::selectList( $aUniqueUserVars, 'table_view_own_details', 'class="inputbox"','value','text',$row->table_view_own_details );

	//get the table templates
	$templates = fabrikListDirs( $mosConfig_absolute_path. "/components/com_fabrik/views/table/tmpl/" );
	if (is_array( $templates )) {
		foreach ($templates as $file) {
			$oTemplates[] = mosHTML::makeOption($file);
		}
	}
	$lists['tableTemplates'] 	 = mosHTML::selectList( $oTemplates, 'table_template', 'class="inputbox"', 'value', 'text', $row->table_template );
	
	// make the filter action drop down
	$filterActions[] = mosHTML::makeOption( 'onchange', _ON_CHANGE );
	$filterActions[] = mosHTML::makeOption( 'submitform', _SUBMIT_FORM );
	$lists['filter_action'] = mosHTML::selectList( $filterActions, 'filter_action', 'class="inputbox" size="1" ', 'value', 'text', $row->filter_action );
	
	//make the order direction drop down 
	$orderDir[] = mosHTML::makeOption( 'ASC', _ASCENDING );
	$orderDir[] = mosHTML::makeOption( 'DESC', _DESCENDING );
	$lists['order_dir'] 		 = mosHTML::selectList( $orderDir, 'order_dir', 'class="inputbox" size="1" ', 'value', 'text', $row->order_dir );
	$lists['group_by_order_dir'] = mosHTML::selectList( $orderDir, 'params[group_by_order_dir]', 'class="inputbox" size="1" ', 'value', 'text', $params->get( 'group_by_order_dir') );
	//find tables that link to this table
	$linkedTables = $row->getJoinsToThisKey( );
	

	$aExisitngLinkedTables = $params->get( 'linkedtable', '', 'array' );
	$aExisitngLinkedForms = $params->get( 'linkedform', '', 'array' );
	
	$aExistingTableHeaders = $params->get( 'linkedtableheader', '', 'array' );
	$aExistingFormHeaders = $params->get( 'linkedformheader', '', 'array' );
	
	$lists['linkedtables']  = array();
	$f = 0;
	if (!is_array( $linkedTables )) {
		$linkedTables = array();
	}
	foreach ($linkedTables as $linkedTable) {
		if (empty( $aExisitngLinkedTables )) {
			$yeschecked = '';
		} else {
			$yeschecked = ( in_array($linkedTable->tablelabel, $aExisitngLinkedTables) || $aExisitngLinkedTables[$f] != '0' ) ? 'checked="checked"' :  '';
		}
		$nochecked = ( !in_array($linkedTable->tablelabel, $aExisitngLinkedTables) || $aExisitngLinkedTables[$f] == '0') ? 'checked="checked"' : '';

		$el =  '<label><input name="params[linkedtable][' . $linkedTable->tablelabel . ']" value="0" ' .$nochecked . ' type="radio">' . _NO . '</label>';
		$el.=  '<label><input name="params[linkedtable][' . $linkedTable->tablelabel . ']" value="' . $linkedTable->tablelabel .'" ' .$yeschecked . ' type="radio">' . _YES . '</label>';
		
		if (empty( $aExisitngLinkedTables )) {
			$yeschecked = '';
		} else {
			$yeschecked = (in_array($linkedTable->tablelabel, $aExisitngLinkedForms) || $aExisitngLinkedForms[$f] != '0')? 'checked="checked"': '';
		}
		$nochecked = ( !in_array($linkedTable->tablelabel, $aExisitngLinkedForms) || $aExisitngLinkedForms[$f] == '0' ) ? 'checked="checked"' : '';
		$el2 =  '<label><input name="params[linkedform][' . $linkedTable->tablelabel . ']" value="0" ' .$nochecked . ' type="radio">' . _NO . '</label>';
		$el2.=  '<label><input name="params[linkedform][' . $linkedTable->tablelabel . ']" value="' . $linkedTable->tablelabel .'" ' .$yeschecked . ' type="radio">' . _YES . '</label>';
		
		
		$tableHeader = '<input name="params[linkedtableheader][' . $linkedTable->tablelabel . ']" value="' . @$aExistingTableHeaders[$f] .'" >';
		$formHeader = '<input name="params[linkedformheader][' . $linkedTable->tablelabel . ']" value="' . @$aExistingFormHeaders[$f] .'" >';
		$lists['linkedtables'][] = array( str_replace( array( "\n", "\r", "<br>", "</br>") , '', $linkedTable->element_label ), 
							str_replace( array( "\n", "\r", "<br>", "</br>") , '', $linkedTable->tablelabel ), 
							$el, $tableHeader, $el2, $formHeader );
		$f ++;
	}
	html_table_content::editTable($row, $lists, $tabs, $connectionTables, $menus, $fabrikid, $params );
}

/**
 * show summary of exiting tables
 */

function displayTables( )
{
	//TODO : fabrik : 2.5 : button to allow you to mirror the table's current form/group/elements in the database table - this will be the only way you can delete fields from the database table
	global $database, $mainframe, $mosConfig_offset, $mosConfig_list_limit, $mosConfig_absolute_path;
	$newFilterTable = mosGetParam( $_REQUEST, 'filter_table', '');
	$filter_table 	= $mainframe->getUserStateFromRequest( "filter_table", 'filter_table', '' );
	$limit 		  	= $mainframe->getUserStateFromRequest( "view{com_fabrik}{tables}limit", 'limit', $mosConfig_list_limit );
	$limitstart   	= $mainframe->getUserStateFromRequest( "view{com_fabrik}{tables}limitstart", 'limitstart', 0 );

	// get the total number of records
	$sql = "SELECT count(*) FROM #__fabrik_tables ";
	if ($filter_table != '') {
		$where[] = " label like '%$filter_table%' ";
	}
	$sWhere = '';
	if (!empty ( $where )) {
		$sWhere .= " WHERE ".implode(' AND ', $where);
		$sql = $sql . $sWhere;
	}	
	$database->setQuery( $sql );
	$total = $database->loadResult( );
	//ensure that the limit starts before the end of the data
	if ($total < $limitstart) { 
		$limitstart = 0;
	}
	echo $database->getErrorMsg( );
	
	$sql = "SELECT *, u.name AS editor, #__fabrik_tables.id AS id FROM #__fabrik_tables " .
			"LEFT JOIN #__users AS u ON #__fabrik_tables.checked_out = u.id " .
			" $sWhere " .
			"LIMIT $limitstart,$limit";
	$database->setQuery( $sql );
	require_once( $mosConfig_absolute_path .'/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );
	$rows = $database->loadObjectList( );
	if ($database->getErrorNum( )) {
		echo $database->stderr( );
		return false;
	}
	$lists['filter_table'] =  '<input type="field" value="' . $filter_table . '" name="filter_table" onblur="document.adminForm.submit( );" />';
	html_table_content::showTables( $rows, $pageNav, $lists );
}

/**
 * publish/unpublish a table
 * @param array/int table to set publish state
 * @param bol publish on/off
 */

function publishTable( $id, $state )
{
	global $database;
	josSpoofCheck();
	$oTable = new fabrikTable( $database );
	$oTable->publish( $id, $state );
}

/**
 * ajax load drop down of all columns in a given table
 */

function ajax_loadTableDropDown()
{
	global $database;
	$conn = mosGetParam($_REQUEST, 'conn', 1);
	$oCnn = new fabrikConnection( $database );
	$oCnn->load( $conn );
	$db = $oCnn->loadTableConnectionDB();
	$table 	= mosGetParam($_REQUEST, 'table', '');
	
	$name 	= mosGetParam($_REQUEST, 'name', 'table_key[]');
	$sql 	= "DESCRIBE `$table`";
	$db->setQuery( $sql );
	$aFields = $db->loadObjectList( );
	$fieldNames = array( );
	if (is_array( $aFields )) {
		foreach ($aFields as $oField) {
			$fieldNames[] = mosHTML::makeOption( $oField->Field );
		}
	}
	$fieldDropDown = mosHTML::selectList( $fieldNames, $name, "class=\"inputbox\"  size=\"1\" ", 'value', 'text', '' );
	echo $fieldDropDown;
}

/**
 * set up export table page
 * @param array table ids to export
 */

function exportTable( $cid )
{
	global $database;
	$rows = array();
	foreach ($cid as $id) {
		$oTable = new fabrikTable( $database );
		$oTable->load( $id );
		$rows[] = $oTable;
	}
	html_table_content::exportSettings( $rows );
}

/**
 * @param array table ids to export
 */

function doexportTable( $cid )
{
	global $database, $mosConfig_absolute_path;
	$format 		= mosGetParam($_POST, 'format', 'xml' );
	$includeData 	= mosGetParam( $_POST, 'tabledata', false );
	$fabrikData 	= mosGetParam( $_POST, 'fabrikfields', false );
	$label		 	= mosGetParam( $_POST, 'label', '' );
	$tablestructure = mosGetParam( $_POST, 'tablestructure', false );
	$incTemplates		= mosGetParam( $_POST, 'inctempaltes', false );
	require_once( $mosConfig_absolute_path ."/administrator/components/com_installer/installer.class.php" );
	require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_export.class.php" );
	$oExport = new fabrik_export( $label, $cid, $format, $includeData, $fabrikData, $tablestructure );
	$oExport->incTemplates = $incTemplates;
	$oExport->export( );
}

function importTable( ){
	global $database;
	$sql = "SELECT id AS value, label AS text FROM #__fabrik_tables";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	$def = new stdClass();
	$def->value = '';
	$def->text = '--Use New Table---';
	$rows = array_merge(array($def), $rows);
	$lists['fabrikTables'] = mosHTML::selectList( $rows, 'fabrik_table', 'class="inputbox" size="1" id="fabrik_table" ', 'value', 'text' );
	
	$oConn = new fabrikConnection( $database );
	$oConn->loadDefaultConnection();
	
	$database->setQuery( "SELECT id AS value, description AS text FROM #__fabrik_connections" );
	$rows = $database->loadObjectList();
	$lists['connections'] = mosHTML::selectList( $rows, 'connection_id', 'class="inputbox" size="1" id="connection_id" ', 'value', 'text', $oConn->id );
	
	html_table_content::importTables( $lists );
}

function doImportTable( ){
	global $mosConfig_absolute_path;
	josSpoofCheck();
	
	require_once( $mosConfig_absolute_path . '/includes/domit/xml_domit_lite_include.php' );
	require_once( $mosConfig_absolute_path ."/administrator/components/com_installer/installer.class.php" );

	$installer = new fabrik_package_import();
	
	// Check if file uploads are enabled
	if (!(bool)ini_get('file_uploads')) {
		HTML_installer::showInstallMessage( "The installer can't continue before file uploads are enabled. Please use the install from directory method.",
			'Installer - Error', 'index2.php?option=com_fabrik&amp;task=importTable' );
		exit();
	}

	// Check that the zlib is available
	if(!extension_loaded('zlib')) {
		html_table_content::showInstallMessage( "The installer can't continue before zlib is installed",
			'Installer - Error', 'index2.php?option=com_fabrik&amp;task=importTable' );
		exit();
	}

	$userfile = mosGetParam( $_FILES, 'userfile', null );	
	
	if (!$userfile) {
		html_table_content::showInstallMessage( 'No file selected', 'Upload new module - error',
		'index2.php?option=com_fabrik&amp;task=importTable');
		exit();
	}

	$userfile_name = $userfile['name'];

	$msg = '';
	$resultdir = $installer->uploadFile( $userfile['tmp_name'], $userfile['name'], $msg );
	
	if ($resultdir !== false) {
		if (!$installer->upload( $userfile['name'] )) {
			html_table_content::showInstallMessage( $installer->getError(), 'Upload '.$userfile_name.' - Upload Failed',
				'index2.php?option=com_fabrik&amp;task=importTable' );
		}
		$ret = $installer->install();

		html_table_content::showInstallMessage( $installer->getError(), 'Upload '.$userfile_name.' - '.($ret ? 'Success' : 'Failed'),
			'index2.php?option=com_fabrik&amp;task=importTable' );
			cleanupInstall( $userfile['name'], $installer->unpackDir() );
	} else {
		html_table_content::showInstallMessage( $msg, 'Upload '.$userfile_name.' -  Upload Error',
			'index2.php?option=com_fabrik&amp;task=importTable' );
	}	
}



/**
 * run after selection of csv file to import, 
 * if existing fabrik table selected then compares the 2 data structures to determine if there are
 * possibly new elements to add to the table.
 * Finally displays a form where you can choose which of the elements to import and in what format 
 */

function importCSV( ){
	global $database;
	josSpoofCheck();
	$oImport = new fabrik_csv_import();
	$oImport->checkUpload();
	$database->setQuery("SELECT elementtype_id AS value, elementtype_name AS text FROM #__fabrik_elementtypes");
	$elementTypes = $database->loadObjectList();
	$_SESSION['fabrik']['csvImportData'] 	 = $oImport->data;
	$_SESSION['fabrik']['csvImportHeadings'] = $oImport->headings;
	$table 			= mosGetParam( $_POST, 'table_name', '');
	$fabrik_table = 0;
	$pKey = '';
	if($table == ''){
		/* its an existing fabrik table */
		$fabrik_table	= mosGetParam( $_POST, 'fabrik_table', 0 );
		$oTable = new fabrikTable($database);
		$oTable->load( $fabrik_table );
		$tableParams = $oTable->loadParams();
		$csvFullName =  $tableParams->get( 'csvfullname', 0) ;
		$table = $oTable->label;
		$oTable->getFormGroupElementData( false, false );
		$lists['matchedHeadings'] = array();
		$lists['newHeadings']	 = array();
		$pKey = $oTable->db_primary_key; 
		$ignore = array('fabrik_cursor', 'fabrik_total', '__details_link' );
		foreach ($oImport->headings as $heading) {
			//ignore some internal fabrik fields
						
			switch( $csvFullName ){
				case 0:
					break;
				case 1:
					$heading = array_pop( explode( ".", $heading ) );
					break;
			}
			$heading = strtolower(preg_replace("/[^A-Za-z0-9]/", "_", $heading));
			if (in_array( $heading, $ignore )) {
				continue;
			}
			$found = false;
			//if "2" we sould use the label
			foreach ($oTable->_oForm->_groups as $oGroup) {
				foreach ($oGroup->_aElements as $oElement) {
					$toMatch = ( $csvFullName == 2 ) ? strtolower( $oElement->element_label ) : strtolower( $oElement->element_name );
					if (strtolower( $heading ) == $toMatch) {
						/** heading found in table */
						$lists['matchedHeadings'][] = $heading;
						$found = true;
					}
				}
			}
			if (!$found) {
				$lists['newHeadings'][] = $heading;
			}
		}
	} else {
		$lists['matchedHeadings'] = $oImport->headings;
	}
	$dropData	= mosGetParam( $_POST, 'drop_data', 0 );
	$elementTypes = mosHTML::selectList( $elementTypes, 'element_type_id[]', 'class="inputbox" size="1" ', 'value', 'text','2' );
	if( mosGetParam( $_POST, 'table_name', '') == '' && empty($lists['newHeadings'])){
		html_table_content::csvContinueConfirmation( $lists, $elementTypes, $oImport->data, $table, $pKey, $fabrik_table, $dropData);
	}else{
		html_table_content::csvChooseElementTypes( $lists, $elementTypes, $oImport->data, $table, $pKey, $fabrik_table);
	}
}

/**
 * cvs import: finally we create (if required) all db tables, fabrik tables, 
 * element, forms groups and insert any data
 */

function makeTableFromCSV( ){
	global $database, $my;
	$headings 		= $_SESSION['fabrik']['csvImportHeadings'];
	$data			= $_SESSION['fabrik']['csvImportData'];
	$elementTypes 	= mosGetParam( $_POST, 'element_type_id', array() );
	$pKey 			= mosGetParam( $_POST, 'key', array() );
	$table 			= mosGetParam( $_POST, 'table', '' );
	$fabrik_table	= mosGetParam( $_POST, 'fabrik_table', 0 );
	$elTypeCounter = 0;
	if( $fabrik_table > 0 ){
		/* exisitng fabrik table selected */
		$oTable 		= new fabrikTable( $database );
		$oTable->load( $fabrik_table );
		$tableParams 	= $oTable->loadParams();
		$fullKey 		= $tableParams->get('csvfullname', 0);
		
		$dropData		= mosGetParam( $_POST, 'drop_data', 0 );
		if($dropData){
			$oTable->dropData();
		}
		$akeyData = $oTable->getPrimaryKeyAndExtra();
		$pKey[$akeyData['colname']]=1;
		$oTable->getFormGroupElementData( false, false );
		$group = array_shift( $oTable->_oForm->_groups );
		$groupId = $group->id;
		/* get the first group id to attach new elements to */
		$createElements = mosGetParam( $_POST, 'createElements', array() );
		foreach( $createElements as $newEl=>$add ){
			if( $add == '1'){
				$oElement = new fabrikElement( $database );
				$oElement->element_label 	= strtolower($newEl);
				$oElement->elementtype_id 	= $elementTypes[$elTypeCounter];
				$oElement->group_id 		= $groupId;
				$oElement->element_name 	= $newEl;
				$oElement->eval 			= 0;
				$oElement->password 		= 0;
				$oElement->state 			= 1;
				$oElement->maxlength 		= 255;
				$oElement->created 			= date( 'Y-m-d' );
				$oElement->created_by 		= $my->id;
				$oElement->created_by_alias 	= $my->username;
				$oElement->checked_out 		= 0;
				$oElement->element_width 	= 30;
				$oElement->element_height 	= 10;
				$oElement->use_wysiwyg 		= 1;
				$oElement->show_in_table_summary = 1;
				$oElement->ordering 		= 0;
				$oElement->store();
				$where = " group_id = '" . $oElement->group_id . "'";
				$oElement->move( 1, $where );
				$oElement->addElementToDatabaseTable( $groupId, true );
			}
			$elTypeCounter ++;
		}

	}
	$fields 			= array();
	$aSpecificElements 	= array();
	$thisPrimaryKey 	= '';
	
	//create elements
	foreach($headings as $key=>$val){
		if(array_key_exists($key, $elementTypes)){
			$elementType = $elementTypes[$key];
			$props 			= new stdClass();
			$props->Field 	= strtolower(preg_replace("/[^A-Za-z0-9]/", "_", $val));
			
			$oElement 		= new fabrikElement( $database );
			$oElement->elementtype_id = $elementType;
			$oElement->element_label = $props->Field;
			$props->Extra = '';
			$props->Null = '';
			$props->Default = '';
			switch($elementType){
				case '5':
					$props->Type = 'text';
					break;
				case '11':
					$props->Type = 'datetime';
					//go through data and turn any dates into unix timestamps
					for($j=0;$j<count($data);$j++){
						for($i=0;$i<count($data[$j]);$i++){
							if($i == $key){
								$data[$j][$i] = str_replace("/", "-", $data[$j][$i]);
								$data[$j][$i] = date("Y-m-d H:i:s", strtotime_uk($data[$j][$i]));
							}
						}
					}
					break;
				case '2':
				default:
					$props->Type = "varchar(255)";
					break;
			}
			if(array_key_exists($val, $pKey)){
				$props->Key = 'PRI';
				$props->Type = "int(10)";
				$oElement->link_to_detail = '1';
				if($thisPrimaryKey == ''){
					$thisPrimaryKey = $props->Field;
				}
			}else{
				$props->Key = '';
			}
			
			$fields[] = $props;
			$aSpecificElements[] = $oElement;
		}
	}
	/** create a new table if one not previously selected **/
	if( $fabrik_table == 0 ){
		//check if the table really exists
		
		$oTable = new fabrikTable( $database );
		$oTable->db_table_name  = preg_replace("/[^A-Za-z0-9]/", "_", $table);
		if(in_array($oTable->db_table_name, $database->getTableList())){
			echo "table already exists - unable to continue";
			return false;
		}
		$oConn					= new fabrikConnection( $database );
		$defaultConId 			= $oConn->loadDefaultConnection();
		$oTable->connection_id 	= $defaultConId;
		$sql = $oTable->buildCreateTableSQL( $oTable->db_table_name, $fields );
		$database->setQuery($sql);
		if(!$database->query()){
			echo $database->getErrorMsg();
			return false;
		}
		$oTable->label 			= $table;
		$oTable->db_primary_key = $thisPrimaryKey;
		$oTable->auto_inc 		= 1;
		$oTable->allow_add 		= 29;
		$oTable->allow_delete 	= 29;
		$oTable->allow_view_details = 29;
		$oTable->allow_edit_details = 29;
		$oTable->publish_up		= '0000-00-00 00:00:00';
		$oTable->publish_down	= '0000-00-00 00:00:00';
		$oTable->state 			= 1;
		$oTable->created 		= date( 'Y-m-d' );
		$oTable->created_by 	= $my->id;
		$oTable->created_by_alias = $my->username;
		$oTable->checked_out 	= 0;
		$oTable->access 		= 0;
		$oTable->filter_action 	= 'onchange'; 
		$oTable->store();
		$aData = array( 'label'=>$oTable->label, 'id'=>$database->insertid( ), 'state'=>1, 'db_table_name'=>$oTable->db_table_name );
		$oForm = $oTable->_createLinkedForm( $aData ); 
		$groupId = $oTable->createLinkedGroup( $aData, false );
		$oForm->createFormGroup( $groupId );
		$oTable->createLinkedElements( $groupId, $aData, $aSpecificElements );
		
		//set the tables form id
		$oTable->_updateFormId( $oForm->id );	
	}
	/* insert in the data */
	$errStr = '';
	foreach($data as $row){
		$aTableData = array();
		$oRecord = new stdClass(); // $$$rob put inside for loop to ensure that table.key is not set when inserting the object
		for($i=0;$i<count($row);$i++){
			if($fullKey){
				$heading = array_pop(explode(".", $headings[$i]));
				$tmpTable = array_shift(explode(".", $headings[$i]));
			}else{
				$heading = $headings[$i];
				$tmpTable = $oTable->db_table_name;
			}
			if(!array_key_exists($tmpTable, $aTableData)){
				$aTableData[$tmpTable] = new stdClass();
			}
			$key = strtolower(preg_replace("/[^A-Za-z0-9]/", "_", $heading));
			$val = $row[$i]; 
			if($fabrik_table == 0){
				$aTableData[$tmpTable]->$key = $val;
			}else{
				if( !array_key_exists (strtolower($key), $pKey) ){
					$aTableData[$tmpTable]->$key = $val;
				}else{
					$aTableData[$tmpTable]->$key = 0;
				}
			}
		}
		foreach( $aTableData as $tmpTable => $oRecord ){
			$oTable->db_table_name = $tmpTable;
			$aKey = $oTable->getPrimaryKeyAndExtra();
			$pk = $tmpTable . '.' . $aKey['colname'];
			$ok = $database->insertObject( $tmpTable, $oRecord, $pk, false );
			if(!$ok){
				$errStr .= $database->getErrorMsg() . "<br />";
			}
		}
	}
	if( $errStr == '' ){
		mosRedirect( 'index2.php?option=com_fabrik&task=tables', _CSV_DATA_IMPORTED );
	} else {
		mosRedirect( 'index2.php?option=com_fabrik&task=tables', $errStr );
	}
}

function strtotime_uk($str)
{
   $str = preg_replace("/^\s*([0-9]{1,2})[\/\. -]+([0-9]{1,2})[\/\. -]*([0-9]{0,4})/", "\\2/\\1/\\3", $str);
   $str = trim( $str,'/' );
   return strtotime( $str );
}
?>