<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrikForm extends fabrikDBTable {
	/** @var int Primary key */
	var $id = null;

	/** @var string The the forms title*/
	var $form_title = null;

	/** @var bol determines if the form records posted data into a database table */
	var $record_in_database = 0;

	/** @var string */
	var $form_introtext = null;

	/** @var string main error message shown at the top of the form if one of the validation rules is not met*/
	var $form_errmessage = null;

	var $created = null;

	var $created_by = null;

	var $created_by_alias = null;

	var $modified = null;

	var $modified_by = null;

	var $checked_out = null;

	var $checked_out_time = null;

	/** @var date start publishing */
	var $publish_up = null;

	/** @var date end publishing */
	var $publish_down = null;

	var $align = null;

	/** @var string the form width in pixels or as a percentage sign */
	var $width = null;

	/** @var email subject */
	var $form_subject = "";

	var $form_submit_message = "";

	var $form_submit_jumppage = null;

	var $email_to = null;

	var $email_from = null;

	var $receipt_email = null;

	var $receipt_message = null;

	var $reset_button = 0;

	/** @var string */
	var $reset_button_label = null;

	/** @var string */
	var $submit_button_label = null;

	/**@var bol publish state of form  - not implemented in 0.4a!*/
	var $state = 0;

	/** @var int foreign key to table id (0 if no table view exists)*/
	var $table_id = null;

	/** @var string pattempalte to use when showing form */
	var $form_template   = null;

	/** @var string pattemplate to use when showing view only version of form */
	var $view_only_template = null;

	/** @var bol use curl to post the form data */
	//var $use_curl = 0;

	/** @var string php code to eval after curl object has been created */
	var $curl_code = null;

	/** @car string xml param attributes*/
	var $attribs = null;

	/* not used in database (need to be prefixed with "_")*/
	/** @var array form's group elements*/
	var $_elements = null;

	/** @var array group objects (their element objects contained within)*/
	var $_groups = null;

	/** @var object table assocated with form*/
	var $_table = null;

	/** @var array of group ids that are actually tablejoins [groupid->joinid]*/
	var $_aJoinGroupIds = array();


	/** @var array allowed file extensions*/
	var $_aDefaultFileTypes = array('.gif', '.jpg', '.png', '.bmp', '.doc', '.xls', 'ppt', '.swf', '.pdf', '.dcr');

	/** @var bol true if editable if 0 then show view only verion of form */
	var $_editable = 1;

	/** @var string encoding type */
	var $_enctype = "application/x-www-form-urlencoded";

	/** @var string html name of form */
	var $_formName = null;

	/** @var string the path to the form - can probably update this to point to SSL page */
	var $_rootPath = null;

	/** @var string the javascript to run on sumbission of the form */
	var	$_js = null;

	/** @var array validation rule classes */
	var $_validationRuleClasses = null;

	/** @var array specific group sets based on whether they contain elements not in table view or unpublished*/
	var $_specGroups = array();

	/**@var bol is the form running as a module(true)*/
	var $_isModule = false;

	/**@var bol is the form running as a mambot(true)*/
	var $_isMambot = false;

	/** @var array attachements to send in email **/
	var $_aAttachments = array();

	/** @var string error */
	var $_err = null;

	/** @var object last current element found in hasElement()*/
	var $_currentElement = null;

	/**
	 * @param database A database connector object
	 */

	/** array of join objects for the form */
	var $_aJoinObjs = array();

	var $_joinTableElementStep = '___';

	/** @var array of join default data */
	var $_joinDefaultData = array();

	/** @var object params object */
	var $_params = null;

	/** @var bol form is admin */
	var $_admin = false;

	/** @var object menu parameters */
	var $_menuParams = null;

	/** @var array data posted by form */
	var $_data = null;

	/** @var string method to use when submitting form data // post or ajax*/
	var $_postMethod = 'post';

	var $_oTable = null;
	
	/** @var bol is random record **/
	
	var $_random = null;

	function fabrikForm( &$db ) {
		$this->mosDBTable( '#__fabrik_forms', 'id', $db );
	}

	/**
	 * save form
	 *
	 * @param array $aData data to save to form
	 * @return int form id
	 */

	function save( $aData = null) {
		if (is_null( $aData )) {
			$aData = $_POST;
		}
		$params = mosGetParam( $aData, 'params', array( ) );
		$this->updateAttribsFromParams( $params );

		if (!$this->bind( $aData )) {
			echo "<script> alert('BIND:- " . $this->getError() . "'); window.history.go(-1); </script>\n";
			exit( );
		}
		if (!$this->check( )) {
			echo "<script> alert('CHECK:-" . $this->getError() . "'); window.history.go(-1); </script>\n";
			exit( );
		}
		$this->created = date( 'Y-m-d' );
		if (!$this->store( )) {
			echo "<script> alert('(true) STORE:-" . $this->getError() . "'); window.history.go(-1); </script>\n";
			exit( );
		}
		$this->checkin( );
		return $this->id;
	}

	/**
	 * attempts to find the form's table id by parsing through table objects to
	 * see if they link to this form - bit of a hack shouldn't really be called
	 * at all
	 * @return true if a table view found, false if no table view exists for the form
	 */
	function findAndUpdateTableId() {
		global $database;
		$sql = "SELECT id FROM #__fabrik_tables WHERE form_id = '$this->id'";
		$database->setQuery( $sql );
		$this->table_id = $database->loadResult( );
		if ( $this->table_id == '') {
			return false;
		} else {
			$this->store( true );
			return true;
		}
	}


	function getFormData( $formId) {
		global $database;
		$row = new fabrikForm( $database );
		$row->load( $formId );
		if ($formId == '') {
			echo( "Error getting form_id to send email!" );
			;
		}
		return $row;
	}

	/**
	 * makes sure that the form is not viewable based on the table's access settings
	 * @param int form's table id
	 * @param int table row id
	 * @return int 0 = no access, 1 = view only , 2 = full form view, 3 = add record only
	 */

	function checkFormAccessFromTableSettings( $tableId, $rowId) {
		global $database, $my;
		if ($tableId == '') {
			return 2;
		}
		$oTable = new fabrikTable( $database );
		$oTable->load( $tableId );
		$ret = 0;
		if ($oTable->canViewDetails( )) {
			$ret = 1;
		}
		/* new form can we add?*/
		if ($rowId == 0) {
			/*if they can edit can they also add?*/
			if ($oTable->canAdd( )) {
				$ret = 3;
			}
		} else {
			/*editing from - can we edit?*/
			if ($oTable->canEdit( )) {
				$ret = 2;
			}
		}
		return $ret;
	}

	/**
	 * for editing and viewing records we need to check whether the user can view their own records
	 * and if the record belongs to that user
	 * @param array row data
	 * @return bol - true if can use
	 */

	function canUseThisRecord( $data) {
		global $my;
		if (!is_object( $this->_table )) {
			//form not linked to a table there for no need to check
			return true;
		}
		if ($this->_table->table_view_own_details > 0) {
			if ($this->_admin) {
				return true;
			}
			$aEls = explode( ',', $this->_table->table_view_own_details_id_col );
			switch ($this->_table->table_view_own_details) {
				case '1':
					$testVar = $my->id;
					break;
				case '2':
					$testVar = $my->email;
					break;
				case '3':
					$testVar = $my->username;
					break;
			}
			if (!empty( $aEls )) {
				foreach ($aEls as $el) {
					foreach ($data as $key=>$val) {
						if (strtolower( $key ) == strtolower( $el )) {
							if ($testVar == $val) {
								return true;
							}
						}
						if (strtolower( $key ) == strtolower( $this->_table->db_table_name . "___" . $el )) {
							if ($testVar == $val) {
								return true;
							}
						}

					}
				}
			}
		} else {
			return true;
		}
		return false;
	}

	/**
	 * add in custom js and css files to the form
	 */

	function addCustomFiles() {
		global $mosConfig_absolute_path, $mainframe, $mosConfig_live_site;
		/* check for a custom javascript file and include it if it exists */
		$aJsPath = $mosConfig_absolute_path . "/components/com_fabrik/js/" . $this->id . ".js";
		if (file_exists( $aJsPath )) {
			$live_js_file = $mosConfig_live_site."/components/com_fabrik/js/" . $this->id . ".js";
			echo "<script type=\"text/javascript\" src=\"$live_js_file\"></script>";
		}
	}

	/**
	 * set the page title for form
	 * @param array form data
	 */

	function setPageTitle( $data) {
		global $mainframe;
		if ($this->_isMambot || $this->_isModule) {
			return;
		}
		$title = "";
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if ($oElement->use_in_page_title == '1') {
					$title .= $oGroup->getElementDefaultValue( $oElement, $data,  $this  ) . " ";
				}
			}
		}
		$mainframe->setPageTitle( $this->form_title . " - " . $title );
	}



	/** collate all the form's data and call the html to display it
	 * @param array error messages
	 * @param array default vaules for elements
	 * @param int table id
	 * @param int table row id
	 * @param bol if the form is editable (TRUE) or view only (False)
	 * @param bol output viewonly details as pdf
	 * @param bol is the form in admin site
	 * @return mixed if form rendered as mambot returns the template object otherwise returns nothing
	 */

	function writeForm( $arErrors, $data, $tableId, $rowId, $editable = '0', $do_fb_pdf='0', $admin = false) {
		global $database, $mainframe, $mosConfig_live_site, $mosConfig_absolute_path, $_SESSION;
		$this->_admin = $admin;
		$this->_editable = $editable;
		if (!$this->_isModule && !$this->_isMambot) {
			require_once( $mainframe->getPath( 'front_html' ) );
		}
		if ($this->_isModule) {
			@session_start();
			if (!array_key_exists( 'fabrik', $_SESSION )) {
				$_SESSION['fabrik'] = array();
				$_SESSION['fabrik']['moduleErrors'] = array();
			}
			$arErrors = $_SESSION['fabrik']['moduleErrors'];
			///$$$rob unset the errors so they dont appear if you move to another page
			// ie only show them once.
			$_SESSION['fabrik']['moduleErrors'] = null;
		}
		if ($rowId != 0 && !$this->canUseThisRecord( $data )) {
			$access = 0;
		} else {
			$access = $this->checkFormAccessFromTableSettings( $tableId, $rowId );
		}
		if ($access != 0) {
			if ($access == 1 && $this->_editable == '1') {
				//echo _RIGHTS_TO_EDIT_ONLY;
				$this->_editable = 0;
			}
			$this->getFormGroupsHiarachy( 0 );
			if (is_object( $this->_table )) {
				$joins = $this->_table->loadJoins( );
				$this->getJoinGroupIds( $joins );
			}
			$this->setPageTitle( $data );
			$this->_enctype = $this->getFormEncType();
			$lists 			= $this->getForeginKeyDropDowns( $data, $editable, $rowId );
			if ($this->_admin) {
				$this->_formName = "adminForm";
				$this->_rootPath = $mosConfig_live_site."/administrator/index2.php";
				$this->_js 		 = "onsubmit=\"javascript:submit_form();\"";
			} else {
				$this->_formName = "fabrik".$this->id;
				$this->_rootPath = $mosConfig_live_site."/index.php";
				$this->_js 		 = "";
				$t = ( $this->_editable ) ? $this->form_template : $this->view_only_template;
				/// $$$ rob - if your form jumps back to itself then the layout is contained within an filter array
				// 	- check and extract if possible
				$layout = mosGetParam( $_REQUEST, 'layout', $t );
				if (is_array( $layout ) && array_key_exists( 'value', $layout )) {
					$layout = $layout['value'];
				}
				$this->form_template = $layout;
			}
			$this->addCustomFiles( );
			$this->loadValidationRuleClasses( );
			$params =& $this->loadParams();
			$params->def( 'icons', $mainframe->getCfg( 'icons' ) );
			$pop 		= intval( mosGetParam( $_GET, 'pop', 0 ) );
			$params->set( 'popup', $pop );

			if ($editable) {
				foreach ($data as $key=>$val) {
					if (is_string( $val )) {
						$data[$key] = htmlspecialchars( $val, ENT_QUOTES );
					}
				}
			}
			if ($do_fb_pdf) {
				//@TODO: draw pdfs
			} else {
				$tmpl = new fabrikViewForm( $this );
				$tmpl->_errors = $arErrors;
				$tmpl->_data 	=& $data;
				$tmpl->_rowId 	= $rowId;
				$tmpl->_params 	=& $params;
				$tmpl->_admin 	= $admin;
				$tmpl->_lists 	=& $lists;
				if (!$admin) {
					if ($this->_isMambot) {
						return $tmpl->display( $this->form_template );
					} else {
						echo $tmpl->display( $this->form_template );
					}
				} else {
					echo $tmpl->display( $this->form_template );
				}
			}
		} else {
			echo mosNotAuth();
		}
	}

	function &getParams(){
		return $this->loadParams();
	}
	
	/**
	 * get the params object for the form
	 * @return object params
	 */
	
	function &loadParams() {
		global $mosConfig_absolute_path;
		if (is_null( $this->_params )) {
			$this->_params = new fabrikParams( $this->attribs, $mosConfig_absolute_path . '/administrator/components/com_fabrik/xml/form.xml', 'component' );
		}
		return $this->_params;
	}

	/**
	 * compares the forms table with its groups to see if any of the groups are in fact table joins
	 * @param array tables joins
	 */

	function getJoinGroupIds($joins) {
		$arJoinGroupIds = array();
		foreach ($this->_groups as $group) {
			foreach ($joins as $join) {
				if ($group->id == $join->group_id) {
					$arJoinGroupIds[$group->id] = $join->id;
				}
			}
		}
		$this->_aJoinGroupIds =$arJoinGroupIds;
		return $arJoinGroupIds;
	}

	/**
	 * gets the javascript actions the forms elements
	 * @return array of javascript actions
	 */

	function getJsActions()
	{
		global $database;
		$aJsActions = array( );
		$aElIds = array( );
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				$aJsActions[$oElement->id] = array();
				$aElIds[] = $oElement->id;
			}
		}
		$sql = 'SELECT * FROM #__fabrik_jsactions WHERE element_id IN (' . implode(',', $aElIds) . ')';
		$database->setQuery( $sql );

		$res = $database->loadObjectList( );
		if (is_array( $res )) {
			foreach ($res as $r) {
				$aJsActions[$r->element_id][] = $r;
			}
		}
		return $aJsActions;
	}

	/**
	 * javascript code:
	 * main ofabrik object
	 * objects created for each element - will be expanded to ensure
	 * specific functionality per element
	 */

	function getFormManagementJS()
	{
		global $mosConfig_live_site, $mainframe;
		if (!defined( '_JOS_FABRIK_FORMJS_INCLUDED' )) {
			define( '_JOS_FABRIK_FORMJS_INCLUDED', 1 );
			$p =  $mosConfig_live_site. '/components/com_fabrik/views/form/form.js';
			$p2 =  $mosConfig_live_site. '/components/com_fabrik/views/form/element.js';
			if (!$this->_isModule) {
				addHeadTag('<script type="text/javascript" src="' . $p . '"></script>');
				addHeadTag('<script type="text/javascript" src="' . $p2 . '"></script>');
			} else {
				echo '<script type="text/javascript" src="' . $p . '"></script>';
				echo '<script type="text/javascript" src="' . $p2 . '"></script>';
			}

		}
	}

	/**
	 * get the javascript for the form (located after form written
	 * @return string javascript
	 */

	function getBottomFormManagementJS()
	{
		global $mosConfig_live_site;
		
		//document.addevent doesnt always work - wtf???
		$str = "

	window.addEvent('domready', function() {\n"; 
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				$opts = ($this->_editable) ? "'ro':false" : "'ro':true"; 
				$id 	= $oElement->getHTMLId();
				// $$$ ROB
				// odd case where for some reason on some systems the htmlid is still null
				// If so then force the load of the id
				if (is_null( $id )) {
					$id = $oElement->_loadHTMLId( $oGroup, $this );
				}
				switch ($oElement->elementtype_id) {
					case '3': // checkbox
						$str .= "ofabrik.addElement(new fbCheckBox('$id', {". $opts. "}));\n" ;
						break;
					case '4': //radio button
						$str .= "ofabrik.addElement(new fbRadio('$id',{". $opts. "}));\n" ;
						break;
					case '6': //drop down
						$str .= "ofabrik.addElement(new fbDropdown('$id',  {". $opts. "}));\n" ;
						break;
					case '5': // for http://doemee.ikgaverder.nl 5 is the display text - have i messedup?
					case '7': //display text
						$params =& $oElement->loadParams();
						if ($params->get( 'textarea-showmax' )) {
							$opts .= ", 'max':'$oElement->maxlength'";
						}
						$str .= "ofabrik.addElement(new fbDisplayText('$id', {" . $opts . "}));\n" ;
						break;
					case '9' : // image
						$params = new fabrikParams( $oElement->attribs );
						$selRoot = $mosConfig_live_site . '/images/stories' . $params->get('selectImage_root_folder', '');
						$opts .= ", rootDir:'$selRoot', 'id':$oElement->id";
						$str .= "var el = new fbImage('$id', {". $opts. "});\n" ;
						$str .= "el.imageFolderList = ofabrik.imageFolderList;\n" ;
						$str .=	"ofabrik.addElement(el);\n" ;
						break;
					case '12': //database join
						$str .= "ofabrik.addElement(new fbDatabaseJoin('$id', {". $opts. "}));\n" ;
						break;
					case '14': //link
						$str .= "ofabrik.addElement( new fbLink('$id', {". $opts. "}));\n" ;
						break;
					default :
						$str .= "ofabrik.addElement(new fbField('$id', {". $opts. "}));\n" ;
						break;
				}
			}
		}
		$str .= "});\n";
		return $str;
	}

	/** get the ids of all the groups in the form
	 * @return array of group ids
	 */

	function getFormGroupIds( )
	{
		global $database, $my;
		$sql = "SELECT #__fabrik_formgroup.group_id AS group_id FROM #__fabrik_formgroup
		WHERE #__fabrik_formgroup.form_id = '$this->id' ORDER BY ordering" ;
		$database->setQuery( $sql );
		$groups = $database->loadResultArray( );
		echo $database->getErrorMsg( );
		return $groups;
	}

	/**
	 * gets each element in the form along with its group info
	 * @param boolean are we using a table view
	 * @param bol included unpublished elements in the result
	 * @return array element objects
	 */

	function getFormGroups( $tableView = false, $excludeUnpublished = true)
	{
		global $database, $my;
		$sql = "SELECT *, #__fabrik_groups.attribs AS gattribs, #__fabrik_joins.id AS join_id, #__fabrik_elements.id as element_id FROM #__fabrik_formgroup"
		. "\n LEFT JOIN #__fabrik_groups "
		. "\n ON #__fabrik_formgroup.group_id = #__fabrik_groups.id"
		. "\n LEFT JOIN #__fabrik_elements  "
		. "\n ON #__fabrik_groups.id = #__fabrik_elements.group_id "
		. "\n LEFT JOIN #__fabrik_joins ON #__fabrik_groups.id = #__fabrik_joins.group_id"
		. "\n WHERE #__fabrik_formgroup.form_id = '$this->id' " ;
		if ($excludeUnpublished) {
			$sql .= " AND #__fabrik_elements.state = '1' ";
		}
		if ($tableView) {
			$sql .= " and show_in_table_summary = '1' ";
		}
		$sql .= "ORDER BY #__fabrik_formgroup.ordering,  #__fabrik_formgroup.group_id, #__fabrik_elements.ordering";
		$database->setQuery( $sql );
		$groups = $database->loadObjectList( );
		echo $database->getErrorMsg( );
		$this->_elements = $groups;
		return $groups;
	}

	/**
	 * similar to getFormGroups() except that this returns a data structure of
	 * form
	 * --->group
	 * -------->element
	 * -------->element
	 * --->group
	 * if run before then existing data returned
	 * @param boolean show elements only in table view (true)
	 * @param bol exclude unpublished elements in the result
	 * @param bol if true load element validations (default true)
	 * @return array element objects
	 */

	function getFormGroupsHiarachy( $tableView = false, $excludeUnpublished = true, $loadValidations = true ) {
		global $database;
		$key = $tableView ?  '1' : '0';
		$key .= $excludeUnpublished ?  '1' : '0';
		if (is_array( $this->_specGroups ) &&  ( array_key_exists( $key, $this->_specGroups) )) {
			return $this->_specGroups[$key];
		} else {
			$aGroupIds = $this->getFormGroupIds( );
			$aGroupObjs = array( );
			foreach ($aGroupIds as $groupId) {
				if ($groupId != '0') {
					$oGroup = new fabrikGroup( $database );
					$oGroup->load( $groupId );

					$oGroup->getMyElements( $tableView, $excludeUnpublished, $loadValidations );
					$aGroupObjs[$groupId] = $oGroup;
				}
			}
			$this->_groups = $aGroupObjs;
			$this->_specGroups[$key] = $aGroupObjs;
			return $aGroupObjs;
		}
	}

	/**
	 * gets the form's groups
	 * @return array of group ids
	 */

	function getGroups() {
		global $database;
		$sql = "SELECT group_id FROM #__fabrik_formgroup WHERE form_id = '$this->id'";
		$database->setQuery( $sql );
		return $database->loadResultArray( );
	}

	/**
	 *sets the forms groups
	 *@param array group ints
	 */

	function setGroups( $groups) {
		global $database, $mosConfig_absolute_path;
		/* first delete old references*/
		$database->setQuery( "DELETE FROM #__fabrik_formgroups WHERE form_id = '$this->id'" );
		/* next create the new formgroup entries*/
		require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_formgroup.class.php" );
		if (is_array( $groups )) {
			foreach ($groups as $group) {
				$oFormGoup = new fabrikFormGroup( $database );
				$oFormGoup->form_id = $this->id;
				$oFormGoup->group_id = $group;
				$oFormGoup->ordering = 1;
				if (!$oFormGoup->store( )) {
					echo "<script> alert('ging niet helemaal goed'); window.history.go(-1); </script>\n";
					exit();
				}
			}
		}
	}

	/**
	 * this checks to see if the form has a file upload element
	 * and returns the correct
	 * encoding type for the form
	 * @param int form id
	 * @param object forms elements
	 * @return string form encoding type
	 */

	function getFormEncType() {
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if ($oElement->elementtype_id == '8') {
					return "multipart/form-data";
				}
			}
		}
		return "application/x-www-form-urlencoded";
	}

	/**
	 * Get table join group drop downs as well
	 * parses the form elements to create a list of drop downs for the form
	 * UPDATE: should now also return radio button lists :O
	 * @param array of element objects
	 * @param bol editable - if false return data only
	 * @param int row id default 0
	 */

	function getForeginKeyDropDowns( $elementData, $editable, $rowId = 0) {
		global $database, $my, $mosConfig_absolute_path, $mosConfig_lang,$mosConfig_dbprefix;
		fabrikLanguageFiles();
		if (!is_object( $this->_table )) {
			$this->_table = $this->loadTable( $this->table_id );
		}
		if (!$this->_isModule && !$this->_isMambot) {
			require_once( $mosConfig_absolute_path . '/components/com_fabrik/fabrik_params.xml.php' );
			require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_parent.class.php" );
		}
		$lists  = array();
		$aGroupRepeats = array( );
		/* used to store if a given group id can be reapeated in front end form*/
		foreach ($this->_groups as $group) {
			foreach ($group->_aElements as $el) {
				/* go through all the elements checking for joins*/
				if ($el->elementtype_id == '12') {
					/* a join type has been created*/

					//do this to get the number of reapeat groups to show
					//$default =  $group->getElementDefaultValue( $el, $activeData, $this, $editable );
					for ($c=0; $c < $group->_repeatGroupCount; $c++) {
						$_elHTMLName = $group->getElementFullName( $el, $this, true, true, true );

						/*if the drop down is the primary key and the form is for inserting a new record then we dont want to create the drop down*/
						// $$$ hugh - added "and auto_inc == 1".  If the pk isn't auto-inc, they probably really do want to select something,
						// and if we don't show the dropdown, they'll never be able to create a new record.
						if ($this->_table->auto_inc == 1 and $this->_table->db_primary_key == $this->_table->db_table_name . '.' . $el->element_name && $rowId == '') {
							$dropdown = '';
							$default = '';
						} else {
							if (array_key_exists( $el->group_id, $aGroupRepeats )) {
								$canRepeatGroup = 	$aGroupRepeats[$el->group_id];
							} else {
								$canRepeatGroup = $group->getCanRepeatGroup();
								$aGroupRepeats[$el->group_id] = $canRepeatGroup;
							}

							$params =& $el->loadParams();

							$displayType 	= $params->get( 'database_join_display_type', 'dropdown' );
							//select id as value, username as text from #__users
							$showBoth 		= $params->get( 'show_both_with_radio_dbjoin', '0' );
							// $$$ hugh - strip slashes and convert quotes
							$where			= stripslashes( htmlspecialchars_decode( $params->get( 'database_join_where_sql', ''), ENT_QUOTES ) );
							$where 			= $el->parseMessageForPlaceHolder($where);
							$joinConnId 	= $el->join_conn_id;

							$cn = new fabrikConnection( $database );
							$cn->load( $joinConnId );
							if (isset( $this->_aJoinGroupIds[$group->id] )) {
								$joinId = $this->_aJoinGroupIds[$group->id];
								$joinGroupId = $group->id;
							} else {
								$joinId = '';
								$joinGroupId = '';
							}
							$col	= $el->element_name;
							if ($cn->testConnection( )) {

								$joinDb = new database( $cn->host, $cn->user, $cn->password, $cn->database, "" );
								
								$tmp = array( );
								switch ($params->get( 'joinType' )) {

									case 'advanced':
										$aAvJoins 	= $el->getAdvancedJoinsObjs( );
										// $$$ hugh - at some point the CONCAT string has gotten htmlspecialchars()'ed.
										// $$$ This of course turns thing like ' ' into &quot;  So we gotta fix that.
										$val 		= stripslashes( htmlspecialchars_decode( $params->get( 'advJoin_concat' ), ENT_QUOTES ) );
										$table 		= $aAvJoins[0]->join_from_table;
										$key 		= $aAvJoins[0]->table_join_key;

										$key 		= $params->get('advJoin_key', $table.'.'.$el->element_name );
										$table 		= $params->get('advJoin_startTable', $table);
										$sql 		= "SELECT DISTINCT($key) AS value, CONCAT($val) AS text, $key FROM $table ";
										foreach ($aAvJoins as $oJoin) {
											$on_oper = $oJoin->attribs ? $oJoin->attribs : '=';
											$sql .= "\n $oJoin->join_type JOIN $oJoin->table_join  ON $oJoin->join_from_table.$oJoin->table_key $on_oper $oJoin->table_join.$oJoin->table_join_key ";
										}
										$sql .= $where;
										break;
									case 'diy':
										$sql = str_replace('#__', $mosConfig_dbprefix, $params->get( 'advanced-join-sql' ));
										$sql =  $sql . " " . $where;
										 
										//try to find the key
										//$pattern = '@^(?:select)?([^as]+)@';
										$pattern = '/select(.*?)as/i';
										$match = preg_match( $pattern, strtolower($sql), $matches );
										if ($match && count( $matches ) > 1) {
											$key = $matches[1];
										}
										 
										break;
									default:
										$table 	= $el->join_db_name;
										$key	= $el->join_key_column;
										$val	= $el->join_val_column;
										$sql = "SELECT DISTINCT($key) AS value, $val AS text, $key FROM $table $where";
										if (!preg_match('/ORDER BY/i',$where)) {
											$sql .= " ORDER BY $val asc ";
										}
										break;
								}
								$joinDb->setQuery( $sql );
								if (mosGetParam( $_REQUEST, 'fabrikdebug') == '1') {
									echo $joinDb->getQuery();
								}
								echo $joinDb->getErrorMsg( );
								if ($displayType == "dropdown" ) {
									$tmp[] = mosHTML::makeOption( '' , _PLEASE_SELECT );
								} else {
									if ($showBoth) {
										$tmp[] = mosHTML::makeOption( '' , _BOTH );
									}
								}
								$aDdObjs = $joinDb->loadObjectList( );
								//$$$rob - translation beta
								if ((class_exists( 'JoomFish' )) && isset( $key )) { //isset(key) as diy join may not tell you its key type
									$translateTable = str_replace($mosConfig_dbprefix, '', $el->join_db_name);
									$tableArray["fieldTableAliasData"] =array();
									$tableArray["fieldTableAliasData"][0]["tableName"] = $translateTable;
									$tableArray["fieldTableAliasData"][0]["fieldName"] = $el->join_val_column;
									$tableArray["fieldTableAliasData"][0]["tableNameAlias"] = $translateTable;
									$tableArray["fieldTableAliasData"][0]["fieldNameAlias"] = $this->_table->db_table_name.'.'.$el->element_name;
									$tableArray["fieldCount"] = 1 ;
									$ids = array();
									foreach ($aDdObjs as $row) {
										$ids[] = $row->value;
									}
									$ids = array_unique($ids);
									JoomFish::translateListWithIDs( $aDdObjs, trim(implode($ids, ","), ","), $translateTable, $mosConfig_lang, $key, $tableArray);
									$transkey = $this->_table->db_table_name.'.'.$el->element_name;
									foreach ($aDdObjs as $ix=>$v)  {
										$row =& $aDdObjs[$ix]; //php 4 pass by reference stupidity
										if (array_key_exists( $transkey, $row )) {
											$row->text = $row->$transkey;
											unset($row->$transkey);
											unset($row->$key);
										}
									}
								}

								//end translation beta

								echo $joinDb->getErrorMsg();
								$table 	 = $this->_table->db_table_name;
								/*was using the full join name b4 - testing for advanced joins in false mode though*/
								$col 	 = $group->getElementFullName( $el, $this, false );

								if ($params->get( 'joinType' ) == 'advanced') {
									/* go through and check distict text only - not sure if this is wise*/
									$aExistingText = array();
									for ($i=count( $aDdObjs )-1; $i>=0; $i-- ) {
										$oDd = $aDdObjs[$i];
										if (!in_array( $oDd->text, $aExistingText )) {
											$aExistingText[] = $oDd->text;
										} else {
											unset( $aDdObjs[$i] );
										}
									}
									/* merge advanced join data into the elementdata array (used to get default values for advanced drop down elements)*/
									$aAvJoins = $el->getAdvancedJoinsObjs( );
									$dbcol 	= $params->get('advJoin_key', $table.'.'.$el->element_name );
									$table	= $params->get('advJoin_startTable', $aAvJoins[0]->join_from_table);
									$sql 	= "SELECT $dbcol AS value FROM $table ";
									$aUsedJoins = array();
									foreach ($aAvJoins as $oJoin) {
										$on_oper = $oJoin->attribs ? $oJoin->attribs : '=';
										$tmpSql = "\n $oJoin->join_type JOIN $oJoin->table_join  ON $oJoin->join_from_table.$oJoin->table_key $on_oper $oJoin->table_join.$oJoin->table_join_key";
										if (!in_array( $tmpSql, $aUsedJoins )) {
											$sql .= $tmpSql;
											$aUsedJoins[] = $tmpSql;
										}
									}
									$tmpKey =  $group->getElementFullName( $el, $this );

									if (array_key_exists( $tmpKey, $elementData )) {
										if (is_array( $elementData[$tmpKey] )) {
											//someone has passed in foo[value]=bar in the querystring
											$sql .= " WHERE $dbcol= '".$elementData[$tmpKey]['value'] . "'";
										} else {
											$sql .= " WHERE $dbcol= '$elementData[$tmpKey]'";
										}

										/**
										 * this was outside of the above if statement, but forced an empty form to show an incorrect defautl value
										 * moving inside for testing
										 */
										$joinDb->setQuery( $sql );
										$elementData[$col] = $joinDb->loadResult();

										if ($joinDb->getErrorMsg() != '') {
											echo "<br>1.adv join db error:" . $joinDb->getErrorMsg() . "<br /><br />";
											echo $joinDb->getQuery();
										}
									}
								}

								/*get the default value */

								if ($group->getCanRepeatGroup() || array_key_exists( $group->id, $this->_aJoinGroupIds )) {
									$activeData = $group->getActiveData( $elementData, $this );
								} else {
									$activeData = $elementData;
								}

								if (is_array( $aDdObjs )) {
									$tmp = array_merge( $tmp, $aDdObjs );
								}

								$translationFound = false;
								if (!$this->_editable) {
									if ((class_exists( 'JoomFish' ))) {
										$transkey = $this->_table->db_table_name.'___'.$el->element_name;
										foreach ($aDdObjs as $row) {
											if ($row->value == $activeData[$transkey]) {
												$activeData[$transkey] = $row->text;
												$default = $row->text;
												$translationFound = true;
											}
										}
									}
								}
								if (!$translationFound) {
									$default =  $group->getElementDefaultValue( $el, $activeData, $this, $editable, $c );
								}
								$defaultLabel = '';
								//$$ rob - ensure that r/o pages show the default value
								if (!$this->_editable) {
									$dropdown = $default;
									$defaultLabel = $default;
								} else {
									if ($el->canUse( )) {
										/*if user can access the drop down*/

										if ($displayType == "dropdown") {
											$dropdown = mosHTML::selectList( $tmp, $_elHTMLName, 'class="inputbox" size="1" ', 'value', 'text', $default );
										} else {
											$dropdown =  fabrik_html_content::radioList( $tmp, $_elHTMLName, 'class="inputbox" size="1" ', $default,'value', 'text' );
										}
									} else {
										/* form is editable, but not the element, so make a hidden field */
										$dropdown = "<input type='hidden' name='$_elHTMLName' id='$el->element_name' value='$default' />";
									}
								}
							} else {
								$dropdown = "Could not make join - drop down connection failed for $el->element_name joinid = $joinConnId";
								$default  = "Could not make join - drop down connection failed for $el->element_name joinid = $joinConnId";
							}
						}
						//get the default label for the drop down (use in read only templates)
						if (is_array( $aDdObjs )) {
							foreach ($aDdObjs as $obj) {
								if ($obj->value == $default) {
									$defaultLabel = $obj->text;
								}
							}
						}

						//$$$ rob - if we cant use the drop down then replace the default id with its label.
						if (!$el->canUse( )) {
							$default = $defaultLabel;
						}
						$col = str_replace('[]', '', $col);
						if (array_key_exists( $group->id, $this->_aJoinGroupIds )) {
							$lists['join'][$joinId][$col]['dropdown'][] = $dropdown;
							$lists['join'][$joinId][$col]['default'][] = $default;
							$lists['join'][$joinId][$col]['defaultLabel'][] = $defaultLabel;
						} else {
							$lists[$col]['dropdown'][] = $dropdown;
							$lists[$col]['default'][] = $default;
							$lists[$col]['defaultLabel'][] = $defaultLabel;
						}
					}
				}
			}
		}
		return $lists;
	}

	/**
	 * processes the form data and decides what action to take
	 * @param array posted form data
	 * @param int table id
	 * @param int row id
	 * @param int menu item id
	 */

	function processForm( $aData, $tableId, $rowId, $Itemid )
	{
		global $mosConfig_absolute_path, $my;
		josSpoofCheck();
		
		require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_table.class.php" );
		require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_params.xml.php" );
		global $mosConfig_absolute_path, $mosConfig_live_site, $database;
		$err 	= '';
		$params =& $this->getParams();
		$this->getFormGroupsHiarachy( true );
		/**** only run the curl code ****/
		//$$$ rob set default to -1, '' was being converted to 0 and hence postCurl was wrongly being called
		$onlyProcessCurl = (int) $params->get( 'only_process_curl', -1 );

		if ($onlyProcessCurl === 0) {
			$this->postCurl( );
			return true;
		}
		elseif ($onlyProcessCurl == 3) {
			eval( $this->curl_code );
		}

		/***********************************/
		// $$$ hugh - moved this line to before the uploader(), otherwise the pass by
		// $$$ reference vs value stuff in PHP4 vs 5 gets messed up, and _data has
		// $$$ no value in the uploader in one or the other!!
		$this->_data 			= $aData;
		$oUploader 				= new uploader( $this );
		$fileUploadFound 	= $oUploader->checkForFileUpload( );

		$arErrors 				= $this->ValidateForm( );
		$aData 						= $this->_data;
		$arUploadErrors	 	= $oUploader->validateForm( $aData );

		$arErrors 				= array_merge( $arErrors, $arUploadErrors );
		$this->_errors 		=& $arErrors;
		$form_err_message 	= $this->form_errmessage;
		$moveError 			= false;
		if (count( $arErrors ) == 0) {
			if ($fileUploadFound) {
				$oUploader->upload( );
				if ($oUploader->moveError) {
					$this->render( $tableId, $rowId, true, false, $this->_admin, '', true );
					return;
				}
			}
			
			$this->_storeDataInSession( $arErrors );
				
			/**** only run the curl code ****/
			if ($onlyProcessCurl == 1) {
				$this->postCurl( );
				return true;
			}
			elseif ($onlyProcessCurl == 4) {
				eval( $this->curl_code );
			}
			/***********************************/
			if ($this->record_in_database == '1') {
				$oTable =& $this->getTable( $tableId );
				// $$$ hugh - remember original name and pk, 'cos these get
				// altered in the join handling code!
				$original_db_table_name = $oTable->db_table_name;
				$original_db_primary_key = $oTable->db_primary_key;

				// get an array of the joins to process
				$aPreProcessedJoins = $oTable->preProcessJoin( );
				if (!$oTable->databaseTableExists( )) {
					$oTable->createFormTable( $this );
				} else {
					$oTable->ammendTable( $this );
				}

				$this->_data 	= $oTable->removeTableNameFromSaveData( $this->_data, '___' );
				$insertId 		= $this->submitToDatabase( $rowId );

				if (array_key_exists( 'join', $this->_data )) {

					foreach ($aPreProcessedJoins as $aPreProcessedJoin) {
						$oJoin = $aPreProcessedJoin['join'];
						if (array_key_exists( 'Copy', $this->_data )) {
							$rowId = '';
							$this->_data['join'][$oJoin->id][$oJoin->table_join.'___'.$oJoin->table_key] = '';
							$this->_data['rowid'] = '';
						}

						$data =& $this->_data['join'][$oJoin->id];
						//$$$rob moved till just before join table data saved
						//$data = $oTable->removeTableNameFromSaveData( $data, $split='___' );
						if (array_key_exists( $oJoin->table_join . '___' . $oJoin->table_join_key, $data )) {
							$joinGroup = $this->_groups[$oJoin->group_id];

							//find the primary key for the join table
							$oTable->db_table_name 	= $oJoin->table_join;
							$fields 				= $oTable->_loadDBFields( $oTable->db_table_name );
							$aKey 					= $oTable->getPrimaryKeyAndExtra();
							$oTable->db_primary_key = $aKey['colname'];
							$joinCnn 				= $oTable->getConnection( );
							$joinDb  				= $joinCnn->loadTableConnectionDB( );

							//$$$rob get the join tables ful primary key
							$joinDb->setQuery( "DESCRIBE $oJoin->table_join" );
							$oJoinPk = $oJoin->table_join . "___";
							$cols = $joinDb->loadObjectList( );
							foreach ($cols as $col) {
								if ($col->Key == "PRI") {
									$oJoinPk .= $col->Field;
								}
							}
							$fullforeginKey = $oJoin->table_join . '___' . $oJoin->table_join_key;


							if ($joinGroup->getCanRepeatGroup()) {
								//find out how many repeated groups were entered
								// might make more sense to store this value in a hidden field rather than guess it from the data?
								foreach ($joinGroup->_aElements as $oElement) {
									$repeatedGroupCount = count( $data[$oJoin->table_join . "___" . $oElement->element_name] );
								}
								$aUpdatedRecordIds = array();
								for ($c = 0; $c<$repeatedGroupCount; $c++) {
									//get the data for each group and record it seperately
									$repData = array();
									foreach ($joinGroup->_aElements as $oElement) {
										$repData[$oElement->element_name] = $data[$oJoin->table_join . "___" . $oElement->element_name][$c];
									}
									$repData[$oJoin->table_join_key] = $insertId;
									if (in_array( $repData[$oTable->db_primary_key], $aUpdatedRecordIds )) {
										$joinRowId = '';
									} else {
										$joinRowId 				= $repData[$oTable->db_primary_key];
									}
									$aUpdatedRecordIds[] 	= $joinRowId;
									$aDeleteRecordId 		= $repData[$oJoin->table_join_key];

									$oTable->storeRow( $repData, $joinRowId, true );
								}
								//remove any joins that have been deleted with the groups "delete" button
								if (!$data) {
									$sql = "DELETE  FROM $oJoin->table_join  "
									. "\nWHERE ($oJoin->table_join_key = $aDeleteRecordId)";
								} else {
									$sql = "DELETE  FROM $oJoin->table_join  "
									. "\nWHERE !($oTable->db_primary_key IN (" . implode( ',', $aUpdatedRecordIds ) . ")) AND ($oJoin->table_join_key = $aDeleteRecordId)";
								}
								$joinDb->setQuery( $sql );
								$joinDb->query();
							} else {
								//$$$rob - erm this should never occurs as we've already checked b4 for the key??
								//if (!array_key_exists($oJoin->table_join_key, $data)) {
								//	$data[$oJoin->table_join_key] = $insertId;
								//}

								 
								// $$$rob test if the joined to table's key (as part of the join) is the same as its primary key
								// if it is then we dont want to overwrite the foreginkey as we will in fact be overwriting the pk
								 
								if ($fullforeginKey != $oJoinPk) {
									$data[$fullforeginKey] = $insertId;
								}
								
								if ($oTable->db_primary_key == '') {
									echo "Please ensure you have selected a primary key for your table, Fabrik can not process this join until you have done so";
									return false;
								}
								
								if (array_key_exists( $oTable->db_primary_key, $data )) {
									$joinRowId 				= $data[$oTable->db_primary_key];
								} else {
									$joinRowId 				= $data[$oJoin->table_join ."___" . $oJoin->table_key];
								}
								
								$data = $oTable->removeTableNameFromSaveData( $data, $split='___' );
								$oTable->storeRow( $data, $joinRowId, true );

								//$$$rob if the fk was the same as the pk then go back to the main table and
								// update its fk to match the
								// pk of the inserted table
								 
								if ($fullforeginKey == $oJoinPk) {
									// $$$ hugh - restore original table name and pk!
									$oTable->db_table_name = $original_db_table_name;
									$oTable->db_primary_key = $original_db_primary_key;
									
									$pkVal = $oTable->_lastInsertId;
									$fk = $oJoin->table_key;
									$this->_data[$fk] = $pkVal;
									// $$$ hugh - I think this needs to be $insertId, not $rowId, otherwise
									// if it's new row (so $rowId was null) we insert a duplicate row in
									// the main table?
									// NOTE TO SELF - test on row edit as well as new row!!
									//$insertId 		= $this->submitToDatabase( $rowId );#
									$insertId 		= $this->submitToDatabase( $insertId );
								}
							}
						}
					}
				}
				/*$$$ ROB moved down under th ejoin table stuff, to avoid poluting
				 $this->_data with wrong key values (e.g. table___pk)
				 */

				//add the key value back into the aData array
				$tmpKey 	= str_replace(".", "___", $oTable->db_primary_key);
				$shortKey 	= $oTable->_shortKey( $oTable->db_primary_key );
				 
				$this->_data[$tmpKey] 		= $oTable->_lastInsertId;
				$_REQUEST[$tmpKey] 			= $oTable->_lastInsertId;
				$_POST[$tmpKey] 			= $oTable->_lastInsertId;

				//$$$ rob - build jump page can use {rowid}
				$_REQUEST['rowid'] = $oTable->_lastInsertId;
				$_POST['rowid'] = $oTable->_lastInsertId;

				if ($oTable->db_primary_key != '') {
					$this->_data[$oTable->db_primary_key] 						 = $insertId;
					$_POST[$oTable->db_table_name . "___" . $oTable->db_primary_key] = $insertId;
					$this->_data[$oTable->db_primary_key] = $insertId;
					$this->_data[$tmpKey] = $insertId;
					$this->_data[$shortKey] = $insertId;
					$_REQUEST[$oTable->db_table_name . "___" . 'fabrik_internal_id'] = $insertId;
				} else {
					$this->_data['fabrik_internal_id'] = $insertId;
					$this->_data[$oTable->db_table_name . '___fabrik_internal_id'] = $insertId;
					$_POST[$oTable->db_table_name . '___fabrik_internal_id'] = $insertId;
					$_POST['fabrik_internal_id'] = $insertId;
					$_REQUEST['fabrik_internal_id'] = $insertId;
					$_REQUEST[$oTable->db_table_name . "___" . 'fabrik_internal_id'] = $insertId;
				}


				$this->_table = $this->loadTable( $this->table_id );
				$this->_table->_aData = $aData;
				$this->_table->doCalculations();
			}

			if ($this->_err != "") {
				echo $this->_err;
				exit;
			}

			if (!($rowId != 0 && !$params->get( 'email_on_edit' ))) {
				if (!$this->_admin) {
					if ($this->receipt_email != "") {
						$this->sendReceipt( $params );
					}
				}

				if ($this->email_to != "" && !$this->_admin) {
					$this->sendEmail( $fileUploadFound );
				}
			}

			/**** run the curl/php code after receipt sent ****/

			if ($onlyProcessCurl == 2) {
				$this->postCurl( );
				return true;
			}
			elseif ($onlyProcessCurl == 5) {
				eval( $this->curl_code );
			}

			/***********************************/
			$jumpPage = $this->form_submit_jumppage;
			$plainJumpPage = str_replace( '&nbsp;', '', strip_tags( $jumpPage ));
			if ($this->email_to != "") {
				if (!$this->_admin) {
					if ($plainJumpPage == '') {
						$this->form_submit_message = $this->parseMessageForPlaceHolder( $this->form_submit_message );
						fabrik_html_content::displayThanks( $this->form_title, $this->form_submit_message );
					} else {
						
						$jumpPage = $this->buildJumpPage( $jumpPage, $Itemid );
						mosRedirect( $jumpPage , "" );
					}
				} else {
					$return = mosGetParam( $_POST, 'returntoform', 0 );
					$cid  = mosGetParam( $_POST, 'fabrik', 0 );
					if ($return == 1) {
						$page = "index2.php?option=com_fabrik&task=showForm&cid=$cid&tableid=$tableId&rowid=";
					} else {
						$page = "index2.php?option=com_fabrik&task=viewTable&cid=$tableId";
					}
					mosRedirect( $page, "record added/updated" );
				}
			} else {
				if ($this->_admin) {
					$return = mosGetParam( $_POST, 'returntoform', 0 );
					$cid  = mosGetParam( $_POST, 'fabrik', 0 );
					if ($return == 1) {
						$page = "index2.php?option=com_fabrik&task=showForm&cid=$cid&tableid=$tableId&rowid=";
					} else {
						$page = "index2.php?option=com_fabrik&task=viewTable&cid=$tableId";
					}
					mosRedirect( $page, "record added/updated" );
				} else {
						
				if ($plainJumpPage == '') {
						$this->form_submit_message = $this->parseMessageForPlaceHolder( $this->form_submit_message );
						fabrik_html_content::displayThanks( $this->form_title, $this->form_submit_message );
					} else {
						$jumpPage =$this->buildJumpPage( $jumpPage, $Itemid );
						mosRedirect( $jumpPage, '' );
					}
				}
			}
		} else {
			if ($this->_isModule = mosGetParam( $aData, 'fabrik_frommodule', 0 )) {
				$this->_storeDataInSession( $arErrors );
				mosRedirect($_SERVER['HTTP_REFERER']);
			} else {
				$this->render( $tableId, $rowId, true, false, $this->_admin, '', true );
			}
		}
	}
	
	/**
	 * stores the elements data in the session 
	 * - useful for repopulating the form or filtering a table's data
	*@since 1.0.5
	* @param array errors
 */
	
	function _storeDataInSession( $arErrors )
	{
		$params =& $this->getParams();
		// $$$ hugh - this line is breaking validation for module/bot, 'cos
		// we need to store the errors abd form if they fail validation
		//if ($params->get( 'search-form', 0 ) != false) {
		if ($params->get( 'search-form', 0 ) || $this->_isModule || $this->_isMambot) {
			if (!$this->_admin)
			{
				@session_start();
				//this was being used just before 1.0.5 release, but was stopping the search form->table working
				session_destroy();
				//restarting the session seems to make the search form->table bit work
				@session_start();
			}
		
			$sessiondata= array();
			$sessiondata['moduleErrors'] = $arErrors;
			$params =& $this->getParams();
			foreach ($_POST as $key => $value) {
				if($key != 'join'){
					$this->_doStoreDataInSession( $key, $value, $sessiondata );
				}else{
					foreach($_POST['join'] as $joinData){
						foreach($joinData as $key => $value) {
							$this->_doStoreDataInSession( $key, $value, $sessiondata );
						}
					}
				}
			}
			$sessiondata['fromForm'] = $this->id;
			mosSession::set( "fabrik", $sessiondata );
		}
	}
	
	function _doStoreDataInSession( $key, $value, &$sessiondata ){
		if ($this->hasElement( $key )) {
			$type = '';
			if (!in_array( $key, $this->_reservedWords )) {
				if (is_array( $value )) {
					// $$$ rob - test if its not an element being used in a ranged search form				
					if (!preg_match( "/\[(.*?)\]/",  $this->_currentElement->element_name )) {
						// 	$$$ hugh - think we need to implode if an array to handle checkbox multi selects
						$value = implode(',', $value);
					} else {
						$type = 'range';
					}
				}
				// $$$ hugh - think we need to do the slashes and specialchars thing here
				$value = htmlspecialchars(get_magic_quotes_gpc() ? stripslashes($value) : $value, ENT_QUOTES);
				$sessiondata[$this->id]["$key"] = array('type'=>$type, 'value'=>$value, 'match'=>false );
			}
		}
	}

	/**
	 * send a receipt to the user who filled in the form
	 * @param object params
	 */

	function sendReceipt( $params) {
		global $mosConfig_absolute_path, $my;

		$askReceipt = $params->get('ask-receipt');
		if ($askReceipt) {
			$receiptAsked = mosGetParam( $_POST, 'fabrik_email_copy', 0 );
			if (!$receiptAsked) {
				return;
			}
		}

		$message = $this->parseMessageForPlaceHolder( $this->receipt_message, true );
		$email_to = $this->email_to;
		$email_from = trim( $this->parseMessageForPlaceHolder( $this->email_from ) );
		$email = mosGetParam( $this->_data, $this->receipt_email, '' );
		
		//check for "Name <email>" for email from
		if (strstr( $email_from, "<" )){
			$bits = explode( "<", $email_from );
			$fromName = trim( $bits[0] );
			$email_from = trim( str_replace( ">", "", $bits[1] ) );
		} else {
			$fromName = $email_from;
		}
		
		if (!$this->record_in_database) {
			foreach ($this->_data as $key=>$val) {
				$aBits = explode('___', $key);
				$newKey = array_pop($aBits);
				if ($newKey == $this->receipt_email) {
					$email = $val;
				}
			}
		}
		$receiptTitle =  html_entity_decode( $params->get('receipt_title', '' ) );
		$receiptTitle = preg_replace_callback('/&#([0-9a-fx]+);/mi', array(&$this, 'replace_num_entity'), $receiptTitle);
		$subject = $this->parseMessageForPlaceHolder( $receiptTitle );
		//if the receipient email is part of a repeat group
		if (is_array( $email )) {
			foreach ($email as $e) {
				if ($e != '') {
					if (!mosMail( $email_from, $fromName, $e, $subject, $message, true )) {
						global $mail;
						echo "Failed sending receipt to " . html_entity_decode($e) . " ($mail->ErrorInfo)!";
					}
				}
			}
		} else {
			if ($email != '') {
				if (!mosMail( $email_from, $fromName, $email, $subject, $message, true )) {
					global $mail;
					echo "Failed sending receipt to " . html_entity_decode($email) . " (".@$mail->ErrorInfo.")!";
				}
			}
		}
	}

	/**
	 * takes the forms data and merges it with the jump page
	 * @param string origional jump page
	 * @param int item id
	 * @return new jump page
	 */

	function buildJumpPage( $jumpPage, $Itemid) {
		global $mosConfig_sef;	
		if (!strstr( $jumpPage, "?") && $mosConfig_sef != 1) {
			$jumpPage .= "?";
		}
		$this->_data = $_POST;
		$jumpPage = $this->parseMessageForPlaceHolder( $jumpPage );
		if ($this->_params->get( 'append_jump_ul' ) == '1') {
			foreach ($this->_data as $key=>$val) {
				if (!strstr( $jumpPage, "$key=" )) {
					if ($val != '') {
						if ($val != '-1') {
							if (!in_array( $key, $this->_reservedWords )) {
								if (is_array( $val )) {
									foreach ($val as $subval) {
										/* used if we want to pass data out of joomla/fabrik to another site */
										$jumpPage .= "&" . $key . "[]=$subval";
										$jumpPage .= "&" . $key . "[value][]=$subval";
									}
								} else {
									/* used if we want to pass data out of joomla/fabrik to another site */
									$jumpPage .= "&" . $key . "=$val";
									$jumpPage .= "&" . $key . "[value]=$val";
								}
							}
						}
					}
				}
			}

		}

		$fromModule 		 = mosGetParam( $_REQUEST, 'fabrik_frommodule', 0 );
		if ($fromModule == '1') {
			$jumpPage .= "&fabrik_frommodule=1";
		}
		if (!strstr( $jumpPage, "&Itemid=" ) && !strstr( $jumpPage, "/Itemid,")) {
			/* if the jump url contains an item id we shouldnt add the forms item id to it*/
			$jumpPage .= "&Itemid=$Itemid";
		}
		$oTable =& $this->getTable();
		return $jumpPage;
	}


	/**
	 * post the form data to the jump page url with curl
	 * now is a bit more generic in that it will apply the php code even if curl not installed
	 */

	function postCurl( )
	{
		if (!function_exists( 'curl_init' )) {
			/*echo "Curl not installed - can not  post form data to jump page";*/
			eval( $this->curl_code );
		} else {
			if ($this->form_submit_jumppage != '') {
				$ch = curl_init( $this->form_submit_jumppage );
				/* URL of gateway for cURL to post to*/
				eval( $this->curl_code );
				/* this presumes that the CURL script will deal with the redirect*/
			} else {
				/*echo "no jump page specified for Curl<br />";*/
			}
		}
	}

	/**
	 * sends emails to all people listed in the form's email to field
	 * @param bol if file uploads have been found
	 */

	function sendEmail( $fileUploadFound )
	{
		global $my, $mosConfig_sitename, $database, $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang;
		$path = $mosConfig_absolute_path .'/administrator/components/com_fabrik/language/'.$mosConfig_lang.'.php';
		if (file_exists( $path )) {
			include_once( $path );
		} else {
			$path = $mosConfig_absolute_path .'/administrator/components/com_fabrik/language/english.php';
			if (file_exists( $path )) {
				include_once( $path );
			}
		}
		//new 4 1.0.3 - email html templates
		$params = $this->loadParams();
		$emailTemplate = $mosConfig_absolute_path . '/components/com_fabrik/views/email/' . $params->get( 'email_template', '' );

		if (!is_dir( $emailTemplate ) && file_exists( $emailTemplate )) {
			$htmlEmail 	= 1;
			$parts = pathinfo( $emailTemplate );
			if ($parts['extension'] == 'php') {
				$message = $this->getPHPTemplateEmail( $fileUploadFound, $emailTemplate );
			} else {
				$message = $this->getTemplateEmail( $fileUploadFound, $emailTemplate );
			}
		} else {
			$htmlEmail 	= 0;
			$message = $this->getTextEmail( $fileUploadFound );
		}
		$cc 		= null;
		$bcc 		= null;

		$email_to 	= $this->parseMessageForPlaceholder( $this->email_to );
		$email_from = trim( $this->parseMessageForPlaceholder( $this->email_from ) );
	
		//check for Name <email>" for email from
		if (strstr( $email_from, "<" )){
			$bits = explode( "<", $email_from );
			$fromName = trim( $bits[0] );
			$email_from = trim( str_replace( ">", "", $bits[1] ) );
		} else {
			$fromName = $email_from;
		}
		$arDontEmailThesKeys = $this->_reservedWords;
		//end html email
		if ($this->form_subject == "") {
			$subject = $mosConfig_sitename . " :: Fabrik Email";
		} else {
			$subject = $this->form_subject;
		}
		$subject = $this->parseMessageForPlaceholder( $subject );
		$subject = preg_replace_callback( '/&#([0-9a-fx]+);/mi', array( &$this, 'replace_num_entity' ), $subject );

		/* Send email*/

		$emails = explode( ',', $email_to );
		foreach ($emails as $email) {
			if (!mosMail( $email_from, $fromName, $email , $subject, $message, $htmlEmail, $cc, $bcc, $this->_aAttachments )) {
				echo "Failed sending email to " . html_entity_decode( $email ) . "<br />";
			}
		}
	}

	/**
	 * use a php template for advanced email templates, partularly for forms with repeat group data
	 *
	 * @param bol if file uploads have been found
	 * @param string path to template
	 * @return string email message
	 */

	function getPHPTemplateEmail( $fileUploadFound, $tmpl) {
		global $mosConfig_live_site, $mosConfig_absolute_path;
		// start capturing output into a buffer
		ob_start();
		require_once( $tmpl );
		$message = ob_get_contents();
		ob_end_clean();
		return  $message;
	}

	/**
	 * template email handling routine, called if email template specified
	 * @param bol if file uploads have been found
	 * @param string path to template
	 * @return string email message
	 */

	function getTemplateEmail( $fileUploadFound, $tmpl) {
		global $mosConfig_live_site, $mosConfig_absolute_path;
		$message = file_get_contents( $tmpl );

		/*remove raw file upload data from the email*/
		$arDontEmailThesKeys = $this->_reservedWords;
		foreach ($_FILES as $key => $file) {
			$arDontEmailThesKeys[] = $key;
		}
		//$$$ rob if not recording in db then we can add in short key version of posted data
		// eg jos_fabrik_data_formid___full_name becomes full_name - this allow people to use {ful_name}
		// in email template
		if (!$this->record_in_database) {
			foreach ($this->_data as $key => $val) {
				if (strstr( $key, '___' )) {
					$key = explode('___', $key);
					$key = array_pop($key);
					$this->_data[$key] = $val;
				}
			}
		}

		foreach ($this->_groups as $oGroup) {
			$repeatGroup = $oGroup->getCanRepeatGroup();
			foreach ($oGroup->_aElements as $oElement) {
				$oElement->element_label = strip_tags( $oElement->element_label );
				if (!array_key_exists( $oElement->element_name, $this->_data )) {
					$elName = $oGroup->getElementFullName( $oElement, $this, true, true, false );
				} else {
					$elName =  $oElement->element_name;
				}
				$key = $elName;
				if (!in_array( $key, $arDontEmailThesKeys ) && array_key_exists($elName, $this->_data )) {
					if (is_string( $this->_data[$elName] )) {
						$val = stripslashes( $this->_data[$elName] );
					} else {
						$val = $this->_data[$elName];
					}
					switch ($oElement->elementtype_id) {
						case 4:
						case 6:
						case 3:
							$labels = explode('|', $oElement->dd_text);
							$values = explode('|', $oElement->dd_values);
							if (!empty( $this->_data ) && array_key_exists( $elName, $this->_data )) {
								if (is_array( $this->_data[$elName] )) {
									//this is for select boxes with multiple selections
									$options = '';
									for ($i=0; $i<count( $this->_data[$elName] ); $i++) {
										$tmpData 	= $this->_data[$elName][$i];
										$key 		= array_search( $tmpData, $values );
										if ($labels[$key] != '') {
											$options .= $labels[$key] . "<br />";
										} else {
											$options .= $tmpData . "<br />";
										}
									}
									$message = str_replace('{' . $elName . '}' , $options , $message);
								} else {
									$key 	= array_search($this->_data[$elName], $values);
									$value 	= stripslashes( $labels[$key] );
									if ($value == '') {
										$value = $this->_data[$elName] . "<br />";
									}
									$message = str_replace('{' . $elName . '}' , $value , $message);
								}
							}
							break;
						case 12: // database join
							if (is_array( $val )) {
								foreach ($val as $v) {
									// $$$ hugh - if no selection, this chunk was wiping $message clean
									// EDIT - actually, this whole section is screwed up, trying to fix it!
									/*
									if (!empty($v)) {
										$ddLabel = $oElement->getDatabaseDropdownDefaultValue( $v );
										$message = str_replace('(' . $v . ')' . $ddLabel , $message);
										if ($repeatGroup) {
											$this->_data[$elName . "_label"][] = $ddLabel;
										} else {
											$this->_data[$elName . "_label"] = $ddLabel;
										}
									}
									*/
									if (!empty($v)) {
										$ddLabel = $oElement->getDatabaseDropdownDefaultValue( $v );
										if ($repeatGroup) {
											$this->_data[$elName . "_label"][] = $ddLabel;
										} else {
											$this->_data[$elName . "_label"] = $ddLabel;
										}
										$message = str_replace('{' . $elName . "_label}" , $ddLabel, $message);
										$message = str_replace('{' . $elName . '}' , $v, $message);
									}
								}
							} else {
								$ddLabel = $oElement->getDatabaseDropdownDefaultValue( $val );
								if ($repeatGroup) {
									$this->_data[$elName . "_label"][] = $ddLabel;
								} else {
									$this->_data[$elName . "_label"] = $ddLabel;
								}
								$message = str_replace('{' . $elName . "_label}" , $ddLabel, $message);
								$message = str_replace('{' . $elName . '}' , $val, $message);
							}
							break;
						case 8:
							if ($fileUploadFound) {
								//remove the http:// from the front of $val otherwise it gets messed up in mosPathName
								$messageVal = $val;
								$prefix = '';
								if (substr( $messageVal, 0, 7) == "http://") {
									$prefix = "http://";
									$messageVal = ltrim( $messageVal, "http://");
								} elseif (substr( $messageVal, 0, 8) == "https://") {
									$messageVal = ltrim( $messageVal, "https://");
									$prefix = "https://";
								}
								$message = str_replace('{' . $elName . '}' ,  $prefix . mosPathName( $messageVal, false )  , $message);
								/** todo: check what happens here with open base_dir in effect */
								$this->_aAttachments[] =  str_replace( $mosConfig_live_site, $mosConfig_absolute_path, $val );
							}
							break;
						default:
							if (is_array( $val )) {
								$message = str_replace('{' . $elName . '}' , implode("<br />", $val) , $message);
							} else {
								$message = str_replace('{' . $elName . '}' , $val , $message);
							}
							break;
					}
				}
			}
		}
		return $message;
	}

	/**
	 * default email handling routine, called if no email template specified
	 * @param bol if file uploads have been found
	 * @return string email message
	 */

	function getTextEmail( $fileUploadFound) {
		global $mosConfig_live_site, $mosConfig_absolute_path;
		$arDontEmailThesKeys = $this->_reservedWords;
		/*remove raw file upload data from the email*/
		foreach ($_FILES as $key => $file) {
			$arDontEmailThesKeys[] = $key;
		}
		$message = "";
		foreach ($this->_groups as $oGroup) {
			$repeatGroup = $oGroup->getCanRepeatGroup();
			foreach ($oGroup->_aElements as $oElement) {
				$oElement->element_label = strip_tags( $oElement->element_label );
				if (!array_key_exists( $oElement->element_name, $this->_data )) {
					$elName = $oGroup->getElementFullName( $oElement, $this );
				} else {
					$elName =  $oElement->element_name;
				}
				$key = $elName;
				if (!in_array( $key, $arDontEmailThesKeys ) && array_key_exists( $elName, $this->_data )) {
					if (is_string( $this->_data[$elName] )) {
						$val = stripslashes($this->_data[$elName]);
					} else {
						$val = $this->_data[$elName];
					}
					switch ($oElement->elementtype_id) {
						case 4:
						case 6:
						case 3:
							$labels = explode('|', $oElement->dd_text);
							$values = explode('|', $oElement->dd_values);
							// was if (!empty($data) && array_key_exists($elName, $data[0])) {
							if (!empty( $this->_data) && array_key_exists( $elName, $this->_data )) {
								if (is_array( $this->_data[$elName] )) {
									//this is for select boxes with multiple selections
									for ($i=0; $i<count( $this->_data[$elName] ); $i++) {
										$tmpData = $this->_data[$elName][$i];
										$key = array_search($tmpData, $values);
										$message .= $oElement->element_label . ' : ' . $labels[$key] . "\n";
									}
								} else {
									$message .= $oElement->element_label . ' : ' . $val . "\n";
								}
							}
							break;
						case 12:
							$message .= $oElement->element_label . ' :';
							if (is_array( $val )) {
								foreach ($val as $v) {
									$ddLabel = $oElement->getDatabaseDropdownDefaultValue( $v );
									if ($repeatGroup) {
										$this->_data[$elName . "_label"][] = $ddLabel;
									} else {
										$this->_data[$elName . "_label"] = $ddLabel;
									}
									$message .=  '(' . $v . ')' . $ddLabel . "\n";
								}
							} else {
								$ddLabel = $oElement->getDatabaseDropdownDefaultValue( $val );
								if ($repeatGroup) {
									$this->_data[$elName . "_label"][] = $ddLabel;
								} else {
									$this->_data[$elName . "_label"] = $ddLabel;
								}
								$message .= '(' . $val . ')' . $oElement->getDatabaseDropdownDefaultValue( $val ) . "\n";
							}
							break;
						case 8:
							if ($fileUploadFound) {
								// $$$ hugh fixed this line (added ['id']), think it's been breaking multi attachments in email
								if ( is_array( $val['id'] ) ) {
									foreach ($val['id'] as $key=>$i) {
										$message .= "file uploaded : " . mosPathName( $this->_data[$elName][$key], false ) . "\n";
										$this->_aAttachments[] =  str_replace( $mosConfig_live_site, $mosConfig_absolute_path, $this->_data[$elName][$key] );
									}
								}else {
									$message .= "file uploaded : " . mosPathName( $this->_data[$elName], false ) . "\n";
									$this->_aAttachments[] =  str_replace( $mosConfig_live_site, $mosConfig_absolute_path, $this->_data[$elName] );
								}
							}
							break;
						default:
							if ( is_array( $val ) ) {
								$message .= $oElement->element_label . ' : ' . implode("\n\t", $val) . "\n";
							} else {
								$message .= $oElement->element_label . ' : ' . $val . "\n";
							}
							break;
					}
				}
			}
		}
		return $message;
	}

	/**
	 * saves the form data to the database
	 * @param int rowid - if 0 then insert a new row - otherwise update this row id
	 * @return int last inserted row id
	 */

	function submitToDatabase( $rowId = '0')
	{
		global $mosConfig_live_site, $database, $mosConfig_absolute_path;
		$this->getFormGroupsHiarachy( );
		require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_connection.class.php" );
		require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_groups.class.php" );
		require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_functions.php" );
		/*check if there is table data that is not posted by the form (ie if no checkboxes were selected)*/
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if ($oElement->elementtype_id == '3') {
					/* replace all non alphanumeric characters with _*/
					/*$elName = preg_replace( "/[^A-Za-z0-9.]/", "_", $oElement->element_name );*/
					$elName = $oElement->element_name;
					if (!array_key_exists( $elName, $this->_data )) {
						$this->_data[$oElement->element_name] = $oElement->ck_value;
					}
				}
				// $$$ hugh - hack for date formats ,oght go here
				// $$$ for the moment, will just fix it so date is NOT formatted when editing,
				// $$$ in drawDate.  But would like to fix things so we can convert back to standard
				// $$$ MySQL date format here.
				// $$$ hugh - started implementing the above!
				elseif ($oElement->elementtype_id == '11') {
					// $$$ hugh - check to see if it's already in MySQL format, which either means
					// that's the format they selected, or we've already converted it (for instances
					// if we're re-saving the main table after saving joined rows).  In the latter case
					// trying to re-format will prolly fail, because it won't match the $format string.
					if (!preg_match('#\d\d\d\d-\d\d-\d\d \d\d:\d\d:\d\d#',$this->_data[$oElement->element_name]))
					{
						$attribs = $oElement->loadParams();
						$format = $attribs->get( 'date_form_format', $attribs->get('date_table_format', 'Y-m-d') );
						if ($this->_data[$oElement->element_name] != '')
						{
							//$this->_data[$oElement->element_name] = date( 'Y-m-d H:i:s', strtotime($this->_data[$oElement->element_name]));
							$timebits = strToDateTime( $this->_data[$oElement->element_name], $format );
							$this->_data[$oElement->element_name] = date( 'Y-m-d H:i:s', $timebits['timestamp']);
	
						}
					}
				}
				// $$$ hugh - normalize url's in links
				// $$$
				elseif ($oElement->elementtype_id == '14') {
					if (!preg_match('#\w+://.*#',$this->_data[$oElement->element_name]['link'])) {
						$this->_data[$oElement->element_name]['link'] = 'http://' . $this->_data[$oElement->element_name]['link'];
					}
				}
			}
		}
		if ($this->table_id != '' and $this->table_id != '0') {
			$oTable =& $this->getTable( $this->table_id );
			$fabrikDb =& $oTable->getDb();
			$table = $oTable->db_table_name;
			//$oConn = new fabrikConnection( $database );
			//$ok = $oConn->load( $oTable->connection_id );
			//if (!$ok) {
			//	$this->_err =  "Can not load database connection tableid = $this->table_id <br>";
			//	return;
			//}
			//$fabrikDb 	= $oConn->loadTableConnectionDB( );
			$primaryKey = $oTable->db_primary_key;
		} else {
			$oTable 	=& new fabrikTable( $database );
			$fabrikDb 	=& $database;
			$primaryKey = ' fabrik_internal_id';
			$table 		= $fabrikDb->_table_prefix . "fabrik_data_" . $this->id;
			$oTable->db_table_name = $table;
		}
		$oTable->_oForm =& $this;

		$this->updateDropdowns( );
		$oTable->storeRow( $this->_data, $rowId, $fabrikDb, $table );
		if ($rowId == 0 || $rowId == '') {
			return $oTable->_lastInsertId;
		} else {
			return $rowId;
		}
	}

	/**
	 * Check the form for drop down elements, if found check if the user can & has added in new options
	 * If so then update the element itself to contain that element.
	 * @param array posted form data
	 */

	function updateDropdowns() {
		global $database;
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement ) {
				if ($oElement->elementtype_id == '6') {
					$params = $oElement->loadParams();
					if ($params->get( 'allow_frontend_addtodropdown' ) == 1) {
						$elName = $oElement->element_name;
						$newValName = $elName . '_newValueList';
						$newLabelName = $elName . '_newLabelList';
						if (array_key_exists($newValName, $this->_data ) && array_key_exists($newLabelName, $this->_data )) {
							$newLabels = explode('|', $this->_data[$newLabelName]);
							array_shift($newLabels);
							$newValues = explode('|', $this->_data[$newValName]);
							array_shift($newValues);

							$existingValues = explode( '|', $oElement->dd_values );
							$existingLabels = explode( '|', $oElement->dd_text );
							for ($i=0; $i<count( $newLabels ); $i++) {
								$l = $newLabels[$i];
								$v = $newValues[$i];
								if (!in_array($v, $existingValues)) {
									$existingValues[] = $v;
									$existingLabels[] = $l;
								}
							}
							$ddVals =  $database->Quote( rtrim(implode('|', $existingValues), '|') ) ;
							$ddText =  $database->Quote( rtrim(implode('|', $existingLabels), '|') );

							//god knows y but $oElement->store() wasnt working ? so resorted to sql update instead
							$sql = "update #__fabrik_elements set dd_values = $ddVals, dd_text = $ddText where id = '$oElement->id'";
							$database->setQuery($sql);
							if (!$database->query()) {
								echo $database->getErrorMsg();
							}
						}
					}
				}
			}
		}
	}

	/**
	 * attempts to determine if the form contains the element
	 * @param string element name to search for
	 * @return bol true if found, false if not found
	 */

	function hasElement( $searchName ) {
		$this->getFormGroupsHiarachy( false );
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				
				if ($searchName == $oElement->element_name) {
					$this->_currentElement = $oElement;
					return true;
				}
			
				if ($searchName == $oGroup->getElementFullName($oElement, $this, true, true, false)) {
					$this->_currentElement = $oElement;
					return true;
				}
			
				$n = $oGroup->getElementFullName($oElement, $this, false, true, false);
				//check for ranged search elements (limit regex to one replace as otherwise full join names get 
				//wrongly identified as being in the form
				$n = preg_replace('/\[(.*?)\]/', '',$n, 1);
				if ($searchName == $n) {
					$this->_currentElement = $oElement;
					return true;
				}
			
				$n = $oGroup->getElementFullName($oElement, $this, true, false, false);
				$n = preg_replace('/\[(.*?)\]/', '',$n, 1);
				if ($searchName == $n) {
					$this->_currentElement = $oElement;
					return true;
				}
				
				$n = $oGroup->getElementFullName($oElement, $this, false, false, false);
				$n = preg_replace('/\[(.*?)\]/', '',$n, 1);
				if ($searchName == $n) {
					$this->_currentElement = $oElement;
					return true;
				}
			}
		}
		return false;
	}

	/** takes a table id and returns a table object
	 * @param int table id
	 * @return object table
	 */

	function loadTable( $tableId) {
		global $database;
		$oTable = new fabrikTable( $database );
		$oTable->load( $tableId );
		return $oTable;
	}

	function &getTable( $id = null) {
		if (!$this->_oTable) {
			$this->_oTable = $this->loadTable( $id );
		}
		return $this->_oTable;
	}

	/**
	 * get the class names for each of the validation rules
	 * @return array (validaionruleid => classname )
	 */

	function loadValidationRuleClasses() {
		global $database, $mosConfig_absolute_path;
		$query = "SELECT id, attribs FROM #__fabrik_validation_rules";
		$database->setQuery( $query );
		$aValidationRuleClasses = array();
		$rows = $database->loadObjectList( );
		echo $database->getErrorMsg();

		foreach ($rows as $row) {
			switch($row->id) {
				case 1:
					$aValidationRuleClasses[$row->id] = 'notempty';
					break;
				case 2:
					$aValidationRuleClasses[$row->id] = 'alphanumeric';
					break;
				case 3:
					$aValidationRuleClasses[$row->id] = 'isemail';
					break;
				default:
					$params = new fabrikParams($row->attribs, $mosConfig_absolute_path.'/administrator/components/com_fabrik/xml/validation_rule.xml', 'component');
					$aValidationRuleClasses[$row->id] = $params->get( 'validation_class' );
					break;
			}
		}
		$this->_validationRuleClasses = $aValidationRuleClasses;
		return $aValidationRuleClasses;
	}

	/**
	 * validates the forms data against the defined set of rules
	 * @param array form data
	 * @return array array of error messages called arErrors() [form_element_name,
	 * error message]
	 */

	function ValidateForm( ) {
		global $database, $mosConfig_lang, $mosConfig_absolute_path;
		$data = $this->_data;
		$arErrors = array();
		$this->getFormGroupsHiarachy( );
		foreach ($this->_groups as $oGroup) {
			if ($oGroup->state != 0) {
				$groupParams =& $oGroup->getParams();
				$repeatGroup = $groupParams->get( 'repeat_group_button' );
				if ($repeatGroup) {
					$groupCount = mosGetParam( $_POST, 'fabrik_repeat_group_' . $oGroup->id . '_counter', 1 );
				} else {
					$groupCount = 1;
				}
				for ($c = 0; $c < $groupCount; $c ++) {
					foreach ($oGroup->_aElements as $element) {
						if ($element->canUse()) {
							$element_name = $element->element_name;
							$element_id = $element->id;
							$sql = "SELECT *, v.id as validation_id FROM #__fabrik_validations v "
							. "\n LEFT JOIN #__fabrik_validation_rules vr ON v.validation_rule_id = vr.id "
							. "\n WHERE v.element_id = '$element_id'";
							$database->setQuery( $sql );
							$validation_rules = $database->loadObjectList( );
							foreach ($validation_rules as $validation_rule) {
								if ( $element_id == $validation_rule->element_id ) {
									//load object for translation
									$oValidation = new fabrikValidation( $database );
									$oValidation->load( $validation_rule->validation_id );
									$error_message = $oValidation->message;
									$alpha_numeric_element_name = $oGroup->getElementFullName( $element, $this, false, true, false );
									$rule_id 	= $validation_rule->id;
									$rule_desc 	= $validation_rule->validation_rule_label;
									$rule_exp	= $validation_rule->validation_rule_expression;
									$rule_label = $validation_rule->validation_rule_label;

									$form_data = $oGroup->getElementDefaultValue( $element, $data, $this, true, $c );

									$rule_exp 	= trim( $rule_exp );
									if ($element->elementtype_id == '8') { //fileupload
										$form_data = $form_data['value'];
									}
									 
									if ($repeatGroup) {
										if (is_array($form_data) && array_key_exists( $c, $form_data)) {
											$form_data = $form_data[$c];
										}
									}
									if (is_array( $form_data )) {
										$form_data = implode( ",", $form_data );
									} else {
										$form_data = stripslashes( $form_data );
									}
									if (!empty( $rule_exp )) {
										$params =& new fabrikParams( $validation_rule->attribs, $mosConfig_absolute_path.'/administrator/components/com_fabrik/xml/validation_rule.xml', 'component' );
										if ($params->get( 'match_or_replace', 1 ) == 0) {
											//replace form data
											$replacement = $params->get( 'replace_text', '' );
											if ($oGroup->getCanRepeatGroup()) {
												$this->_data['join'][$oGroup->join_id][$alpha_numeric_element_name] = preg_replace( $rule_exp, $replacement, $form_data );
											} else {
												$this->_data[$alpha_numeric_element_name] = preg_replace( $rule_exp, $replacement, $form_data );
											}
										} else {
											if ( !(preg_match( $rule_exp, $form_data, $matches ) )) {
												$oGroup->_addError( $arErrors, $alpha_numeric_element_name, $error_message, $c );
											}
										}
									} else {
										if ($rule_label == 'akismet') {
											$rule_id = '666';
										}
										switch ($rule_id) {
											case 1:
												/* required field*/
												if ($element->elementtype_id == '8') {
													if ($form_data == '') {
														if (!array_key_exists($alpha_numeric_element_name, $_FILES)) {
															$oGroup->_addError( $arErrors, $alpha_numeric_element_name, $error_message, $c );
														} else {
															$fname = $_FILES[$alpha_numeric_element_name]['name'];
															if (is_array( $fname )) { //repeat group
																$fname = $fname[$c];
															}
															if ($fname == '') {
																$oGroup->_addError( $arErrors, $alpha_numeric_element_name, $error_message, $c );
															}
														}
													}
												} else {
													if ($form_data == "" or (($element->elementtype_id == '12' or $element->elementtype_id == '6') and $form_data == '-1')) {
														$oGroup->_addError( $arErrors, $alpha_numeric_element_name, $error_message, $c );
													}
												}
												 
												break;
											case 2:
												/* must be alpha numeric*/
												 
												if ($element->elementtype_id == '8') {
													$fname = $_FILES[$alpha_numeric_element_name]['name'];
													if (is_array( $fname )) { //repeat group
														$fname = $fname[$c];
													}
													//strip extension
													$fname = explode(".", $fname);
													$fname = $fname[0];
												} else {
													$fname = $form_data;
												}
												if (!$this->isAlphaNumeric( $fname )) {
													$oGroup->_addError( $arErrors, $alpha_numeric_element_name, $error_message, $c );
												}
												break;
											case 3:
												/* must be an email address*/
												if (!$this->check_email_address( $form_data )) {
													$oGroup->_addError( $arErrors, $alpha_numeric_element_name, $error_message, $c );
												}
												break;
											case 666:
												/* hugh - testing Akismet */
												if ($element->elementtype_id == '5') {
													global $mosConfig_live_site, $my, $fabrikConfig;
													if ($fabrikConfig->fbConf_akismet_key  != '')
													{
														require_once($mosConfig_absolute_path . '/components/com_fabrik/libs/akismet/akismet.class.php');
														$akismet_comment = array (
															'author' => $my->username,
															'email' => $my->email,
															'website' => $mosConfig_live_site,
															'body' => $form_data
														);
														$akismet = new Akismet($mosConfig_live_site, $fabrikConfig->fbConf_akismet_key, $akismet_comment);
														if($akismet->errorsExist()) {
															echo"Couldn't connected to Akismet server!";
														} else {
															if($akismet->isSpam()) {
																$oGroup->_addError( $arErrors, $alpha_numeric_element_name, $error_message, $c );
															}
														}
													}
												}
												break;
											default:
												break;
										}
									}
								}
							}
						}
					}
				}//end repeat group
			}
		}
		if (mosGetParam( $_REQUEST, 'fabrikdebug')) {
			echo "<pre>";print_r($arErrors);echo "</pre>";
		}
		return $arErrors;
	}


	function getTableName()
	{
		global $mosConfig_dbprefix;
		if ( !is_object( $this->_table )) {
			$this->_table = $this->loadTable( $this->table_id );
		}
		if ( $this->_table->db_table_name != '' ) {
			return $this->_table->db_table_name;
		}
		return $mosConfig_dbprefix . 'fabrik_data_' . $this->id;
	}

	/**
	 * overloaded check function
	 */

	function check()
	{
		/* check for valid name*/
		if ( trim( $this->form_title ) == '' ) {
			$err .= "Your Form must contain a title!\n";
		}
		if ( trim( $this->form_submit_jumppage ) == '' and trim( $this->form_submit_message ) == '' ) {
			$err .= "Either a thank you message or a jump page must be entered .\n";
		}
		if ( isset( $err ) ) {
			$this->_error = $err;
			return false;
		}
		return true;
	}

	/**
	 * copy form row
	 * @param int form id to copy
	 * @param array
	 */
	function copyRow( $id, $updateOrderColumns=array()) {
		global $database;
		$tbl = $this->_tbl;
		$_tbl_key = $this->_tbl_key;
		/*get the data to copy*/
		$sql = "SELECT * FROM $tbl WHERE $_tbl_key = '$id'";
		$database->setQuery( $sql );
		$item = $database->loadObjectList();
		$item = $item[0];
		/*add the data to this object as long as its not the key*/
		foreach ($item as $key=>$val) {
			if ( $key != $_tbl_key) {
				$this->$key = $val;
			}
		}
		/* Check if the name exists*/
		$name = $this->form_title;
		if ( substr( $name, 0 , 8 ) == "Copy_of_" )	{
			if ( strrpos( $name, "-" ) > 0 ) {
				$tot = strrpos($name, "-") - strlen($name);
				$sName = substr($name, 8, $tot ) ;
			} else {
				$sName = substr($name, 8) ;
			}
			$sql = "SELECT form_title FROM $tbl WHERE form_title LIKE '%$sName%'";
		} else {
			$sql = "SELECT form_title FROM $tbl WHERE form_title LIKE '%$name%'";
			$name = "Copy_of_" . $name;
		}
		$database->setQuery( $sql );
		$names = $database->loadResultArray();
		if (count($names) == 2) {
			$name = $name . "-2";
		} else if (count($names) > 2)	{
			if (strrpos($name, "-") > 0) {
				$name = substr($name , 0, strrpos($name, "-")+1) . (count($names));
			} else {
				$name = $name . "-" . (count($names));
			}
		}

		$this->form_title = $name;

		if ( !$this->check() ) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		if ( !$this->store() ) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		/* parse the update code to state which columns get updated*/
		$updatewhere = "";
		if ( is_array( $updateOrderColumns ) ) {
			foreach ($updateOrderColumns as $key=>$val) {
				/* here we replace the value with date created from the row */
				if ( substr($val,0,4) == '$row' ) {
					$val = $row->$key;
				}
				$updatewhere .= " $key = '$val' and";
			}
			/* strip the last and from the where statement*/
			$updatewhere = substr($updatewhere,0,strlen($updatewhere)-3 );
		}
		$this->updateOrder( $updatewhere );
	}

	/**
	 * when saving a table that links to a database for the first time we
	 * need to link together the created form and the created group
	 * @param int group id
	 */

	function createFormGroup( $groupId ) {
		global $database, $my, $mosConfig_absolute_path;
		/*load in existing groups*/
		$sql = "SELECT group_id FROM #__fabrik_formgroup WHERE form_id = '$this->id'";
		$database->setQuery( $sql );
		$aFormGroups = $database->loadResultArray( );
		$sFromGroups = implode( ',', $aFormGroups );
		$sFromGroups .= ",$groupId";
		$this->_saveFormGroup( $sFromGroups, 1 );
	}


	/**
	 * Save the group
	 * @param string csv of group ids to associate with the form
	 * @param bol record in database
	 */

	function _saveFormGroup( $current_groups_str, $record_in_database = '1') {
		global $database, $my, $mosConfig_dbprefix;
		$oTable = $this->loadTable( $this->table_id );
		//$tableDatabase = null;
		if ( $record_in_database == '1' ) {
			if ( $this->table_id == '0' || is_null( $this->table_id ) ) {
				if (!$this->findAndUpdateTableId( ) ) {
					//echo "Could not find a table linking to this form - do we create a table for it?";
				}
			}
			/*
			 $oConn->load( $oTable->connection_id );
			 $tableDatabase = $oConn->loadTableConnectionDB( );
			 $dbTableName = $oTable->db_table_name;*/
		}
		//$menu = mosGetParam( $_POST, 'menu', 'mainmenu' );
		//$menuid = mosGetParam( $_POST, 'menuid', 0 );
		$database->setQuery( "DELETE FROM #__fabrik_formgroup WHERE form_id = '$this->id'");
		// delete the old form groups
		if ( !$database->query( ) ) {
			$msg .= $database->getErrorMsg( ) . "\n";
		}
		$orderid = 1;
		$current_groups = explode( ",", $current_groups_str );
		foreach ($current_groups as $group_id) {
			$sql = "INSERT INTO #__fabrik_formgroup (form_id, group_id, ordering) VALUES ('$this->id','$group_id','$orderid')";
			$database->setQuery( $sql );
			if (!$database->query( )) {
				echo $database->getErrorMsg() . "\n";exit;
			}
			$orderid ++;
		}
		if ($record_in_database == '1') {
			if (is_null( $this->table_id ) || $this->table_id == '') {
				// a form has been set to record in database for the first time
				$oConn = new fabrikConnection( $database );
				$oConn->loadDefaultConnection();
				$oTable->db_table_name =  $mosConfig_dbprefix . "fabrik_formdata_" . $this->id;

				if ( !$oTable->databaseTableExists( $oTable->db_table_name, $database ) ) {
					//need to pass the correct database obj here
					$oTable->createFormTable( $this, $oTable->db_table_name );
				} else {
					$oTable->ammendTable( $this );
				}
				$oTable->state = $this->state;
				$oTable->label = $this->form_title;
				$oTable->form_id = $this->id;
				$oTable->connection_id = $oConn->id;
				//$$$ rob set up default permissions
				$oTable->access 			= 29;
				$oTable->allow_add 			= 29;
				$oTable->allow_delete 	= 29;
				$oTable->allow_view_details 	= 29;
				$oTable->allow_edit_details 	= 29;
				$oTable->filter_action = 'onchange';
				$oTable->publish_up = '0000-00-00 00:00:00';
				$oTable->publish_down = '0000-00-00 00:00:00';
				$oTable->created 		= date( 'Y-m-d H:i:s' );
				$oTable->created_by 	= $my->id;
				$oTable->attribs = "allow-data-translation=0
show-table-nav=1
advanced-filter=0
empty_data_msg=
detaillink=0
detailurl=
csv_export_frontend=0
csvfullname=0
rss=0
rsslimit=150
rsslimitmax=2500
feed_title=
feed_date=
group_by_order=
group_by_order_dir=ASC";
				$oTable->store();
				// $$$ hugh - needs to be $this, not $oForm
				// $$$ STATUS - provisional
				// $oForm->table_id = $oTable->id;
				$this->table_id = $oTable->id;
				// $$$ end hugh
				$this->store();
			} else {
				if ( !$oTable->databaseTableExists( ) ) {
					//need to pass the correct database obj here
					$oTable->createFormTable( $this );
				} else {
					$oTable->ammendTable( $this );
				}
			}
		}
	}

	/**
	 * updates a form with its associated table id
	 * @param int tableid
	 */

	function updateFormWithNewTableId( $tableId) {
		global $database;
		$sql = "UPDATE #__fabrik_forms SET table_id = '$tableId' WHERE id = '$this->id'";
		$database->setQuery( $sql );
		$database->query();
	}

	/**
	 * sets the variable of each of the form's group's elements to the value
	 * specified
	 * @param string variable name
	 * @param string variable value
	 * @return bol false if update error occurs
	 */

	function setElementVars( $varName, $varVal) {
		global $mosConfig_absolute_path, $database;
		require_once( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_elements.class.php" );
		if ($this->_elements == null) {
			$this->getFormGroups( );
		}
		foreach ($this->_elements as $el ) {
			$oElement = new fabrikElement( $database );
			$oElement->load( $el->id );
			if (!$oElement->setVar( $varName, $varVal )) {
				return false;
			}
			$oElement->store( );
		}
		return true;
	}

	/**
	 * check if the given email address is correctly formatted
	 * @param string email address to check
	 * @return bol ok / not ok
	 */
	function check_email_address( $email) {
		/* First, we check that there's one symbol, and that the lengths are right*/
		if ( !ereg("[^@]{1,64}@[^@]{1,255}", $email ) ) {
			/* Email invalid because wrong number of characters in one section, or wrong number of symbols.*/
			return false;
		}
		/* Split it into sections to make life easier*/
		$email_array = explode( "@", $email );
		$local_array = explode( ".", $email_array[0] );
		for ( $i = 0; $i < sizeof($local_array); $i++ ) {
			if ( !ereg( "^(([A-Za-z0-9!#$%&'*+/=?^_`{|}~-][A-Za-z0-9!#$%&'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$", $local_array[0] ) ) {
				return false;
			}
		}
		/* Check if domain is IP. If not, it should be valid domain name */
		if ( !ereg( "^\[?[0-9\.]+\]?$", $email_array[1] ) ) {
			$domain_array = explode( ".", $email_array[1] );
			if ( sizeof( $domain_array ) < 2 ) {
				/* Not enough parts to domain */
				return false;
			}
			for ( $i = 0; $i < sizeof( $domain_array ); $i++ ) {
				if ( !ereg( "^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$", $domain_array[$i])) {
					return false;
				}
			}
		}
		return true;
	}

	/**
	 * check if string is alpha numeric
	 * @param string data to check
	 * @return bol ok or not
	 */

	function isAlphaNumeric( $data) {
		if ( ereg('[^A-Za-z0-9]', $data ) ) {
			return false;
		} else {
			return true;
		}
	}

	/**
	 * determines if the form can be published
	 * @return bol true if publish dates are ok
	 */

	function canPublish() {
		global $database;
		if (method_exists($database, 'getNullDate')) {
			$nullDate = $database->getNullDate( );
		} else {
			$nullDate = $this->getNullDate( );
		}
		if ( $this->state == '1') {
			if ( date( 'Y-m-d 00:00:00' ) >= $this->publish_up || $this->publish_up == '' || $this->publish_up == $nullDate ) {
				if ( date('Y-m-d 00:00:00') <= $this->publish_down || $this->publish_down == '' || $this->publish_down == $nullDate ) {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * creates a html dropdown off all forms
	 * @param int selected group id
	 * @return string group list
	 */

	function makeDropDown( $selectedId = 0) {
		global $database;
		$database->setQuery( "SELECT id AS value, form_title AS text FROM #__fabrik_forms ORDER BY form_title" );
		$aTmp[] = mosHTML::makeOption( "-1", _PLEASE_SELECT );
		$forms = $database->loadObjectList( );
		$forms = array_merge(  $aTmp, $forms );
		$list = mosHTML::selectList( $forms, 'filter_formId', 'class="inputbox"  onchange="document.adminForm.submit( );"', 'value', 'text', $selectedId );
		return $list;
	}

	/**
	 * create a drop down list of all the elements in the form
	 * @param string drop down name
	 * @param string current value
	 * @param bol add elements that are not show in the table view
	 * @param bol add elements that are unpublished
	 * @param add the table name to the option's element name
	 * @param array joins for the table
	 * @param string table database name
	 * @return string html list
	 */

	function getElementList( $name = 'order_by', $default = '', $showNotInTable = true, $excludeUnpublished = false, $showTableName = false, $aJoinObjs=array( ), $tableName = '') {
		$aEls = array( );
		$aEls = $this->getElementOptions( $showNotInTable, $excludeUnpublished, $showTableName, $aJoinObjs, $tableName );
		$aEls[] = mosHTML::makeOption( '', '-' );
		asort($aEls);
		return mosHTML::selectList( $aEls, $name, 'class="inputbox" size="1" ', 'value', 'text', $default );
	}

	/**
	 * crreates options array to be then used by getElementList to create a drop down of elements in the form
	 * sperated as elements need to collate this options from muliple forms
	 * @param bol add elements that are not show in the table view
	 * @param bol add elements that are unpublished
	 * @param add the table name to the option's element name
	 * @param array joins for the table
	 * @param string table database name
	 * @return array html options
	 */

	function getElementOptions( $showNotInTable = true, $excludeUnpublished = false, $showTableName = false, $aJoinObjs=array( ), $tableName = '') {
		$aGroupEls = $this->getFormGroupsHiarachy( $showNotInTable, $excludeUnpublished );
		$aEls = array( );
		foreach ($aGroupEls as $group) {
			foreach ($group->_aElements as $el) {
				$val = $el->element_name;
				$label = $el->element_label;
				if ($group->is_join && is_array( $aJoinObjs )) {
					foreach ($aJoinObjs as $oJoin) {
						if ($oJoin->group_id == $group->id) {
							$val = $oJoin->table_join . '.' . $val;
							$label = $oJoin->table_join . '.' . $label;
						}
					}
				} else {
					if ($tableName != '') {
						$val = $tableName . '.' . $val;
					}
				}
				$aEls[] = mosHTML::makeOption( $val, $label );
			}
		}
		asort($aEls);
		return $aEls;
	}

	/**
	 * get an array of element ids
	 * @access private
	 * @return array element ids
	 */

	function _getElementIds() {
		$aGroupEls = $this->getFormGroupsHiarachy( false, false );
		$aIds = array();
		foreach ($aGroupEls as $group) {
			foreach ($group->_aElements as $el) {
				$aIds[]  = $el->id;
			}
		}
		return $aIds;
	}

	/**
*get array of validation errors
* @return array of errors - empty array if no errors set
* */
	function getErrors()
	{
		if (isset( $this->_errors )) {
			return $this->_errors;
		}
		return array();
	}
	
	/**
	 * collates data to write out the form
	 * @param int table id
	 * @param int table row id
	 * @param bol if the form is not editable then display a viewonly datasheet
	 * @param bol output viewonly data as a pdf
	 * @param bol in admin view
	 * @param string key filed to use for record - default ''
	 * @return mixed . Object template if rendered as mambot otherwise empty
	 */

	function render( $tableId = '', $rowId, $editable = false, $do_mf_pdf = false, $admin = false, $usekey = '', $render = true)
	{
		global $_SESSION;
		$aJoinFields = array( );
		$arErrors = $this->getErrors();
		$aGroups = null;
		// $$$ hugh - see if a form mambot failed verification, and if so reload form data from session.
		if (is_array( $_SESSION )) {
			if (array_key_exists( "fabrik",  $_SESSION )) {
				//$$$ rob 1.0.5.2 + added check that the modulerror wasnt just an  empty array otherwise this was always run
				if (array_key_exists('moduleErrors', $_SESSION['fabrik']) && !empty($_SESSION['fabrik']['moduleErrors']) and array_key_exists( 'fromForm',  $_SESSION["fabrik"] )) {
					$formForm = $_SESSION["fabrik"]['fromForm'];
					if (array_key_exists( $formForm,  $_SESSION["fabrik"] )) {
						$_REQUEST = array_merge( $_REQUEST, $_SESSION["fabrik"][$formForm] );
						//keep fromForm var in place as its used to create filters from search form's when viewing table data. 
						//unset( $_SESSION["fabrik"]['fromForm'] );
					}
				}
			}
		}
		//check if the form does have a table id
		if ($tableId == '') {
			$tableId = $this->table_id;
		}
		//$$$rob if its a fom linked to a table, as a new record that hasnt failed validation
		// $$$ hugh - but if this if for new records, shouldn't $rowId be empty?
		// $$$ hmmm, we have to run this stuff whether it's new or old record, otherwise
		// $$$ oTable and isn't created, so join stuff later on craps out
		//if ($tableId != '' && $rowId != '' && empty($this->_errors)) {
		if ($tableId != '' && empty($this->_errors)) {
			$oTable 	=& $this->getTable( $tableId );
			$fabrikDb   =& $oTable->getDb();
			if (!$fabrikDb) {
				echo "could not connect to database";
				return false;
			}

			$table  	= $oTable->db_table_name;
			if ($usekey) {
				$usekey = $table . '.' . $usekey;
			}
			$key 		= $oTable->db_primary_key;
			if ($key == '' && strstr( $oTable->db_table_name, 'fabrik_data' )) {
				$key 	= 'fabrik_internal_id';
			}

			$this->_aJoinObjs = $oTable->loadJoins( );
			
			if ($rowId != '') {
				//dont waste time building the query if no row selected
				$sql = $this->_buildQuery( $tableId, $rowId, $usekey );
				$fabrikDb->setQuery( $sql );
				if (mosGetParam($_REQUEST, 'fabrikdebug') == '1') {
					echo $fabrikDb->getQuery();
				}
				$elementData = $fabrikDb->loadObjectList( );
			} else {
				$elementData = array();
			}

			//take a copy of the join data and store. Note this can be more than one
			// result set in which case the joined group should be duplicated on presenting the form
			// and fille with the correct data

			echo $fabrikDb->getErrorMsg();
			$random = $this->_isRandom();
			if ($random && !empty( $elementData )) {
				$thiskey = str_replace( ".", "___", $oTable->db_primary_key );
				$rowId = $elementData[0]->$thiskey;
			}
			if ($rowId != '' &&  !empty( $elementData )) {
				$formDefaultData = mosObjectToArray( $elementData[0] );
				// $$$ hugh - testing key override
				if ($usekey != '') {
					$thiskey = str_replace( ".", "___", $key );
					$rowId = $elementData[0]->$thiskey;
				}
			} else {
				$formDefaultData = $_REQUEST;
				$rowId = '';
			}
			$this->_table = $oTable;
		} else {
			$formDefaultData = (is_null($this->_data)) ? $_REQUEST : $this->_data;
			$elementData =& $formDefaultData;//not sure what the dif is between these 2
		}
		$this->getJoinDefaultData( $elementData, $rowId );
		/* add join data into array*/

		if ( is_array( $formDefaultData ) && is_array( $aGroups )) {
			foreach ($aGroups as $oGroup) {
				if ($oGroup->is_join && array_key_exists( $joinId, $this->_joinDefaultData )) {
					$repData = $this->_joinDefaultData[$joinId];
					$numRepeats = (is_array($repData)) ? count(current($repData)) : 0;
					$aTmp = array();
					for ($i=0; $i<$numRepeats; $i++) {
						foreach ($repData as $thiskey=>$set) {
							$aTmp[$thiskey] = $set[$i];
						}
						$formDefaultData['join'][$joinId][] = $aTmp;
					}
				}
			}
		}
		
		$this->setAdmin( $admin );
		if ($render) {
			if ( $this->canPublish( )) {
				return $this->writeForm( $arErrors, $formDefaultData, $tableId, $rowId, $editable, $do_mf_pdf, $admin );
			} else {
				if (!$admin) {
					fabrik_html_content::notPublished( 'form' );
				} else {
					$this->writeForm( $arErrors, $formDefaultData, $tableId, $rowId, $editable, $do_mf_pdf, $admin );
				}
			}
		}
	}
	
	function _buildQuery( $tableId = '', $rowId = 0, $usekey = '')
	{
		$oTable 	=& $this->getTable( $tableId );
		$table  	= $oTable->db_table_name;
		$aGroups 	=& $this->getFormGroupsHiarachy( );
		$key 		= $oTable->db_primary_key;
		if ($key == '' && strstr( $oTable->db_table_name, 'fabrik_data' )) {
			$key 	= 'fabrik_internal_id';
		}
		//check if the form does have a table id
		if ($tableId == '') {
			$tableId = $this->table_id;
		}
		/*rather than do select *
		 we have to manually try to make a list of elements (table.ele) as otherwise
		 duplicate element names overwrite data !*/
		if (is_array( $this->_aJoinObjs )) {
	
			$sql = "SELECT  ";
			$aUsedTables = array( $table );
			foreach ($this->_aJoinObjs as $oJoin) {
				$aUsedTables[$oJoin->group_id] = array( $oJoin->table_join, $oJoin->id );
			}
	
			foreach ($aGroups as $oGroup) {
				foreach ($oGroup->_aElements as $oElement) {
					if ($oGroup->is_join) {
						$posTable = $aUsedTables[$oElement->group_id][0];
						$joinId = $aUsedTables[$oElement->group_id][1];
						$elName = $posTable . '.' . $oElement->element_name;
						$tmpName = $posTable . $this->_joinTableElementStep . $oElement->element_name;
						$elAsName =  'join[' . $joinId . ']' . $tmpName;
						$sql .= $elName . ' AS `' . $elAsName .'`,';
	
					} else {
	
						$possibleTables = $oElement->getElementsGroupTables( );
						foreach ($possibleTables as $posTable) {
							if (in_array( $posTable->db_table_name, $aUsedTables )) {
								$sql .= $posTable->db_table_name . '.' . $oElement->element_name ;
								$sql .= ' AS `' . $posTable->db_table_name . $this->_joinTableElementStep . $oElement->element_name . '`,';
							}
						}
					}
				}
			}
			//when doing multipage forms sometimes no elements correspond so we need to enter the *
			if ($sql == "SELECT  ") { $sql .= " * ";}
			$sql = substr( $sql, 0, strlen($sql)-1 );
			$sql .= " FROM $table";
		} else {
			$sql = "SELECT * FROM $table";
		}
	
		if (is_array( $this->_aJoinObjs )) {
			/** $$$ hugh - need to grab $fabrikDb.  Erroring out in rev 946.
			  * This is a quick fix, but I'm not sure if I'm selecting the
			  * right db ... might need to be the joins db?
			*/
			$fabrikDb   =& $oTable->getDb();
			if (!$fabrikDb) {
				echo "could not connect to database";
				return false;
			}			
			foreach ($this->_aJoinObjs as $oJoin) {
				$on_oper = $oJoin->attribs ? $oJoin->attribs : '=';
				$sql .= " $oJoin->join_type JOIN $oJoin->table_join " .
				"ON $oJoin->table_join.$oJoin->table_join_key" .
				" $on_oper " .
				"$oJoin->join_from_table.$oJoin->table_key \n";
	
				$sql2 = "DESCRIBE $oJoin->table_join" ;
				$fabrikDb->setQuery( $sql2 );
				$aJoinFields[$oJoin->id] = $fabrikDb->loadResultArray();
			}
		}
	
		//Apply table prefilters to the query to restrict access to the correct form data
		$oTable->_aData = array();
		$oTable->loadParams();
		// $$$ rob pass in the false param to ONLY get prefilters
		$sql .= " " . $oTable->getSQLWhere( false );
	
		// if radom=1 is passed in by the querystring (or set in menu link params) then:
		// * prefilters still applied
		// * rowId ignored
		// * random record inserted in the form
		$random = $this->_isRandom();
		
		if (!$random && $rowId != '') {
			$sql .= strstr($sql , "WHERE")?  " AND " : " WHERE ";
			// $$$ hugh - testing key override
			$sql .=  ($usekey != '') ? " $usekey = '$rowId' " : " $key = '$rowId' ";
		}
	
		if ($random) {
			$sql .= " ORDER BY RAND() LIMIT 1 ";
		}
		return $sql;
	}

	function _isRandom()
	{
		if(isset($this->_random)){
			return $this->_random;
		}
		$this->_random = 0;
		if (is_object( $this->_menuParams )) {
			$this->_random = mosGetParam( $_GET, 'random', $this->_menuParams->get( 'random', 0 ) );
		}
		return $this->_random;
	}
	/**
	 * for editing records (not validating existing ones, as the validated data is already in
	 * the format that this function outputs
	 **/
	function getJoinDefaultData( $elementData, $rowId )
	{
		if (!is_null( $this->_joinDefaultData )) {
			$this->_joinDefaultData= array();
			$errors = $this->getErrors();
			if (!empty( $errors )) {
				if (array_key_exists( 'join', $elementData )) {
					$this->_joinDefaultData = $elementData['join'];
				}
			} else {
				//was: if ( $rowId != '' && is_array( $this->_aJoinObjs )) {
				if ($rowId != '') {
					foreach ($elementData as $row) {
						foreach ($row as $thiskey=>$val) {
							foreach ($this->_aJoinObjs as $oJoin) {
								if (strstr( $thiskey, 'join[' . $oJoin->id . ']' )) {
									$newKey = str_replace('join[' . $oJoin->id . ']', '', $thiskey);
									if (!array_key_exists( $oJoin->id, $this->_joinDefaultData )) {
										$this->_joinDefaultData[$oJoin->id][$newKey] = array($val);
									} else {
										if (count($this->_joinDefaultData) > 0) {
											$this->_joinDefaultData[$oJoin->id][$newKey][] = $val;
										}
									}
								}
							}
						}
					}
				}
			}
		}
		return $this->_joinDefaultData;
	}
}

class uploader extends fabrikDBTable {

	var $_groups = null;
	var $_form = null;
	var $moveError = false;

	function uploader(&$oForm)
	{
		// $$$ hugh - made this assignment a reference, otherwise in some versions of PHP
		// the original form instance data doesn't get updated with the uploaded filename
		// as per this thread:
		// http://fabrikar.com/index.php?option=com_smf&Itemid=9&topic=1688.15
		$this->_form =& $oForm;
		$this->_groups = &$oForm->_groups;
	}
	/**
	 * perform upload of files
	 * @return bol true if error occured
	 */

	function upload()
	{
		global $mosConfig_absolute_path, $mosConfig_live_site, $database;
		foreach ($this->_form->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if ($oElement->elementtype_id == '8') {
					$elName = $oGroup->getElementFullName( $oElement, $this->_form, true, true, false  );
					$aFile =  $_FILES[$elName];
					$myFileName = $aFile['name'];
					if (is_array( $myFileName )) {
						for ($c = 0; $c < count( $myFileName ); $c ++) {
							$file = $myFileName[$c];
							$tmpFile = $aFile['tmp_name'][$c];
							$this->_uploadIndividualFile( $oGroup, $oElement, $file, $tmpFile, $c );
						}
					} else {
						$tmpFile = $aFile['tmp_name'];
						$this->_uploadIndividualFile( $oGroup, $oElement, $myFileName, $tmpFile, 0 );
					}
				}
			}
		}
	}

	function _uploadIndividualFile( &$oGroup, &$oElement, $myFileName, $tmpFile, $c)
	{
		global $mosConfig_absolute_path, $mosConfig_live_site;
		// $$$ hugh - strip funky characters and spaces from name, only allow
		// $$$ a-z, A-Z, 0-9, -, _ and .
		$myFileName = preg_replace('#[^\w\.-]#','',$myFileName);
		if ($myFileName != '') {
			$aData = $this->_form->_data;
			$myTargetFolder = $oElement->ul_directory;
			$elName = $oGroup->getElementFullName( $oElement, $this->_form, true, true, false );
			$subfolder = false;
			$groupRepeat = $oGroup->getCanRepeatGroup();
			if (array_key_exists( 'ul_end_dir', $this->_form->_data[$elName] )) {
				if (is_array( $aData[$elName]['ul_end_dir'] )) {
					$subfolder =  $aData[$elName]['ul_end_dir'][$c];
				} else {
					$subfolder =  $aData[$elName]['ul_end_dir'];
				}
				$myTargetFolder .= '/' . $subfolder ;
			}
			 
			$this->_makeRecursiveFolders( $myTargetFolder );
			$uploadFolder = mosPathName( $this->addEndSlash( $mosConfig_absolute_path ) . $myTargetFolder );
			$destFile = $uploadFolder . $myFileName;
			$fileIncrement = $oElement->ul_file_increment;

			if (file_exists( $destFile ) and $fileIncrement) {
				$destFile = $this->incrementFileName( $destFile, $destFile, 1 );
				//get the filename with out the path
				$newFileName = explode( "/", $destFile );
				$newFileName = end( $newFileName );
				//update the $_FILES data to contain the new file name
				$_FILES[$elName]['name'] = $newFileName;
			}
			if ( move_uploaded_file( $tmpFile, $destFile ) == false ) {
				$arErrors['ul_userfile'][] = "The file upload was unsuccessful (from $tmpFile to $destFile), please try again";
				$this->moveError = true;
			} else {
				mosChmod( $destFile );
				// $$$ hugh - Windows path issue
				$dosFreeDestFile = str_replace('\\','/',$destFile);
				if (!$groupRepeat) {
					$this->_form->_data[$elName] = str_replace( $mosConfig_absolute_path, $mosConfig_live_site, $dosFreeDestFile );
				} else {
					$this->_form->_data[$elName][$c] = str_replace( $mosConfig_absolute_path, $mosConfig_live_site, $dosFreeDestFile );
				}
				$oUpParams = $oElement->loadParams();
				
				//resize original if a width and height stipulated
				//@since 1.0.5.2 $$$rob
				$oImageController = new imageController();
				$imageLib =  $oUpParams->get( 'image_library', '' );
				if ($imageLib != '') {
					$oImage= $oImageController->loadLib( $imageLib );
				}
				$maxWidth 		= $oUpParams->get( 'image_max_width', '' );
				$maxHeight 		= $oUpParams->get( 'image_max_height', '' );
				$origFilePath = mosPathName( $destFile, false );
				if ($maxWidth != '' || $maxHeight != '') {
					$oImage->resize( $maxWidth, $maxHeight, $origFilePath, $origFilePath );
				}
				//end resize orignal
				
				if ($oUpParams->get( 'make_thumbnail' ) == '1') {
					 
					$thumbPath 		= $oUpParams->get( 'thumb_dir' );
					//$$$rob modify thumb path if sub folder selected in front end
					if ($subfolder) {
						$thumbPath .= '/' . $subfolder ;
						$this->_makeRecursiveFolders( $thumbPath );
					}
					 
					$thumbPrefix 	= $oUpParams->get( 'thumb_prefix' );
					$maxWidth 		= $oUpParams->get( 'thumb_max_width' );
					$maxHeight 		= $oUpParams->get( 'thumb_max_height' );
					$this->_makeRecursiveFolders( $thumbPath );
					
					if ($imageLib != '') {
						$f = basename( $destFile );
						$destThumbFile = mosPathName($this->addEndSlash( $mosConfig_absolute_path ) . $thumbPath )  . $thumbPrefix . $f;
						$oImage->resize( $maxWidth, $maxHeight, $origFilePath, $destThumbFile );
					}
				}
			}
		}
	}

	/**
	 * moves  a file from one location to another
	 * @param string file to move
	 * @param string location to move file to
	 * @param bol do we overwrite any existing files found at pathTo?
	 */

	function move( $pathFrom , $pathTo, $overwrite = true )
	{
		if (file_exists($pathTo)) {
			if ($overwrite) {
				unlink($pathTo);
				$ok = rename($pathFrom, $pathTo);
			} else {
				$ok = false;
			}
		} else {
			$ok = rename($pathFrom, $pathTo);
		}
		return $ok;
	}

	/**
	 * @access private
	 * @param string path to folder - eg /images/stories
	 */


	function _makeRecursiveFolders( $folderPath)
	{
		global $mosConfig_absolute_path;
		$uploadFolder = mosPathName($this->addEndSlash( $mosConfig_absolute_path ) . $folderPath);
		if (!is_dir( $uploadFolder )) {
			$newUploadPath = $this->addEndSlash( $mosConfig_absolute_path );
			$aFolderParts = explode( '/', $folderPath );
			foreach ($aFolderParts as $part) {
				$newUploadPath .= $part . '/';
				if (!is_dir($newUploadPath)) {
					mkdir( $newUploadPath );
				}
			}
		}
		mosChmodRecursive($uploadFolder);
	}

	/**
	 * iterates through $_FILE data to see if any files have been uploaded
	 * @return bol true if files uploaded
	 */

	function checkForFileUpload()
	{
		if (isset($_FILES) and !empty($_FILES)) {
			foreach ($_FILES as $f) {
				if ($f['name'] != '') {
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * checks that the uploaded file meets each of the settings defined for it
	 * @param array posted form data
	 * @param array element objects
	 */

	function validateForm( $data)
	{
		$arErrors = array();
		foreach ($this->_groups as $oGroup) {
			foreach ($oGroup->_aElements as $oElement) {
				if ($oElement->elementtype_id == '8') {
					$elName = $oGroup->getElementFullName( $oElement, $this->_form );
					$elName = str_replace('[]', '', $elName);
					if (!$this->_fileUploadFileTypeOK( $oElement, $elName )) {
						$arErrors[$elName][] = _FILE_TYPE_NOT_ALLOWED;
					}
					if (!$this->_fileUploadSizeOK( $oElement, $elName )) {
						if (is_array($_FILES[$elName]['size'])) {
							$a = ($_FILES[$elName]['size'] );
							sort($a, SORT_NUMERIC );
							$mySize = array_pop( $a ) / 1000 ;
						} else {
							$mySize = $_FILES[$elName]['size'] / 1000;
						}
						$arErrors[$elName][] = sprintf( _FILE_TOO_LARGE, $oElement->ul_max_file_size, $mySize );
					}
				}
			}
		}
		return $arErrors;
	}

	/**
	 * This checks the uploaded file type against the csv specified in the upload
	 * element
	 * @access PRIVATE
	 * @param object upload element
	 * @param string element name
	 * @return bol true if upload file type ok
	 */

	function _fileUploadFileTypeOK( $oElement, $elName )
	{
		if ($_FILES[$elName]['name'] == '') {
			return true;
		}
		if ($oElement->ul_file_types != '') {
			$ar_file_types = explode( ",", $oElement->ul_file_types );
		} else {
			$ar_file_types = $this->_form->_aDefaultFileTypes;
		}

		if (is_array( $_FILES[$elName]['name'] )) {
			foreach ($_FILES[$elName]['name'] as $name ) {
				if ($name != '') {
					$bits = explode( ".", $name );
					$curr_f_ext = "." . strtolower(array_pop( $bits ));

					$found = false;
					foreach ($ar_file_types as $fType) {
						if (strcasecmp( $fType,$curr_f_ext ) == 0) {
							$found = true;
						}
					}
					if (!$found) {
						return false;
					}
				}
			}
			return true;
		} else {
			$name = $_FILES[$elName]['name'];
			$bits = explode( ".", $name );
			$curr_f_ext = "." . strtolower(array_pop( $bits ));
			$found = false;
			foreach ($ar_file_types as $fType) {
				if (strcasecmp( $fType,$curr_f_ext ) == 0) {
					$found = true;
				}
			}
			return $found;
		}
	}

	/**
	 * This checks that thte fileupload size is not greater than that specified in
	 * the upload element
	 * @access PRIVATE
	 * @param object upload element
	 * @param string element name
	 * @return bol true if upload file type ok
	 */

	function _fileUploadSizeOK( $oElement, $elName)
	{
		$mySize = $_FILES[$elName]['size'];
		/* convert kb to bytes */
		$max_size = $oElement->ul_max_file_size * 1000;
		if (is_array( $mySize )) {
			foreach ($mySize as $s) {
				if ($s > $max_size) {
					return false;
				}
			}
			return true;
		} else {
			if ($mySize <= $max_size) {
				return true;
			}
			return false;
		}
	}
}

/**
 *	image manipulation class
 * @author Rob Clayburn <rob@pollen-8.co.uk>
 * @version $Revision: 1.0 $
 * @since 1.0
 * @package pollen8
 * @access public
 * @copyright Pollen 8 design Ltd
 */

class imageController{

	/** @var object image manipulation lib, sepecific to library */
	var $_lib = null;

	function getLibs()
	{
		$libs = array();
		$gds = $this->_testGD();
		foreach ($gds as $key=>$val) {
			$libs[] = mosHTML::makeOption($key, $val);
		}
		$im = $this->_testImagemagick();
		foreach ($im as $key=>$val) {
			$libs[] = mosHTML::makeOption($key, $val);
		}
		return $libs;
	}

	/**
	 * load in the correct image library
	 *
	 * @param string image lib to load
	 * @return object image lib
	 */
	function loadLib( $lib )
	{
		$class = "image" . $lib;
		if (class_exists($class)) {
			return new $class();
		} else {
			echo "can't load class: $class";
			exit;
		}
	}

	function _testGD()
	{
		$gd = array();
		$GDfuncList = get_extension_funcs( 'gd' );
		ob_start();
		@phpinfo(INFO_MODULES);
		$output=ob_get_contents();
		ob_end_clean();
		$matches[1]='';
		if (preg_match( "/GD Version[ \t]*(<[^>]+>[ \t]*)+([^<>]+)/s",$output,$matches )) {
			$gdversion = $matches[2];
		}
		if (function_exists( 'imagecreatetruecolor' ) && function_exists( 'imagecreatefromjpeg' )) {
			$gd['gd2'] = "GD: " . $gdversion;
		} elseif (function_exists( 'imagecreatefromjpeg' )) {
			$gd['gd1'] = "GD: " . $gdversion;
		}
		return $gd;
	}

	/**
	 * test for magickwand library
	 *
	 * @return array
	 */
	function _testImagemagick( )
	{
		if ( function_exists( "NewMagickWand" ) ) {
			$im["IM"] = "Magick wand";
		} else {
			$output = array( );
			$status = null;
			@exec( 'convert -version', $output, $status );
			$im = array( );
			if (!is_null( $status ) && !empty( $output )) {
				if (preg_match( "/imagemagick[ \t]+([0-9\.]+)/i",$output[0],$matches ) )
				$im["IM"] = $matches[0] ;
			}
			unset( $output, $status );
		}
		return $im;
	}
}

class imageBase{

	var $imageMagickDir = '/usr/local/bin/';

	/**
	 * convert any file type
	 * requires imagemagick
	 *
	 * @param string origional file path
	 * @param string new file extension (
	 * @return new file path eg "jpg"
	 */

	function convertFileType($origFile, $newFileType)
	{
		$aFile = explode(".", $origFile);
		$aFile[count($aFile)-1] = $newFileType;
		$aPath = explode("/", $aFile[count($aFile)-2]); // doesnt work if full stops in image name
		$newFileName = $aPath[count($aPath)-1] . "." . $aFile[count($aFile)-1];
		$newFilePath = implode(".", $aFile);
		$command = "'" . $this->imageMagickDir   . "convert' " . $origFile .
		" -flatten -quality 100 "   .
		" $newFilePath ";
		$str = exec($command);
		return $newFileName;
	}
}

class imageGD extends imageBase{

	/**
	 * resize an image to a specific width/height using standard php gd graphics lib
	 * @param int maximum image Width (px)
	 * @param int maximum image Height (px)
	 * @param string current images folder pathe (must have trailing end slash)
	 * @param string destination folder path for resized image (must have trailing end slash)
	 * @param string file name of the image to resize
	 * @param bol save the resized image
	 * @return object? image
	 *
	 */
	function resize( $maxWidth, $maxHeight, $origFile, $destFile )
	{
		/* check if the file exists*/
		if (!file_exists ($origFile)) {
			echo("no file found for $origFile");
			exit();
		}
		/* Load image*/
		$img = null;
		$ext = strtolower(end(explode('.', $origFile)));
		if ($ext == 'jpg' || $ext == 'jpeg') {
			$img = @imagecreatefromjpeg($origFile);
			$header = "image/jpeg";
		} else if ($ext == 'png') {
			$img = @imagecreatefrompng($origFile);
			$header = "image/png";
			/* Only if your version of GD includes GIF support*/
		} else if ($ext == 'gif') {
			if (function_exists( imagecreatefromgif )) {
				$img = @imagecreatefromgif ($origFile);
				$header = "image/gif";
			} else {
				echo("imagecreate from gif not available");
				exit();
			}
		}
		/* If an image was successfully loaded, test the image for size*/
		if ($img) {
			/* Get image size and scale ratio*/
			$width = imagesx($img);
			$height = imagesy($img);
			$scale = min($maxWidth / $width, $maxHeight / $height);
			/* If the image is larger than the max shrink it*/
			if ($scale < 1) {
				$new_width = floor($scale * $width);
				$new_height = floor($scale * $height);
				/* Create a new temporary image*/
				$tmp_img = imagecreatetruecolor($new_width, $new_height);
				/* Copy and resize old image into new image*/
				imagecopyresampled($tmp_img, $img, 0, 0, 0, 0,
				$new_width, $new_height, $width, $height);
				imagedestroy($img);
				$img = $tmp_img;
			}
		}
		/* Create error image if necessary*/
		if (!$img) {
			echo("no image created for $origFile, extension = $ext  ");
		} else {
			/* save the file */
			if ($header == "image/jpeg") {
				imagejpeg($img, $destFile);
			} else {
				if ($header == "image/png") {
					imagepng($img, $destFile);
				} else {
					/* imagegif ($img);*/
					if (function_exists( "imagegif" )) {
						imagegif ($img, $destFile);
					} else {
						/* try using imagemagick to convert gif to png:*/
						$image_file = $this->convertFileType($destFile, 'png');
						return $image_file;
					}
				}
			}
		}
		return $img;
	}
}

class imageGD2 extends imageBase{


	/**
	 * resize an image to a specific width/height using standard php gd graphics lib
	 * @param int maximum image Width (px)
	 * @param int maximum image Height (px)
	 * @param string current images folder pathe (must have trailing end slash)
	 * @param string destination folder path for resized image (must have trailing end slash)
	 * @param string file name of the image to resize
	 * @param bol save the resized image
	 * @return object? image
	 *
	 */
	function resize( $maxWidth, $maxHeight, $origFile, $destFile )
	{

		/* check if the file exists*/
		if (!file_exists ($origFile)) {
			echo("no file found for $origFile");
			exit();
		}

		/* Load image*/
		$img = null;
		$ext = strtolower(end(explode('.', $origFile)));

		if ($ext == 'jpg' || $ext == 'jpeg') {
			$imageInfo = getimagesize( $origFile );
			$memoryNeeded = round(($imageInfo[0] * $imageInfo[1] * $imageInfo['bits'] * $imageInfo['channels'] / 8 + Pow(2, 16)) * 1.65);
			if (function_exists('memory_get_usage') && memory_get_usage() + $memoryNeeded > (integer) ini_get('memory_limit') * pow(1024, 2)) {
				$new_limit = (integer) ini_get('memory_limit') + ceil(((memory_get_usage() + $memoryNeeded) - (integer) ini_get('memory_limit') * pow(1024, 2)) / pow(1024, 2));
				ini_set('memory_limit', $new_limit . 'M');
			}

			$img = imagecreatefromjpeg( $origFile );
			$header = "image/jpeg";
		} else if ($ext == 'png') {
			//$$$rob: see if we need to bump up the memory??
			$filesize = getimagesize( $origFile );
			$required_memory = round( $filesize[0] * $filesize[1] * $filesize['bits'] ) * 1.2;
			if (function_exists( 'memory_get_usage' )) {
				$new_limit=memory_get_usage() + $required_memory;
				ini_set( "memory_limit", $new_limit );
			}
			$img = imagecreatefrompng( $origFile );
			 
			$header = "image/png";

			//transparency test
			imagealphablending( $img, true );
			imageSaveAlpha( $img, true );

			/* Only if your version of GD includes GIF support*/
		} else if ($ext == 'gif') {
			if (function_exists( imagecreatefromgif )) {
				$img = @imagecreatefromgif ($origFile);
				$header = "image/gif";
			} else {
				echo("imagecreate from gif not available");
				exit();
			}
		}

		/* If an image was successfully loaded, test the image for size*/
		if ($img) {
			/* Get image size and scale ratio*/
			$width = imagesx($img);
			$height = imagesy($img);
			$scale = min($maxWidth / $width, $maxHeight / $height);
			/* If the image is larger than the max shrink it*/
			if ($scale < 1) {
				$new_width = floor($scale * $width);
				$new_height = floor($scale * $height);
				/* Create a new temporary image*/
				$tmp_img = imagecreatetruecolor($new_width, $new_height);
				/* Copy and resize old image into new image*/
				imagecopyresampled($tmp_img, $img, 0, 0, 0, 0,
				$new_width, $new_height, $width, $height);
				imagedestroy($img);
				$img = $tmp_img;
			}
		}

		/* Create error image if necessary*/
		if (!$img) {
			echo("no image created for $origFile, extension = $ext  ");
		} else {
			/* save the file */
			if ($header == "image/jpeg") {
				imagejpeg($img, $destFile);
			} else {
				if ($header == "image/png") {
					imagepng($img, $destFile);
				} else {
					/* imagegif ($img);*/
					if (function_exists( "imagegif" )) {
						imagegif ($img, $destFile);
					} else {
						/* try using imagemagick to convert gif to png:*/
						$image_file = $this->convertFileType( $destFile, 'png' );
						return $image_file;
					}
				}
			}
		}
		ini_restore ("memory_limit");
		return $img;
	}
}

class imageIM extends imageBase{

	var $imageMagickDir = '/usr/local/bin/';

	function image() {

	}

	/**
	 * resize an image to a specific width/height using imagemagick
	 * you cant set the quality of the resized image
	 * @param int maximum image Width (px)
	 * @param int maximum image Height (px)
	 * @param string full path of image to resize
	 * @param string full file path to save resized image to
	 * @return string output from image magick command
	 */
	
	function resize( $maxWidth, $maxHeight, $origFile, $destFile )
	{
		$resource = NewMagickWand();
		if (!MagickReadImage( $resource, $origFile )) {
			echo "ERROR!";
			print_r(MagickGetException( $resource ));
		}
		$resource = MagickTransformImage( $resource, '0x0', $maxWidth . 'x' . $maxWidth );
		MagickWriteImage( $resource, $destFile );
	}
}
?>