<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

defined('_VALID_MOS') or die('Direct Access to this location is not allowed.'); 

global $_VERSION, $database, $Itemid, $mainframe, $mosConfig_absolute_path, $mosConfig_live_site; 

@session_start();

require_once( dirname(__FILE__) . "/fabrik_parent.class.php" );
require_once( $mainframe->getPath( 'front_html' ) );
require_once( $mainframe->getPath( 'class' ) );
require_once( dirname(__FILE__) .  "/fabrik_functions.php" );
require_once( dirname(__FILE__) .  "/fabrik_export.class.php" );
require_once( dirname(__FILE__) .  "/fabrik_connection.class.php" );
require_once( dirname(__FILE__) .  "/fabrik_formgroup.class.php" );
require_once( dirname(__FILE__) .  "/fabrik_groups.class.php" );
require_once( dirname(__FILE__) .  "/fabrik_elements.class.php" );
require_once( dirname(__FILE__) .  "/fabrik_join.class.php" );
require_once( dirname(__FILE__) .  "/fabrik_table.class.php" );	
require_once( dirname(__FILE__) .  "/fabrik_validation.class.php" );	
require_once( dirname(__FILE__) .  "/fabrik_validation_rule.class.php" );
require_once( dirname(__FILE__) .  "/fabrik_params.xml.php" );
require_once( dirname(__FILE__) .  "/views/form/view.html.php" );
require_once( dirname(__FILE__) .  "/views/table/view.html.php" );
require_once( dirname(__FILE__) .  "/version.php" );


require_once ( $mosConfig_absolute_path . "/components/com_fabrik/fabrik_configuration.class.php" );
$fabrikConfig = new fabrikConfig();

// $$$ hugh - for now, we're going to call updateParams() every time,
// $$$ for a few revs, get people converted without having to keep telling
// $$$ people to run the task.  Yes, I know it's extra db hits, but a few
// $$$ more won't kill us, and it'll cause support headaches if we don't do this.
// $$$ TODO - WORK OUT SOME WAY OF SETTING A PARAM / SWITCH SO WE KNOW WE DID THIS
updateParams();

$params = new stdClass( );
if ($Itemid) {
	$menu = new mosMenu( $database );
	$menu->load( $Itemid );
	$params =& new mosParameters( $menu->params );
} else {
	$menu = "";
	$params =& new mosParameters( '' );
}
$Itemid 	= mosGetParam( $_REQUEST, 'Itemid', $Itemid );
$task 		= $params->get( 'task', '' );
$form_id 	= $params->get( 'fabrik', '0' );
$tableId 	= $params->get( 'tableid', '' );
// $$$ hugh - not sure why rowId wasn't being picked up from params?
// $$$ experiment - use '-1' to mean $my->id
$rowId		= $params->get( 'rowid', '' );
if ($rowId == '-1') {
	$rowId = $my->id;
}
$rowId 		= mosGetParam( $_REQUEST, 'rowid', $rowId );
$usekey		= $params->get( 'usekey', '' );
$usekey		= mosGetParam( $_REQUEST, 'usekey', $usekey );

// $$$ hugh - try allowing template override using querystring
$template_name = mosGetParam( $_REQUEST, 'template', '' );
/* overwrites itemid value if set in querystring or post data*/

$tableId 	= mosGetParam( $_REQUEST, 'tableid', $tableId );
/* overwrites itemid value if set in querystring or post data*/ 
$form_id 	= mosGetParam( $_REQUEST, 'fabrik', $form_id );	
/* overwrites act value if set in querystring or post data */

//$$$ rob test for delete from table mamobt
$posttask = mosGetParam( $_POST, 'task', $task );
if ($posttask == 'delete') {
	$task = $posttask;
} else {
	$task 		= mosGetParam( $_REQUEST, 'task', $task );			
}
$orderBy 	= mosGetParam( $_REQUEST, 'orderby', '' );
$orderDir 	= mosGetParam( $_REQUEST, 'orderdir', 'asc' );
$do_mf_pdf	= mosGetParam( $_GET, 'do_mf_pdf', 0 );
$no_html 	= mosGetParam( $_REQUEST, 'no_html', 0);

// $$$ hugh - testing FirePHP http://www.firephp.org/Wiki/Main/QuickStart
/*
if ($fabrik_php_debug = mosGetParam( $_REQUEST, 'fabrik_php_debug') == '1')
{
	require_once( $mosConfig_absolute_path . "/components/com_fabrik/libs/FirePHPCore/fb.php" );
	fb('Hello world!', FirePHP::LOG);
	fb($_REQUEST, 'REQUEST data', FirePHP::LOG);
}
*/

if (!( $task == 'tableFeed' || $no_html == 1)) {
	writeFrontEndfabrikHead();
}
if (!isset( $task )) {
	$task = "";
} 
switch ($task) {
	case "version":
		$v = new fabrikVersion();
		$v->checkRevision();
		break;
	case "test":
		require_once(  dirname(__FILE__) .  "/fabrik_test.php" );
		break;
	case "updateParams":
		updateParams();
		break;
	case "export":
		$oExport = new fabrik_export('', array( $tableId ), 'csv', null, null, null );
		$oExport->export();
		break;
	case "resetFilters":
		//unset the search form session data
		$fromForm = @$_SESSION['fabrik']['fromForm'];
		unset($_SESSION['fabrik'][$fromForm]);
		
		$oTable = new fabrikTable( $database );
		$oTable->load( $tableId );
		
		$form = $oTable->getForm();
		//unset the table filter data
		unset($_SESSION['fabrik'][$form->id]);
		
		$groups = $oTable->getFormGroupElementData( true );
		foreach($groups as $group){
			$elements = $group->_aElements;
			foreach($elements as $element){
				$n = $group->getElementFullName($element, $form);
				$k = "$n{com_fabrik}{table}{".$tableId."}";
				unset($_SESSION[$k]);
			}
		}
		$oTable->_menuParams = $params;
		// $$$ hugh - alow overrding template from querystring
		if ($template_name != '') {
			$oTable->table_template = $template_name;
		}
		$oTable->setAdmin( false );
		$oTable->render( );
		break;
	/* deletes rows from the fabrik table */
	case "delete": 
		$aIds = mosGetParam( $_POST, 'ids', array() );
		
		deleteTableRows( $aIds, $tableId );
		break;
	case "empty":
		/** empties table rows and resets key to 0 **/
		truncateTable( $tableId );
	case "processForm":
		processForm( $form_id, $tableId, $rowId, $Itemid );
		break;
	case "viewTable":
		$oTable = new fabrikTable( $database );
		$oTable->load( $tableId );
		$oTable->_menuParams = $params;
		// $$$ hugh - alow overrding template from querystring
		if ($template_name != '') {
			$oTable->table_template = $template_name;
		}
		$oTable->setAdmin( false );
		$oTable->render( );
		break;	
	case "viewForm":	
		makeForm( $params, $tableId, $form_id, $rowId, true, $do_mf_pdf, $usekey, $template_name );
		break;	
	case "viewTableRowDetails":
		makeForm( $params, $tableId, $form_id, $rowId, false, $do_mf_pdf, $usekey, $template_name );
		break;
	case "emailForm":
		emailForm( $form_id );
		break;
	case "sendEmail":
		fabrikSendEmail( $form_id );
		break;
	case "tableFeed":
		$oTable = new fabrikTable( $database );
		$oTable->load( $tableId );
		$oTable->createRSSFeed();
		break;
	case "elementPluginAjax":
		elementPluginAjax();
		break;
	case "userPluginAjax":
		userPluginAjax();
		break;
		//ajax pagination
	case "nextRecord":
		$oTable = new fabrikTable( $database );
		$oTable->load( $tableId );
		echo $oTable->nextRecord();
		break;
	default:
		makeForm( $params, $tableId, $form_id, $rowId, '1', $usekey, $template_name );
		break;
}


/**
 * run an element plugins ajax code
 */

function elementPluginAjax(){
	global $database;
	$formid = mosGetParam($_REQUEST, 'formid', '');
	$plugin = mosGetParam($_REQUEST, 'plugin', '');
	$method = mosGetParam($_REQUEST, 'method', '');
	$id = mosGetParam($_REQUEST, 'element_id', '');
	$oElement = new fabrikElement( $database );
	$oElement->load($id);
	$oElement->_formId = $formid;
	
	if (method_exists( $oElement, $method )) {
		$oElement->$method();
	}
}

function userPluginAjax(){
	global $database;
	require_once(dirname(__FILE__) .  "/user_ajax.php" );
	$method = mosGetParam($_REQUEST, 'method', '');
	$userAjax = new userAjax ( $database );
	if (method_exists( $userAjax, $method )) {
		$userAjax->$method();
	}

}

/**
 * send email to friend
 */
 
function fabrikSendEmail( $form_id )
{
	global $database, $mainframe;
	global $mosConfig_live_site, $mosConfig_sitename, $mosConfig_db;
	$oForm = new fabrikForm( $database );
	$validate = mosGetParam( $_POST, mosHash( $mosConfig_db ), 0 );
	if (!$validate) {
		// probably a spoofing attack
		mosErrorAlert( _NOT_AUTH );
	}

	// First, make sure the form was posted from a browser.
	// For basic web-forms, we don't care about anything
	// other than requests from a browser:   
	if (!isset( $_SERVER['HTTP_USER_AGENT'] )) {
		header( "HTTP/1.0 403 Forbidden" );
		mosErrorAlert( _NOT_AUTH );
	}
	
	// Make sure the form was indeed POST'ed:
	//  (requires your html form to use: action="post")
	if (!$_SERVER['REQUEST_METHOD'] == 'POST') {
		header( "HTTP/1.0 403 Forbidden" );
		mosErrorAlert( _NOT_AUTH );
	}
	
	// Attempt to defend against header injections:
	$badStrings = array(
	'Content-Type:',
	'MIME-Version:',
	'Content-Transfer-Encoding:',
	'bcc:',
	'cc:'
	);
	
	// Loop through each POST'ed value and test if it contains
	// one of the $badStrings:
	foreach ($_POST as $k => $v) {
		foreach ($badStrings as $v2) {
			if (strpos( $v, $v2 ) !== false) {
				header( "HTTP/1.0 403 Forbidden" );
				mosErrorAlert( _NOT_AUTH );
			}
		}
	}   
	
	// Made it past spammer test, free up some memory
	// and continue rest of script:   
	unset($k, $v, $v2, $badStrings);
	
	// check for session cookie
	// Session Cookie `name`
	$sessionCookieName 	= mosMainFrame::sessionCookieName();		
	// Get Session Cookie `value`
	$sessioncookie 		= mosGetParam( $_COOKIE, $sessionCookieName, null );			
	
	if ( !(strlen($sessioncookie) == 32 || $sessioncookie == '-') ) {
		mosErrorAlert( _NOT_AUTH );
	}	
	
	$email 				= mosGetParam( $_POST, 'email', '' );
	$yourname 			= mosGetParam( $_POST, 'yourname', '' );
	$youremail 			= mosGetParam( $_POST, 'youremail', '' );
	$subject_default 	= _EMAIL_INFO .' ' . $yourname;
	$subject = mosGetParam( $_POST, 'subject', $subject_default );

	if ( $form_id < 1 || !$email || !$youremail || ( $oForm->check_email_address( $email ) == false ) || ($oForm->check_email_address( $youremail ) == false)) {
		mosErrorAlert( _EMAIL_ERR_NOINFO );
	}

	$query = "SELECT template"
	. "\n FROM #__templates_menu"
	. "\n WHERE client_id = 0"
	. "\n AND menuid = 0"
	;
	$database->setQuery( $query );
	$template = $database->loadResult( );

	// link sent in email
	$task = mosGetParam($_POST, 'userTask', 'viewForm');
	$rowId = mosGetParam($_POST, 'rowId', '');
	$link = sefRelToAbs( $mosConfig_live_site .'/index.php?option=com_fabrik&task='. $task . '&fabrik='. $form_id  . '&rowid=' . $rowId );
	// message text
	$msg = sprintf( _EMAIL_MSG, $mosConfig_sitename, $yourname, $youremail, $link );

	// mail function
	mosMail( $youremail, $yourname, $email, $subject, $msg );	
	fabrik_html_content::emailSent( $email, $template );
}

/**
 * set up the email to a frind form
 * @param int form id
 */
 
function emailForm( $form_id ){
	global $database, $my;
	$oForm = new fabrikForm( $database );
	$oForm->load( $form_id );
	if (!$oForm->canPublish()) {
		mosNotAuth();
		return;
	} else {
		$query = "SELECT template"
		. "\n FROM #__templates_menu"
		. "\n W client_id = 0"
		. "\n AND menuid = 0"
		;
		$database->setQuery( $query );
		$template = $database->loadResult();
		fabrik_html_content::emailForm( $oForm, $template );
	}	
}

/**
 * creates a form object to process the forms data
 * @param string component name
 * @param int form id
 * @param int table id
 * @param int row id
 */

function processForm( $formId, $tableId, $rowId, $Itemid ){
	global $database;
	$oForm = new fabrikForm( $database );
	$oForm->load( $formId );
	$oForm->setAdmin( false );
	$data = array_merge( $_POST, $_GET );
	$oForm->processForm( $data, $tableId, $rowId, $Itemid );
}

/**
 * collates data to write out the form
 * @param object menu parameters
 * @param int table id
 * @param string component name
 * @param int table row id
 * @param bol if the form is not editable then display a viewonly datasheet 
 * @param bol output viewonly data as a pdf
 */
 

function makeForm( $menuParams, $tableId = '', $formId, $rowId, $editable = false, $do_mf_pdf=false, $usekey = '', $template_name = '' ){
	global $database;
	$oForm = new fabrikForm( $database );
	$oForm->load( $formId );
	$oForm->_menuParams = $menuParams;
	if ($template_name != '') {
		$oForm->form_template = $template_name;
		$oForm->view_only_template = $template_name;
	}
	$oForm->render( $tableId, $rowId, $editable, $do_mf_pdf, false, $usekey );
} 

/**
 * deletes rows for the given table info
 * @param string component name
 * @param array ids to delete
 * @param int table id
 */
 
function deleteTableRows( $aIds, $tableId ){
	global $Itemid, $database;
	$oTable = new fabrikTable( $database );
	$oTable->load( $tableId );
	$oTable->getConnection( );
	$msg = '';
	foreach ($aIds as $id) {
		$msg .= $oTable->deleteTableRow( $id );
	}
	$pageURL = mosGetParam( $_POST, 'pageURL', "option=com_fabrik&Itemid=$Itemid");
	$pageURL  = 'index.php?' . $pageURL;
	mosRedirect( $pageURL, $msg );
}

/**
 * @param int table id
 */
function truncateTable( $tableId ){
	global $Itemid, $database;
	$oTable = new fabrikTable( $database );
	$oTable->load( $tableId );
	$oTable->getConnection( );
	$oTable->truncate();
	$pageURL = mosGetParam( $_POST, 'pageURL', "option=com_fabrik&Itemid=$Itemid");
	$pageURL  = 'index.php?' . $pageURL;
	mosRedirect( $pageURL, $msg );
}

/**
* parses the form elements to create a list of drop downs for the form
* @param object origional element data
* @param object form elements
*/

function getForeginKeyDropDowns( $elementData, $formGroupEls ){
   	global $database;
	 $lists  = array();
  	foreach( $formGroupEls as $el ){ // go through all the elements checking for joins
		$joinConnId = $el->join_conn_id;
  		if ($joinConnId != "0" and $joinConnId != "") { // a join connection has been set up
  			$cn = new fabrikConnection( $database );
  			$cn->load( $joinConnId );
  			if ( @ mysql_connect( $cn->host, $cn->user, $cn->password ) ) {
				$joinDb = new database( $cn->host, $cn->user, $cn->password, $cn->database, "" );
				$table 	= $el->join_db_name;
				$key	= $el->join_key_column;
				$val	= $el->join_val_column;
				$col	= $el->element_name;
				$tmp = array();
				$sql = "SELECT $key AS value, $val AS text FROM $table ";
				$joinDb->setQuery( $sql );
				$tmp[] = mosHTML::makeOption( '-1' , _PLEASE_SELECT );
				$tmp = array_merge( $tmp, $joinDb->loadObjectList( ) );
				$dropdown = mosHTML::selectList( $tmp, $el->element_name, 'class="inputbox" size="1" ', 'value', 'text', $elementData[$el->element_name] );
				$lists[$el->element_name]['dropdown'] = $dropdown;
				$sql = "SELECT $val FROM $table WHERE $key = '" . $elementData[$el->element_name] . "'";
				$joinDb->setQuery( $sql );
				$default = $joinDb->loadResult( );
				$lists[$el->element_name]['default'] = $default;
			} else {
				$lists[$el->element_name]['dropdown'] = "(getForeginKeyDropDowns) Could not make join - cnn failed";
				$lists[$el->element_name]['default'] = "(getForeginKeyDropDowns) Could not make join - cnn failed";
			}
		}
	}
	return $lists;	
}

// $$$ hugh - new settings / update stuff
// $$$ TODO - class'ify the new fabrik_settings
function updateParams(){
	global $database;
	// $$$ hugh - find out if the new settings table exists yet
	$database->setQuery("describe `#__fabrik_settings`");
	$table_exists = $database->loadObjectList();
	$setting_exists = false;
	echo $database->getErrorMsg( );
	if ($table_exists) {
		// $$$ hugh - if the settings table does exist,
		// $$$ check to see if params_updated has already been set
		$database->setQuery("SELECT * from `#__fabrik_settings`");
		$rows = $database->loadObjectList();
		
		/** $$$ rob since 1.0.5.2 radio button, checkbox and dds now store data split with //..*..// instead of "," **/
		$groupSplitterSet = false;
		$groupRowFound = false;
		$params_updated = false;
		foreach ($rows as $row) {
			if ($row->setting_name == 'params_updated') {
				if ($row->setting_value != '0') {
					// $$$ hugh - already set, so just bang out
					//return;
					$params_updated = true;
				} else {
					// $$$ hugh - set, but to 0, so carry on and update params
					$setting_exists = $row->id;
					break;
				}
			}
			/** since 1.0.5.2 **/
			if ($row->setting_name == 'group_splitter_changed') {
				$groupSplitterSet = $row->setting_value;
				$groupRowFound = true;
			}
		}
	
		if (!$groupSplitterSet) {
				$database->setQuery( "SELECT id FROM #__fabrik_tables" );
				$rows = $database->loadObjectList();
				$eids = array(3, 4, 6);
				
				foreach ($rows as $row) {
					$oTable = new fabrikTable( $database );
					$oTable->load( $row->id );
					$data = $oTable->getFormGroupElementData( false, false, false );
					foreach($data as $group) {
						foreach ($group->_aElements as $oElement) {
							if (in_array( $oElement->elementtype_id, $eids)) {
								//update table data
								$sql = "update $oTable->db_table_name SET $oElement->element_name = REPLACE($oElement->element_name, ',', '//..*..//')";
								$database->setQuery($sql);
								$database->query();
								echo $database->getErrorMsg( );
								//update element defaults as well?
							}		
						}
					}
				}
				
				if (!$groupRowFound) {
					$sql = "insert into #__fabrik_settings (`setting_name`, `setting_value`) VALUES ('group_splitter_changed', '1')";
					
				}else{
					$sql = "update #__fabrik_settings set setting_value = '1' where setting_name = 'group_splitter_changed'";
				}
				$database->setQuery($sql);
				$database->query();
				echo $database->getErrorMsg( );
			}
		
		
	} else {
		// $$$ hugh -  create the new settings table.
		$query = "
			CREATE TABLE `#__fabrik_settings` (
			`id` INT( 4 ) NOT NULL auto_increment,
			`setting_name` VARCHAR( 100 ) NOT NULL,
			`setting_value` VARCHAR( 255 ) NOT NULL,
			PRIMARY KEY ( `id` ))";
		$database->setQuery($query);
		$database->query();
		echo $database->getErrorMsg( );
	}
	// $$$ hugh - table didn't exist or params_updated not set,
	// $$$ so go ahead and update the params.
	$oFabrikParams = new fabrikParams('','');
	$tables = array('#__fabrik_elements', '#__fabrik_forms', '#__fabrik_groups', '#__fabrik_tables');
	$param_names = array('filter-join','filter-fields','filter-conditions','filter-value','filter-access','filter-eval','linkedtable','linkedform');
	foreach ($tables as $table) {
		$database->setQuery("select id, attribs from $table");
		$rows = $database->loadObjectList();
		foreach ($rows as $row) {
			// $$$ no need to do anything if we find new splitter
			if (($row->attribs != '') and (!strstr( $row->attribs, $oFabrikParams->_splitter_1 ))) {
				$new_row = '';
				$attribs = explode("\n",$row->attribs);
				foreach ($attribs as $attrib) {
					list($key,$val) = explode('=',$attrib,2);
					if (in_array( $key,$param_names )) {
						$val = str_replace(',', $oFabrikParams->_splitter_1, $val);
					}
					$new_row .= "$key=$val\n";
				}
				$new_row = rtrim($new_row);
				if ($new_row != $row->attribs) {
					$new_row = addslashes($new_row);
					$sql = "update $table set attribs = '$new_row' where id = $row->id";
					$database->setQuery($sql);
					$database->query();
					echo $database->getErrorMsg( );
				}
			}
		}
	}
	// $$$ hugh - update or insert 'params_update' setting
	if (!$params_updated) { 
		if ($setting_exists) {
			$query = "UPDATE #__fabrik_settings SET setting_name = 'params_updated', setting_value = '1' WHERE id = '$setting_exists'";
		} else {
			$query = "INSERT INTO #__fabrik_settings (`setting_name`,`setting_value`) VALUES ('params_updated','1')";
		}
		$database->setQuery($query);
		$database->query();
		echo $database->getErrorMsg( );
	}
}


?>