<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrikElement extends fabrikDBTable {

	/** @var int Primary key */
	var $id = null;

	/** @var string The label used in the form*/
	var $element_label = null;

	/** @var int The id that defines the element type*/
	var $elementtype_id = null;

	/** @var int The group id that the element belongs to */
	var $group_id = null;

	/** @var string The element name*/
	var $element_name = null;

	/** var string created by date */
    var $created = null;

	/** @var int creator id */
    var $created_by = null;

	/** @var string name of creator */
    var $created_by_alias = null;

	/** @var last date modified */
    var $modified = null;

	/** @var int last user to modifiy the element */
    var $modified_by = null;

	/** @var bol is the element checked out or not */
    var $checked_out = null;

	/** @var datetime time element was checked out at */
    var $checked_out_time = null;

	/** @var int width for text box area */
	var $element_width = null;

	/** @var int text box height */
	var $element_height = null;
	
	/** @var bol use wysiwyg editor for text area*/
	var $use_wysiwyg = 0; 

	/** @var string default value */
	var $default  = null;

	/** @var bol is the element visible */
	var $hidden = 0;
	
	/** @var bol is the default value evalued by php */
	var $eval = 0;

	/** @var bol if a field is it as password field */
	var $password = 0;

	/** @var int maximum number of characters in field */
	var $maxlength = null;

	/** @var int is the box checked by default */
	var $box_checked = 0;

	/** @var int is the radio button checked by default */
	var $radio_checked = 0;

	/** @var bol allow multiple selections in drop down lists */
	var $multiple = 0;

	/** @var string drop down text*/
	var $dd_text = null;
	
	/** @var string initially selected value for the drop down */
	var $dd_intial_selection = null;

	/** @var string minimum selection */
	var $dd_min_selection = null;

	/** @var string maximum selection */
	var $dd_max_selection = null;

	/** @var string dropdown values */
	var $dd_values = null;

	/** @var string image name */
	var $image_name = null;

	/** @var int order of element */
	var $ordering = null;

	/** @var string checkbox values */
	var $ck_value = null;

	/** @var string radio button values */
	var $rad_value = null;
	
	/** @var string A csv list of file types that are allowed to be uploaded - eg image/gif,image/jpg*/
	var $ul_file_types = null;
	
	/** @var string The directory to upload teh file to */
	var $ul_directory = null;
	
	/** @var int maxium file size allowed to be uploaded (kb)*/
	var $ul_max_file_size = null;
	
	/** @var bol states if uploaded file is emailed to recipient*/ 
	var $ul_email_file = 0;
	
	/** @var bol states if uploaded files of the same name should be renamed to avoid overwriting exisiting file*/
	var $ul_file_increment = 0;
	
	/** @var bol show the element in the table summary */
	var $show_in_table_summary = 0;
	
	/** @var int id to fabrik database connection*/
	var $join_conn_id = null;
	
	/** @var string table name to make data join with*/  
	var $join_db_name = null;
	
	/** @var string column name to use as foregin key - this will match the column value */
	var $join_key_column = null;
	
	/** @var string column name to replace the column value with */
	var $join_val_column = null;
	
	/** @var bol alllows people to order by this column in table view*/
	var $can_order = 0;
	
	/** @var bol allows people to filter by this column in table view */
	var $can_filter = 0;
	
	/** @var string filter type dropdown or field*/
	var $filter_type = null;
	
	/** @var bol filter search string exact (true) or partial (false) match will return record*/
	var $filter_exact_match = 0;
	
	/** @var bol published state of element*/
	var $state = 0;
	
	/** @var string javascript to run on button press */
	var $button_javascript = null;

	/** @var string float value for image (left, right, none);*/
	var $image_float = null;        
        
    /** @var string url to create image link from */
    var $link_url = null;
    
    /** @var bol states if the element acts as a link though to the row's detail page*/
     var $link_to_detail = 0;
     
     /** @var bol is this element a primary key for the table */
    var $primary_key = 0;
	
	 /** @var bol if primary key then is it an autoincrementing number */
    var $auto_increment = 0;
    
    /** @var bol sets if this elements data is added to the page title */
    var $use_in_page_title = 0;
    
    /** @var int access to element */
    var $access = 0;
    
    /** @var string link */
    var $link = null;
	
	/** @var string xml element attributes */
	var $attribs = null;
	
	/** @var string js to run on element */
	var $_js = null;
	
	/** @var object params */
	var $_params = null;
	
	/** @var array validation objects associated with the element */
	var $_aValidations = null;
	 
	/** @var array advanced joins */
	var $_advancedJoins = null;
	
	/** @var object to contain access rights **/
	var $_access = null;
	
	var $_elementHTMLId = null;
	
	/** @var string element name before possible update on save **/
	var $_origName = null;
	
	/**
	* @param database A database connector object
	*/

	function fabrikElement( &$db ) {
		$this->mosDBTable( '#__fabrik_elements', 'id', $db );
		$this->_access = new stdClass();
	}

	/**
	 * check element on saving
	 * @return mixed true if check ok, otherwise string error message
	 */

	function check( $new ) {
		global $database;
		if(!$new && ($this->_origName == $this->element_name)){
			return true;
		}
		// allow mutliple element names if they contan []
		if (strstr( $this->element_name, "[]" )) {
			return true;
		}
		//check if the element_name already exists in on of the groups tables
		$oGroup = new fabrikGroup( $database );
		$oGroup->load( $this->group_id );
		$formIds = $oGroup->getFormsIamIn( true );
		foreach( $formIds as $id ){
			$oForm = new fabrikForm( $database );
			$oForm->load( $id );
			$oForm->getFormGroupsHiarachy( false, false, false );
			foreach( $oForm->_groups as $oGroup ){
				foreach( $oGroup->_aElements as $oElement ){
					if( strtolower( $oElement->element_name ) == strtolower($this->element_name) ){
						return "Please select a unique element name";
					}
				}
			}
		}
		return true;
	}
	
	//place holder for 2.0 code
	function getElementJS(){
		return '';
	}
	
	function loadLanguage(){
	}

	function getOrderbyFullName( &$oGroup, &$oForm, $includeJoinString = true, $useStep = true ){
		return $oGroup->getElementFullName( $this, $oForm, $includeJoinString , $useStep, false );
	}
	
	/**
	 * can be overwritten in the plugin class
	 * @param object form
	 * @param bol encase label in <label> tag
	 * @param string id of element related to the label
	 */
	
	function getLabel( &$oForm,  $bLabel = false,  $elementHTMLId = '' ){
		global $mosConfig_lang, $mosConfig_mbf_content, $database, $mosConfig_live_site, $Itemid, $mainframe, $my;
		if( $this->hidden || $this->elementtype_id == 10 ){ //10 is the user element type
			return '';
		}
		$task = mosGetParam( $_REQUEST, 'task', '' );
		if( $task == 'viewForm' && ! ($this->canUse() || $this->canView())){
			return '';
		}
		if ($this->elementtype_id == '7') {
			return '';
		}
		$canUse = $this->canUse( );
		if(!$canUse){
			$bLabel = false;
		}
		
		$params =& $this->loadParams();
		$elementid = "fb_el_" . $elementHTMLId;
		$str = '';
		if( $this->canView( ) || $canUse ){
			$str .= "<div class=\"fabrikLabel";
			if( isset($this->_aValidations ) && $canUse ){
				if ( count( $this->_aValidations ) > 0 ) {
					foreach( $this->_aValidations as $oValidation ){
						$vid = $oValidation->validation_rule_id;
						if ( array_key_exists( $vid, $oForm->_validationRuleClasses ) ) {
							if( $oForm->_validationRuleClasses[$vid] != '' ){
								$str .= " " . $oForm->_validationRuleClasses[$vid];
							}
						}
					}
				}
			}
			if( !$canUse ){
				$str .= " readonly";	
			}
			switch( $this->elementtype_id ){
				case "3":
				case "4":
				$bLabel = false; // no label for radio/chx buttons as the labels are per sub element
				break;
			}
			$str .= "\" id=\"$elementid" . "_text\">";
			if ( $bLabel ){
				$str .= "<label for=\"$elementHTMLId\">";
			}
			$label = $this->element_label;
			//posssible solution to mamblefish traslation bug????:
			 if ((false) && (class_exists('MambelFish'))) {
 				$label = MambelFish::translate( $this, 'fabrik_elements', $mosConfig_lang );
			 }
			
			$rollOver = str_replace( "'", "\'", $params->get( 'rollover' ));
			$rollOver = str_replace( '"', '\"', $rollOver );
			
			$hoverTitle = str_replace( "'", "\'", $params->get( 'hover_text_title', 'Hover text' ));
			$hoverTitle = str_replace( '"', '\"', $hoverTitle );
			
			if ( $rollOver != '' ){
				$str .= "<span class=\"editlinktip\"><span onmouseover=\"return overlib('$rollOver', CAPTION, '$hoverTitle', BELOW, RIGHT);\" onmouseout=\"return nd();\">$label</span></span>";
			} else {
				$str .= $label;
			}
			if ( $bLabel ){
				$str .= "</label>";
			}
			$str .= "</div>\n";
		}
		return $str;		
	}
	
	function getHoverIcon(){
		$params = $this->loadParams();
		$rollOver = str_replace( "'", "\'", $params->get( 'rollover' ));
		$rollOver = str_replace( '"', '\"', $rollOver );
		$hoverTitle = str_replace( "'", "\'", $params->get( 'hover_text_title', 'Hover text' ));
		$hoverTitle = str_replace( '"', '\"', $hoverTitle );
		if ( $rollOver != '' ){
			return "<span class=\"hoverImage\" onmouseover=\"return overlib('$rollOver', CAPTION, '$hoverTitle', BELOW, RIGHT);\" onmouseout=\"return nd();\"></span>";
		}
		return '';
	}
	
	/**
	 * create the elements html id 
	 *
	 * @param object $oGroup
	 * @param object $oForm
	 * @return string html id
	 */

	function _loadHTMLId( &$oGroup, &$oForm ){
		$includeJoinString = true;
		$defaultVal = '';
		
		if( $oGroup->is_join ){
			$oJoin = new fabrikJoin( $this->_db );
			$oJoin->loadFromGroupId( $oGroup->id, $oForm->_table->id );
			if( $includeJoinString ){
				$fullName = 'join___' . $oJoin->id . '___' . $oJoin->table_join . '___' . $this->element_name ;
			}else{
				$fullName =  $oJoin->table_join . '___' . $this->element_name ;
			}	
		} else{
			$tableName = $oForm->getTableName();
			$fullName = $tableName . '___' . $this->element_name;
		}
		
		//@TODO: check this - repeated elements do need to have something applied to thier
		// id based on their order in the repeated groups
	
		if( $oGroup->getCanRepeatGroup() == 1  ){
			//$fullName .=  "[]";
		}				
		$this->_elementHTMLId =  $fullName;	
		return $this->_elementHTMLId;	
	}
	
	function getHTMLId(){
		return $this->_elementHTMLId;
	}
	
	/**
	 * check user can view the read only element & view in table view
	 * @return bol can view or not
	 */

	function canView( ){
	 	global $my, $acl, $database;
	 	$rowId = mosGetParam($_REQUEST, 'rowid', '');
	 	$this->loadParams( );
	 	$a = $this->_params->get( 'view_access', '' );
	 	if( $a == '29' || $a == '' || $a == '0' ){
	 		$this->_access->view =  true;
	 	}else{
	 
	 		if(!is_object($this->_access) || !array_key_exists('view', $this->_access)){
			 	$sql = "select name from #__core_acl_aro_groups where group_id >= '$a' AND group_id != 29 AND group_id != 30";
			 	$database->setQuery($sql);
		 
			 	$groupNames = $database->loadResultArray();
			 	foreach($groupNames as $name){
			 		$acl->_mos_add_acl( 'action', 'viewElement' . $this->element_name, 'fabrik', $name, 'components', null );
			 	}
		 		if($acl->acl_check( 'action', 'viewElement' . $this->element_name, 'fabrik', $my->usertype, 'components', null )){
					$this->_access->view =  true;
				}else{
					$this->_access->view = false;
				}
		 	}
	 	}
	 	return $this->_access->view;
	}
	
	/**
	 * check user can view the active element
	 * @return bol can view or not
	 */
	 
	 function canUse( ){
	 	global $my, $acl, $database;
	 	$a = $this->access;
	 	//$$$ rob - if the form is in view only mode then you cant use the element
	 	if(mosGetParam($_REQUEST, 'task') == 'viewTableRowDetails'){
	 		return false;
	 	}
	 	if( $a == '29' || $a == '' || $a == '0' ){
	 		$this->_access->use =  true;
	 		return true;
	 	}
	 	if( !is_object($this->_access) || !array_key_exists( 'use', $this->_access ) ){
		 	$sql = "select name from #__core_acl_aro_groups where group_id >= '$a' AND group_id < 28";
		 	$database->setQuery($sql);
		 	$groupNames = $database->loadResultArray();
		 	foreach( $groupNames as $name ){
		 		$acl->_mos_add_acl( 'action', 'useElement' . $this->element_name, 'fabrik', $name, 'components', null );
			 }
	 		if($acl->acl_check( 'action', 'useElement' . $this->element_name, 'fabrik', $my->usertype, 'components', null )){
	 			$this->_access->use =  true;
			}else{
				$this->_access->use = false;
			}
		}
		return $this->_access->use;
	}
	
	function copyRow($id, $updateOrderColumns){
		global $database;
		$tbl = $this->_tbl;
		$_tbl_key = $this->_tbl_key;
		$sql = "select * FROM $tbl WHERE $_tbl_key = '$id'";
		$database->setQuery( $sql );
		$item = $database->loadObjectList();
		$item = $item[0];
		foreach($item as $key=>$val){
			if($key != 	$_tbl_key){
				$this->$key = $val;
			}
		}

		$name = $this->element_name;
		if(substr($name, 0 , 8) == "Copy_of_")	{
			if(strrpos($name, "-") > 0) {
				$tot = strrpos($name, "-") - strlen($name);
				$sName = substr($name, 8, $tot ) ;
			} else {
				$sName = substr($name, 8) ;
			}
			$sql = "SELECT element_name FROM $tbl WHERE element_name LIKE '%$sName%'";
		} else {
			$sql = "SELECT element_name FROM $tbl WHERE element_name LIKE '%$name%'";
			$name = "Copy_of_" . $name;
		}
		$database->setQuery( $sql );
		$names = $database->loadResultArray();
		if( count($names) == 2) {
			$name = $name . "-2";
		} else if(count($names) > 2)	{
			if(strrpos($name, "-") > 0) {
				$name = substr($name , 0, strrpos($name, "-")+1) . (count($names));
			} else {
				$name = $name . "-" . (count($names));
			}
		} 

		$this->element_name = $name;
		if (!$this->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";			
			exit();
		}
		if (!$this->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$updatewhere = "";
		if(is_array($updateOrderColumns)){
			foreach($updateOrderColumns as $key=>$val){
				if (substr($val,0,4) == '$row') { 
				    $val = $row->$key;
				}
				$updatewhere .= " $key = '$val' and";
			}
		}
		$updatewhere = substr($updatewhere,0,strlen($updatewhere)-3 );
		$this->updateOrder( $updatewhere  );
	}
	
	function addToTable($cid, $state){
		if (!is_array( $cid ) || count( $cid ) < 1) {
			$this->_error = "No items selected.";
			return false;
		}
		$cids = implode( ',', $cid );
		$this->_db->setQuery( "UPDATE $this->_tbl SET show_in_table_summary='$state'"
		. "\nWHERE $this->_tbl_key IN ($cids) "
		);
		if (!$this->_db->query()) {
			$this->_error = $this->_db->getErrorMsg();
			return false;
		}
		if (count( $cid ) == 1) {
			$this->checkin( $cid[0] );
		}
		$this->_error = '';
		return true;
	}
	

	/**
	 * draws out the html form element
	 * @param array lists
	 * @param object element group
	 * @param array data
	 * @param int repeat group counter
	 */

	function render( $lists, &$oGroup, &$data, $repeatCounter )
	{
		global $mosConfig_absolute_path;
		$parsed_name = preg_replace("/[^A-Za-z0-9]/", "_", $this->element_name);
		$arErrors = array(); 
		$rowId = mosGetParam( $_GET, 'rowid', '' );
		$this->loadParams();
		$htmlElement = '';
		switch ($this->elementtype_id) {
				case '1' :
				case '2' :
					if($this->password == "1"){
						$aIgnoreOnUpdate[] = preg_replace("/[^A-Za-z0-9]/", "_", $this->element_name);
					}
					$htmlElement = fabrik_html_content :: drawField($this, $data,  false );
					break;
				case '3' :
					$htmlElement = fabrik_html_content :: drawCheckBox($this, $data );
					break;
				case '4' :
					$htmlElement = fabrik_html_content :: drawRadioButton($this, $data );
					break;
				case '5' :
					$htmlElement = fabrik_html_content :: drawTextArea( $this, $data );
					break;
				case '6' :
					$htmlElement = fabrik_html_content :: drawDropDown( $this, $data );
					break;
				case '7' :
					// $$$ hugh added $data as arg so eval'ed text can get at it
					$htmlElement = fabrik_html_content :: drawText( $this, $data );
					break;
				case '8' :
					$htmlElement = fabrik_html_content :: drawFileUpload( $this, $data, 0, $rowId );
					break;
				case '9' :
					$htmlElement = fabrik_html_content :: drawImage( $this, $data );
					break;
				case '10' :
					$htmlElement = fabrik_html_content :: drawUsername( $this );
					break;
				case '11' :
					$htmlElement = fabrik_html_content :: drawDate( $this, $data );
					break;
				case '12' :
					if ($this->join_conn_id != '0') {
						$htmlElement = fabrik_html_content :: drawDbDropDown( $lists, $data, $this, $oGroup, $repeatCounter );
					}
					break;
				case '13' :
					$htmlElement = fabrik_html_content :: drawButton( $this );
					break;
				case '14' :
					$htmlElement = fabrik_html_content::drawURL( $this, $data, false );
					break;
			} 
			if (!$this->canUse() || !$this->_editable) {
				$htmlElement = "<div class='readonly' id='" . $this->_elementHTMLId . "'>" .$htmlElement . "</div>";
			}
			return $htmlElement;
	}
	
	/**
	 * get the html for the elements label
	*/
	 
	function renderLabel(){
		global $mosConfig_absolute_path;
		if($this->hidden){ return '';}
		$this->_loadParams();
		$class = 'fabrikLabel';
		$addLabel =  false;
		$groupeltype = $this->elementtype_id;
		$hidden = $this->hidden;
		if ($groupeltype == '7') {
			$class = 'fabrikText';
		} else {
			if ($groupeltype == '9') { 
			} else {
				if (!$hidden) {
					if ($groupeltype == '13') { 
						return '';
					}else{
						$addLabel =  true;	
					}
				}
			}
			return  fabrik_html_content::getLabel($this, $class, $addLabel, $this->_params);
		}
	}
	

	/**
	 * overwirte the standard load function to load in validations and js
	 */
	
	/**
	*	binds an array/hash to this object
	*	@param int $oid optional argument, if not specifed then the value of current key is used
	*	@return any result from the database operation
	*/
	function load( $oid=null ) {
		$k = $this->_tbl_key;
		
		if ($oid !== null) {
			$this->$k = $oid;
		}
		$oid = $this->$k;
		if ($oid === null) {
			return false;
		}
		$class_vars = get_class_vars(get_class($this));
		foreach ($class_vars as $name => $value) {
			if (($name != $k) and ($name != "_db") and ($name != "_tbl") and ($name != "_tbl_key")) {
				$this->$name = $value;
			}
		}
		$this->reset();
		
		$query = "SELECT #__fabrik_elements.*, "
		. "\n concat( action , ' = \"' ,  code , '\"') as js"
		. "\n FROM $this->_tbl"
		. "\n left join #__fabrik_jsactions on"
		. "\n $this->_tbl.id"
  		. "\n = #__fabrik_jsactions.element_id"
 		. "\n WHERE $this->_tbl.$this->_tbl_key = '$oid'";
 		
		$this->_db->setQuery( $query );
		return $this->_db->loadObject( $this );
	}
	
	/**
	 * checks if the params object has been created and if not creates and returns it
	 * @return object params
	 */
	function &loadParams(){
		global $mosConfig_absolute_path;
		if(!isset($this->_params)){
			$this->_params = &new fabrikParams( $this->attribs, $mosConfig_absolute_path . '/administrator/components/com_fabrik/xml/element.xml', 'component' );
		}
		return $this->_params;
	}
	
	/**
	 * get the database field type based on the element type
	 * @return string field type e.g. varchar(255)
	 */

	function getFieldDescription(){
		 switch ( $this->elementtype_id ) {
	 		case "2" :
	 			//field
				$p = $this->loadParams();
				$type = $p->get( 'text_format', 'text' );
				switch ($type) 
				{
					case 'text':
						$objtype = "VARCHAR(255)";
						break;
					case 'number':
						$objtype = "INT(" . $p->get('integer_length', 10) . ")";
						break;
					case 'decimal':
						$objtype = "DECIMAL(" . $p->get( 'integer_length', 10 ) . "," . $p->get( 'decimal_length', 2 ) . ")";
				}
				break;
			case "3" : 
				//checkbox
				$objtype = "text";
				break;
			case "4" : 
				//radio button
				$objtype = "text"; 
				// 4 & 3 changed to text as i gues you can have mulitple select with vals of x lenght
				break;
			case "5" : 
				// text area
				$objtype = "text";
				break;
			case "6" : 
				// drop down
				$objtype = "varchar (255)";
				break;
			case "7" : 
				// display text
				$objtype = "text ";
				break;
			case "8" : 
				// file upload
				$objtype = "varchar (255)"; // for image upload we only save the file name here
				break;
			case "9" : 
				// image
				$objtype = "text ";
				break;
			case "10" : 
				// username
				$objtype = "varchar (25)";
				break;
			case "11" : 
				// date
				$objtype = "datetime ";
				break;
			case "14" : 
				// url
				$objtype = "text";
			default :
				$objtype = "varchar (255)";
				break;
		}
		return $objtype;	
	}
	
	/**
	 * loads in elements validation objects
	 * @return array validation objects
	 */
	 
	 function loadValidations( ){
	 	global $database;
	 	$query = "SELECT id FROM #__fabrik_validations WHERE element_id = '$this->id'";
	 	$database->setQuery( $query );
	 	$aIds = $database->loadResultArray( );
	 	$aValidations = array();
	 	foreach($aIds as $id){
	 			$oValidation = new fabrikValidation( $database );
	 			$oValidation->load( $id );
	 			$aValidations[] = $oValidation; 
	 			
	 	}
	 	$this->_aValidations = $aValidations;
	 	return $aValidations;
	 }
	 
	 /**
	  * 
	  */
	 
	 function getValidations(){
		$sql = "SELECT * FROM #__fabrik_validations WHERE element_id = '$this->id'";
		$this->_db->setQuery( $sql );
		echo $this->_db->getErrorMsg( );
		return $this->_db->loadObjectList( );	 	
	 }
	 
	 /**
	  * 
	  */
	  
	  function getimageAlignmentDd(){
		$aligns[] = mosHTML::makeOption( "none" );
		$aligns[] = mosHTML::makeOption( "left" );
		$aligns[] = mosHTML::makeOption( "right" );
		return mosHTML::selectList($aligns, 'image_float', 'class=\"inputbox\" size=\"1\"', 'value', 'text', $this->image_float);	  	
	  }
	
	/**
	 * get a html drop down list of the elment types with this objs element type selected as default
	 * @return string html element type list
	 */  
	function getElementTypeDd(){
		$this->_db->setQuery( "SELECT elementtype_id AS value, elementtype_name AS text FROM #__fabrik_elementtypes ORDER BY elementtype_id" );
		$elementstypes = $this->_db->loadObjectList( );
		return mosHTML::selectList( $elementstypes, 'elementtype_id', 'class="inputbox" id="elementtype_id"  size="1"', 'value', 'text', intval( $this->elementtype_id ) );
	}
	
	 /**
	  * 
	  */
	  
	function getGroupsDd()
	{
		$sql = "SELECT id AS value, group_name AS text FROM #__fabrik_groups order by group_name";
		$this->_db->setQuery( $sql );
		$groups =  $this->_db->loadObjectList( );
		array_unshift( $groups, mosHTML::makeOption( '', _PLEASE_SELECT ) );
		return mosHTML::selectList( $groups, 'group_id', 'class="inputbox" size="1" id="group_id"', 'value', 'text', intval( $this->group_id ) );	  	
	}
	 
	 /**
	  * 
	  */
	 
	 function getJSEventTypesDd( $jsActions){
		return mosHTML::selectList( $jsActions, 'js_action[]', 'class=\"inputbox\" size=\"1\"', 'value', 'text', '');	 	
	 }
	 
	 /**
	  *create the js code to observe the elements js actions
	  * @param array all javascript events for the form key'd on element id
	  * @return string js events
	  */

	 function getFormattedJSActions( $allJsActions ){
	 	$jsStr = '';
	 	if(array_key_exists($this->id, $allJsActions)){
	 		$elId = $this->getHTMLId();

	 		foreach($allJsActions[$this->id] as $jsAct){
				$js = addSlashes($jsAct->code);
				$js = str_replace(array("\n", "\r"), "", $js);
				$jsStr .= "ofabrik.dispatchEvent( '$this->elementtype_id', '$elId', '$jsAct->action', '$js');\n";
	 		}
	 	}
	 	return $jsStr;
	 }
	 
	 /**
	  * @return array available javascript events
	  */
	 
	 function getJSDefaultActions(){
	 	$jsActions = array( );
	 	$jsActions[] = mosHTML::makeOption( "onfocus" );
		$jsActions[] = mosHTML::makeOption( "onblur" );
		$jsActions[] = mosHTML::makeOption( "onabort" );
		$jsActions[] = mosHTML::makeOption( "onclick" );
		$jsActions[] = mosHTML::makeOption( "onchange" );
		$jsActions[] = mosHTML::makeOption( "ondblclick" );
		$jsActions[] = mosHTML::makeOption( "onkeydown" );
		$jsActions[] = mosHTML::makeOption( "onkeypress" );
		$jsActions[] = mosHTML::makeOption( "onkeyup" );
		$jsActions[] = mosHTML::makeOption( "onmouseup" );
		$jsActions[] = mosHTML::makeOption( "onmousedown" );
		$jsActions[] = mosHTML::makeOption( "onmouseover" );
		$jsActions[] = mosHTML::makeOption( "onmouseout" );
		$jsActions[] = mosHTML::makeOption( "onselect" );
		$jsActions[] = mosHTML::makeOption( "onload" );
		$jsActions[] = mosHTML::makeOption( "onunload" );
		return $jsActions; 	
	 }
	 
	 /**
	  * make a data array to create current js action html elements
	  */
	 
	 function getJSActionsDd( $defaultList ){
		$sql = "SELECT * FROM #__fabrik_jsactions WHERE element_id = '$this->id'";
		$this->_db->setQuery( $sql );
		$aJsActionObjs = $this->_db->loadObjectList( );
		echo $this->_db->getErrorMsg( );
		$aJsActions = array( );
		if ( is_array( $aJsActionObjs ) ) {
			foreach ( $aJsActionObjs as $oJsAction ) {
				$jsActionList = mosHTML::selectList( $defaultList, 'js_action[]', "class=\"inputbox\"  size=\"1\" ", 'value', 'text', $oJsAction->action );
				$aJsActions[] = array( $jsActionList, $oJsAction->code );
			}
		}
	 	return $aJsActions;
	 }
	 
	 /**
	  * presumes that the group is in a form (NOT a table joins group)
	  * if its a table join group then use getElementsJoinTables();
	  * @return array tables that the element is in
	  */
	 
	 function getElementsGroupTables( ){
	 	$aTableNames = array( );
	 	$sql = "SELECT form_id FROM #__fabrik_formgroup WHERE group_id = '$this->group_id'";
	 	$this->_db->setQuery( $sql );
	 	echo $this->_db->getErrorMsg( );
	 	$aForms = $this->_db->loadResultArray( );
	 	foreach( $aForms as $formId ){
	 		$sql = "SELECT * FROM #__fabrik_tables WHERE form_id = '$formId'";
	 		echo $this->_db->getErrorMsg( );
	 		$this->_db->setQuery( $sql );
	 		$aTables = $this->_db->loadObjectList( );
	 		$aTableNames = array_merge( $aTableNames, $aTables );
	 	}
	 	return $aTableNames;
	 }
	 
	 
	 /**
	  * presumes that the group is NOT in a form (IE in a table joins group)
	  * if its a in a form then use getElementsGroupTables();
	  * @return array tables that the element is in
	  */
	  
	 function getElementsJoinTables(){
		$sql = "SELECT table_join FROM #__fabrik_joins WHERE element_id = '$this->id'";
	 	$this->_db->setQuery( $sql );
	 	echo $this->_db->getErrorMsg( );
	 	$aTables = $this->_db->loadResultArray( );
	 	return $aTables;		
	 }
	 
	 /**
	  * 
	  */
	 
	 function getAdvancedJoinsObjs()
	 {
	 	$sql = "SELECT * FROM #__fabrik_joins WHERE element_id = '$this->id' AND element_id != '0' ORDER BY id";
		$this->_db->setQuery( $sql );
		$this->_advancedJoins = $this->_db->loadObjectList( );
		return $this->_advancedJoins;
	 }
	 
	 /**
	  * used to get the default value for table filters when they are advanced element joins
	  * @param array posted filter information
	  * @return dafault value for filter
	  */
	  
	function getDefaultAdvancedFilterVal( $aFilter )
	{
	 	if (is_null( $this->_advancedJoins )) {
	 		$this->getAdvancedJoinsObjs();
	 	}
 		foreach ($this->_advancedJoins as $oJoin) {
 			$testKey = $oJoin->join_from_table . "." . $oJoin->table_join_key;
 			if (isset( $aFilter[$testKey] )) {
					return $aFilter[$testKey]['filterVal'];
			}	
 		}
	 	return '';
	 }
	 
	 /**
	  * @param object element params
	  */
	  
	 function getAdvancedJoins( $params )
	 {
	 	global $database;
	 	$aJoinObjs = $this->getAdvancedJoinsObjs( );
		$lists = array( );
		// $$$ hugh - this needs to move into the aJoinObjs loop,
		// $$$ so we can set the default
		// $joinTypeDd = html_content::makeTableJoinTypeDd( );
		// $$$ hugh - reinstated this call to build the default $lists[] dd,
		// but left the new call in the aJoinObjs loop to pick up selected values on existing dd's
		$joinTypeDd = html_content::makeTableJoinTypeDd( );
		$lists['jointypes'] = $joinTypeDd;
		$lists['tablejoin'] = "";
		$lists['defaultJoinTalbes'] = '';
		$lists['defaultJoinTableFrom'] = '';
		$joinFromTables = array();
		$javascript = '';
		
		$startTable = $params->get('advJoin_startTable', '');
		if ($startTable != '') {
			$joinFromTables[] = mosHTML::makeOption( $startTable, $startTable );
		}
		$myTables = $this->getElementsGroupTables( );
	 	foreach ($myTables as $table) {
	 		$joinFromTables[] = mosHTML::makeOption( $table->db_table_name, $table->db_table_name );
	 	}
	 	
		$oConn = new fabrikConnection( $this->_db );
		if ($this->join_conn_id == null || $this->join_conn_id == -1) {
			$oConn->loadDefaultConnection( );
		} else {
			$oConn->load( $this->join_conn_id );
		}
		
		if (is_array( $aJoinObjs )) {
			for ($ff = 0;$ff < count( $aJoinObjs ); $ff++) {
				$oJoin = $aJoinObjs[$ff];
				$joinFromTables[] = mosHTML::makeOption( $oJoin->table_join, $oJoin->table_join );
				// $$$ hugh - moved this from up there ^^ somewhere and added the $sel arg
				$joinTypeDd = html_content::makeTableJoinTypeDd( $aJoinObjs[$ff]->join_type );
				$aJoinObjs[$ff]->join_type = $joinTypeDd;
				$tableDd = $oConn->getTableDdForThisConnection( $javascript, 'table_join[]', $oJoin->table_join );
				$aJoinObjs[$ff]->table_join = $tableDd;
			}
			
			for ($ff = 0;$ff<count( $aJoinObjs );$ff++) {
				$aJoinObjs[$ff]->join_from_table = mosHTML::selectList( $joinFromTables, 'join_from_table[]', 'class="inputbox" size="1" ', 'value', 'text',$aJoinObjs[$ff]->join_from_table ); 
			}
			$lists['joins'] = $aJoinObjs;
			$lists['defaultJoinTalbes'] = $oConn->getTableDdForThisConnection( $javascript, 'table_join[]', '');
			$lists['defaultJoinTableFrom'] = mosHTML::selectList( $joinFromTables, 'join_from_table[]', ' class="inputbox" size="1" ', 'value', 'text','' );
		}
		return $lists;	
	 }
	 
	 /**
	  * saves the element (admin)
	  * @param array data to bind to the element 
	  */
	  
	function save( $aData )
	{
		$aData['element_name'] = strtolower( preg_replace("/[^A-Za-z0-9\[\]]/", "_", $aData['element_name'] ) );
		if (array_key_exists( 'id', $aData )) {
			$this->load( $aData['id'] );
		} else {
			$aData['id'] = '0';
		}
		$this->_origName 	= preg_replace( "/[^A-Za-z0-9\[\]]/", "_", mosGetParam( $aData, 'element_name_orig', '' ) );
		
		$origGroupId = $this->group_id;
		$aData['image_name'] = '';
		if (isset( $aData['imagefiles'] )) {
			$aData['image_name'] = $aData['imagefiles'];
		}
		// get the max current ordering value
		$ordering = $this->_getNextFreeGroupOrder( $aData['group_id'] );
		if (!isset( $aData['ordering'] ) || $aData['ordering'] == '') {
			$aData['ordering'] = $ordering;
		}
		
		$aCheckBoxes = array( 'hidden', 'eval', 'multiple', 'show_in_table_summary', 'link_to_detail', 'can_order', 'can_filter', 'filter_exact_match', 'state', 'use_in_page_title', 'password', 'use_wysiwyg', 'ul_email_file', 'ul_file_increment' );
		foreach ($aCheckBoxes as $checkBox) { /** make sure that checkboxes have data correct*/
			if (!isset( $aData[$checkBox] )) {
				$aData[$checkBox] = 0;
			}
		}
		
		// if maxlength == '' then we need to set it to the maxlength of the field
		if ($aData['maxlength'] == '') {
			$aData['maxlength'] = $aData['element_width'];
		}
		$params = mosGetParam( $aData, 'params', array() );
		$this->updateAttribsFromParams( $params );
		$aData['default'] = stripslashes( $aData['default'] );
		$new = ( $aData['id'] == '0' || $origGroupId != $aData['group_id'] ) ? true : false;
	  	
		if (!$this->bind( $aData )) {
			echo "<script> alert('".$this->getError()."'); window.history.go(-1); </script>\n";
			exit( );
		}
		
		$msg = $this->check( $new );
		if ($msg !== true) {
			echo "<script> alert('".$msg."'); window.history.go(-1); </script>\n";
			exit( );
		}
		
		$this->modified 	= date( 'Y-m-d' );
		if (!$this->store( )) {
			echo "<script> alert('".$this->getError()."'); window.history.go(-1); </script>\n";
			exit ();
		}
		
		$this->addElementToDatabaseTable( $this->group_id, $new, $this->_origName );
		$this->checkin( );
		$this->updateValidations( );
		$this->updateJavascript( );
		$this->updateJoins( );	
	}
	  

/**
	 * returns the next free ordering id for an element in the elements group
	 * @param int group id
	 * @access private
	 * @return int element order value
	 */
	
	function _getNextFreeGroupOrder( $group_id = null )
	{
		global $database;
		if (is_null( $group_id )) {
			$group_id = $this->group_id;
		}
		$sql = "SELECT MAX(ordering) FROM #__fabrik_elements WHERE group_id = '$group_id'";
		$database->setQuery( $sql );
		$ordering = $database->loadResult( );
		$ordering ++;
		return $ordering;
	}
	 
	 /**
	  * load this elements advanced joins
	  */
	 
	function loadJoins( )
	{
		global $database;
		if (!isset( $this->_aJoins )) {
			$sql = "SELECT * FROM #__fabrik_joins WHERE element_id = '$this->id' ORDER BY id";
			$database->setQuery( $sql );
			$this->_aJoins = $database->LoadObjectList( );
		}
		return $this->_aJoins;
	}
	
	/**
	 * delete old javascript actions for the element
	 * & add new javascript actions
	 */
	 
	function updateJavascript( )
	{
		$this->_db->setQuery( "DELETE FROM #__fabrik_jsactions WHERE element_id = '$this->id'" );
		$this->_db->query( );
		if (isset( $_POST['js_action'] )) {
			if (is_array( $_POST['js_action'] )) {
				for ($c = 0; $c <= count( $_POST['js_action'] ); $c ++) {
					$jsAction = $_POST['js_action'][$c];
					if ($jsAction != '') {
						$code = $_POST['js_code'][$c];
						$code = str_replace( "}", "}\n", $code );
						$code = str_replace( '"', "'", $code );
						$sql = "INSERT INTO #__fabrik_jsactions (element_id, action, code) VALUES ('$this->id', '$jsAction', \"$code\")";
						$this->_db->setQuery( $sql );
						$this->_db->query( );
						if ($this->_db->getErrorMsg() != '') {
							echo "<br>1.db error for $sql <br /><br />";
						}
					}
				}
			}
		}
	}
	
	/**
	 * update elements validations when saving the element
	 */
	 
	 function updateValidations( ){
		$this->_db->setQuery( "DELETE FROM #__fabrik_validations WHERE element_id = '$this->id'");
		$this->_db->query( );
		if ( isset ( $_POST['validation_rule_id'] ) ) {
			if ( is_array( $_POST['validation_rule_id'] ) ) {
				for ( $c = 0; $c < count( $_POST['validation_rule_id'] ); $c ++ ) {
					$valId = $_POST['validation_rule_id'][$c];
					if ( $valId != '' ) {
						$errMessage = $_POST['message'][$c];
						$sql = "INSERT INTO #__fabrik_validations (element_id, validation_rule_id, message) VALUES ('$this->id', '$valId', '$errMessage')";
						$this->_db->setQuery( $sql );
						$this->_db->query( );
					}
				}
			}
		}
	 }
	 
										
	/**
	 * when adding a new element this will ensure its added to all tables that the
	 * elements group is associated with
	 * @param int group id
	 * @param bol if the field is to be added (true) or altered (false) 
	 * @param string original column name leave null to ignore
	 */
	
	function addElementToDatabaseTable( $groupId, $new, $origColName = null )
	{
		global $database, $my;
		// don't bother if the element has no name as it will cause an sql error'
		if ($this->element_name == '') {
			return;
		}
		$oGroup = new fabrikGroup( $database );
		$oForm 	= new fabrikForm( $database );
		$oTable = new fabrikTable( $database );
		$oConn 	= new fabrikConnection( $database );
		$oGroup->load( $groupId );
		$afFormIds = $oGroup->getFormsIamIn( );
		
		if ($oGroup->is_join == '1') {
			$oJoin = new fabrikJoin( $database );
			$oJoin->loadFromGroupId( $groupId );
			$oTable->alterStructure( $this, $new, $oJoin->table_join, $database, $origColName );
		} else {
			$afFormIds = $oGroup->getFormsIamIn( );
			
			if (is_array( $afFormIds )) {
				foreach ($afFormIds as $formId) {
					$oForm->load( $formId );
					$tableId = $oForm->table_id;
					$oTable->load( $tableId );
					
					if ($oTable->connection_id > 0) {
						$fabrikDb =& $oTable->getDb();
						$oTable->alterStructure( $this, $new, $oTable->db_table_name, $fabrikDb, $origColName );
					}
					
					$oTable->doCalculations();
				}
			}
		}
	}
	 
	 /**
	 * deals with ensuring joins are managed correctly when table/element is saved
	 * not sure this does anything for elements!
	 * $$$ hugh - I'm confused.  The existingJoins code seems to prevent us
	 * $$$ from ever editing an element join once it is created?
	 * $$$ Started playing around so it saves previous joins.
	 */
	 
	function updateJoins( ){
		$aOldJoins = $this->loadJoins( );
		$aOldJoinsToKeep = array( );
		$oJoin = new fabrikJoin( $this->_db );
		$joinIds 		= mosGetParam( $_POST, 'join_id', array() );
		$joinTypes 		= mosGetParam( $_POST, 'join_type', array() );
		$joinTableFrom  = mosGetParam( $_POST, 'join_from_table', array() );
		$joinTable 		= mosGetParam( $_POST, 'table_join', array() );
		$tableKey		= mosGetParam( $_POST, 'table_key', array() );
		$joinTableKey	= mosGetParam( $_POST, 'table_join_key', array() );
		$joinOnOperator	= mosGetParam( $_POST, 'table_join_on_operator', array() );
		$groupIds		= mosGetParam( $_POST, 'group_id', array() );
		
		for ( $i = 0;$i < count( $joinTypes );$i++ ){
			//$existingJoin = false;
			foreach ( $aOldJoins as $oOldJoin ){
				if ( $joinIds[$i] == $oOldJoin->id ) {
					//$existingJoin = true;
					$aOldJoinsToKeep[] = $joinIds[$i];
				}
			}
			//if ( !$existingJoin ){
				$oJoin->id = $joinIds[$i];
				$oJoin->table_id = $this->id;
				$oJoin->join_from_table = $joinTableFrom[$i]; 
				$oJoin->table_join = $joinTable[$i];
				$oJoin->table_join_key = $joinTableKey[$i];
				$oJoin->table_key = $tableKey[$i];
				$oJoin->join_type = $joinTypes[$i];
				$oJoin->group_id = 0;
				$oJoin->element_id = $this->id;
				$oJoin->attribs = $joinOnOperator[$i];
					
				$ok = $oJoin->store( );	
				echo $this->_db->getErrorMsg( );		
			//} else {
			//	$aOldJoinsToKeep[] = $joinIds[$i];
			//}
		}
		if( is_array( $aOldJoins ) ){
			foreach( $aOldJoins as $oOldJoin ){
				if( !in_array( $oOldJoin->id, $aOldJoinsToKeep ) ){
					$oJoin->load( $oOldJoin->id );
					// $$$ hugh
					// $$$ deleteAll calls all the delete group stuff.
					// $$$ OK, so we shouldn't have a group_id set if we
					// $$$ are an element join, but still ... safer just
					// $$$ to directly zap the one join.
					//$oJoin->deleteAll( $oOldJoin->group_id );
					$oJoin->delete();
				}
			}
		}
	}
	
	
	/**
	* a recursive method to return a list of all folders from a given parent directory
	* @param string parent directory
	* @return array child directories of parent directory
	*/
	
	function recursive_listdir( $base ) {
		static $filelist = array( );
		static $dirlist = array( );
		if ( is_dir( $base ) ) {
			$dh = opendir( $base );
			if ( $dh != false ) {
				while ( false !== ( $dir = readdir( $dh ) ) ) {
					if ( is_dir( $base."/".$dir ) && $dir !== '.' && $dir !== '..' && strtolower( $dir ) !== 'cvs' ) {
						$subbase = $base."/".$dir;
						$dirlist[] = $subbase;
						$subdirlist = $this->recursive_listdir( $subbase );
					}
				}
				closedir($dh);
			}
		}
		return $dirlist;
	}
	
	/**
	 * @return element name parsed to ensure only alphanumeric characters
	 * DEPRECIATED - should be using the group's getelement name function instead
	 */
	 
	function getParsedName(){
		return preg_replace("/[^A-Za-z0-9]/", "_", $this->element_name);
	}
	
	/**
	* Internal function to recursive scan the media manager directories
	* @param string Path to scan
	* @param string root path of this folder
	* @param array  Value array of all existing folders
	* @param array  Value array of all existing images
	* 
	*/
	function ReadImages( $imagePath, $folderPath, &$folders, &$images, $aFolderFilter ) {
		$imgFiles = $this->fabrikReadDirectory( $imagePath, '.', true, false, $aFolderFilter );
		foreach ($imgFiles as $file) {
			$ff_ 	= $folderPath . $file .'/';
			$ff 	= $folderPath . $file;
			$i_f 	= $imagePath .'/'. $file;

			if ( is_dir( $i_f ) && $file != 'CVS' && $file != '.svn' ) {
				
				if(!in_array($file, $aFolderFilter)){
					$folders[] = mosHTML::makeOption( $ff_ );
					$this->ReadImages( $i_f, $ff_, $folders, $images, $aFolderFilter );
				}
            // $$$ hugh - sneak mp3's in here for now
			} else if ( eregi( "bmp|gif|jpg|png|mp3", $file ) && is_file( $i_f ) ) {
				// leading / we don't need
				$imageFile = substr( $ff, 1 );
				$images[$folderPath][] = mosHTML::makeOption( $imageFile, $file );
			}
		}
	}	

	
	/**
	* Utility function to read the files in a directory
	* @param string The file system path
	* @param string A filter for the names
	* @param boolean Recurse search into sub-directories
	* @param boolean True if to prepend the full path to the file name
	*/
	
	function fabrikReadDirectory( $path, $filter='.', $recurse=false, $fullpath=false, $aFolderFilter=array(), $foldersOnly = false   ) {
		$arr = array();
		if (!@is_dir( $path )) {
			return $arr;
		}
		$handle = opendir( $path );
	
		while ($file = readdir($handle)) {
			$dir = mosPathName( $path.'/'.$file, false );
			$isDir = is_dir( $dir );
			if (($file != ".") && ($file != "..")) {
				if (preg_match( "/$filter/", $file )) {
					if(($isDir && $foldersOnly) || !$foldersOnly){
						if ($fullpath) {
							$arr[] = trim( mosPathName( $path.'/'.$file, false ) );
						} else {
							$arr[] = trim( $file );
						}
					}
				}
				$goDown = true;
				if ($recurse && $isDir) {
					foreach( $aFolderFilter as $sFolderFilter ){
						if (strstr( $dir, $sFolderFilter )) {
							$goDown = false;
						}
					}
					
					if ($goDown) {
						$arr2 = $this->fabrikReadDirectory( $dir, $filter, $recurse, $fullpath,$aFolderFilter,$foldersOnly );
						$arrDiff = array_diff($arr, $arr2 );
						$arr = array_merge( $arrDiff );
					}
				}
			}
		}
		closedir($handle);
		asort($arr);
		return $arr;
	}
	
	/**
	 * Enter description here...
	 *
	 * @param string $defaultVal
	 * @param int repeat group counter
	 * @return string database drop down default value
	 */

	function getDatabaseDropdownDefaultValue( $defaultVal, $repeatCounter = 0 ){
		global $my, $database;
		$params = $this->loadParams( );

		$cn = new fabrikConnection( $database );
		if( $this->join_conn_id == '' || $this->join_conn_id == '-1' ){
			$cn->loadDefaultConnection( );
		} else {
			$cn->load( $this->join_conn_id );
		}
		if ( $cn->testConnection() ) {
			$joinDb = new database( $cn->host, $cn->user, $cn->password, $cn->database, "" );
			
			if( $params->get( 'joinType' ) == 'advanced' ){
				$col	= $this->element_name;
 				$aVals 	= array();

				$aAvJoins = $this->getAdvancedJoinsObjs( );
				$val = stripslashes( $params->get( 'advJoin_concat' ) );
				$table = $aAvJoins[0]->join_from_table;
				$key = $aAvJoins[0]->table_join_key;

				$key = $params->get('advJoin_key', $table.'.'.$this->element_name );	
				$table = $params->get('advJoin_startTable', $table);				  					
					
				$sql = "SELECT CONCAT($val) AS text FROM $table";
				$aUsedJoins = array();
				foreach( $aAvJoins as $oJoin){
					$tmpSql = "\n $oJoin->join_type JOIN $oJoin->table_join  ON $oJoin->join_from_table.$oJoin->table_key = $oJoin->table_join.$oJoin->table_join_key";
					if(!in_array($tmpSql, $aUsedJoins)){
						$sql .= $tmpSql;
						$aUsedJoins[] = $tmpSql;
					}	
				}
				$sql .= " where $key = '$defaultVal'";
				$joinDb->setQuery($sql);
				$defaultVal = $joinDb->loadResult();
			}else{
				$sql = "SELECT $this->join_val_column FROM $this->join_db_name WHERE $this->join_key_column = '$defaultVal'";
				$joinDb->setQuery($sql);
				$defaultVal = $joinDb->loadResult();
			}
		}
		return $defaultVal;
	}
	
	function ajax_GetImages( ){
		global $mosConfig_absolute_path;
		$params 	= $this->loadParams();
		$v = urldecode(mosGetParam($_GET, 'f', ''));
		$rootDir 	=  $params->get( 'selectImage_root_folder', '' );
		$rDir = mosPathName($mosConfig_absolute_path . "/images/stories" .  $rootDir . '/' . $v);
		$images = array( );
		$folders = array( );
		$this->readImages( $rDir, "/", $folders, $images, array(), false );
		$images = $images['/'];
		$js = "[";
		foreach( $images as $i ){
			$js .= "'$i->value',";
		}
		$js = rtrim($js, ",");
		$js .= "]";
		echo $js;
	}
}


/**
 * used for storing prefilters 
 * (essentially elements with a param 'prefilter' set to 1)
 */

class preFilter extends fabrikElement {

	/**
	* @param database A database connector object
	*/
	
	/*
	 * where, 	field, condition , value, access
	 */
	function fabrikTable( &$db ) {	
		$this->mosDBTable( '#__fabrik_prefilter', 'id', $db );
	}
	
	function save(){
		$params = mosGetParam( $_POST, 'params', '' );
		if ( is_array( $params )) {
			$txt = array();
			foreach ( $params as $k=>$v ) {
				if( is_array( $v ) ){
					$str = '';
					foreach( $v as $key2=>$val2 ){
						$str .= "$key2,";
					}
					$v = substr( $str, 0, strlen( $str )-1 );
				}
				$v = str_replace( "\'", "'", $v );
				$v = htmlspecialchars( $v, ENT_QUOTES );
				$txt[] = "$k=$v";
			}
			$txt[] = "prefilter=1";
			$oTable->attribs = implode( "\n", $txt );
		}		
	}
}

	
?>