<?php

/**
 * @package  fabrik
 * @version 906 | rob | 2008-05-20 11:06:14 +0200 (Tue, 20 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class fabrikJoin extends fabrikDBTable{

	/** @var int primary key */
	var $id = null;
	
	/** @var int fabrik table id the join belongs to 
	 * nb: EITHER  table_id OR element_id IS USED BASED ON WHETHER THIS IS A TABLE JOIN
	 * OR AN ADVANCED ELEMENT JOIN*/
	var $table_id = null;
	
	/** @var int element id the join belongs to */
	var $element_id = null;
	
	/** @var string table to join from (draw from list of tables join to tables and tables own name)*/
	var $join_from_table = null;
	
	/** @var string table to join to */
	var $table_join = null;
	
	/** @var string table column to use for join */
	var $table_key = null;
	
	/** @var string join table column to use in join */
	var $table_join_key = null;
	
	/** @var string join type */
	var $join_type = null; 
	
	/** @var int group id that the join elements are stored under */
	var $group_id = null;
    
    function fabrikJoin( &$db ) {	
		$this->mosDBTable( '#__fabrik_joins', 'id', $db );
	}
	
	/**
	 * load join based on group id
	 * @param int group id
	 * @param object join
	 */
	
	function loadFromGroupId( $groupId ){
		global $database;
		$k = $this->_tbl_key;
		$class_vars = get_class_vars(get_class($this));
		foreach ($class_vars as $name => $value) {
			if (($name != $k) and ($name != "_db") and ($name != "_tbl") and ($name != "_tbl_key")) {
				$this->$name = $value;
			}
		}

		$sql = "SELECT * FROM $this->_tbl WHERE group_id = '$groupId'";
		$this->_db->setQuery( $sql );
		return $this->_db->loadObject( $this );
	}
	
	/**
	 * deletes the loaded join and then 
	 * removes all elements, groups & form group record
	 * @param int the group id that the join is linked to 
	 */
	 
	function deleteAll( $groupId ){
		global $database;
		$sql = "DELETE FROM #__fabrik_elements WHERE group_id = '$groupId'";
		
		$database->setQuery( $sql );
		if( !$database->query( ) ){
			echo $database->getError();	exit;
		}
		
		$sql = "DELETE FROM #__fabrik_groups WHERE id = '$groupId'";
		$database->setQuery( $sql );
		if( !$database->query( ) ){
			echo $database->getError();	exit;
		}
	
		/* delete all form group records */
		$sql = "DELETE FROM #__fabrik_formgroup WHERE group_id = '$groupId'";
		$database->setQuery( $sql );
		if( !$database->query( ) ){
			echo $database->getError();	exit;
		}
		$this->delete( );
	}
	
	/**
	 * saves the table join data
	 * @param array data to save
	 */
	 
	function save( $source ) {
		if (!$this->bind( $source )) {
			return false;
		}
		if (!$this->check()) {
			return false;
		}
		if (!$this->store()) {
			return false;
		}

		$this->_error = '';
		return true;
	}	
	
}
?>