<?php

/**
 * @package  fabrik
 * @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function migrate(){
	global $database;

	$aErrs = array();
	$aErrs = migrateElements($aErrs);
	$aErrs = migrateFormGroups($aErrs);
	$aErrs = migrateForms($aErrs);
	$aErrs = migrateGroups($aErrs);
	$aErrs = migrateJoins($aErrs);
	$aErrs = migrateJSActions($aErrs);
	$aErrs = migrateTables($aErrs);
	$aErrs = migrateValidations($aErrs);
	$aErrs = migrateValidationRules($aErrs);
	$aErrs = getDataTables($aErrs);
	
	$aErrs = updateLinks($aErrs);
	copyTemplates();
	if(!empty($aErrs)){
		print_r($aErrs);
		
	}else{
		echo "update ok";
	}
}

function copyTemplates(){
	global $mosConfig_absolute_path;
	$formTemplates = mosReadDirectory( $mosConfig_absolute_path . '/components/com_mosforms/tmpl/form/', '.', false  );
	
	foreach ($formTemplates as $file) {
		
		$oldPath = $mosConfig_absolute_path . '/components/com_mosforms/tmpl/form/' . $file;
		if(!is_dir($oldPath)){
			$newPath = $mosConfig_absolute_path . '/components/com_fabrik/tmpl/form/' . $file;
			if(!file_exists($newPath)){
				echo "copy: $oldPath, $newPath <br>";
				copy($oldPath, $newPath);
			}
		}
	}
	
	$tableTemplates = mosReadDirectory( $mosConfig_absolute_path . '/components/com_mosforms/tmpl/table/', '.', false  );
	
	foreach ($tableTemplates as $file) {
		if($file != 'standard.html'){
			$oldPath = $mosConfig_absolute_path . '/components/com_mosforms/tmpl/table/' . $file;
			if(!is_dir($oldPath)){
				$newPath = $mosConfig_absolute_path . '/components/com_fabrik/tmpl/table/' . $file;
				if(!file_exists($newPath)){
					copy($oldPath, $newPath);
					

				
				// Let's make sure the file exists and is writable first.
				if (is_writable($newPath)) {
				
				   	// In our example we're opening $filename in append mode.
				   	// The file pointer is at the bottom of the file hence
				   	// that's where $somecontent will go when we fwrite() it.
				   	if (!$handle = fopen($newPath, 'r')) {
				         echo "Cannot open file ($newPath)";
				         exit;
				   	}
					$contents = fread($handle, filesize($newPath));
					$contents = str_replace('mosform', 'fabrik', $contents);
					fclose($handle);
					
				   	if (!$handle = fopen($newPath, 'w')) {
				         echo "Cannot open file ($newPath)";
				         exit;
				   	}
				   	
				   // Write $somecontent to our opened file.
				   if (fwrite($handle, $contents) === FALSE) {
				       echo "Cannot write to file ($filename)";
				       exit;
				   }
				  
				  
				   fclose($handle);
				
				} else {
				   echo "The file $newPath is not writable";
				}

				}
			}
		}
	}

	$viewonlyTemplates = mosReadDirectory( $mosConfig_absolute_path . '/components/com_mosforms/tmpl/viewonly/', '.', false  );
	
	foreach ($viewonlyTemplates as $file) {
		$oldPath = $mosConfig_absolute_path . '/components/com_mosforms/tmpl/viewonly/' . $file;
		if(!is_dir($oldPath)){
			$newPath = $mosConfig_absolute_path . '/components/com_fabrik/tmpl/viewonly/' . $file;
			if(!file_exists($newPath)){
				copy($oldPath, $newPath);
			}
		}
	}	
	
}

function updateLinks($aErrs){
	global $database;
	$sql = "UPDATE #__menu  SET link =  REPLACE(link, 'com_mosforms', 'com_fabrik')";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	$sql = "SELECT 	id FROM #__components WHERE name='MosForms'";
	$database->setQuery($sql);
	$oldID = $database->loadResult();
	
	$sql = "SELECT 	id FROM #__components WHERE name='Fabrik'";
	$database->setQuery($sql);
	$newID = $database->loadResult();

	$sql = "UPDATE #__menu  SET  componentid = '$newID', params = REPLACE(params, 'act=', 'task=')
, params = REPLACE(params, 'viewtable', 'viewTable')
, params = REPLACE(params, 'viewform', 'viewForm')
, params = REPLACE(params, 'mosform', 'fabrik') WHERE componentid = '$oldID'";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	return $aErrs;
}

function migrateElements($aErrs){
	global $database;
	$sql = "delete from #__fabrik_elements";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_elements";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	foreach($rows as $row){
		$sql = "insert into #__fabrik_elements";
		$aKeys = array();
		$aVals = array();
		foreach($row as $key=>$val){
			/** check for old keys */
			switch($key){
				case 'element_id':
					$key = 'id';
					break;
			
			}
			if($key == 'element_name'){
				$val = preg_replace("/[^A-Za-z0-9]/", "_", $val);
			}
			/** ignore old fields that are not used */
			if($key != 'alt_text' && $key != 'element_field_width' && $key != 'groups' && $key != 'md5'){
				$aKeys[] = "`$key`";
				$val = addSlashes($val);
				$aVals[] = "'$val'";
			}
		}
		$strKeys = trim(implode(', ', $aKeys), ', ');
		$strVals = trim(implode(', ', $aVals), ', ');
		$sql = $sql . " ($strKeys) VALUES ($strVals)";
		$database->setQuery($sql);
		if(!$database->query()){
			$aErrs[] = $database->getErrorMsg();
		}
	}	
	return $aErrs;
}

function migrateFormGroups($aErrs){
	global $database;
	$sql = "delete from #__fabrik_formgroup";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_formgroup";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	foreach($rows as $row){
		$sql = "insert into #__fabrik_formgroup";
		$aKeys = array();
		$aVals = array();
		foreach($row as $key=>$val){
			/** check for old keys */
			switch($key){
				case 'element_id':
					$key = 'id';
					break;
			
			}
			/** ignore old fields that are not used */
			if($key != 'alt_text' && $key != 'element_field_width'){
				$aKeys[] = "`$key`";
				$val = addSlashes($val);
				$aVals[] = "'$val'";
			}
		}
		$strKeys = trim(implode(', ', $aKeys), ', ');
		$strVals = trim(implode(', ', $aVals), ', ');
		$sql = $sql . " ($strKeys) VALUES ($strVals)";
		$database->setQuery($sql);
		if(!$database->query()){
			$aErrs[] = $database->getErrorMsg();
		}
	}	
	return $aErrs;
}
		
function migrateForms($aErrs){
	global $database;
	$sql = "delete from #__fabrik_forms";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_forms";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	foreach($rows as $row){
		$sql = "insert into #__fabrik_forms";
		$aKeys = array();
		$aVals = array();
		foreach($row as $key=>$val){
			/** check for old keys */
			switch($key){
				case 'sumbit_button_label':
					$key = 'submit_button_label';
					break;
			
			}
			/** ignore old fields that are not used */
			if($key != 'alt_text' && $key != 'element_field_width'){
				$aKeys[] = "`$key`";
				$val = addSlashes($val);
				$aVals[] = "'$val'";
			}
		}
		$strKeys = trim(implode(', ', $aKeys), ', ');
		$strVals = trim(implode(', ', $aVals), ', ');
		$sql = $sql . " ($strKeys) VALUES ($strVals)";
		$database->setQuery($sql);
		if(!$database->query()){
			$aErrs[] = $database->getErrorMsg();
		}
	}	
	return $aErrs;
}
			
function migrateGroups($aErrs){
	global $database;
	$sql = "delete from #__fabrik_groups";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_groups";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	foreach($rows as $row){
		$sql = "insert into #__fabrik_groups";
		$aKeys = array();
		$aVals = array();
		foreach($row as $key=>$val){
			/** check for old keys */
			switch($key){
				case 'group_id':
					$key = 'id';
					break;
			
			}
			/** ignore old fields that are not used */
			if($key != 'alt_text' && $key != 'element_field_width'){
				$aKeys[] = "`$key`";
				$val = addSlashes($val);
				$aVals[] = "'$val'";
			}
		}
		$strKeys = trim(implode(', ', $aKeys), ', ');
		$strVals = trim(implode(', ', $aVals), ', ');
		$sql = $sql . " ($strKeys) VALUES ($strVals)";
		$database->setQuery($sql);
		if(!$database->query()){
			$aErrs[] = $database->getErrorMsg();
		}
	}	
	return $aErrs;
}
					
function migrateJoins($aErrs){
	global $database;
	$sql = "delete from #__fabrik_joins";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_joins";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	if(!is_null($rows)){
		foreach($rows as $row){
			$sql = "insert into #__fabrik_joins";
			$aKeys = array();
			$aVals = array();
			foreach($row as $key=>$val){
			
			
					$aKeys[] = "`$key`";
					$val = addSlashes($val);
					$aVals[] = "'$val'";
		
			}
			$strKeys = trim(implode(', ', $aKeys), ', ');
			$strVals = trim(implode(', ', $aVals), ', ');
			$sql = $sql . " ($strKeys) VALUES ($strVals)";
			$database->setQuery($sql);
			if(!$database->query()){
				$aErrs[] = $database->getErrorMsg();
			}
		}	
	}
	return $aErrs;
}

function migrateJSActions($aErrs){
	global $database;
	$sql = "delete from #__fabrik_jsactions";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_jsactions";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	if(!is_null($rows)){
		foreach($rows as $row){
			$sql = "insert into #__fabrik_jsactions";
			$aKeys = array();
			$aVals = array();
			foreach($row as $key=>$val){
			
			
					$aKeys[] = "`$key`";
					$val = addSlashes($val);
					$aVals[] = "'$val'";
		
			}
			$strKeys = trim(implode(', ', $aKeys), ', ');
			$strVals = trim(implode(', ', $aVals), ', ');
			$sql = $sql . " ($strKeys) VALUES ($strVals)";
			$database->setQuery($sql);
			if(!$database->query()){
				$aErrs[] = $database->getErrorMsg();
			}
		}	
	}
	return $aErrs;
}
		
function migrateValidations($aErrs){
	global $database;
	$sql = "delete from #__fabrik_validations";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_validations";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	if(!is_null($rows)){
		foreach($rows as $row){
			$sql = "insert into #__fabrik_validations";
			$aKeys = array();
			$aVals = array();
			foreach($row as $key=>$val){
			
				if($key == 'validation_id'){ $key = 'id';}
					$aKeys[] = "`$key`";
					$val = addSlashes($val);
					$aVals[] = "'$val'";
		
			}
			$strKeys = trim(implode(', ', $aKeys), ', ');
			$strVals = trim(implode(', ', $aVals), ', ');
			$sql = $sql . " ($strKeys) VALUES ($strVals)";
			$database->setQuery($sql);
			if(!$database->query()){
				$aErrs[] = $database->getErrorMsg();
			}
		}	
	}
	return $aErrs;
}
				
function migrateTables($aErrs){
	global $database;
	$sql = "delete from #__fabrik_tables";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_tables";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	if(!is_null($rows)){
		foreach($rows as $row){
			$sql = "insert into #__fabrik_tables";
			$aKeys = array();
			$aVals = array();
			foreach($row as $key=>$val){
			
			
					$aKeys[] = "`$key`";
					$val = addSlashes($val);
					$aVals[] = "'$val'";
		
			}
			$strKeys = trim(implode(', ', $aKeys), ', ');
			$strVals = trim(implode(', ', $aVals), ', ');
			$sql = $sql . " ($strKeys) VALUES ($strVals)";
			$database->setQuery($sql);
			if(!$database->query()){
				$aErrs[] = $database->getErrorMsg();
			}
		}	
	}
	return $aErrs;
}

function migrateValidationRules($aErrs){
	global $database;
	$sql = "delete from #__fabrik_validation_rules";
	$database->setQuery($sql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$sql = "select * from #__mosform_validation_rules";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	if(!is_null($rows)){
		foreach($rows as $row){
			$sql = "insert into #__fabrik_validation_rules";
			$aKeys = array();
			$aVals = array();
			foreach($row as $key=>$val){
			
					if($key == 'validation_rule_id'){$key = 'id';}
					$aKeys[] = "`$key`";
					$val = addSlashes($val);
					$aVals[] = "'$val'";
		
			}
			$strKeys = trim(implode(', ', $aKeys), ', ');
			$strVals = trim(implode(', ', $aVals), ', ');
			$sql = $sql . " ($strKeys) VALUES ($strVals)";
			$database->setQuery($sql);
			if(!$database->query()){
				$aErrs[] = $database->getErrorMsg();
			}
		}	
	}
	return $aErrs;
}

function getDataTables($aErrs){
	global $database;
	$database->setQuery("show tables");
	$a = $database->loadResultArray();

	foreach($a as $name){
		if(strstr($name, 'mosform_formdata_')){
			$aErrs = copyDataTables($name, $aErrs);
		}
	}
	return $aErrs;
}

function copyDataTables($table, $aErrs){
	global $database;
	$newTable = str_replace('mosform', 'fabrik', $table);
	global $database;
	$dropSql = "drop table if exists $newTable;\n";
	$database->setQuery($dropSql);
	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}
	
	$createSql = "create table $newTable(";

	
	$database->setQuery("describe $table");
	$rows = $database->loadObjectList();
    foreach($rows as $row){
		$createSql .= " `$row->Field` $row->Type $row->Extra ";
		if($row->Key == 'PRI'){
			$createSql .= " primary key";
		}
		$createSql .= ", ";
    }
    $createSql = rtrim($createSql, ", ");
    $createSql .= ")";
	$database->setQuery($createSql);

	if(!$database->query()){
		$aErrs[] = $database->getErrorMsg();
	}

	$sql = "select * from $table";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	if(!is_null($rows)){
		foreach($rows as $row){
			$sql = "insert into $newTable";
			$aKeys = array();
			$aVals = array();
			foreach($row as $key=>$val){
			
					if($key == 'validation_rule_id'){$key = 'id';}
					$aKeys[] = "`$key`";
					$val = addSlashes($val);
					$aVals[] = "'$val'";
		
			}
			$strKeys = trim(implode(', ', $aKeys), ', ');
			$strVals = trim(implode(', ', $aVals), ', ');
			$sql = $sql . " ($strKeys) VALUES ($strVals)";
			$database->setQuery($sql);
			if(!$database->query()){
				$aErrs[] = $database->getErrorMsg();
			}
		}	
	}
	return $aErrs;
}

?>