<?php
class TestOfPost971_0 extends UnitTestCase {
    
	var $_tableid = null; // fake change to bump Unfuddle rev#
	
    function setUp() {
        global $database, $mosConfig_live_site;
        
       	$database->setQuery( "DROP TABLE IF EXISTS `testofpost971_0`");
        $database->query();
        $database->setQuery( "DROP TABLE IF EXISTS `testofpost971_0_innerjoin`");
        $database->query();
	        
        $database->setQuery( "CREATE TABLE `testofpost971_0` (
		`id` INT( 6 ) NOT NULL AUTO_INCREMENT ,
		`label` VARCHAR( 255 ) NOT NULL,
		`user_id` INT( 6 ) NOT NULL,
		PRIMARY KEY ( `id` )
		)");
       $database->query();
       
		$database->setQuery("CREATE TABLE `testofpost971_0_innerjoin` (
		`id` INT( 6 ) NOT NULL AUTO_INCREMENT,
		`label` VARCHAR( 255 ) NOT NULL,
		`parent_id` INT( 6 ) NOT NULL,
		PRIMARY KEY ( `id` )
		) ");
       $database->query();
       $database->setQuery("INSERT INTO `testofpost971_0_innerjoin` ( `id` , `label` , `parent_id` ) VALUES ('', 'joined to parent', '1');");
       $database->query();
       $database->setQuery("INSERT INTO `testofpost971_0_innerjoin` ( `id` , `label` , `parent_id` ) VALUES ('', 'joined to parent2', '1');");
       $database->query();
       $database->setQuery("INSERT INTO `testofpost971_0_innerjoin` ( `id` , `label` , `parent_id` ) VALUES ('', 'not joined to parent', '2');");
       $database->query();
       $database->setQuery("INSERT INTO `testofpost971_0_innerjoin` ( `id` , `label` , `parent_id` ) VALUES ('', 'joined to no login record', '3');");
     $database->query();
     
    }
    
    function tearDown() {
        global $database, $mosConfig_live_site;
        if($this->_tearDown){
	        $database->setQuery( "DROP TABLE IF EXISTS `testofpost971_0`");
	        $database->query();
	        $database->setQuery( "DROP TABLE IF EXISTS `testofpost971_0_innerjoin`");
	        $database->query();
	        $oTable = new fabrikTable( $database );
	        $oTable->load( $this->_tableid );
	        $oTable->deleteTable( true );
        }
    }
    
	function testCreateTableWithPrefiltersAndJoins() {
        /**
         * INITIAL ISSUE:
         * 
         * Generated a Fabrik table from an existing mysql table.  
         * Saved it.  
         * Created a pre-filter on {$my->id} and set permissions on pre-filter to super administrator.  
         * Saved it.  
         * Tested it and that worked fine. Added an inner table join on the joomla-id, table view now shows the correct record.
         * Modified the table access and set view and view detailed record to registered. 
         *  Set Edit to Author, delete to administrator.
         * Table view still shows correctly for logged in user.  
         * Set Joomlaid element in the first record to view detailed record, and set the join element in the joined table to view detailed record.
         * 
         * RESULT EXPERIENCED:
         * 
         * Clicking on 'view' or the detailed record link in the table view takes you to "Sorry this form is unpublished."
         * Code:
         * http://localhost/index.php?option=com_fabrik&task=viewTableRowDetails&Itemid=60&fabrik=23&rowid=1&fabrik__cursor=0&fabrik__total=1tableid=24
         * 
         * This should take me to a detailed view for the combined record.  In this case I don't actually display any records from the original table, only the joined table.
         */
		
        ///variables to set for test (should query db to get first user that matches these)//

        $this->_tearDown = true; // set to false if you want to keep the db and tables created by the test
        $adminId = 62;
        $regUserId = 64;
        $userName = 'registered'; //test logging in with a normal registered user account
        $pw = 'registered';
        
        //create a new registered user:
		
        
        ////
		global $database, $mosConfig_live_site;
       $aData = Array
(
    'label' => 'testofpost971_0',
    'table_template' => 'default',
    'rows_per_page' => '30',
    'filter_action' => 'onchange',
    'params' => array
        (
            'csv_export_frontend' => 0,
            'empty_data_msg' => '',
            'detaillink' => 0,
            'rss' => 0,
            'group_by_order' => '', 
            'group_by_order_dir' => 'ASC'
        ),

    'state' => 1,
    'created_by_alias' => '',
    'created_by' => 62,
    'created' => '',
    'publish_up' => '2007-07-31',
    'publish_down' => '',
    'access' => 29,
    'allow_view_details' => 29,
    'allow_edit_details' => 29,
    'allow_add' => 29,
    'allow_delete' => 29,
    'connection_id' => 1,
    'db_table_name' => 'testofpost971_0',
    'order_by' => '',
    'order_dir' => 'ASC',
    'group_by' => '',
    'link_name' => '',
    'option' => 'com_fabrik',
    'task' => 'saveTable',
    'id' => '',
    'fabrikid' => '' 
);
    	
        $oTable = new fabrikTable( $database );
        
        //check if table exists 
		
        $this->assertTrue( $oTable->save( $aData ) );
        
        $this->assertTrue(is_object($oTable), 'table created');
        $oForm = new fabrikForm( $database );
        $this->assertTrue(is_object($oForm), 'form created');
        $oGroup = new fabrikGroup( $database );
        $this->assertTrue(is_object($oGroup), 'group created');
        
        $oElement = new fabrikElement( $database );
        $this->assertTrue(is_object($oElement), 'element created');
        
        $data = array('id' => '1', 'label'=>'admin record', 'user_id'=> $adminId);
       	$this->assertTrue( $oTable->storeRow( $data, 0 ) );
        
       	$data = array('id' => '', 'label'=>'other record', 'user_id'=> $regUserId);
       	$this->assertTrue( $oTable->storeRow( $data, 0 ) );
       	
       	$data = array('id' => '', 'label'=>'record everyone can see', 'user_id'=> 0);
       	$this->assertTrue( $oTable->storeRow( $data, 0 ) );
       	
       	//create prefilter

		$aDontEncode = array();
		
		//filter-access 30 = everyone
		$params = array('filter-join'=>'where',
			'filter-fields'=>'testofpost971_0.user_id',
			'filter-conditions'=>'equals',
			'filter-value'=>'return ' . "'" . '{$my->id}' . "';",
			'filter-eval'=>'on',
			'filter-access'=>'30'
		);
		$oTable->updateAttribsFromParams( $params, $aDontEncode );
		$oTable->store();

       //set up inner join
		$aData = array(
    'join_id' => array(''),
    'group_id' => array('' ),
    'join_type' => array('inner' ),
    'join_from_table' => array( 'testofpost971_0'),
    'table_join' => array('testofpost971_0_innerjoin' ),
    'table_key' => array('id'),
    'table_join_key' => array('parent_id'));
    
		$oTable->updateJoins( $aData );
		
		//set access levels 
		$oTable->access= 18;
	    $oTable->allow_view_details= 18;
	    $oTable->allow_edit_details= 19;
	    $oTable->allow_add= 29;
	    $oTable->allow_delete= 24;
		$oTable->store();
		
		//create a browser to test our table
		$browser = &new SimpleBrowser();
		$browser->addHeader('User-Agent: simpletest'); //needed for login
		$validate = josSpoofValue(1);
		$url = $mosConfig_live_site . '/index.php?option=com_fabrik&task=viewTable&tableid=' .  $oTable->id;
       	$formData = new SimplePostEncoding(array('return'=>$url, 'username'=>$userName, 'passwd'=>$pw, $validate=>'1', 'option' =>'login', 'opt2'=>'login', 'lang'=>'english', 'force_session'=>'1'));
       	$webPage = $browser->post($mosConfig_live_site . "/index2.php", $formData);
       	

		echo $url;
		
	    $webPage = $browser->get( $url );
        $this->assertPattern( '/' .  $oTable->label . '/i', $browser->getTitle());
        $this->assertNoPattern('/Parse error/i', $webPage, 'A parse error was encountered');
        $this->assertPattern('/other record/i', $webPage, "Doesnt look like the tables showing records");
		
		$this->assertNoPattern('/joined to no login record/i', $webPage, 'A record was shown that should have been filtered out by the prefilter');
       	$res = $browser->getLink('View');
		$this->assertNotEqual($browser->getLink('View'), false,  "No view link found on table");
		$browser->clickLink('View');
		$page = $browser->getContent();
		$this->assertNoPattern('/Sorry this form is unpublished/i', $page, 'The view link shows the message "Sorry this form is unpublished"');
		$this->_tableid = $oTable->id;
}
}


?>