<?php

class TestOfPost963_0 extends UnitTestCase {
	 
	/**
	 * creates a simple table and form with a checkbox
	 * creates element validation to check for 5 checked chech boxes
	 * tests failure of validation
	 * tests success of vaildation
	 */
	var $_tableid = null;
	var $_tearDown = false;
	
	function setUp() {
        global $database, $mosConfig_live_site;
        $database->setQuery( "DROP TABLE IF EXISTS `testofpost963_0`");
        $database->query();
        
        $database->setQuery( "CREATE TABLE `testofpost963_0` (
		`id` INT( 6 ) NOT NULL AUTO_INCREMENT ,
		`checkbox` TEXT NOT NULL,
		PRIMARY KEY ( `id` )
		)");
       $database->query();
	 }
	 
	 function tearDown(){
	    global $database, $mosConfig_live_site;
        if( $this->_tearDown ){
	        $database->setQuery( "DROP TABLE IF EXISTS `testofpost963_0`");
	        $database->query();
	        $oTable = new fabrikTable( $database );
	        $oTable->load( $this->_tableid );
	        $oTable->deleteTable( true );
        }	 	
	 }
	 
	 function testFormWithCheckBoxValidation() {
			global $database, $mosConfig_live_site;
	       $aData = Array
	(
	    'label' => 'testofpost963_0',
	    'table_template' => 'default',
	    'rows_per_page' => '30',
	    'filter_action' => 'onchange',
	    'params' => array
	        (
	            'csv_export_frontend' => 0,
	            'empty_data_msg' => '',
	            'detaillink' => 0,
	            'rss' => 0,
	            'group_by_order' => '', 
	            'group_by_order_dir' => 'ASC'
	        ),
	
	    'state' => 1,
	    'created_by_alias' => '',
	    'created_by' => 62,
	    'created' => '',
	    'publish_up' => '2007-07-31',
	    'publish_down' => '',
	    'access' => 29,
	    'allow_view_details' => 29,
	    'allow_edit_details' => 29,
	    'allow_add' => 29,
	    'allow_delete' => 29,
	    'connection_id' => 1,
	    'db_table_name' => 'testofpost963_0',
	    'order_by' => '',
	    'order_dir' => 'ASC',
	    'group_by' => '',
	    'link_name' => '',
	    'option' => 'com_fabrik',
	    'task' => 'saveTable',
	    'id' => '',
	    'fabrikid' => '' 
	);
    	
        $oTable = new fabrikTable( $database );
        
        //check if table exists 
		$database->setQuery( "SELECT id FROM #__fabrik_tables WHERE db_table_name = 'testofpost963_0'");
		$id = $database->loadResult();
		if( $id != '' ){
			$oTable->load($id);
	        echo $oTable->deleteTable( true );
		}
        $this->assertTrue( $oTable->save( $aData ) ); 	
	 	
        $aIds = $oTable->_oForm->_getElementIds();
        //make checkbox element
		$database->setQuery("SELECT id FROM #__fabrik_elements WHERE element_name = 'checkbox'");
		$ids = $database->loadResultArray();
		foreach($ids as $i){
			if( in_array( $i, $aIds ) ){
				continue;
			}
		}
		echo "id =$i ";
		$oElement = new fabrikElement( $database );
		$oElement->load($i);
        $oElement->elementtype_id = '3';
    	$oElement->dd_values = '1|2|3|4|5|6|7|8|9|10';
    	$oElement->dd_text = 'One|Two|Three|Four|Five|Six|Seven|Eight|Nine|Ten';
    	$oElement->store();
    	//echo "<pre>";print_r($oElement);echo"</pre>";
        //make validation rule
		$vr = new fabrikValidationRule( $database );
		$vr->validation_rule_label = 'ten checkbox options';
		$vr->validation_rule_expression = '/^[0-9],[0-9],[0-9],[0-9],[0-9]$/';
        $vr->store();
        //make validation
		$v = new fabrikValidation( $database );
		$v->element_id = $oElement->id;
    	$v->validation_rule_id = $vr->id;
    	$v->message = 'Please select 5 options';
  		$v->store();

  		//test going to the table, creating a new record, entering 1 entry and checking that error page is shown

  		$browser = &new SimpleBrowser();
		$browser->addHeader('User-Agent: simpletest'); //needed for login
		$url = $mosConfig_live_site . '/index.php?option=com_fabrik&task=viewTable&tableid=' .  $oTable->id;
		echo $url . "<br>";
		
	    $webPage = $browser->get( $url );
        $this->assertPattern( '/' .  $oTable->label . '/i', $browser->getTitle());
        $this->assertNoPattern('/Parse error/i', $webPage, 'A parse error was encountered');
		
		$this->assertNotEqual($browser->getLink('Add Listing'), false,  "No add listing link found on table");
		$browser->clickLink('Add Listing');
		
		$page = $browser->getContent();
		//
		$this->assertNoPattern('/Sorry this form is unpublished/i', $page, 'The view link shows the message "Sorry this form is unpublished"');
		$browser->clickSubmitByName('Submit');
		
		$page = $browser->getContent();
		$this->assertPattern('/Please select 5 options/i', $page, 'The validation did not work"');
		
		//back on the form so lets tick some boxes

		 $browser->setField('testofpost963_0___checkbox[]', array('1', '2', '3', '4', '5'));
		 $browser->clickSubmitByName('Submit');
		
		$page = $browser->getContent();
		$this->assertNoPattern('/Please select 5 options/i', $page, 'The validation did not succeed when it should have"');
		$this->_tableid = $oTable->id;
	 }
}
?>