<?php

/**
 * @package  fabrik
 * @version 905 | fabrik_cheesegrits | 2008-05-19 21:21:05 +0200 (Mon, 19 May 2008
 * @Copyright (C) Rob Clayburn
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

/* MOS Intruder Alerts */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

/**
 * class displaying admin forms to manage tables
 * @param array contains lists used in showing data
 * @param string element type list
 * @param array data found in uploaded csv file
 * @param string new table name to save to
 * @param string primary key
 * @param int if 0 then no exisiting fabrik table selected if > 0 then refers to the fabrik table id
 */

class html_table_content {
	
	/**
	 * @param int table id
	 */
	function confirmDelete( $id ){
	?>
	<h1><?php echo _DELETE . ' ' . _TABLE ;?></h1>
	<form action="index2.php" method="post" name="adminForm">
		<table class="adminform">
			<tr><td><label>
			<input type="radio" name="deleteMethod" value="0" checked="checked"/>
			<?php echo _DELETE_ONLY_TABLE;?>
		</label></td></tr>
		<tr><td><label>
			<input type="radio" name="deleteMethod" value="1" checked="checked"/>
			<?php echo _DELETE_ALL_TABLE;?>
		</label>
		<input type="hidden" name="cid" value="<?php echo implode(',', $id );?>" /></td></tr>
		<tr><td>
		<input type="submit" name="submit" value="<?php echo _DELETE;?>" />
		<input type="hidden" name="option" value="com_fabrik" />
		<input type="hidden" name="task" value="doDeleteTable" />
		</td></tr>
		</table>
		<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
	</form>
	<?php	
	}
	
	/**
	 * 
	 */
	function csvContinueConfirmation( $lists, $elementTypes, $data, $table, $pKey, $fabrik_table, $dropData ){
		?>
		<h1><?php echo _CVSDATA_AND_FABRIKDATA_MATCH; ?></h1>
		<p><?php echo _CVSDATA_AND_FABRIKDATA_MATCH_DESC; ?></p>
		<form action="index2.php" method="post" name="adminForm">
			<input type="hidden" name="option" value="com_fabrik" /> 
			<input type="hidden" name="table" value="<?php echo $table;?>" /> 
			<input type="hidden" name="fabrik_table" value="<?php echo $fabrik_table;?>" />
			<input type="hidden" name="task" value="makeTableFromCSV" />
			<input type="hidden" name="drop_data" value="<?php echo $dropData;?>" />
			<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
		</form>
	<?php	
	}
	
	function csvChooseElementTypes( $lists, $elementTypes, $data, $table, $pKey, $fabrik_table ){
		;?>
		<h1><?php echo _ASSIGN_ELEMENTTYPES;?></h1>
		<form action="index2.php" method="post" name="adminForm"> 
			<?php if(!empty($lists['newHeadings'])){
				echo "<H3>" . _NEW_HEADINGS_FOUND . "</h3>";
				echo str_replace('{table}', $table, _NEW_HEADINGS_EXPLAINATION);?>

				<table class="adminlist">
					<tr>
						<th class="title"><?php echo _CREATE_ELEMENT;?></th>
						<th class="title"><?php echo _LABEL;?></th>
						<th class="title"><?php echo _VIEWELEMENTS_ELEMENTTYPE;?></th>
						<?php if($pKey == ''){?>
						<th class="title"><?php echo _PRIMARY_KEY;?></th>
						<?php } ?>
						<th><?php echo _SAMPLE_DATA;?></th>
					</tr>
	
					<?php for($i=0;$i<count($lists['newHeadings']);$i++){
					$heading = $lists['newHeadings'][$i];
					foreach($_SESSION['fabrik']['csvImportHeadings'] as $sKey => $sVal){
						if(strtolower($heading) == strtolower($sVal)){
							$sample = $data[0][$sKey];
						}
					}
					?>
				
					<tr>
						<td><label><?php echo _YES;?><input type="radio"
							name="createElements[<?php echo $heading;?>]"
	value="1"></label> <label><?php echo _NO;?><input type="radio"
	name="createElements[<?php echo $heading;?>]" value=")"
	checked="checked"></label>
</td>
<td><?php echo $heading;?></td>
<td><?php echo $elementTypes;?></td>
<?php if($pKey == ''){?>
<td><input type="checkbox" name="key[<?php echo $heading;?>]" value="1" /></td>
<?php } ?>
<td><?php echo $sample;?></td>
</tr>
<?php }?>
</table>

<?php
			}?> <?php 	echo "<H3>" . _EXISTING_HEADINGS_FOUND . "</h3>";?>
<table class="adminlist">
	<tr>
		<th class="title"><?php echo _LABEL;?></th>
		<th class="title"><?php echo _VIEWELEMENTS_ELEMENTTYPE;?></th>
		<?php if($pKey == ''){?>
		<th class="title"><?php echo _PRIMARY_KEY;?></th>
		<?php } ?>
		<th><?php echo _SAMPLE_DATA;?></th>
	</tr>

	<?php for($i=0;$i<count($lists['matchedHeadings']);$i++){
					$heading = $lists['matchedHeadings'][$i];
					foreach($_SESSION['fabrik']['csvImportHeadings'] as $sKey => $sVal){
						if(strtolower($heading) == strtolower($sVal)){
							$sample = $data[0][$sKey];
						}
					}
					?>
	<tr>
		<td><?php echo $heading;?></td>
		<td><?php echo $elementTypes;?></td>
		<?php if($pKey == ''){?>
		<td><input type="checkbox" name="key[<?php echo $heading;?>]"
			value="1" /></td>
		<?php } ?>
		<td><?php echo $sample;?></td>
	</tr>
	<?php }?>
</table>
<input type="hidden" name="option" value="com_fabrik" /> <input
	type="hidden" name="table" value="<?php echo $table;?>" /> <input
	type="hidden" name="fabrik_table" value="<?php echo $fabrik_table;?>" />
	<input type="hidden" name="task" value="makeTableFromCSV" />
	<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
</form>
<?php
	
	}
	/** 
	 * show a summary of the table's forms, groups and elements
	 * @param object form
	 * @param array element group objects
	 */

	function showTableDetail( &$oForm, &$formGroupEls ) {
		echo "<h1 class=\"sectionname\">"._FORM_CREATED_FROM_TABLE."</h1>";
		echo "<h3>"._ADDFORM_TITLE."</h3>";
		echo "<a href=\"index2.php?option=com_fabrik&amp;task=editForm&amp;hidemainmenu=1&amp;cid=$oForm->id\">".$oForm->form_title."</a><br />";
		echo "<h3>"._ELEMENTS."</h3>";
		echo "<table style=\"margin-bottom:50px;\" class=\"adminlist\" width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" >\n";		
		echo "<tr><th class='title'>"._ELEMENT."</th><th class='title'>"._ELEMENT_LABEL."</th><th class='title'>"._GROUP."</th></tr>";
		$k = 1;
		foreach ( $formGroupEls as $el ) {
			$cid = $el->element_id;
			echo "<tr class='sectiontableentry$k row$k'>"
			."<td><a href=\"index2.php?option=com_fabrik&amp;task=editElement&amp;cid=$cid\">$el->element_name</a></td>"
			."<td>"."$el->element_label"."</td><td>"."$el->group_name"."</td></tr>";
			$k = 1 - $k;
		}
		echo "</table>";
	}
	
	/**
	 * show a list of all the tables
	 * @param array of table objects
	 * @param object page navigation
	 * @param array html lists to render
	 */
	 
	function showTables( $rows, $pageNav, $lists ) {
		 global $my;
		 ?>
		 <h1 class="sectionname"><?php echo _VIEWTABLE_HEADING	?></h1>
		 <form action="index2.php" method="post" name="adminForm" id="adminForm" >
		 
		 	<table cellpadding="4" cellspacing="0" border="0" width="100%">
				<tr> 
					<td>
						<?php
						echo _TABLE;
						echo $lists['filter_table'];
						?>
					</td>
				</tr>
			</table>
		
			<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist"> 
				<thead>
				<tr>
					<th width="1%" class="title" > 
						<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $rows );?>);" />
					</th>
					<th class="title" width="1%" >&nbsp;</th>
					<th class="title" width="29%" align="center"><?php echo _TABLE_NAME; ?></th>
					<th class="title" width="50%" align="center"><?php echo _VIEWFORMS_VIEW_DB ;?></th>
					<th class="title" width="5%"><?php echo _PUBLISHED; ?></th>
					<th class="title" width="20%" ><?php echo _VIEW_TABLE_DETAILS; ?></th>
				</tr>
				</thead>
				<?php 			
				$k = 0;
				for ( $i = 0, $n = count( $rows ); $i < $n; $i ++ ) {
					$row = & $rows[$i];
					$checked = fabrikCommonHTML::CheckedOutProcessing( $row, $i );
					$link 	= 'index2.php?option=com_fabrik&amp;task=editTable&amp;hidemainmenu=1&amp;cid='. $row->id;
					?> 
					<tr class="<?php echo "row$k"; ?>">
						<td width="1%"><?php echo $checked;?></td>
						<td width="1%"><?php echo $row->id; ?></td>
						<td width="29%">
							<?php
							if ( $row->checked_out && ( $row->checked_out != $my->id )) {
								echo $row->label;
							} else {
							?>
								<a href="<?php echo $link;?>"><?php echo $row->label; ?></a>
							<?php } ?>
						</td>
						<td width="50%">
							<a href="#view" onclick="return listItemTask('cb<?php echo $i;?>','viewTable');"><?php echo _VIEWFORMS_VIEW_DB;?></a>
						</td>

						<td width="5%">
							<?php if ($row->state == "1") {
								$img = 'publish_g.png';
								$alt = 'Published';
							} else {
								$img = "publish_x.png";
								$alt = 'Unpublished';
							}
							$times = '';
							if (isset ($row->publish_up)) {
								if ($row->publish_up == '0000-00-00 00:00:00') {
									$times .= "<tr><td>Start: Always</td></tr>";
								} else {
									$times .= "<tr><td>Start: $row->publish_up</td></tr>";
								}
							}
							if (isset ($row->publish_down)) {
								if ($row->publish_down == '0000-00-00 00:00:00') {
									$times .= "<tr><td>Finish: No Expiry</td></tr>";
								} else {
									$times .= "<tr><td>Finish: $row->publish_down</td></tr>";
								}
							} ?>
							<a href="javascript: void(0);" onMouseOver="return overlib('<table><?php echo $times; ?></table>', CAPTION, 'Publish Information', BELOW, RIGHT);" onMouseOut="return nd();" onClick="return listItemTask('cb<?php echo $i;?>','<?php echo $row->state ? "unpublishTable" : "publishTable";?>')">
							<img src="images/<?php echo $img;?>" width="12" height="12" border="0" alt="<?php echo $alt; ?>" />
						</td>
						
						<td width="20%" >
							<a href="#showlinkedelements" onclick="return listItemTask('cb<?php echo $i;?>','showlinkedelements');"><?php echo _VIEW_TABLE_DETAILS;?></a>
						</td>			
					</tr> 
					<?php $k = 1 - $k;
				} ?> 
				<tfoot>
				<td colspan="6">
					<?php echo $pageNav->getListFooter(); ?>
				</td>
				</tfoot>
			</table>
		<input type="hidden" name="option" value="com_fabrik" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="task" value="tables" />
		<input type="hidden" name="hidemainmenu" value="0" />
		<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
	</form>		
	<?php
	}

	/**
	 * either edit an existing table or add a new one
	 * @param object table 
	 * @param array the drop down lists used on the form
	 * @param object tabs
	 * @param array connection tables
	 * @param object menus
	 * @param string compoent action
	 * @param int form id that the table links to?
	 * @param object parameters
	 */

	function editTable( $row, $lists, $tabs, $connectionTables, &$menus, $fabrikid, $params ) {
		global $mosConfig_live_site;
		mosMakeHtmlSafe( $row );
		?> 
		<script language="javascript" type="text/javascript">
			<!--
			var connectiontables = new Array;
			<?php
			$i = 0;
			if( is_array( $connectionTables ) ){
				foreach ( $connectionTables as $k => $items ) {
					foreach ( $items as $v ) {
						echo "connectiontables[".$i ++."] = new Array( '$k','".addslashes($v->value)."','".addslashes($v->text)."' );\n\t\t";
					}
				}
			}
			?>
			function submitbutton(pressbutton){
				if (pressbutton == 'cancelTable') {
					submitform( pressbutton );
					return;
				}
				var err = "";
				var form = document.adminForm;
				if(pressbutton == 'menuLinkTable'){
					if(form.menuselect.selectedIndex == -1){
						err = err + "<?php echo _PLEASE_SELECT_A_MENU;?>\n";
					}
					if($('link_name').value == ''){
						err = err + "<?php echo _PLEASE_ENTER_A_MENU_LABEL; ?>\n";
					}
				}
				<?php getEditorContents( 'editor1', 'introduction' ) ; ?>
				
				if($('label').value == ''){
					err = err +"<?php echo _ADDTABLE_ERR_LABEL; ?>\n";
				}			
			
				if($('connection_id')){
					if($('connection_id').value == '-1'){
						err = err +"<?php echo _ADDTABLE_ERR_CONNECTION; ?>\n";
					}
				}			
				
				if($('tablename')){
					if($('tablename').value == '' || $('tablename').value == '-1'){
						err = err + "<?php echo _ADDTABLE_ERR_DATABASE; ?>\n";
					}	
				}
						
				if (err == ""){
					submitform( pressbutton );
				}else{
					alert (err);
				}
			}
			joinCounter = 0;
		
			adminFilters = new Class({
				initialize: function( el, fields ) {
					this.el = $(el);
					this.fields = fields;
					this.filters = new Array();
					this.counter = 0;
					this.onDeleteClick = this.deleteFilterOption.bindAsEventListener(this);
				},
				
			addHeadings: function(){
	 			var tr = new Element('tr', {'class': 'title','id':'filterTh'});
	 			
	 			var th = new Element('th', {}).appendText('<?php echo  _JOIN; ?>');
	 			tr.appendChild(th);
	 			var th = new Element('th', {}).appendText('<?php echo  _FIELD; ?>');
	 			tr.appendChild(th);
	 			var th = new Element('th', {}).appendText('<?php echo  _CONDITION; ?>');
	 			tr.appendChild(th);
	 			var th = new Element('th', {}).appendText('<?php echo  _VALUE . " (" . _EVAL . ")"; ?>');
	 			tr.appendChild(th);
	 			
	 			var th = new Element('th', {});
	 			var span = new Element('span', {'class':'editlinktip'});
	 			var span2 = new Element('span', {
	 			'events': {
					'mouseout': function(){
					    return nd();
					},
					'mouseover': function(){
					    return overlib('<?php echo _APPLY_FILTER_TO_DESC;?>', CAPTION, '<?php echo _APPLY_FILTER_TO; ?>', BELOW, RIGHT);
					}
			    }
	 			}).appendText('<?php echo _APPLY_FILTER_TO; ?>');
	 			
	 			span.appendChild(span2);
	 			th.appendChild(span)
	 			tr.appendChild(th);
	 			
	 			var th = new Element('th', {}).appendText('<?php echo  _DELETE; ?>');
	 			tr.appendChild(th);
	 			
				tr.injectTop(this.el);
			},
				
			deleteFilterOption: function( e ){
				var event = new Event(e);
				var element = event.target;
				$(element.id).removeEvent( "click", this.onDeleteClick );
	        	var tr = element.parentNode.parentNode;
	        	var table = tr.parentNode;
	        	table.removeChild(tr);
	        	this.counter --;
	        	if(this.counter == 0){
	        		var th = $('filterTh');
	        		table.removeChild(th);
	        	}
				event.stop();
			},
			
			addFilterOption: function( selJoin, selFilter, selCondition, selValue, selAccess, eval, override ){
				if(this.counter <= 0){
					this.addHeadings();
				}
				var selJoin = selJoin ? selJoin : '';
				var selFilter = selFilter ? selFilter : '';
				var selCondition = selCondition ? selCondition : '';
				var selValue = selValue ? selValue : '';
				var selAccess = selAccess ? selAccess : '';
				//$$$ rob set override to true to allow it to be overridden by url filters (&foo[bar]=foo)
				var override = override ? override : false;

				if( this.counter == 0){
					var joinDd = 'WHERE <input type="hidden" name="params[filter-join][]" value="where" />';
				}else{
					var joinDd = '<?php	echo $row->getFilterJoinDd( true, 'params[filter-join][]');?>';
				}
				var conditionsDd = '<?php echo $row->getFilterConditionDd( true, 'params[filter-conditions][]', 2);	?>';					

				var tr = new Element('tr');
				var td = new Element('td');
				td.innerHTML = joinDd;
				var td1 = new Element('td');
				td1.innerHTML = this.fields;
				var td2 = new Element('td');
				td2.innerHTML = conditionsDd;
				var td3 = new Element('td');
				var checked =(eval == "on") ? true : false;
				var box = new Element('input', {'type':'checkbox', 'id':'eval_' + this.counter, 'name':'params[filter-eval][]','checked':checked });
				
				//create eval box
				//alert('eval:' + eval);
				var nochecked =(eval == "off") ? 'checked' : '';
				var opts1 = {'type':'radio','value':'off','checked':nochecked, 'id':'eval_no_' + this.counter, 'name':'params[filter-eval]['+this.counter+'][]'};
				
				var yeschecked =(eval == "on") ? 'checked' : '';
				var opts2 = {'type':'radio','value':'on','checked':yeschecked, 'id':'eval_yes_' + this.counter, 'name':'params[filter-eval]['+this.counter+'][]'};
				
				//$$$ hugh - adding 'subquery'
				//var sqchecked =(eval == "subquery") ? 'checked' : '';
				var sqchecked =(eval == "subquery") ? true : false;
				var opts3 = {'type':'radio','value':'subquery','checked':sqchecked, 'id':'eval_subquery_' + this.counter, 'name':'params[filter-eval]['+this.counter+'][]'};
				//alert('eval:' + eval + ' ' + ' no:' + nochecked + ' yes: ' + yeschecked + 'sq: ' + sqchecked);			
				var box = new Element('span').adopt([
					new Element('span').appendText('<?php echo   _EVAL; ?>: '),
					new Element('input', opts1),
					new Element('label', {'for':'eval_no_' + this.counter}).appendText('No'),
					new Element('input', opts2),
					new Element('label', {'for':'eval_yes_' + this.counter}).appendText('Yes'),
					new Element('input', opts3),
					new Element('label', {'for':'eval_subquery_' + this.counter}).appendText('Subquery')
				])
				
			
				//end 
				var td4 = new Element('td');
				td4.innerHTML = '<?php echo addslashes( str_replace(array("\n", "\r"), '', $lists['filter-access'] ) );?>';
				
				var nochecked =(override == "1") ? '' : 'checked';
				var opts1 = {'type':'radio','value':'0','checked':nochecked, 'id':'overide_no_' + this.counter, 'name':'params[filter-override]['+this.counter+'][]'};
				
				var yeschecked =(override == "1") ? '' : 'checked'; //$$$rob doesnt work in ie
				var opts2 = {'type':'radio','value':'1','checked':yeschecked, 'id':'overide_yes_' + this.counter, 'name':'params[filter-override]['+this.counter+'][]'};
				var span = new Element('span').adopt([
					new Element('br'),
					new Element('span').appendText('Overridden by url filter'),
					new Element('br'),
					new Element('input', opts1),
					new Element('label', {'for':'overide_no_' + this.counter}).appendText('No'),
					new Element('input',opts2),
					new Element('label', {'for':'overide_yes_' + this.counter}).appendText('Yes')
				])
				span.injectInside(td4);
				
				var td5 = new Element('td');
		
				var textArea = new Element('textarea', {'name':'params[filter-value][]', 'cols':17, 'rows':4 }).appendText(selValue);
				td3.appendChild(textArea);
				td3.appendChild(new Element('br'));
				td3.appendChild(box);
			
				var delId = this.el.id + "-del-" + this.counter;
				var a = new Element('a', {href:'#', 'id':delId});
				a.appendText('[-]');
				td5.appendChild(a);
				tr.appendChild(td);
				tr.appendChild(td1);
				tr.appendChild(td2);
				tr.appendChild(td3);
				tr.appendChild(td4);
				tr.appendChild(td5);
			
				this.el.appendChild(tr);
				
				if(eval == "on"){
					$('eval_yes_' + this.counter).checked = 'checked';
				}
				else if (eval == "subquery") {
					$('eval_subquery_' + this.counter).checked = 'checked';					
				}
				else{
					$('eval_no_' + this.counter).checked = 'checked';
				} 
				
				if(override == "1"){
					$('overide_yes_' + this.counter).checked = 'checked';
				}else{
					$('overide_no_' + this.counter).checked = 'checked';
				} 

				if( selJoin!='' || selFilter!='' || selCondition!='' || selValue!=''){
					var checked = true;
				}else{
					var checked = false;
				}
				
				$(this.el.id + "-del-" + this.counter).addEvent( "click", this.onDeleteClick);
				
				/*set default values*/ 
				if( selJoin != '' ){
					var sels = $A(td.getElementsByTagName('SELECT'));
					if(sels.length >= 1){
						for(i=0;i<sels[0].length;i++){
							if(sels[0][i].value == selJoin){
								sels[0].options.selectedIndex = i;
							}
						}
					}
				}
				if( selFilter != '' ){
					var sels = $A(td1.getElementsByTagName('SELECT'));
					if(sels.length >= 1){
						for(var i=0;i<sels[0].length;i++){
							if(sels[0][i].value == selFilter){
								sels[0].options.selectedIndex = i;
							}
						}
					}
				}				

				if( selCondition != '' ){
					var sels = $A(td2.getElementsByTagName('SELECT'));
					if(sels.length >= 1){
						for(var i=0;i<sels[0].length;i++){
							if(sels[0][i].value == selCondition){
								sels[0].options.selectedIndex = i;
							}
						}
					}
				}	
				
				if( selAccess != '' ){
					var sels = $A(td4.getElementsByTagName('SELECT'));
					if(sels.length >= 1){
						for(var i=0;i<sels[0].length;i++){
							if(sels[0][i].value == selAccess){
								sels[0].options.selectedIndex = i;
							}
						}
					}
				}					
				
				this.counter ++;	
				
			}
		});

		//-->
		</script>
		<h1 class="sectionname">
		<?php
		echo $row->id ? _EDIT : _ADD;
		echo _ADD_TABLE_TITLE
		?>
		</h1>
<form action="index2.php" method="post" name="adminForm"><?php 
		if( $row->db_primary_key == "" && $row->id != '' ){
				echo "<p class='warning'>" . _PLEASE_CREATE_PRIMARY_KEY . "</p>";
		}?>
<table style="width:100%">
	<tr>
		<td style="width:50%" valign="top">
		<table cellpadding="4" cellspacing="0" border="0" width="100%"
			class="adminform">
			<tr>
				<td><label for="label"><?php echo _LABEL; ?></label></td>
				<td><input class="inputbox" type="text" id="label" name="label"
					size="50" value="<?php echo $row->label?>" /></td>
			</tr>
			<tr>
				<td><?php echo _INTRODUCTION; ?></td>
				<td><?php editorArea('editor1', $row->introduction, 'introduction', '100%;', '200', '75', '20');
				?></td>
			</tr>
			<tr>
				<td><?php echo _TEMPLATE; ?></td>
				<td><?php print_r($lists['tableTemplates']); ?></td>
			</tr>
			<tr>
				<td><label for="rows_per_page"><?php echo _ROWS_PER_PAGE; ?></label></td>
				<td><input type="text" name="rows_per_page" id="rows_per_page"
					class="inputbox" value="<?php echo $row->rows_per_page; ?>"
					size="3" /></td>
			</tr>
			<?php 
			echo $params->renderSingleParam('allow-data-translation');
			echo $params->renderSingleParam('show-table-nav');
			echo $params->renderSingleParam('empty_data_msg');
			echo $params->renderSingleParam('detaillink');
			echo $params->renderSingleParam('detailurl');
			?>
			<tr>
				<th colspan="2"><?php echo _FILTER;?></th>
			</tr>
			<?php echo $params->renderSingleParam('allow-filters');
			echo $params->renderSingleParam('advanced-filter');?>
			<tr>
				<td><?php echo _FILTER_TRIGGER; ?></td>
				<td><?php echo $lists['filter_action']; ?></td>
			</tr>
		</table>
		</td>
		<td valign="top"><?php
					$tabs->startPane("content-pane");
					$tabs->startTab(_PUBLISHING, "publish-page"); ?>
		<table class="adminform">
			<tr>
				<th colspan="2"><?php echo _PUBLISHING_INFO; ?></th>
			</tr>
			<tr>
				<td valign="top" align="right"><label for="publishtable"><?php echo _PUBLISHED; ?>:</label>
				</td>
				<td><input type="checkbox" id="publishtable" name="state" value="1"
				<?php echo $row->state ? 'checked="checked"' : ''; ?> /></td>
			</tr>
			<tr>
				<td valign="top" align="right"><label for="created_by_alias"><?php echo _AUTHOR_ALIAS; ?>:</label>
				</td>
				<td><input type="text" id="created_by_alias" name="created_by_alias"
					size="30" maxlength="100"
					value="<?php echo $row->created_by_alias; ?>" class="text_area" />
				</td>
			</tr>
			<tr>
				<td valign="top" align="right"><?php echo _CHANGE_CREATOR; ?>:</td>
				<td><?php echo $lists['created_by']; ?></td>
			</tr>
			<tr>
				<td valign="top" align="right"><label for="created"><?php echo _OVERRIDE_CREATE_DATE ;?></label>
				</td>
				<td><input class="text_area" type="text" name="created" id="created"
					size="25" maxlength="19" value="<?php echo $row->created; ?>" /> <input
					name="reset" type="reset" class="button"
					onClick="return showCalendar('created', 'y-mm-dd');" value="..." />
				</td>
			</tr>
			<tr>
				<td valign="top" align="right"><label for="publish_up"><?php echo _START_PUBLISHING; ?>:</label>
				</td>
				<td><input class="text_area" type="text" name="publish_up"
					id="publish_up" size="25" maxlength="19"
					value="<?php echo $row->publish_up; ?>" /> <input type="reset"
					class="button" value="..."
					onClick="return showCalendar('publish_up', 'y-mm-dd');" /></td>
			</tr>
			<tr>
				<td valign="top" align="right"><label for="publish_down"><?php echo _FINISH_PUBLISHING; ?>:</label>
				</td>
				<td><input class="text_area" type="text" name="publish_down"
					id="publish_down" size="25" maxlength="19"
					value="<?php echo $row->publish_down; ?>" /> <input type="reset"
					class="button" value="..."
					onClick="return showCalendar('publish_down', 'y-mm-dd');" /></td>
			</tr>
			<tr>
				<th colspan="2"><?php echo _CSV_OPTIONS;?></th>
			</tr>
			<?php
			echo $params->renderSingleParam('csv_export_frontend');
			echo $params->renderSingleParam('csvfullname');
			?>
			<tr>
				<th colspan="2"><?php echo _RSS_TITLE; ?></th>
			</tr>
			<?php echo $params->renderSingleParam('rss'); 
			echo $params->renderSingleParam('rsslimit');
			echo $params->renderSingleParam('rsslimitmax');
			?>
			<tr>
				<td><?php echo _RSS_FEED_TITLE; ?></td>
				<td><?php echo $lists['feed_title']; ?></td>
			</tr>
			<tr>
				<td><?php echo _RSS_FEED_DATE; ?></td>
				<td><?php echo $lists['feed_date']; ?></td>
			</tr>
			
		</table>
		<?php
		$tabs->endTab( );
		$tabs->startTab( _ACCESS, "access-page" ); ?>
		<table class="adminform">
			<tr>
				<th colspan="2"><?php echo _ACCESS; ?></th>
			</tr>
			<tr>
				<td><?php echo _TABLE_ACCESS; ?></td>
				<td><?php echo $lists['access']; ?></td>
			</tr>
			<tr>
				<td><?php echo _TABLE_VIEW_ACCESS; ?></td>
				<td><?php echo $lists['allow_view_details']; ?></td>
			</tr>
			<tr>
				<td><?php echo _TABLE_EDIT_ACCESS; ?></td>
				<td><?php echo $lists['allow_edit_details']; ?></td>
			</tr>
			<tr>
				<td><?php echo _TABLE_ADD_ACCESS; ?></td>
				<td><?php echo $lists['allow_add']; ?></td>
			</tr>
			<tr>
				<td><?php echo _TABLE_DELETE_ACCESS; ?></td>
				<td><?php echo $lists['allow_delete']; ?></td>
			</tr>
			<tr>
				<td>
				<span onmouseover="return overlib('<?php echo EMPTYPBUTTONDESC;?>', CAPTION, '<?php echo EMPTYPBUTTON;?>', BELOW, RIGHT);" onmouseout="return nd();">
				<?php echo EMPTYPBUTTON; ?>
				</span></td>
				<td><?php echo $lists['allow_empty']; ?></td>
			</tr>
		</table>
		<?php
					$tabs->endTab( );
					$tabs->startTab( _DATA, "tabledata-page" ); ?>
		<table class="adminform">
			<tr>
				<th colspan="2"><?php echo _DATA; ?></th>
			</tr>
			<tr>
				<td><?php echo _TABLE_CONNECTION; ?></td>
				<td><?php echo $lists['connections']; ?></td>
			</tr>
			<tr>
				<td><?php echo _TABLE_TABLE_NAME; ?></td>
				<td><?php echo $lists['tablename']; ?></td>
			</tr>
			<?php if($row->id <> ''){ ?>
			<tr>
				<td><label for="db_primary_key"><?php echo _PRIMARY_KEY; ?></label>
				<a href="#"
					onmouseover="return overlib('<?php echo (_PRIMARY_KEY_LONG); ?>', CAPTION, '<?php echo _PRIMARY_KEY;?>', BELOW, RIGHT);"
					onmouseout="return nd();"><img
					src="<?php echo $mosConfig_live_site; ?>/includes/js/ThemeOffice/tooltip.png"
					border="0" /></a></td>
				<td><?php echo $lists['db_primary_key'];?></td>
			</tr>
			<tr>
				<td><label for="auto_inc"><?php echo _AUTO_INCREMENT; ?></label></td>
				<td><input type="checkbox" name="auto_inc" id="auto_inc" value="1"
				<?php echo $row->auto_inc ? 'checked="checked"' : ''; ?> /></td>
			</tr>
			<?php } ?>
			<tr>
				<td><label for="order_by"><?php echo _ORDER_BY; ?></label></td>
				<td id="orderByTd"><?php echo $lists['order_by']; ?></td>
			</tr>
			<tr>
				<td><?php echo _ORDER_DIRECTION; ?></td>
				<td><?php echo $lists['order_dir']; ?></td>
			</tr>
			<tr>
				<th colspan="2"><?php echo _GROUP_BY; ?></th>
			</tr>
			<tr>
				<td><label for="group_by"><?php echo _GROUP_BY; ?></label></td>
				<td id="groupByTd"><?php echo $lists['group_by'];?></td>
			</tr>
			<tr>
				<td><label for="params[group_by_order]"><?php echo _GROUP_BY_ORDER; ?></label></td>
				<td id="groupByOrderTd"><?php echo $lists['group_by_order'];?></td>
			</tr>
			<tr>
				<td><?php echo _GROUP_BY_ORDER_DIRECTION; ?></td>
				<td><?php echo $lists['group_by_order_dir']; ?></td>
			</tr>
			<tr>
				<th colspan="2"><span class="editlinktip"> <span
					onmouseout="return nd();"
					onmouseover="return overlib('<?php echo _PREFILTER_INFO; ?>', CAPTION, '<?php echo _PREFILTER; ?>', BELOW, RIGHT);">
				<?php echo _PREFILTER; ?> </span> </span></th>
			</tr>
			<tr>
				<td nowrap="true" colspan="2"><a href="#"
					onclick="myAdminFilters.addFilterOption(); return false;"><?php echo _ADD_FILTER; ?></a>
				</td>
			</tr>
			<tr>
				<td colspan="2">
				<table width="100%">
					<tbody id="filterContainer">

					</tbody>
				</table>
				</td>
			</tr>
		</table>

		<table table class="adminform">
			<tr>
				<th colspan="5"><?php echo _TABLE_JOINS ;?></th>
			</tr>
			<?php if($row->id != 0){ 
								/* if not a new table */ 
							?>
			<tr>
				<td nowrap="true" colspan="5"><a href="#"
					onclick="addJoin(); return false;"><?php echo _ADD_JOIN; ?></a></td>
			</tr>
			<tr>
				<td id="joindtd" colspan="5"></td>
			</tr>
			<?php 
							}else{
								echo "<tr><td colspan='5'>" . _JOINS_CREATED_AFTER_TABLE_SAVED . "</td></tr>";
								}
							?>
			<tr>
				<th colspan="5"><span class="editlinktip"> <span
					onmouseover="return overlib('<?php echo _LINKS_TO_THIS_TABLE_LONG; ?>', CAPTION, '<?php echo _LINKS_TO_THIS_TABLE; ?>', BELOW, RIGHT);"
					onmouseout="return nd();"> <?php echo _LINKS_TO_THIS_TABLE; ?> </span></span>
				</th>
			</tr>
			<tr>
				<td><?php echo _TABLE;?></td>
				<td><?php echo _LINK_TO_TABLE;?></td>
				<td><?php echo _LABEL;?></td>
				<td><?php echo _LINK_TO_FORM;?></td>
				<td><?php echo _LABEL;?></td>
			</tr>
			<?php foreach( $lists['linkedtables'] as $linkedTable ){?>
			<tr>
				<td><span class="editlinktip"> <span
					onmouseover="return overlib('table:<?php echo $linkedTable[1]; ?>', CAPTION, '<?php echo $linkedTable[0]; ?>', BELOW, RIGHT);"
					onmouseout="return nd();"> <?php echo $linkedTable[1]; ?> </span></span>
				</td>
				<td><?php echo $linkedTable[2]; ?></td>
				<td><?php echo $linkedTable[3]; ?></td>
				<td><?php echo $linkedTable[4]; ?></td>
				<td><?php echo $linkedTable[5]; ?></td>
			</tr>
			<?php } ?>
			<tr>
		
		</table>
		<?php
					$tabs->endTab( );
					$tabs->startTab( _LINK_TO_MENU, "linktomenu-page" ); ?>
		<table class="adminform">
			<tr>
				<th colspan="2"><?php echo _LINK_TO_MENU; ?></th>
			</tr>
			<tr>
				<td><?php echo _SELECT_MENU; ?>
				
				
				<td><?php echo $lists['menuselect']; ?></td>
			</tr>
			<tr>
				<td valign="top"><label for="link_name"><?php echo _MENU_ITEM_NAME; ?></label></td>
				<td><input type="text" id="link_name" name="link_name"
					class="inputbox" value="" size="30" /></td>
			</tr>
			<tr>
				<td colspan="2"><input name="menu_link" type="button" class="button"
					value="<?php echo _LINK_TO_MENU; ?>"
					onClick="submitbutton('menuLinkTable');" /></td>
			</tr>
			<tr>
				<th colspan="2"><?php echo _EXISTING_MENU_LINKS; ?></th>
			</tr>
			<?php if ($menus == NULL) { ?>
			<tr>
				<td colspan="2"><?php echo _MS_NONE; ?></td>
			</tr>
			<?php
							} else {
								menuLinksContent($menus, 'Table');
							}?>
			<tr>
				<td colspan="2"></td>
			</tr>
		</table>
		<?php
				$tabs->endTab();
				$tabs->endPane(); ?></td>
	</tr>
</table>
<input type="hidden" name="option" value="com_fabrik" /> <input
	type="hidden" name="task" value="saveTable" /> <input type="hidden"
	name="id" value="<?php echo $row->id;?>" /> <input type="hidden"
	name="fabrikid" value="<?php echo $fabrikid; ?>" />
	<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
	</form>
<script type="text/javascript">
	
	function buildJoins(){
        	<?php
		if( array_key_exists( 'joins', $lists ) ){
			for ($i = 0; $i < count($lists['joins']); $i ++) {
				$j = $lists['joins'][$i];
				?>
				addJoin(<?php echo "'" . $j->group_id . "','" . $j->id . "','" . str_replace("\n", "", $j->join_type) . "','" . 
				str_replace("\n", "", $j->table_join) . "','" . $j->table_key . "','" . $j->table_join_key  . "','" . 
				str_replace("\n", "", $j->join_from_table) . "'"; ?>);												 
			<?php } 
			
		}else{ 
		/* no joins but make default */
			
		}?>  
	}
			    
	function addJoin(groupId, joinId, joinTypeDd, joinTableDd, thisKey, joinKey, joinFromTable){
		var defaultJoinTypeDd = '<?php echo str_replace("\n", "", $lists['jointypes']);?>';
		var defaultTableDd = '<?php echo str_replace("\n", "", $lists['defaultJoinTalbes']);?>';
		var defaultJoinTableFrom = '<?php echo str_replace("\n", "", $lists['defaultJoinTableFrom']);?>';
		var joinId = joinId ? joinId : '';
           var thisKey = thisKey ? thisKey : '';
           var joinKey = joinKey ? joinKey : '';
           var joinTypeDd = joinTypeDd ? joinTypeDd : defaultJoinTypeDd;
           var joinFromTable = joinFromTable ? joinFromTable : defaultJoinTableFrom;
           var joinTableDd = joinTableDd ? joinTableDd : defaultTableDd;
           var groupId = groupId ? groupId : '';
		
		var sContent = 
			'<table class="adminform" id="join' + joinCounter + '">'
			+ '<tr>'
			+ '<td><?php echo _JOIN_TYPE; ?>'
			+ '<input type="hidden" name="join_id[]" value="' + joinId + '" />' 
			+ '<input type="hidden" name="group_id[]" value="' + groupId + '" />' 
			+'</td>' 
			+'<td>'
			+ joinTypeDd 
			+'</td><tr>'
			+ '<tr>'
			+ '<td><?php echo _JOIN_FROM_TABLE; ?>'
			+'</td>' 
			+'<td>'
			+ joinFromTable 
			+'</td><tr>'					
			+ '<tr>'
			+ '<td><?php echo _JOIN_TO_TABLE; ?></td>' 
			+'<td>'
			+ joinTableDd 
			+'</td><tr>'					
			+ '<tr><td><?php echo _JOIN_THIS_TABLES_ID_COLUMN; ?></td>' 
			+'<td id="joinThisTableId">'
			+ '<input type="text" name="table_key[]" value="' + thisKey + '" class="inputbox" size="30" />'
			+' </td>'
			+'</tr>'
			+ '<tr><td><?php echo _JOIN_JOIN_TABLES_ID_COLUMN; ?></td>' 
			+'	<td  id="joinJoinTableId">'
			+ '<input type="text" name="table_join_key[]" value="' + joinKey + '" class="inputbox" size="30" />'
			+' </td>'
			+'</tr>'					
			+'<tr>'
			+	'<td colspan="2"><a href="#" onclick="deleteJoin(\'join'+joinCounter+'\');"><?php echo _DELETE; ?></a></td>'
			+ '</tr>'					
			+'</table>';					          	


		var oNewBody = $('joindtd');
		var oNew = document.createElement('div');
		oNew.innerHTML = sContent;
		
		oNewBody.appendChild(oNew.firstChild , oNewBody.childNodes[0]);
		joinCounter++;
	}     	
	
	function deleteJoin(sTagId){
		var oNode = $(sTagId);
      		oNode.parentNode.removeChild(oNode);
	}
			
			
	(window).addEvent( 'load', function(e){
			myAdminFilters = new adminFilters( 'filterContainer', "<?php echo addslashes( str_replace(array("\n", "\r"), '', $lists['filter-fields']) );?>" );
			<?php 
			$afilterJoins 		= $params->get('filter-join', '', 'array'); 
			$afilterFields 		= $params->get('filter-fields', '', 'array');
			$afilterConditions 	= $params->get('filter-conditions', '', 'array');
			$afilterEval	 	= $params->get('filter-eval', '', 'array');
			$afilterValues 		= $params->get('filter-value', '', 'array');
			$afilterAccess 		= $params->get('filter-access', '', 'array');
			$aFilterOverride =$params->get('filter-override', '', 'array');
			for($i=0;$i<count($afilterJoins);$i++){
				$selJoin 	  = $afilterJoins[$i];
				$selFilter 	  = $afilterFields[$i];
				$selCondition = $afilterConditions[$i];
				$filerEval	  = ( array_key_exists( $i, $afilterEval )) ? 	$afilterEval[$i] : ""; 
				$override		= $aFilterOverride[$i];
			
				if($selCondition == '&gt;'){ $selCondition = '>';}
				if($selCondition == '&lt;'){ $selCondition = '<';}
				$selValue 	  = $afilterValues[$i];
				$selAccess 	  = $afilterAccess[$i];
				//alow for multiline js variables 
				$selValue = htmlspecialchars_decode( $selValue, ENT_QUOTES );
				$selValue = FastJSON::encode($selValue);
				if($selFilter != ''){
					echo "var selValue = ($selValue);\n";
					echo "myAdminFilters.addFilterOption( '$selJoin', '$selFilter', '$selCondition', $selValue, '$selAccess', '$filerEval', '$override' );\n";
				}
			}?>
		buildJoins();
		watchJoins();
		
	});
	
	function watchJoins(){
		//$A(document.getElementsByClassName('join_from')).each(function(dd){
		$$('*').filterByClass('join_from').each(function(dd){
		(dd).addEvent( 'change', function(e){
			var event = new Event(e);
			var sel = event.target.parentNode.parentNode.parentNode.parentNode;
			var joinCounter = sel.id.replace('join', '');
			//updateJoinStatement(joinCounter);
			var table = event.target.getValue();
			var conn = $('connection_id').getValue();
				var url = 'index3.php?option=com_fabrik&no_html=1&task=ajax_loadTableDropDown&table=' + table + '&conn=' + conn;
				var myAjax = new Ajax(url, {
				options :{
					option:'com_fabrik',
			  		no_html:true,
			  		task: 'ajax_loadTableDropDown',
			  		table: table
				},
				onComplete:function(res){
					$('joinThisTableId' + joinCounter).innerHTML = res;
					watchFieldList('table_key[]');
				}}
				);
				myAjax.request();
			});
		});	
		
		//$A(document.getElementsByClassName('join_to')).each(function(dd){
		$$('*').filterByClass('join_to').each(function(dd){
			dd.addEvent( 'change', function(e){
				var event = new Event(e);
				var sel = event.target.parentNode.parentNode.parentNode.parentNode;
				var joinCounter = sel.id.replace('join', '');
				//updateJoinStatement(joinCounter);
				var table = event.target.getValue();
				var conn = $('connection_id').getValue();
				var url = 'index3.php?name=table_join_key[]&option=com_fabrik&no_html=1&task=ajax_loadTableDropDown&table=' + table + '&conn=' + conn;
				var myAjax = new Ajax(url, {
				options :{
					option:'com_fabrik',
			  		no_html:true,
			  		task: 'ajax_loadTableDropDown',
			  		table: table
				},
				onComplete:function(res){
					$('joinJoinTableId' + joinCounter).innerHTML = res;
					watchFieldList('table_key[]');
				}}
				);
				myAjax.request();
			});
		});	
	
		watchFieldList('join_type[]');
		watchFieldList('table_join_key[]');
		watchFieldList('table_key[]');
	}
	

	if($('tablename')){
		$('tablename').addEvent( 'change', function(e){
			var cid = $('connection_id').getValue();
			var table = $('tablename').getValue();
			var url = 'index3.php?option=com_fabrik&no_html=1&task=ajax_updateColumDropDowns&cid=' + cid + '&table=' + table;
			var myAjax = new Ajax(url, {
			onComplete:function(res){
				eval(res)
			}}
			);
			myAjax.request();
				
		});
	};
	
	function watchFieldList(name){
		$A(document.getElementsByName(name)).each(function(dd){
			dd.addEvent( 'change', function(e){
				var event = new Event(e);
				var sel = event.target.parentNode.parentNode.parentNode.parentNode;
				var joinCounter = sel.id.replace('join', '');
				//updateJoinStatement(joinCounter);
			});
		});	
	}

	</script>
<?php
	}

	/**
	 * export table settings
	 */
	 
	function exportSettings( $rows )
	{
	 	echo "<h1 class=\"sectionname\">" . _EXPORT_TABLES_HEADING . "</h1>";
	 	echo "<p>" . _EXPORT_TABLES_INTRO_1 . "</p>";
	 	echo "<ul>";
	 	foreach ($rows as $oTable) {
	 		echo "<li>" . $oTable->label . "</li>";	
	 	}
	 	echo "</ul>";
	 	echo "<p>" . _EXPORT_TABLES_INTRO_2 . "</p>";
	 	?>
	 	<form action="index3.php" method="post" name="adminForm">
	 	<?php 
	 	foreach ($rows as $oTable) {
	 		echo "<input type='hidden' name='cid[]' value='" . $oTable->id . "' />";	
	 	}
	 	?>
	 	<table cellpadding="4" cellspacing="0" border="0" width="100%"  class="adminform">
	 		<tr>
	 			<th colspan="2"><?php echo _FORMAT ;?></th>
	 		</tr>
	 		<tr>
	 			<td><?php echo _FORMAT ;?></td>
	 			<td>
	 				<label><input class="inputbox" checked="checked" type="radio" name="format" value="xml" />xml</label>
	 				<!--<label><input class="inputbox" type="radio" name="format" value="sql" />csv</label>-->
	 			</td>
	 		</tr>
	 		<tr>
	 			<td><?php echo _LABEL ;?></td>
	 			<td>
	 				<label><input class="inputbox" name="label" value="" /></label>
	 			</td>
	 		</tr>
	 		
	 		<tr>
	 			<th colspan="2"><?php echo _OPTIONS ;?></th>
	 		</tr>
	 		
	 		<!--<tr>
	 			<td><label for="joins"><?php echo _EXPORT_JOINS ;?></label></td>
	 			<td><input class="inputbox" type="checkbox" id="joins" name="joins" value="1" /></td>
	 		</tr>-->
	 		<tr>
	 			<td><label for="fabrikfields"><?php echo _EXPORT_FABRIK_FIELDS ;?></label></td>
	 			<td><input class="inputbox" type="checkbox" name="fabrikfields" id="fabrikfields" value="1" /></td>
	 		</tr>
	 		<tr>
	 			<td><label for="tabledata"><?php echo _EXPORT_TABLE_STRUCTURE ;?></label></td>
	 			<td><input class="inputbox" type="checkbox" id="tablestructure" name="tablestructure" value="1" /></td>
	 		</tr>
	 		<tr>
	 			<td><label for="tabledata"><?php echo _EXPORT_TABLE_DATA ;?></label></td>
				<td><input class="inputbox" type="checkbox" id="tabledata" name="tabledata" value="1" /></td>
			</tr>
			<tr>
	 			<td><label for="tabledata"><?php echo _ADD . " " . _TEMPLATES ;?></label></td>
	 			<td><input class="inputbox" type="checkbox" id="inctempaltes" name="inctempaltes" value="1" /></td>
	 		</tr>
	 	</table>
	 	<input type="hidden" name="option" value="com_fabrik" /> 
		<input type="hidden" name="task" value="doexportTable" />
		<input type="hidden" name="no_html" value="1" />
		<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
	</form>
	 	<?php 
	 }
	 
	 /**
	  * show the upload page where you can import preiously exported xml tables
	  */
	  
	 function importTables( $lists ){
	 	?>
		<script language="javascript" type="text/javascript">
		function submitbutton3(pressbutton) {
			var form = document.adminForm_dir;

			/* do field validation */
			if (form.userfile.value == ""){
				alert( "<?php echo _PLEASE_SELECT_A_PACKAGE_FILE;?>" );
			} else {
				form.submit();
			}
		}
		</script>
		<form enctype="multipart/form-data" action="index2.php" method="post" name="filename">
			<table class="adminheading">
				<tr>
					<th class="install"></th>
				</tr>
			</table>
			<table class="adminform">
				<tr>
					<th colspan="2"><?php echo _UPLOAD_PACKAGE_FILE;?></th>
				</tr>
				<tr>
					<td align="left"><?php echo _PACKAGE_FILE;?></td>
					<td><input class="text_area"
						name="userfile" type="file" size="70" /> <input class="button"
						type="submit" value="Upload File &amp; Install" /></td>
				</tr>
				<tr>
					<td align="left"><?php echo _CONNECTION;?></td>
					<td><?php echo $lists['connections'];?></td>
				</tr>
				<tr>
					<td><span class="editlinktip">
					<label onMouseOver="return overlib('<?php echo _OVERWRITE_TABLESDESC;?>', CAPTION, '<?php echo _OVERWRITE_TABLES;?>', BELOW, RIGHT);" onMouseOut="return nd();" for="overwritetables">
					<?php echo _OVERWRITE_TABLES;?></label>
					</span></td>
					<td><input type="checkbox" value="1" id="overwritetables" name="overwritetables" />
				</tr>
			</table>
			<input type="hidden" name="task" value="uploadfile" />
			<input type="hidden" name="option" value="com_fabrik"/>
			<input type="hidden" name="task" value="doimportTable" />
			<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
		</form>
		<form enctype="multipart/form-data" action="index2.php" method="post" name="csv">
			<table class="adminheading">
			<tr>
				<th class="install">
				</th>
			</tr>
			</table>
			<table class="adminform">
			<tr>
				<th colspan="2">
				<?php echo _IMPORT_CSV_FILE;?>
				</th>
			</tr>
			<tr>
				<td align="left">
					<lable for="userfile"><?php echo _CSV_FILE;?></label>
				</td>
				<td>
					<input class="text_area" name="userfile" id="userfile"  type="file" size="70"/>
				</td>
			</tr>
			<tr>
				<td align="left">
					<label for="table_name"><?php echo _CREATE_A_NEW_TABLE;?></label>
				</td>
				<td>
					<input class="input" id="table_name" name="table_name" size="30" id="table_name" />
				</td>
			</tr>
			<tr>
				<td align="left">
					<label for="fabrik_table"><strong><?php echo _OR . " " . _APPEND_TO_EXISITING_TABLE;?> </strong></label>
				</td>
				<td>
					<?php echo $lists['fabrikTables'];?>
				</td>
			</tr>
			<tr>
				<td align="left">
				 	<label for="drop_data"><?php echo _DROP_EXISTING_DATA;?></label>
				 </td>
				 <td>
					<input type="checkbox" name="drop_data" id="drop_data" value="1" />
				</td>
			</tr>
			<tr>
				<td align="left">
					<label for="field_delimiter"><?php echo _FILED_DELIMITER;?></label>
				</td>
				<td>
					<input size="2" class="input" id="field_delimiter" name="field_delimiter" value=","/>
				</td>
			</tr>
			<tr>
				<td align="left">
					<label for="text_delimiter"><?php echo _TEXT_DELIMITER;?></label>
				</td>
				<td>
					<input size="2" class="input" name="text_delimiter" id="text_delimiter" value='&quot;'/>
				</td>
			</tr>
			<tr>
				<td colspan="2" align="left">
					<input class="button" type="submit" value="<?php echo _IMPORT_CSV;?>" />
				</td>
			</tr>
			</table>
			<input type="hidden" name="task" value="uploadfile"/>
			<input type="hidden" name="option" value="com_fabrik"/>
			<input type="hidden" name="task" value="importCSV" />
			<input type="hidden" name="<?php echo josSpoofValue(); ?>" value="1" />
		</form>	
		<script type="text/javascript">
			$('fabrik_table').addEvent( 'change', function(e){
			 if( $('fabrik_table').selectedIndex != 0){
			 	$('table_name').value = '';
			 }
			});
			$('table_name').addEvent( 'click', function(e){
			 $('fabrik_table').selectedIndex = 0;
			 
			});
		</script>
		<?php
	  }
	  
	  	/**
	* @param string
	* @param string
	* @param string
	* @param string
	*/
	function showInstallMessage( $message, $title, $url ) {
		global $PHP_SELF;
		?>
		<table class="adminheading">
		<tr>
			<th class="install">
			<?php echo $title; ?>
			</th>
		</tr>
		</table>

		<table class="adminform">
		<tr>
			<td align="left">
			<strong><?php echo $message; ?></strong>
			</td>
		</tr>
		<tr>
			<td colspan="2" align="center">
			[&nbsp;<a href="<?php echo $url;?>" style="font-size: 16px; font-weight: bold">Continue ...</a>&nbsp;]
			</td>
		</tr>
		</table>
		<?php
	}
}

?>